#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr long long INFLL = numeric_limits<long long>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ll = long long;

map<pair<int, int>, int> tin, tout;

bool isuancv(pair<int, int> u, pair<int, int> v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

map<pair<int, int>, vector<pair<int, int>>> g;

int timer = 0;

void dfs(pair<int, int> v, pair<int, int> p) {
    tin[v] = timer++;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = timer++;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("C-input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    for (auto &i: a) {
        --i;
    }
    map<pair<int, int>, pair<int, int>> p;
    p[{0, 0}] = {-1, -1};
    vector<bool> m(n);
    for (int i = 0; i < n; ++i) {
        pair<int, int> rc = {0, 0};
        for (int j = 0; j < n; ++j) {
            auto gg = rc;
            if (m[j]) {
                ++gg.first;
            } else {
                ++gg.first;
                ++gg.second;
            }
            p[gg] = rc;
            rc = gg;
        }
        m[a[i]] = true;
    }
    for (auto [u, v]: p) {
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs({0, 0}, {-1, -1});
    int q;
    cin >> q;
    while (q--) {
        pair<int, int> u, v;
        cin >> u.first >> u.second >> v.first >> v.second;
//        while (!isuancv(u, v)) {
//            u = p[u];
//        }
        vector<pair<int, int>> pu, pv;
        while (u != pair(-1, -1)) {
            pu.push_back(u);
            u = p[u];
        }
        while (v != pair(-1, -1)) {
            pv.push_back(v);
            v = p[v];
        }
        pair ans = {0, 0};
        for (auto i: pu) {
            for (auto j: pv) {
                if (i == j) {
                    ans = max(ans, i);
                }
            }
        }
        cout << ans.first << " " << ans.second << "\n";
    }
}
