#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 100010;

void solve()
{
	int n;
	cin >> n;

	int k = 0;
	bool ok = 1;
	for (int i = 1; i <= n; i++)
	{
		int t;
		cin >> t;
		if (i != t)
		{
			ok = 0;
		}
		if (ok) k = i;
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++)
	{
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		if (c1 >= n - k && c2 >= n - k)
		{
			if (r1 - c1 == r2 - c2)
			{
				if (r1 < r2)
				{
					cout << r1 << " " << c1 << '\n';
				}
				else
				{
					cout << r2 << " " << c2 << '\n';
				}
			}
			else
			{
				r1 -= c1;
				r2 -= c2;
				cout << min(r1, r2) << " 0\n";
			}
		}
		else if (c1 >= n - k)
		{
			cout << r1 - c1 << " 0\n";
		}
		else if (c2 >= n - k)
		{
			cout << r2 - c2 << " 0\n";
		}
		else
		{
			if (c1 == c2)
			{
				if (r1 < r2)
				{
					cout << r1 << " " << c1 << '\n';
				}
				else
				{
					cout << r2 << " " << c2 << '\n';
				}
			}
			else
			{
				if (k + c1 < k + c2)
				{
					cout << k + c1 << " " << c1 << '\n';
				}
				else
				{
					cout << k + c2 << " " << c2 << '\n';
				}
			}
		}
		
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}