#pragma "Ofast"
#include <iostream>
#include <vector>
#include <stdio.h>
#include <algorithm>
using namespace std;
vector<int> d[2000000];
vector<int> merge(vector<int>& l, vector<int>& r) {
	int ls = l.size();
	int rs = r.size();
	int cl = 0;
	int cr = 0;
	int cpos = 0;
	vector<int> ans(ls + rs);
	while (cpos < ans.size()) {
		if (cl == ls) {
			ans[cpos++] = r[cr++];
		}
		else if (cr == rs) {
			ans[cpos++] = l[cl++];
		}
		else if (l[cl] < r[cr]) {
			ans[cpos++] = l[cl++];
		}
		else {
			ans[cpos++] = r[cr++];
		}
	}
	return ans;
}
vector<int> a;
int askl, askr, val;
void build(int v, int l, int r) {
	if (l > r) {
		return;
	}
	if (l == r) {
		d[v] = { a[l] };
		return;
	}
	build(2 * v + 1, l, (l + r) / 2);
	build(2 * v + 2, (l + r) / 2 + 1, r);
	d[v] = merge(d[2 * v + 1], d[2 * v + 2]);
}

int ask1(int v, int l, int r) {
	if (l > askr || r < askl) {
		return 0;
	}
	if (l >= askl && r <= askr) {
		return lower_bound(d[v].begin(), d[v].end(), val) - d[v].begin();
	}
	int aa = ask1(2 * v + 1, l, (l + r) / 2);
	int bb = ask1(2 * v + 2, (l + r) / 2 + 1, r);
	return aa + bb;
}
int ask2(int v, int l, int r) {
	if (l > askr || r < askl) {
		return 1e9;
	}
	if (l >= askl && r <= askr) {
		return d[v][0];
	}
	int aa = ask2(2 * v + 1, l, (l + r) / 2);
	int bb = ask2(2 * v + 2, (l + r) / 2 + 1, r);
	return min(aa, bb);
}
int ask3(int v, int l, int r, int remain, int val) {
	if (l == r) {
		return l;
	}
	//int atleft = lower_bound(d[2 * v + 1].begin(), d[2 * v + 1].end(), val) - d[2 * v + 1].begin();
	int L = -1;
	int R = d[2 * v + 1].size();
	while (R - L > 1) {

		int med = (L + R) / 2;
		if (d[2 * v + 1][med] >= val) {
			R = med;
		}
		else {
			L = med;
		}

	}
	int atleft = L+1;


	if (atleft >= remain) {
		return ask3(2 * v + 1, l, (l + r) / 2, remain, val);
	}
	else {
		return ask3(2 * v + 2, (l + r) / 2 + 1, r, remain - atleft, val);
	}

}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	scanf("%d", &n);
	a.resize(n);
	//d.resize(4*n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	build(0, 0, n - 1);
	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int lev1, lev2, c1, c2;

		//cin >> lev1 >> c1 >> lev2 >> c2;
		scanf("%d %d %d %d", &lev1, &c1, &lev2, &c2);
		c1 = lev1 - c1;
		c2 = lev2 - c2;
		;
		/*while (have < c1) {
			iiii++;

			if (a[iiii] < lev1) {
				have++;
			}


		}*/

		int chg1;
		if (c1 == 0) {
			chg1 = -1;
		}
		else {
			chg1 = ask3(0, 0, n - 1, c1, lev1);
		}
		int chg2;
		if (c2 == 0) {
			chg2 = -1;
		}
		else {
			chg2 = ask3(0, 0, n - 1, c2, lev2);
		}

		if (chg1 > chg2) {
			swap(chg1, chg2);
		}
		int levelat = min(lev1, lev2);
		askl = chg1 + 1;
		askr = chg2;
		levelat = min(levelat, ask2(0, 0, n - 1));
		/*for (int i = chg1 + 1; i <= chg2; i++) {
			levelat = min(levelat, a[i]);
		}*/
		askl = 0;
		askr = chg1;
		val = levelat;
		int coordans = ask1(0, 0, n - 1);
		/*for (int i = 0; i <= chg1; i++) {
			if (a[i] < levelat) {
				coordans++;
			}
		}*/

		coordans = levelat - coordans;
		printf("%d %d\n", levelat, coordans);
		//cout << levelat << ' ' << coordans << '\n';




	}


}