#include <bits/stdc++.h>

#define debug(x) cerr << (#x) << " = " << (x) << "\n";
#define len(x) ((int) (x).size())

using namespace std;
typedef long long ll;


const int INF_I = 0x3f3f3f3f;


void config_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed;
    cout.precision(20);
}


void solve();


int main() {
    config_io();
    solve();
    return 0;
}


struct point {
    ll x, y;

    bool operator<(const point& other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};


void solve() {
    int k;
    bool ok2 = false;
    cin >> k;
    if (k == 2) {
        ok2 = true;
    }
    for (int _i = 0; _i < k; ++_i) {
        int tttt;
        cin >> tttt;
    }

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        ll n, w, h;
        cin >> n >> w >> h;

        vector<point> p(n);

        for (int j = 0; j < n; ++j) {
            cin >> p[j].x >> p[j].y;
        }
        sort(p.begin(), p.end());

        ll h_min = h;
        ll ans = 0;
        ll d = h;
        for (int j = 0; j < n; ++j) {
            ll q1 = max(0ll, h_min - p[j].y) * (w - p[j].x);

            if (ok2 && q1 == 0) {
                d = min(p[j].y, d);
            }

            if (p[j].y < h_min) {
                ans += q1;
                h_min = p[j].y;
            }
        }

        if (ok2) {
            ans += (h - d) * (p[0].x);
            for (int j = 0; j < n - 1; ++j) {
                if (p[j].y > d) {
                    ans += (p[j].y - d) * (p[j + 1].x - p[j].x);
                }
            }
        }

        cout << ans << "\n";
    }
}

/*
2
1 2
1
4 9 7
3 0
0 5
4 4
1 2
 * */