#include "bits/stdc++.h"
#define ll long long
#define ld long double

using namespace std;

struct H{
    ll pr;
    ll from;
    ll num;
};

bool operator<(H l, H r){
    return l.pr < r.pr;
}

vector<set<int>> gr;
vector<multiset<H>> free_for_vertex;
vector<ll> bought;
vector<ll> c;
vector<pair<ll, ll>> lr;
vector<ll> height;
ll out_price;
bool ok;

void f(ll v){
    multiset<H> can_use;
    can_use.emplace(H{c[v], v, lr[v].second});
    ll filled = 0;
    for(auto u : gr[v]){
        f(u);
        filled += height[u];
        if(!ok)
            return;
    }
    for(auto u : gr[v]){
        can_use.merge(free_for_vertex[u]);
    }
    if(filled > lr[v].second){
        ok = false;
        return;
    }
    if(filled >= lr[v].first){
        height[v] = filled;
        ll canAdd = lr[v].second - filled;
        while (canAdd > 0){
            auto k = *can_use.begin();
            can_use.erase(can_use.begin());
            if(k.num <= canAdd){
                free_for_vertex[v].emplace(k);
            }else{
                free_for_vertex[v].emplace(H{k.pr,  k.from, canAdd});
            }
            can_use.emplace(H{k.pr,  k.from, k.num - canAdd});
            canAdd -= k.num;
        }
    }else{
        height[v] = lr[v].first;
        ll need_add = lr[v].first - filled;
        while (need_add > 0){
            auto k = *can_use.begin();
            can_use.erase(can_use.begin());
            if(k.num <= need_add){
                out_price += k.num * k.pr;
                bought[k.from] += k.num;
            }else{
                out_price += need_add * k.pr;
                bought[k.from] += need_add;
                can_use.emplace(H{k.pr,  k.from, k.num - need_add});
            }
            need_add -= k.num;
        }

        ll canAdd = lr[v].second - lr[v].first;
        while (canAdd > 0){
            auto k = *can_use.begin();
            can_use.erase(can_use.begin());
            if(k.num <= canAdd){
                free_for_vertex[v].emplace(k);
            }else{
                free_for_vertex[v].emplace(H{k.pr,  k.from, canAdd});
                can_use.emplace(H{k.pr,  k.from, k.num - canAdd});
            }
            canAdd -= k.num;
        }
    }
}

int main() {
    ll t;
    cin >> t;
    while(t--){
        ll n;
        cin >> n;
        gr.assign(n, set<int>());
        c.resize(n);
        lr.resize(n);
        bought.assign(n, 0);
        free_for_vertex.resize(n);
        height.resize(n);
        for (int i = 1; i < n; ++i) {
            ll p;
            cin >> p;
            p--;
            gr[p].emplace(i);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> lr[i].first >> lr[i].second;
        }
        ok = true;
        out_price = 0;
        f(0);
        if(ok) {
            cout << out_price << endl;
            for (int i = 0; i < n; ++i) {
                cout << bought[i] << " ";
            }
            cout << endl;
        }else
            cout << -1 << endl;
    }
    return 0;
}
