#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 3001;

int p[MAXN * MAXN + MAXN];
int d[MAXN * MAXN + MAXN];

int ver(int i, int j) {
	return i * MAXN + j;
}

signed main() {
	int n; cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector <int> c(n, 1);
	if (n <= 3000) {
		d[0] = 0;
		p[0] = 0;
		for (int i = 1; i <= n; i++) {
			p[ver(i, i)] = ver(i - 1, i - 1);
			d[ver(i, i)] = i;
		}
		for (int i = 0; i < n; i++) {
			c[a[i] - 1] = 0;
			int vi = 0, vj = 0;
			for (int j = 0; j < n; j++) {
				vi++; vj += c[j];
				p[ver(vi, vj)] = ver(vi - 1, vj - c[j]);
				d[ver(vi, vj)] = d[ver(vi - 1, vj - c[j])] + 1;
			}
		}
		int q; cin >> q;
		for (int i = 0; i < q; i++) {
			int vi, vj, ui, uj;
			cin >> vi >> vj >> ui >> uj;
			int v = ver(vi, vj);
			int u = ver(ui, uj);
			while (d[v] > d[u]) v = p[v];
			while (d[u] > d[v]) u = p[v];
			while (p[v] != p[u]) { u = p[u]; v = p[v]; }
			if (v != u) v = p[v];
			cout << v / MAXN << ' ' << v % MAXN << endl;
		}
	}
}