#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define ld long double
#define ll __int128

const int N = 1e5 + 10, INF = 1e18;
vector<int> c(N), g[N], l(N), r(N), can(N), par(N), used(N), cnt(N);
bool bad = 0;
int ans = 0;
vector<pair<int,int>> arr;

pair<int,int> seg(pair<int,int> a, pair<int,int> b) {
    return {max(a.first, b.first), min(a.second, b.second)};
}

pair<int,int> zhfs(int v, int p) {
    pair<int,int> pr = {0, 0};
    par[v] = p;
    bool was = 0;
    for (auto to : g[v]) {
        if (to != p) {
            auto val = zhfs(to, v);
            pr.first += val.first, pr.second += val.second;
            was = 1;
        }
    }
    if (!was) {
        return {l[v], r[v]};
    } else {
        auto s = seg({l[v], r[v]}, pr);
        if (s.first > s.second) {
            bad = 1;
        }
        return s;
    }
}

void walk(int v, int p) {
    if (!used[v]) arr.pb({c[v], v});
    for (auto to : g[v]) {
        if (to != p) {
            walk(to, v);
        }
    }
}

void dfs(int v, int p) {
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
    int have = r[v] - can[v];
    if (have >= l[v]) return;
    int need = l[v] - have;
    arr.clear();
    walk(v, p);
    sort(arr.begin(), arr.end());
    for (auto to : arr) {
        int u = to.second;
        int mn = INF;
        while (u != -1) {
            mn = min(mn, can[u]);
            u = par[u];
        }
        if (mn < need) {
            u = to.second;
            ans += mn * c[u];
            cnt[u] += mn;
            used[u] = 1;
            while (u != -1) {
                can[u] -= mn;
                u = par[u];
            }
            need -= mn;
        } else {
            u = to.second;
            cnt[u] += need;
            ans += need * c[u];
            while (u != -1) {
                can[u] -= need;
                u = par[u];
            }
            break;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    bad = 0;
    ans = 0;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        used[i] = 0;
        cnt[i] = 0;
    }
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        can[i] = r[i];
    }
    zhfs(0, -1);
    if (bad) {
        cout << -1 << endl;
        return;
    }
    dfs(0, -1);
    cout << ans << endl;
    for (int i = 0; i < n; i++) {
        cout << cnt[i] << ' ';
    }
    cout << endl;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
