#include <iostream>
#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()
#define pll pair<ll, ll>
#define pikachu push_back
typedef long long ll;
typedef long double ld;

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

void merge(set<pll > &a, set<pll > &b) {
    if (sz(a) < sz(b)) swap(a, b);
    for (auto e: b) a.insert(e);
}

template<typename A, typename B>
bool cmax(A& a, const B& b){
    if (a < b){
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmin(A& a, const B& b){
    if (a > b){
        a = b;
        return true;
    }
    return false;
}
const ll INFL = 1e18 + 666;
struct SegT{
    ll n;
    vector<pll> T;
    SegT(ll t): n(t){
        T.resize(4 * n, {INFL, -1});
    }
    pll get(ll v, ll L, ll R, ll pos){
        if (R - L == 1) return T[v];
        ll m = (R + L) / 2;
        if (pos < m){
            auto kek = get(v * 2 + 1, L, m, pos);
            cmin(kek, T[v]);
            return kek;
        }
        auto kek = get(v * 2 + 2, m, R, pos);
        cmin(kek, T[v]);
        return kek;
    }
    pll get(ll pos){
        return get(0, 0, n, pos);
    }
    void min(ll v, ll L, ll R, ll l, ll r, pll x){
        if (l >= R || L >= r) return;
        if (l >= L && R <= r){
            cmin(T[v], x);
            return;
        }
        ll m = (R + L) / 2;
        min(v * 2 + 1, L, m, l, r, x);
        min(v * 2 + 2, m, R, l, r, x);
    }
    void min(ll l, ll r, pll x){
        min(0, 0, n, l, r, x);
    }
};
void task() {
    ll n;
    cin >> n;
    vector<vector<ll>> g(n);
    vector<ll> cnt(n, 0), l(n), r(n), c(n);
    vector<ll> tin(n), tout(n);
    for (ll i = 1; i < n; ++i) {
        ll x;
        cin >> x;
        g[--x].pikachu(i);
    }
    for (auto &e: c) cin >> e;
    for (ll i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    bool fl = 1;
    ll ct = 0;
    function<void(ll)> check = [&](ll v){
        ll mi = 0;
        tin[v] = ct++;
        for(auto u: g[v]){
            check(u);
            mi += l[u];;
        }
        tout[v] = ct;
        if (mi > r[v]) fl = 0;
    };
    check(0);
    if (!fl){
        cout << "-1\n";
        return;
    }
    SegT T(n);
    function<ll(ll)> VAL = [&](ll v){
        return T.get(tin[v]).first;
    };
    function<void(ll, ll)> UPD = [&](ll v, ll x){
        auto [val, p] = T.get(tin[v]);
        T.min(tin[p], tout[p], {val - x, p});
        cnt[v] += x;
    };
    function<void(set<pll>&, ll)> get = [&](set<pll>& s, ll x){
        while(x > 0){
            if (!sz(s)){
                cout << "-1\n";
                return;
            }
            auto [price, ver] = *s.begin();
            if (VAL(ver) > 0){
                if (VAL(ver) <= x){
                    ll V = VAL(ver);
                    UPD(ver, V);
                    x -= V;
                    s.erase(s.begin());
                }
                else{
                    UPD(ver, x);
                    x = 0;
                }
            }
            else s.erase(s.begin());
        }
    };
    function<pair<set<pll>, ll>(ll)> dfs = [&](ll v){
        set<pll> kek;
        kek.insert({c[v], v});
        ll sm = 0;
        for(auto u: g[v]){
            auto child = dfs(u);
            sm += child.second;
            merge(kek, child.first);
        }
        T.min(tin[v], tout[v], {r[v] - sm, v});
        if (sm < l[v]){
            get(kek, l[v] - sm);
            sm = l[v];
        }
        return make_pair(move(kek), sm);
    };
    dfs(0);
    ll ans = 0;
    for(ll i = 0; i < n; ++i){
        ans += c[i] * cnt[i];
    }
    cout << ans << '\n';
    for(auto e: cnt) cout << e << ' ';
    cout << '\n';
}

void run() {
    ll t;
    cin >> t;
    while(t--){
        task();
    }
}
