#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define sz(x) (int) size(x)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define uniq(x) x.resize(unique(all(x)) - begin(x));
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 998244353;
const int N = (100000) + 1;

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void solve() {
    int n;
    ll w, h;
    cin >> n >> w >> h;
    vector<pii> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i].first >> v[i].second;
    sort(all(v));
    vector<pii> gg;
    for (int i = 0; i < n; ++i) {
        if (gg.empty() || gg.back().second > v[i].second) gg.push_back(v[i]);
    }
    ll ans = 0;
    gg.emplace_back(w, 0);
    for (int i = sz(gg) - 2; i > -1; --i) {
        ans += (gg[i + 1].first - gg[i].first) * (h - gg[i].second);
    }
    cout << ans << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int k;
    cin >> k;
    vector<int> now(k);
    for (int i = 0; i < k; ++i) cin >> now[i];
    int test = 1;
    cin >> test;
    while (test--)
        solve();
    return 0;
}