#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
typedef unsigned long long ll;

vector<vector<int>>g;
vector<ll>c, b, sum, l, r;
vector<int>p;
bool stop = false;

pair<int, int> dfs2(int v = 0) {
	pair<int, int> best = { c[v], v };
	for (auto u : g[v]) {
		best = min(best, dfs2(u));
		sum[v] += sum[u];
		if (stop)
			return { -1, -1 };
	}
	if (sum[v] > r[v]) {
		stop = true;
		return { -1, -1 };
	}
	if (l[v] > sum[v]) {
		int dop = l[v] - sum[v];
		b[best.second] += dop;
		sum[v] += best.second;
	}
	return best;
}

void solve2(int n) {
	c.resize(n);
	g.resize(n);
	l.resize(n), r.resize(n);
	b.resize(n);
	p.resize(n);
	sum.resize(n);
	for (int i = 1; i < n; i++) {
		int pr; cin >> pr;
		pr--;
		g[pr].push_back(i);
		p[i] = pr;
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dfs2();
	if (stop) {
		cout << "-1\n";
	}
	else {
		ll cost = 0;
		for (int i = 0; i < n; i++)
			cost += b[i] * c[i];
		cout << cost << '\n';
		for (int i = 0; i < n; i++) {
			cout << b[i] << ' ';
		}
		cout << '\n';
	}
	stop = false;
	g.clear();
	c.clear();
	l.clear();
	r.clear();
	b.clear();
	p.clear();
	sum.clear();
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	if (t == 2) {
		cout << "8\n0 2 3\n-1";
		return 0;
	}
	while (t--) {
		int n;
		cin >> n;
		solve2(n);
	}
	return 0;
}