#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;

int number = 1;
map<pair<int, int>, int> mp;
unordered_map<int, pair<int, int>> rev;
vector<int> gr[9000001];
int add[3001];

vector<pair<int, int>> current;


void make_frun(int n) {
    pair<int, int> p = {0, 0};
    int cur = mp[p];
    current.push_back(p);
    for (int i = 0; i < n; ++i) {
        p.first++;
        p.second += add[i];
        int t = mp[p];
        if (mp[p] == 0) {
            rev[number] = p;
            t = number;
            mp[p] = number++;
            gr[cur].push_back(mp[p]);
        }
        cur = t;
        current.push_back(p);
    }
}
void make_run(int n, int ind = 0) {
    pair<int, int> p = current[ind];
    int cur = mp[p];

    for (int i = ind; i < n; ++i) {
        p.first++;
        p.second += add[i];
        current[i + 1] = p;
        int t = mp[p];
        if (mp[p] == 0) {
            rev[number] = p;
            t = number;
            mp[p] = number++;
            gr[cur].push_back(mp[p]);
        }
        cur = t;
    }
}

int tin[9000001];
int tout[9000001];
int timer = 0;
void dfs_t(int v) {
    tin[v] = timer++;

    for (auto &x : gr[v])
        dfs_t(x);

    tout[v] = timer++;
}

bool is_par(int u, int v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}


int find(int u, int v, int c = 0) {
    for (auto &x : gr[c]) {
        if (is_par(x, u) && is_par(x, v))
            return find(u, v, x);
    }
    return c;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n; cin >> n;
    rev[0] = {0, 0};
    vector<int> a(n);
    for (auto &x : a)
        cin >> x;

    for (auto &x : add) {
        x = 1;
    }


    make_frun(n);

    for (int i = 0; i < n; ++i) {
        add[a[i] - 1] = 0;
        make_run(n);
    }

    for (auto &x : gr) {
        sort(x.begin(), x.end());
        x.resize(unique(x.begin(), x.end()) - x.begin());
    }
    dfs_t(0);


//    for (auto &x : mp) {
//        cout << "{ " << x.first.first << ", " << x.first.second << " }: " << x.second << '\n';
//    }

//    for (auto &x : gr) {
//        for (auto &y : x) {
//            cout << y << ' ';
//        }
//        cout << '\n';
//    }

//    for (int i = 0; i < number; ++i) {
//        cout << i << ' ' << tin[i] << ' ' << tout[i] << '\n';
//    }

    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        int v = mp[{r1, c1}];
        int u = mp[{r2, c2}];

        int uv = find(v, u);
        cout << rev[uv].first << ' ' << rev[uv].second << '\n';
    }
}