#include "iostream"
#include "vector"
#include "algorithm"

using namespace std;

const long long INF = 1e9;

signed main() {
    long long n; cin >> n;
    vector<long long> p(n);
    for (long long i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector<vector<long long>> ans(n, vector<long long>(n, 0));
    /*for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            ans[i][j] = j - i;
        }
    }*/
    for (long long i = n - 1; i >= 0; --i) {
        long long dist = 0;
        for (long long j = i + 1; j < n; ++j) {
            if (p[j] < p[i]) dist++;
        }
        long long mx = -INF, less = 0;
        for (long long j = i - 1; j >= 0; --j) {
            mx = max(mx, j + less);
            ans[j][i] = max(ans[j][i], dist + mx - j + 1);
            if (p[j] < p[i]) less++;
        }
    }
    /*for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    for (long long i = 0; i < n; ++i) {
        long long dist = 0;
        for (long long j = 0; j < i; ++j) {
            if (p[j] > p[i]) dist++;
        }
        long long mx = -INF, more = 0;
        for (long long j = i + 1; j < n; ++j) {
            mx = max(mx, more - j);
            ans[i][j] = max(ans[i][j], dist + mx + j + 1);
            if (p[j] > p[i]) more++;
        }
    }
    /*for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    vector<pair<long long, long long>> s;
    for (long long i = 0; i < n; ++i) {
        s.emplace_back(p[i], i);
    }
    sort(s.begin(), s.end());
    vector<long long> pos(n);
    for (long long i = 0; i < n; ++i) {
        pos[s[i].second] = i;
    }
    for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            ans[i][j] = max(ans[i][j], abs(pos[i] - pos[j]));
        }
    }
    long long res = 0;
    for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            res += ans[i][j];
        }
    }
    /*for (long long i = 0; i < n; ++i) {
        for (long long j = i + 1; j < n; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }*/
    cout << res << endl;
}