#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 5, R = 1 << 17;

vector<int> g[maxn];

int prr[maxn], pos[maxn];
int sz[maxn];

void build_first(int v) {
    prr[v] = v;
    sz[v] = 1;
    for (auto u : g[v]) {
        build_first(u);
        sz[v] += sz[u];
    }
    vector<pair<int, int>> p;
    for (auto u : g[v]) {
        p.emplace_back(sz[u], u);
    }
    sort(p.rbegin(), p.rend());
    g[v].clear();
    for (auto pp : p) {
        g[v].push_back(pp.second);
    }
}

int ttt = 0;

void build_second(int v) {
    pos[v] = ttt;
    ttt++;
    if (!g[v].empty()) {
        prr[g[v][0]] = prr[v];
        for (auto u : g[v]) {
            build_second(u);
        }
    }
}

int t[R * 2], psh[R * 2];

void build(int n) {
    for (int i = 0; i < n; ++i) {
        for (int p = i + R; p > 0; p /= 2) {
            t[p] = psh[p] = 0;
            if (p < R) {
                t[p * 2 + 1] = psh[p * 2 + 1] = 0;
            }
        }
    }
}

void push(int node) {
    if (psh[node] != 0) {
        t[node * 2] += psh[node];
        t[node * 2 + 1] += psh[node];
        psh[node * 2] += psh[node];
        psh[node * 2 + 1] += psh[node];
    }
    psh[node] = 0;
}

void add(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        psh[node] += val;
        t[node] += val;
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    push(node);
    int nm = (nl + nr) / 2;
    add(ql, qr, val, node * 2, nl, nm);
    add(ql, qr, val, node * 2 + 1, nm, nr);
    t[node] = min(t[node * 2], t[node * 2 + 1]);
}

int get(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return t[node];
    }
    if (qr <= nl || nr <= ql) {
        return 1e9 + 7;
    }
    push(node);
    int nm = (nl + nr) / 2;
    int ans = min(get(ql, qr, node * 2, nl, nm), get(ql, qr, node * 2 + 1, nm, nr));
    t[node] = min(t[node * 2], t[node * 2 + 1]);
    return ans;
}

int p[maxn], c[maxn], l[maxn], r[maxn];

set<pair<int, int>> d[maxn];

int cnt_all[maxn], cnt_nw[maxn];

void add_v(int v, int val) {
    while (v != -1) {
        add(pos[prr[v]], pos[v] + 1, val);
        v = p[prr[v]];
    }
}

int get_v(int v) {
    int ans = 1e9 + 7;
    while (v != -1) {
        ans = min(ans, get(pos[prr[v]], pos[v] + 1));
        v = p[prr[v]];
    }
    return ans;
}

// void add(int v, int val) {
//     for (; v != -1; v = p[v]) {
//         cnt_all[v] += val;
//     }
// }

// int get(int v) {
//     int ans = r[v] - cnt_all[v];
//     for (; v != -1; v = p[v]) {
//         ans = min(ans, r[v] - cnt_all[v]);
//     }
//     return ans;
// }

long long ans = 0;

void dfs(int v) {
    for (auto u : g[v]) {
        dfs(u);
        if (d[u].size() > d[v].size()) {
            swap(d[u], d[v]);
        }
    }
    for (auto u : g[v]) {
        for (auto p : d[u]) {
            d[v].insert(p);
        }
    }
    if (ans == -1) {
        return;
    }
    while (get(pos[v], pos[v] + 1) > r[v] - l[v] && !d[v].empty()) {
        int a = get_v(d[v].begin()->second);
        a = min(a, l[v] - (r[v] - get(pos[v], pos[v] + 1)));
        ans += a * 1LL * d[v].begin()->first;
        add_v(d[v].begin()->second, -a);
        cnt_nw[d[v].begin()->second] += a;
        if (get_v(d[v].begin()->second) == 0) {
            d[v].erase(d[v].begin());
        }
    }
    if (get(pos[v], pos[v] + 1) > r[v] - l[v]) {
        ans = -1;
    }
}

void solve() {
    int n;
    cin >> n;
    ttt = 0;
    ans = 0;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    build_first(0);
    build_second(0);
    for (int i = 0; i < n; ++i) {
        d[i].clear();
        cnt_nw[i] = cnt_all[i] = 0;
        cin >> c[i];
        d[i].insert({c[i], i});
    }
    build(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        add(pos[i], pos[i] + 1, r[i]);
    }
    dfs(0);
    cout << ans << '\n';
    if (ans != -1) {
        for (int i = 0; i < n; ++i) {
            cout << cnt_nw[i] << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
