#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;
#define int long long

int cnt_can;
char can[4];

void solve() {
  int n, w, h;
  cin >> n >> w >> h;
  vector<array<int, 2>> a(n);
  for (auto &x : a) {
    cin >> x[0] >> x[1];
  }
  if (cnt_can == 1) {
    sort(a.begin(), a.end(), [&] (const array<int, 2>& lhs, const array<int, 2>& rhs) {
      return lhs[0] > rhs[0] || (lhs[0] == rhs[0] && lhs[1] < rhs[1]);
    });
    vector<array<int, 2>> stk;
    for (int i = 0; i < n; i++) {
      while (!stk.empty() && stk.back()[1] >= a[i][1]) {
        stk.pop_back();
      }
      stk.push_back(a[i]);
    }
    a = stk;
    n = (int) a.size();
    int res = 0;
    res = (w - a[0][0]) * (h - a[0][1]);
    for (int i = 1; i < n; i++) {
      res += (a[i - 1][0] - a[i][0]) * (h - a[i][1]);
    }
    cout << res << '\n';
  } else if (cnt_can == 2 && can[0] && can[2]) {
    sort(a.begin(), a.end(), [&] (const array<int, 2>& lhs, const array<int, 2>& rhs) {
      return lhs[0] > rhs[0] || (lhs[0] == rhs[0] && lhs[1] < rhs[1]);
    });
    vector<vector<int>> dp(n + 1, vector<int> (n + 1));
    dp[0][n] = (w - a[0][0]) * (h - a[0][1]);
    dp[n][0] = a[0][0] * a[0][1];
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        for (int prev_i = 0; prev_i < i; prev_i++) {
          if (a[prev_i][0] < a[i][0]) {
            dp[i][j] = max(dp[i][j], dp[prev_i][j] + );
          }
        }
      }
    }
//    vector<vector<int>> dp(2, vector<int> (n));
//    for (int i = 0; i < n; i++) {
//      vector<vector<int>> ndp(2, vector<int> (n));
//      for (int j = 0; j < i - 1; j++) {
//        ndp[0][j] = dp[0][j] + ;
//      }
//    }
//    vector<vector<vector<int>>> dp(2, vector<vector<int>> (n, vector<int> (n)));
//    for (int i = 0; i < n; i++) {
//      for (int j = 0; j <= i; j++) {
//        for (int k = 0; k <= i; k++) {

//        }
//      }
//    }
  } else {
    assert(false);
  }
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cin >> cnt_can;
  for (int i = 0; i < cnt_can; i++) {
    int pos;
    cin >> pos;
    can[pos - 1] = 1;
  }
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
