#include <bits/stdc++.h>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(a) a.begin(), a.end()

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

mt19937 rnd(time(0));

void solve() {
    ll n, w, h;
    cin >> n >> w >> h;

    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    sort(all(a));

    ll ans = 0;

    ll last_y = h;

    for (auto i : a) {
        if (i.second >= last_y) continue;

        ans += (last_y - i.second) * (w - i.first);
        last_y = i.second;
    }

    cout << ans << '\n';
}

signed main() {
    fast_stream();

    ll gh;
    cin >> gh >> gh;

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*
10
1 2 3 4 4 5 4 8 1
715028053 417838085 71832107 869116961 872335120 79833896 943607627 948373498 253462209 536117063
544 1000
976 1000
189 1000
564 1000
294 1000
632 1000
576 1000
906 1000
598 1000
99 1000
 */









