#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n;
    cin >> n;

    vector <int> p(n);
    for (int &x: p) cin >> x;

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int cnti = 0, cntj = 0;
            for (int k = 0; k < i; k++)
                if (p[k] > p[i])
                    cnti++;

            for (int k = j; k < n; k++)
                cntj += (p[k] < p[j]);

            int cnt1 = 0, cnt2 = 0;
            for (int k = 0; k < n; k++) {
                cnt1 += (p[k] < p[j] && p[k] > p[i]);
                cnt2 += (p[k] > p[j] && p[k] < p[i]);
            }

            int best = max({
                           j - i + max(cnti, cntj),
                           p[i] < p[j] ? cnt1 + 1 : cnt2 + 1
            });

            answer += best;
        }
    }

    cout << answer << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
