#include <bits/stdc++.h>

using namespace std;

const int N = 500;

vector<int> g[N];

int64_t c[N], l[N], r[N];
int64_t dp[N], cnt[N], ans[N];

set<pair<int, int>> best[N];

void dfs(int v, int p) {
    int q = 0;
    for (auto u: g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
        q++;
        if (dp[u] == INT32_MAX) {
            dp[v] = INT32_MAX;
            return;
        }
    }
    if (q == 0) {
        dp[v] = l[v] * c[v];
        cnt[v] = l[v];
        ans[v] = l[v];
        for (int i = 0; i < r[v] - l[v]; i++) {
            best[v].insert({c[v], v});
        }
    } else {
        int64_t mn = 0;
        for (auto u: g[v]) {
            if (u == p) {
                continue;
            }
            mn += cnt[u];
            dp[v] += dp[u];
            for (auto it : best[u]) {
                if (best[v].size() < N) {
                    best[v].insert(it);
                } else {
                    auto it1 = best[v].end();
                    it1--;
                    if (it.first < it1->first) {
                        best[v].erase(it1);
                        best[v].insert(it);
                    }
                }
            }
        }
        cnt[v] = mn;
        if (mn > r[v]) {
            dp[v] = INT32_MAX;
            return;
        }
        if (mn < l[v]) {
            int64_t need = l[v] - mn;
            while (!best[v].empty()) {
                if (need == 0) {
                    break;
                }
                auto it = *best[v].begin();
                best[v].erase(best[v].begin());
                need--;
                ans[it.second]++;
                cnt[v]++;
                dp[v] += it.first;
            }
            if (need > 0) {
                dp[v] += need * c[v];
                cnt[v] += need;
                ans[v] += need;
            }
        }
        for (int i = 0; i < r[v] - cnt[v]; i++) {
            if (best[v].size() < N) {
                best[v].insert({c[v], v});
            } else {
                auto it1 = best[v].end();
                it1--;
                if (c[v] < it1->first) {
                    best[v].erase(it1);
                    best[v].insert({c[v], v});
                }
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
        g[i].push_back(v);
    }

    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }

    dfs(0, -1);

    if (dp[0] == INT32_MAX) {
        cout << "-1\n";
    } else {
        cout << dp[0] << "\n";
        for (int i = 0; i < n; i++) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        for (auto &it : best) {
            it.clear();
        }
        for (auto &it : g) {
            it.clear();
            it.resize(0);
            it.shrink_to_fit();
        }
        solve();
    }
}
