#include <bits/stdc++.h>

using namespace std;

#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 3001, inf = 1e9 + 7, lg = 24;

int p[maxn], n, pr[maxn * maxn], was[maxn], a[maxn], tin[maxn * maxn], tout[maxn * maxn], timer = 0;
vc <int> g[maxn * maxn];

int encode (int x, int y) {
    return x * (n + 1) + y;
}

pii decode (int u) {
    return {u / (n + 1), u % (n + 1)};
}

void dfs (int x, int y, int h = 0) {
    while (h < n) {
        int u = encode(x, y), v = encode(x + 1, y);
        if (!p[h]) ++v;
        pr[v] = u;
        g[u].pb(v);
        was[h] = u;
        x = v / (n + 1);
        y = v % (n + 1);
        ++h;
    }
}

void go (int u) {
    tin[u] = timer++;
    for (int v: g[u]) go(v);
    tout[u] = timer++;
}

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void output (int u) {
    pii tmp = decode(u);
    cout << tmp.first << ' ' << tmp.second << '\n';
}

void solve () {
    cin >> n;
    dfs(0, 0);
    forn (i, n) {
        cin >> a[i];
        p[a[i] - 1] = 1;
        pii tmp = decode(was[a[i] - 1]);
        dfs(tmp.first, tmp.second, a[i] - 1);
    }
    int q;
    cin >> q;
    go(0);
    while (q--) {
        int x, y;
        cin >> x >> y;
        int u = encode(x, y);
        cin >> x >> y;
        int v = encode(x, y);
        if (is_ancestor(u, v)) {
            output(u);
            continue;
        }
        if (is_ancestor(v, u)) {
            output(v);
            continue;
        }
        while (!is_ancestor(pr[u], v)) u = pr[u];
        while (!is_ancestor(pr[v], u)) v = pr[v];
        output(pr[u]);
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--)solve();
}
