#include <bits/stdc++.h>

using namespace std;
#define int long long

int f(vector<pair<int, int>> vec, int w, int h) {
    sort(vec.begin(), vec.end(), [&](pair<int, int> a, pair<int, int> b) {
        return a.first > b.first or (a.first == b.first and a.second < b.second);
    });
    vector<pair<int, int>> st;
    for (auto c: vec) {
        while (!st.empty() and st.back().second >= c.second) st.pop_back();
        st.push_back(c);
    }
    int ans = 0;
    int last = w;
    for (auto c: st) {
        ans += (h - c.second) * (last - c.first);
        last = c.first;
    }
    return ans;
}

void solve1() {
    int t;
    cin >> t;
    while (t--) {
        int n, w, h;
        cin >> n >> w >> h;
        vector<pair<int, int>> vec;
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            vec.push_back({x, y});
        }
        cout << f(vec, w, h) << "\n";
    }
}


void solve2() {
    int t;
    cin >> t;
    while (t--) {
        int n, w, h;
        cin >> n >> w >> h;
        vector<pair<int, int>> vec(n);
        for (int i = 0; i < n; ++i) cin >> vec[i].first >> vec[i].second;
        sort(vec.begin(), vec.end(), [&](pair<int, int> a, pair<int, int> b) {
            return a.second < b.second;
        });
        int ans = 0;

    }

}

signed main() {
    int k;
    cin >> k;
    vector<int> vec(k);
    for (int i = 0; i < k; ++i) cin >> vec[i];
    if (vec.size() == 1) {
        solve1();
    } else {
        solve2();
    }

    return 0;
}