#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define pb push_back
const int maxN = 1e5 + 9;
const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
template <typename T>
inline int len(T& x) {
    return x.size();
}


int n;
vector<int> g[maxN];
ll a[maxN], l[maxN], r[maxN];
ll ans[maxN];
//ll sans[maxN];
ll mnr[maxN];
struct cmp {
    bool operator()(const int& x, const int& y) const {
        if(a[x] != a[y]) return a[x] > a[y];
        return x < y;
    }
};
vector<int> dsu[maxN];
int id[maxN];
ll t[maxN * 4];
bool bad = false;
vector<int> eul;
int el[maxN], er[maxN];
int par[maxN];
int sz[maxN];
int nxtp[maxN];
ll lz[maxN * 4];


void clear(int n) {
    bad = false;
    eul.clear();
    for(int i = 0; i <= n; ++i) {
        par[i] = 0;
        g[i].clear();
        dsu[i].clear();
        id[i] = i;
        a[i] = l[i] = r[i] = ans[i] = 0;
        mnr[i] = llinf;
        el[i] = er[i] = 0;
        sz[i] = 0;
        nxtp[i] = 0;
    }
    for(int i = 0; i <= n * 4; ++i) {
        t[i] = 0;
        lz[i] = 0;
    }
}

void merge(int u, int v) {
    int pu = id[u], pv = id[v];
    if(len(dsu[pu]) < len(dsu[pv])) {
        swap(pu, pv);
        swap(u, v);
    }
    for(auto &i: dsu[pv]) {
        id[i] = pu;
        dsu[pu].pb(i);
        push_heap(dsu[pu].begin(), dsu[pu].end(), cmp());
    }
    dsu[pv].clear();
}

void szs(int v) {
    sz[v] = 1;
    for(auto &i: g[v]) {szs(i); sz[v] += sz[i];}
    for(int i = 0; i < len(g[v]); ++i) {
        if(sz[g[v][i]] > sz[g[v][0]]) swap(g[v][0], g[v][i]);
    }
}
void eo(int v) {
    if(nxtp[v] == 0) nxtp[v] = v;
    el[v] = len(eul);
    eul.pb(v);
    for(int i = 0; i < len(g[v]); ++i) {
        int to = g[v][i];
        if(i != 0) nxtp[to] = to;
        else nxtp[to] = nxtp[v];
        eo(to);
    }
    er[v] = len(eul) - 1;
}

void push(int v) {
    t[v * 2] += lz[v];
    t[v * 2 + 1] += lz[v];
    lz[v * 2] += lz[v];
    lz[v * 2 + 1] += lz[v];
    lz[v] = 0;
}

ll getmn(int v, int tl, int tr, int ql, int qr) {
    if(ql > qr) return LLONG_MAX;
    if(tl == ql && tr == qr) return t[v];
    push(v);
    int tm = (tl + tr) / 2;
    return min(getmn(v * 2, tl, tm, ql, min(qr, tm)), getmn(v * 2 + 1, tm + 1, tr, max(tm + 1, ql), qr));
}


//void upd(int v, int tl, int tr, int i, ll x) {
//    if(tl == tr) {
//        t[v] += x;
//        return;
//    }
//    push(v);
//    int tm = (tl + tr) / 2;
//    if(i <= tm) upd(v * 2, tl, tm, i, x);
//    else upd(v * 2 + 1, tm + 1, tr, i, x);
//    t[v] = min(t[v * 2], t[v * 2 + 1]);
//}
void updlr(int v, int tl, int tr, int ql, int qr, ll x) {
    if(ql > qr) return;
    if(tl == ql && tr == qr) {
        t[v] += x;
        lz[v] += x;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    updlr(v * 2, tl, tm, ql, min(qr, tm), x);
    updlr(v * 2 + 1, tm + 1, tr, max(tm + 1, ql), qr, x);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}



ll getsum(int v) {
    return r[v] - getmn(1, 0, n - 1, el[v], el[v]);
}

ll getmn(int v) {
    ll res = llinf;
    while(v != 0) {
        int L = el[v];
        int R = el[nxtp[v]];
        if(L > R) swap(L, R);
        res = min(res, getmn(1, 0, n - 1, L, R));
        v = par[nxtp[v]];
    }
    return max(0LL, res);
}
void add_pth(int v, ll x) {
    while(v != 0) {
        int L = el[v];
        int R = el[nxtp[v]];
        if(L > R) swap(L, R);
        updlr(1, 0, n - 1, L, R, x);
        v = par[nxtp[v]];
    }
}


void add(int v, ll x) {
    updlr(1, 0, n - 1, el[v], el[v], x);
}


void dfs(int v) {
    dsu[id[v]].pb(v);
    mnr[v] = min(mnr[v], r[v]);
    for(auto &i: g[v]) {
        mnr[i] = min(mnr[i], mnr[v]);
        dfs(i);

        if(bad) return;

        merge(v, i);
    }

    ll cursum = -1;
    while(true) {
        cursum = getsum(v);
        if(cursum >= l[v]) break;

        if(dsu[id[v]].empty()) {
            bad = true;
            return;
        }
        int u = dsu[id[v]][0];
        ll canbuy = getmn(u);
        if(canbuy == 0) {
            pop_heap(dsu[id[v]].begin(), dsu[id[v]].end(), cmp());
            dsu[id[v]].pop_back();
            continue;
        }

        ll buy = min(l[v] - (cursum), canbuy);
        ans[u] += buy;
        add_pth(u, -buy);

        if(buy == canbuy) {
            pop_heap(dsu[id[v]].begin(), dsu[id[v]].end(), cmp());
            dsu[id[v]].pop_back();
            continue;
        }

    }

//    cursum = getsum(v);
    if(cursum > mnr[v]) {
        bad = true;
        return;
    }
}
void solve() {
    cin >> n;
    clear(n);
    for(int i = 2; i <= n; ++i) {
        int p; cin >> p;
        par[i] = p;
        g[p].pb(i);
    }
    for(int i = 1; i <= n; ++i) cin >> a[i];
    for(int i = 1; i <= n; ++i) cin >> l[i] >> r[i];

    szs(1);
    eo(1);
    for(int i = 1; i <= n; ++i) {
        add(i, r[i]);
    }
    dfs(1);

    if(bad) cout << -1 << '\n';
    else {

//        for(int i = 1; i <= n; ++i) {
//            ll f = getsum(i);
//            assert(l[i] <= f && f <= r[i]);
//        }

        ll res = 0;
        for(int i = 1; i <= n; ++i) res += ans[i] * a[i];
        cout << res << '\n';
        for(int i = 1; i <= n; ++i) {
            cout << ans[i] << ' ';
        }
        cout << '\n';
    }
}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

 */