#include <iostream>
#include <vector>
#include <set>
#include <tuple>

using namespace std;

void solve()
{
	int n;
	cin >> n;
	vector<pair<int, multiset<tuple<int, int, int> > > > g(n);
	vector<long long> sum(n, 0);
	for(int i = 1; i < n; i++){
		cin >> g[i].first;
		g[i].first--;
	}
	vector<int> c(n), l(n), r(n), d(n, 0);
	for(int i = 0; i < n; i++)
		cin >> c[i];
	for(int i = 0; i < n; i++){
		cin >> l[i] >> r[i];
		g[i].second.insert({c[i], r[i], i});
	}
	for(int i = n - 1; i >= 0; i--){
		while(!g[i].second.empty() && sum[i] < l[i]){
			auto [f, s, t] = *g[i].second.begin();
			g[i].second.erase(g[i].second.begin());
			if(s > l[i] - sum[i]){
				g[i].second.insert({f, s - (l[i] - sum[i]), t});
				d[t] += l[i] - sum[i];
				sum[i] += l[i] - sum[i];
			}
			else{
				d[t] += s;
				sum[i] += s;
			}
			//cout << 1;
		}
		if(i != 0){
			sum[g[i].first] += sum[i];
			while(!g[i].second.empty()){
				g[g[i].first].second.insert(*g[i].second.begin());
				g[i].second.erase(g[i].second.begin());
				//cout << 2;
			}
		}
	}
	long long ans = 0;
	for(int i = 0; i < n; i++){
		if(sum[i] < l[i] || sum[i] > r[i]){
			cout << -1 << endl;
			return ;
		}
		ans += d[i] * c[i];
	}
	cout << ans << endl;
	for(int i = 0; i < n - 1; i++)
		cout << d[i] << " ";
	cout << d[n - 1] << endl;
}

int main()
{
    int t;
    cin >> t;
    while(t-- > 0)
		solve();
    return 0;
}
