#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

vector<vector<int>> g;
vector<int> mn;
vector<multiset<pair<int, int>>> dp;
vector<int> l, r;
vector<int> c;
vector<int> cnt;

int ans = 0;

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
        mn[v] = min(mn[v], mn[u]);
    }
    ans += mn[v] * l[v];
}

void solve() {
    int n;
    cin >> n;
    ans = 0;
    g.assign(n + 1, {});
    mn.assign(n + 1, INF);
    l.assign(n + 1, 0);
    r.assign(n + 1, 0);
    c.assign(n + 1, 0);
    cnt.assign(n + 1, 0);
    for (int u = 2; u <= n; u++) {
        int v;
        cin >> v;
        g[v].pb(u);
    }
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    dfs(1);
    cout << ans << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt;
    cin >> tt;
    while (tt--)
        solve();
}
