#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long

using namespace std;
template <typename T>
using oset = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
using ll = long long;

constexpr int MAXN = 100005;
int p[MAXN], l[MAXN], r[MAXN], c[MAXN], b[MAXN];
ll sumb[MAXN];

struct Comp {
    bool operator()(const int &a, const int &b) const {
        if (c[a] == c[b]) {
            return a < b;
        }
        return c[a] < c[b];
    }
};

int kekref[MAXN];
set<int, Comp> kekbuf[MAXN];
int kekbufr = 0;

void allocset(int v) {
    kekref[v] = kekbufr++;
}

vector<int> graph[MAXN];
int par[MAXN];

int n;

bool dfs(int v) {
    if (graph[v].empty()) {
        allocset(v);
        b[v] = l[v];
        if (l[v] != r[v]) {
            kekbuf[kekref[v]].insert(v);
        }
        sumb[v] = l[v];
        return true;
    }
    for (int ch : graph[v]) {
        if (!dfs(ch)) {
            return false;
        }
        sumb[v] += sumb[ch];
    }
    if (sumb[v] > r[v]) {
        return false;
    }
    int maxset = kekref[graph[v][0]];
    for (int ch : graph[v]) {
        if (kekbuf[kekref[ch]].size() > kekbuf[maxset].size()) {
            maxset = kekref[ch];
        }
    }
    kekref[v] = maxset;
    for (int ch : graph[v]) {
        if (kekref[ch] == maxset) {
            continue;
        }
        for (int u : kekbuf[kekref[ch]]) {
            kekbuf[maxset].insert(u);
        }
    }
    if (r[v] != 0) {
        kekbuf[maxset].insert(v);
    }
    ll to = l[v] - sumb[v];
    while (to > 0) {
        auto fr = kekbuf[maxset].begin();
        int val = *fr;
        // en kub))))
        if (n > 5000) {
            // mi mozhem togda ofc))))))
            b[val] += to;
            break;
        }
        else {
            // togda podnimemsa
            ll mn = min(to, r[val] - sumb[val]);
            int w = val;
            while (w != v) {
                w = par[w];
                mn = min(mn, r[w] - sumb[w]);
            }
            to -= mn;
            w = val;
            sumb[w] += mn;
            b[val] += mn;
            while (w != v) {
                w = par[w];
                sumb[w] += mn;
            }
            if (mn != to) {
                kekbuf[maxset].erase(val);
            }
        }
    }
    return true;
}

int32_t main() {
    int t, offset = 0;
    cin >> t;
    while (t --> 0) {
        cin >> n;
        for (int i = offset + 1; i < n + offset; ++i) {
            cin >> par[i];
            par[i] += offset - 1;
            graph[par[i]].push_back(i);
        }
        for (int i = offset; i < n + offset; ++i) {
            cin >> c[i];
        }
        for (int i = offset; i < n + offset; ++i) {
            cin >> l[i] >> r[i];
        }
        if (!dfs(offset)) {
            cout << "-1\n";
            offset += n;
            continue;
        }
        ll rr = 0;
        for (int i = offset; i < n + offset; ++i) {
            rr += c[i] * 1ll * b[i];
        }
        cout << rr << '\n';
        for (int i = offset; i < n + offset; ++i) {
            cout << b[i] << ' ';
        }
        cout << '\n';
        offset += n;
    }
    return 0;
}
