#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

const int64 INF = (int64)1e18 + 2;

int64 toint(pair <int64, int64> p) {
	return p.first * (p.first + 1) / 2 + p.second;
}

vector <vector <int64>> g;
vector <pair <int64, int64>> t;
int64 curt = -1;
void tdfs(int64 v) {
	t[v].first = ++curt;
	for (auto u : g[v]) {
		tdfs(u);
	}
	t[v].second = ++curt;
}

void solve() {
	int n; cin >> n;
	int k = n;
	int pra = 0;
	bool flag = true;
	for (int i = 0; i < n; ++i) {
		int a; cin >> a;
		if (pra + 1 != a) {
			if (flag) k = i;
			flag = false;
		}
		pra = a;
	}

	int q; cin >> q;
	while (q--) {
		pair <int64, int64> a, b;
		cin >> a.first >> a.second >> b.first >> b.second;

		if (b.first - b.second < a.first - a.second) swap(a, b);
		
		if (b.first - b.second <= k) {
			if (a.first - a.second == b.first - b.second) {
				if (b.first < a.first) swap(a, b);
				cout << a.first << ' ' << a.second << '\n';
			}
			else {
				if (b.first - b.second < a.first - a.second) swap(a, b);
				cout << a.first - a.second << ' ' << 0 << '\n';
			}
		}
		else if (a.first - a.second <= k) {
			b.first = b.second + k;
			if (a.first - a.second == b.first - b.second) {
				if (b.first < a.first) swap(a, b);
				cout << a.first << ' ' << a.second << '\n';
			}
			else {
				if (b.first - b.second < a.first - a.second) swap(a, b);
				cout << a.first - a.second << ' ' << 0 << '\n';
			}
		}
		else {
			if (a.second == b.second) {
				if (b.first < a.first) swap(a, b);
				cout << a.first << ' ' << a.second << '\n';
			}
			else {
				a.first = a.second + k;
				b.first = b.second + k;
				if (a.first - a.second == b.first - b.second) {
					if (b.first < a.first) swap(a, b);
					cout << a.first << ' ' << a.second << '\n';
				}
				else {
					if (b.first - b.second < a.first - a.second) swap(a, b);
					cout << a.first - a.second << ' ' << 0 << '\n';
				}
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int q = 1; //cin >> q;
	while (q--) {
		solve();
		cout << "\n\n";
	}
}