#include <iostream>
#include <bits/stdc++.h>
using namespace std;
//define int long long
#define ll long long
#define pb push_back
#define pii pair<int, int>
struct info{
    ll c;
    int num;
    int pred;
    ll left;
    ll l, r;
    ll min_to_validate;
    ll bought_in_subtree;
    ll sold = 0;
};
int n;
vector <info> a;
vector <vector <int>> to;
vector <vector <int>> in_subtree;
bool comp(int u, int v){
    return a[u].c < a[v].c;
}
bool dfs (int v){
    in_subtree[v].pb(v);
    for (int i: to[v]) {
        if (!dfs(i)) return 0;
        a[v].bought_in_subtree += a[i].bought_in_subtree;
        a[v].min_to_validate += a[i].min_to_validate;
        for (auto j: in_subtree[i]) in_subtree[v].pb(j);
    }
    if (a[v].bought_in_subtree > a[v].r) return 0;
    ll to_buy = a[v].l - a[v].bought_in_subtree;
    sort(in_subtree[v].begin(), in_subtree[v].end(), comp);
    for (auto i: in_subtree[v]){
        if (to_buy <= 0) break;
        ll can_give = 1e18;
        int u = i;
        while (u != v){
            can_give = min(can_give, a[u].r - a[u].bought_in_subtree);
            if (can_give == 0) break;
            u = a[u].pred;
        }
        can_give = min(can_give, to_buy);
        if (can_give == 0) continue;
        to_buy -= can_give;
        a[v].min_to_validate += can_give * a[i].c;
        a[i].sold += can_give;
        u = i;
        while (u != v){
            a[u].bought_in_subtree += can_give;
            u = a[u].pred;
        }
        a[v].bought_in_subtree += can_give;
    }
    if (to_buy > 0) return 0;
    else return 1;
}

void solve(){
    cin >> n;
    in_subtree.clear();
    in_subtree.assign(n + 1, vector <int> ());
    a.assign(n + 1, {0, 0, 0, 0, 0, 0, 0, 0});
    to.clear();
    to.assign(n + 1, vector <int> ());
    for (int i = 2; i <= n; i++){
        int p; cin >> p;
        a[i].pred = p;
        to[p].pb(i);
    }
    for (int i = 1; i <= n; i++){
        cin >> a[i].c;
    }
    for (int i = 1; i <= n; i++){
        cin >> a[i].l >> a[i].r;
    }
    if (!dfs(1)){
        cout << -1 << '\n';
    }
    else{
        cout << a[1].min_to_validate << '\n';
        for (int i = 1; i <= n; i++) cout << a[i].sold << ' ';
        cout << '\n';
    }

}
signed main() {
    int t; cin >> t;
    while (t--) solve();

    return 0;
}