#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define endl '\n'
#define all(a) (a).begin(), (a).end()
#define ss second
#define ff first

const int INF = 1e9, mod = 1e9 + 7, maxn = 10000000;

set<int> g[maxn];
int t[maxn];
int h[maxn];
int ps[maxn];
pair<int, int> tree[maxn * 4];
pair<int, int> pos1[maxn];
vector<int> d;
map<pair<int, int>, int> pos;

void dfs(int v, int p, int ds) {
    h[v] = ds;
    d.push_back(v);
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v, ds + 1);
            d.push_back(v);
        }
    }

}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        if (l < d.size()) tree[v] = {h[d[l]], d[l]};
        else tree[v] = {INF, 0};
        return;
    }
    int m = (r + l) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return {INF, 0};
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    int m = (r + l) / 2;
    return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n;
    cin >> n;
    int tp = 0;

    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < i + 1; ++j) {
            pos[{i, j}] = tp;
            pos1[tp] = {i, j};
            tp++;
        }
    }
    for (int i = 1; i < n + 1; ++i) {
        int x = pos[{i - 1, i - 1}];
        int y = pos[{i, i}];
        g[x].insert(y);
        g[y].insert(x);
    }

    for (int j = 0; j < n; ++j) {
        int pp;
        cin >> pp;
        pp--;
        t[pp] = 1;
        int x = 0, y = 0;
        for (int i = 0; i < n; ++i) {

            int x1 = x;
            int y1 = y;
            if (t[i] == 1) {
                x++;
            } else {
                x++;
                y++;
            }
            int tx = pos[{x1, y1}];
            int ty = pos[{x, y}];
            g[tx].insert(ty);
            g[ty].insert(tx);
        }
    }
    dfs(0, -1, 0);

    for (int i = 0; i < d.size(); ++i) {
        ps[d[i]] = i;
    }
    build(0, 0, d.size());

    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int tx = pos[{x1, y1}];
        int ty = pos[{x2, y2}];
        int ll = ps[tx];
        int rr = ps[ty];
        if (rr < ll) swap(rr, ll);
        int ans = get(0, 0, d.size(), ll, rr + 1).ss;
        cout << pos1[ans].ff << " " << pos1[ans].ss << endl;
    }
}
