#include <bits/stdc++.h>
#define int long long
//#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el << " ";
    return out;
}

int n;
int get_v(pair <int, int> p) {
    return p.second * (n + 1) + p.first;
}

pair <int, int> get_p(int v) {
    return {v % (n + 1), v / (n + 1)};
}

vector <int> par;
void build_edjes(vector<int> now) {
    pair <int, int> v = {0, 0};
    for (int i = 0; i < now.size(); i++) {
        pair <int, int> u = {v.first + (now[i] == 0), v.second + (now[i] == 1)};
        par[get_v(u)] = get_v(v);
//        cout << v.first << " " << v.second << " -> " << u.first << " " << u.second << endl;
        v = u;

    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    par.resize((n + 1) * (n + 1), -1);
    vector <int> a(n);
    cin >> a;
    for (int i = 0; i < n; i++) a[i]--;

    vector <int> now(n);
    build_edjes(now);
    for (auto x: a) {
        now[x] = 1;
        build_edjes(now);
    }

    for (int i = 0; i < par.size(); i++) {
        if (par[i] == -1) continue;
//        cout << get_p(i).first << " " << get_p(i).second << " ** ";
//        cout << get_p(par[i]).first << " " << get_p(par[i]).second << endl;
    }

    int q;
    cin >> q;
    while(q--) {
        pair <int, int> u, v;
        pair <int, int> now;
        cin >> now.first >> now.second;
        v = {now.second, now.first - now.second};
        cin >> now.first >> now.second;
        u = {now.second, now.first - now.second};

//        cout << v.first << " " << v.second << " & " << u.first << " " << u.second << endl;
        set <int> st;
        for (int x = get_v(v); x != -1; x = par[x]) {
            st.insert(x);
//            cout << "in " << get_p(x).first << " " << get_p(x).second << endl;
        }
        pair <int, int> best = {0, 0};
        for (int x = get_v(u); x != -1; x = par[x]) {
            if (st.find(x) != st.end()) {
                now = get_p(x);
                if (now.first + now.second > best.first + best.second) {
                    best = now;
                }
            }
        }
//        cout << "gg " << best.first << " " << best.second << endl;
        cout << best.first + best.second << " " << best.first << endl;
    }
}

