#include <iostream>
#include <vector>
#include<algorithm>
#include <set>
using namespace std;
#define ll long long
vector<vector<int>> g;
int n;
vector<ll> c, l, r;
bool fl=1;
struct ADD {
    ll c, x, id;

    ADD(ll c, ll x, ll id) : c(c), x(x), id(id) {}

    bool operator<(const ADD &ad) const {
        if (c != ad.c)
            return c < ad.c;
        if (x != ad.x)
            return x < ad.x;
            return id < ad.id;

    }
};
vector<ll> ans;
void mergev(set<ADD> & a, set<ADD> &  b) {

    if(a.size() < b.size())
        a.swap(b);
    while (!b.empty()) {
        auto sa = *b.begin();
        b.erase(sa);
        a.insert(sa);
    }
}
vector<set<ADD>> add;
void norm(set<ADD> &  ag, ll dx)
{
    set<ADD> add1;
    while(dx && !ag.empty())
    {
        auto u = *ag.begin();
        ag.erase(u);
        if(dx>=u.x)
        {
            dx-=u.x;
            add1.insert(u);
        }
        else
        {

            u.x = dx;
            add1.insert(u);
            dx=0;
            break;
        }
    }

    ag.swap(add1);
}
ll dfs(int v, int pr=-1) {
    ll sl = 0;

    for (auto to: g[v]) {
        if (to == pr)
            continue;
        sl += dfs(to, v);
    }
    if (sl > r[v]) {
        fl = 0;
        return 0;
    }
    add[v].insert(ADD(c[v], r[v] - sl, v));
    for (auto to: g[v]) {
        if (to == pr)
            continue;
        mergev(add[v], add[to]);
    }
    while (!add[v].empty() && sl < l[v]) {
        auto u = *add[v].begin();
        add[v].erase(u);
        int d = min(l[v] - sl, u.x);
        if (d >= u.x) {
            ans[u.id] += d;
            sl += d;
        } else {
            ans[u.id] += d;
            u.x -= d;
            add[v].insert(u);
            sl += d;
        }
    }
    if (sl < l[v]) {
        fl = 0;
        return 0;
    }
    norm(add[v], r[v] - sl);
    return sl;
}

void solve()
{
    cin>>n;
    g.clear();
    g.resize(n);
    c.clear();
    c.resize(n);
    l.clear();
    r.clear();
    l.resize(n);
    r.resize(n);
    for(int i=1;i<n;++i)
    {
        int p;
        cin>>p;
        p--;
        g[p].push_back(i);
    }
    for(int i=0;i<n;++i)
    {
        cin>>c[i];
    }
    for(int i=0;i<n;++i) {
        cin >> l[i] >> r[i];
    }
    fl=1;
    ans.clear();
    ans.resize(n);
    add.clear();
    add.resize(n);
    dfs(0);
    if(fl==0)
    {
        cout<<-1<<'\n';
        return;
    }
    ll res=0;
    for(int i=0;i<n;++i)
    {
        res+=ans[i]*c[i];
    }
    cout<<res<<'\n';
    for(int i=0;i<n;++i)
    {
        cout<<ans[i]<<' ';
    }
    cout<<'\n';
}
int main() {
    int Q;
    cin>>Q;
    while(Q--)
    {
        solve();
    }
    return 0;
}