#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include<algorithm>
#include <set>
using namespace std;
#define ll long long
#define int long long
vector<vector<int>> g;
int n;
vector<ll> c, l, r;
bool fl=1;
struct ADD {
    ll c, x, id;

    ADD(ll c, ll x, ll id) : c(c), x(x), id(id) {}

    bool operator<(const ADD &a) const {
        return c < a.c;
    }
};
vector<ll> ans;
void mergev(set<ADD> & a, set<ADD>  & b) {
    if(a.size()<b.size())
        a.swap(b);

    while(!b.empty()) {
        a.insert(*(b.begin()));
        b.erase(*b.begin());
    }
}
vector<set<ADD>> add;
void norm(set<ADD> & add, ll & ss1,  ll dx)
{
    while(!add.empty() && ss1>dx)
    {
        auto u=*add.rbegin();
        add.erase(u);
        ll d = min(ss1-dx, u.x);
        if(d==u.x)
        {
            ss1-=d;
            continue;
        }
        else
        {
            ss1=dx;
            u.x-=d;
            add.insert(u);
            break;
        }
    }
}
vector<ll> ss;
ll dfs(int v, int pr=-1) {
    ll sl = 0;

    for (auto to: g[v]) {
        if (to == pr)
            continue;
        sl += dfs(to, v);
        ss[v] += ss[to];
    }
    if (sl > r[v]) {
        fl = 0;
        return 0;
    }
    add[v].insert(ADD(c[v], r[v] - sl, v));
    ss[v] += r[v] - sl;
    for (auto to: g[v]) {
        if (to == pr)
            continue;
        mergev(add[v], add[to]);
    }

    while (!add[v].empty() && sl < l[v]) {
        int d = min(l[v] - sl, add[v].begin()->x);
        if (d == add[v].begin()->x) {
            ans[add[v].begin()->id] += d;
            add[v].erase(*add[v].begin());
            sl += d;
            ss[v] -= d;
        } else {
            ans[add[v].begin()->id] += d;
            auto ut = *add[v].begin();
            add[v].erase(ut);
            ut.x -= d;
            add[v].insert(ut);
            sl += d;
            ss[v] -= d;
        }
    }
    if (sl < l[v]) {
        fl = 0;
        return 0;
    }
    //norm(add[v], ss[v], r[v] - sl);
    return sl;
}

void solve()
{
    cin>>n;
    g.clear();
    g.resize(n);
    c.clear();
    c.resize(n);
    l.clear();
    r.clear();
    ss.clear();
    ss.resize(n);
    l.resize(n);
    r.resize(n);
    for(int i=1;i<n;++i)
    {
        int p;
        cin>>p;
        p--;
        g[p].push_back(i);
    }
    for(int i=0;i<n;++i)
    {
        cin>>c[i];
    }
    for(int i=0;i<n;++i) {
        cin >> l[i] >> r[i];
    }
    fl=1;
    ans.clear();
    ans.resize(n);
    add.clear();
    add.resize(n);
    dfs(0);
    if(fl==0)
    {
        cout<<-1<<'\n';
        return;
    }
    ll res=0;
    for(int i=0;i<n;++i)
    {
        res+=ans[i]*c[i];
    }
    cout<<res<<'\n';
    for(int i=0;i<n;++i)
    {
        cout<<ans[i]<<' ';
    }
    cout<<'\n';
}
signed main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int Q;
    cin>>Q;
    while(Q--)
    {
        solve();
    }
    return 0;
}