#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include<algorithm>
#include <set>
#include <cassert>
using namespace std;
#define ll long long
int n;
vector<int> nxt;
vector<int> a;
const int N = 6005;
int tin[N][N], tout[N][N];
int timer = 0;
bool is_anc(int r1, int c1, int r2, int c2) {
    return tin[r1][c1] <= tin[r2][c2] && tout[r1][c1] >= tout[r2][c2];
}
bool g[N][N][2];
bool used[N][N];
int pred[N][N];
void dfs(int r, int c) {
    if (r == n)
        return;
    int c1 = nxt[r];
    g[r][c][c1] = 1;
    dfs(r + 1, c + c1);
}
void dfs1(int r, int c) {
    tin[r][c] = timer++;

    for (int dx = 0; dx <= 1; ++dx) {
        if (g[r][c][dx] == 1) {
            pred[r+1][c + dx] = c;
            dfs1(r + 1, c + dx);
        }
    }
    tout[r][c] = timer++;
}
int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);

    cin >> n;
    a.resize(n);
    nxt.resize(n, 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n + 1; ++i)
    {
        dfs(0, 0);
        if(i<n)
            nxt[a[i]] = 0;
    }
    int N = (n + 1) * (n + 2) / 2;
    dfs1(0, 0);
    int q;
    cin >> q;
    while (q--)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 > r2)
            swap(r1, r2), swap(c1, c2);
        while (!is_anc(r1, c1, r2, c2))
        {
            c1 = pred[r1][c1];
            r1--;
        }
        cout << r1 << ' ' << c1 << '\n';
    }
    return 0;
}
