#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 4000;

int n, q;
int changes[Base];
string moves[Base];
//pair<int, int> breakPoints[Base];

int getMove(int x, int y)
{
	if (x - y == 0)
	{
		return 0;
	}
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (changes[i] <= x)
		{
			cnt++;
			if (cnt == x - y)
			{
				return i + 1;
			}
		}
	}

	exit(-1);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	moves[0] = "";
	for (int i = 0; i < n; i++)
	{
		moves[0] += "1";
	}
	//breakPoints[0] = make_pair(0, 0);
	for (int i = 0; i < n; i++)
	{
		cin >> changes[i];
		moves[i + 1] = moves[i];
		moves[i + 1][changes[i] - 1] = '0';
		/*int cnt = 0;
		for (int j = 0; j < i; j++)
		{
			if (changes[j] < changes[i])
			{
				cnt++;
			}
		}
		breakPoints[i + 1] = make_pair(changes[i] - 1, changes[i] - 1 - cnt);*/
	}

	cin >> q;
	while (q--)
	{
		int a1, b1, a2, b2;
		cin >> a1 >> b1 >> a2 >> b2;

		int m1 = getMove(a1, b1);
		int m2 = getMove(a2, b2);

		int x = 0, y = 0;
		if (m1 != m2)
		{
			int id = 0;
			while (moves[m1][id] == moves[m2][id])
			{
				x++;
				y += moves[m1][id] - '0';
				id++;
			}
		}
		else
		{
			x = min(a1, a2);
			y = min(b1, b2);
		}

		cout << x << ' ' << y << endl;
	}

	return 0;
}