#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> ans(n, vector<int>(n, 0));
    for(int i = 0; i < n; ++i) {
        a[i] -= 1;
        for(int j = i + 1; j < n; ++j) {
            ans[i][j] = j - i;
        }
    }

    vector<pair<int, int>> pref(n), suf(n);

    for(int i = 0; i < n; ++i) {
        int cntmin = 0, cntmax = 0;
        for(int j = 0; j < i; ++j) {
            if(a[j] < a[i]){
                cntmin += 1;
            }else{
                cntmax += 1;
            }
        }
        pref[i] = {cntmin, cntmax};
        cntmin = 0; cntmax = 0;
        for(int j = i + 1; j < n; ++j) {
            if(a[j] < a[i]){
                cntmin += 1;
            }else{
                cntmax += 1;
            }
        }
        suf[i] = {cntmin, cntmax};
    }

    ll t = 0;
    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j) {
            int k = max({j - i + pref[i].second, abs(a[j] - a[i]), j - i + suf[j].first});
            //cout << i << ' ' << j << ' ' << k << '\n';
            t += (ll)k;
        }
    }
    cout << t;

    return 0;
}
