#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

#define fi first
#define se second

struct s1{
    ll fi;
    int se, vert;
    s1(ll a, int b, int c): fi(a), se(b), vert(c) {};
};

struct res{
    bool success;
    ll minc;
    vector<s1> c;
    res(bool success, ll minc, vector<s1> c): success(success), minc(minc), c(c) {};
};

vector<int> p;
vector<int> c;
vector<pair<int, int>> a;

vector<vector<int>> ch;

vector<int> cnt;

vector<s1> mrg(vector<s1> &a, vector<s1> &b) {
    vector<s1> ans;
    int p1 = 0, p2 = 0;
    while(p1 < a.size() || p2 < b.size()) {
        if(p1 == a.size()) {
            ans.push_back(b[p2]);
            p2 ++;
            continue;
        }
        if(p2 == b.size()) {
            ans.push_back(a[p1]);
            p1 ++;
            continue;
        }
        //cout << "LALALALA\n";
        //cout << a[p1].fi << ' ' << a[p2].se << '\n';
        if(a[p1].fi > b[p2].fi) {
            ans.push_back(a[p1]);
            p1 ++;
        }else{
            ans.push_back(b[p2]);
            p2 ++;
        }
    }
    return ans;
}

res solve(int v) {
    if(ch[v].empty()) {
        ll minc = ((ll)a[v].fi)*((ll)c[v]);
        cnt[v] = a[v].fi;
        return res(true, minc, {s1(c[v], (a[v].se - a[v].fi), v)});
    }
    ll mn = 0;
    for(auto u: ch[v]) {
        mn += a[u].fi;
    }
    if(mn > a[v].se) return res(false, 0, {});



    vector<s1> all = {};
    ll minc = 0;
    for(auto u: ch[v]) {
        res r = solve(u);
        if(!r.success) return res(false, 0, {});
        minc += r.minc;
        //cout << "U: " << u << '\n';
        //cout << "MINC: " << ' ' << r.minc << '\n';
        //for(auto x: r.c) cout << "(" << x.fi << ' ' << x.se << ") ";
        //cout << '\n';
        all = mrg(all, r.c);
    }
    mn = 0;
    for(auto u: ch[v]) {
        mn += a[u].fi;
    }
    if(mn > a[v].se) return res(false, 0, {});
    //cout << "ALL: ";
    //for(auto x: all) cout << "(" << x.fi << ' ' << x.se << ") ";
    //cout << '\n';
    //cout << "V: " << ' ' << v << ' ' << "MN: " << mn << '\n';
    if(mn < a[v].fi) {
        int rem = a[v].fi - mn;
        //cout << "REM: " << rem << '\n';
        while(rem > 0) {
            if(all.size() == 0 || all[all.size() - 1].fi > c[v]) {
                minc += ((ll)c[v])*((ll)rem);
                cnt[v] += rem;
                rem = 0;
                break;
            }
            if(all[all.size() - 1].se > rem) {
                minc += all[all.size() - 1].fi*rem;
                all[all.size() - 1].se -= rem;
                cnt[all[all.size() - 1].vert] += rem;
                rem = 0;
                //cout << "a\n";
            }else{
                minc += all[all.size() - 1].fi*((ll)all[all.size() - 1].se);
                rem -= all[all.size() - 1].se;
                cnt[all[all.size() - 1].vert] += all[all.size() - 1].se;
                all.pop_back();
                //cout << "b\n";
            }
        }
        mn = a[v].fi;
    }else{
        a[v].fi = mn;
    }

    vector<s1> st = {s1(-c[v], a[v].se - mn, v)};

    return res(true, minc, mrg(all, st));

}

int main() {
    //cin.tie(); cout.tie(); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int q = 0; q < t; ++q) {
        int n;
        cin >> n;
        p.resize(n);
        ch.resize(n);
        for(int i = 0; i < n; ++i) ch[i] = {};
        for(int i = 1; i < n; ++i) {
            cin >> p[i];
            p[i]--;
            ch[p[i]].push_back(i);
        }
        c.resize(n);
        a.resize(n);
        for(int i = 0; i < n; ++i) cin >> c[i];
        for(int i = 0; i < n; ++i) cin >> a[i].fi >> a[i].se;
        cnt.resize(n);
        for(int i = 0; i < n; ++i) cnt[i] = 0;
        res r = solve(0);
        if(r.success) {
            cout << r.minc << '\n';
            for(auto x: cnt) cout << x << ' ';
            cout << '\n';
        }else{
            cout << -1 << '\n';
        }
    }

    return 0;
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

1
4
1 2 2
5 4 1 3
2 2
1 3
1 1
2 2

1
3
1 2

 */