#include<bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define forn(i, n) for (int i = 0; i < n; i++)
#define ld long double
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()

int k;

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pii> a(n);
    forn (i, n) {
        cin >> a[i].fi >> a[i].se;
    }
    sort(all(a), [&] (pii x, pii y) {
        if (x.se != y.se) return x.se < y.se;
    });
    int ans = 0, tmp = 0;
    function<void(int, int, int)> dfs = [&] (int i, int l, int r) {
        //cout << i << " " << l << " " << r << " " << tmp << endl;
        ans = max(ans, tmp);
        if (i == n) {
            return;
        }
        int x = a[i].fi;
        if (x <= l || x >= r) {
            ans = max(ans, tmp + (h - a[i].se) * (r - l));
            return;
        }
        tmp += (h - a[i].se) * (r - x);
        dfs(i + 1, l, x);
        tmp -= (h - a[i].se) * (r - x);
        tmp += (h - a[i].se) * (x - l);
        dfs(i + 1, x, r);
        tmp -= (h - a[i].se) * (x - l);
    };
    dfs(0, 0, w);
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> k;
    forn (i, k) cin >> t;
    cin >> t;
    while (t--) {
        solve();
    }
}
