#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;


vector<vector<int>> g;
vector<int> depth;
vector<int> par;
int n;

int cell(int r, int c) {
    return r * (n + 1) + c;
}

void dfs(int v, int p, int d) {
    par[v] = p;
    depth[v] = d;
    for (int u : g[v]) {
        dfs(u, v, d + 1);
    }
}

int depth_min(int v, int u) {
    return (depth[v] < depth[u] ? v : u);
}

int lca(int v, int u) {
    if (depth[v] < depth[u])
        swap(v, u);
    while (depth[v] > depth[u])
        v = par[v];
    while (v != u) {
        v = par[v];
        u = par[u];
    }
    return v;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }

    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 > r2) {
            swap(r1, r2);
            swap(c1, c2);
        }
        int r3, c3;
        if (r2 - r1 == c2 - c1) {
            r3 = r1, c3 = c1;
        } else {
            int i = r1 - c1;
            int j = r2 - c2;
            r3 = min(i, j);
            c3 = 0;
        }
        cout << r3 << " " << c3 << "\n";
    }

//    for (int v = 0; v < ssize(g); ++v) {
//        int vr = v / (n + 1);
//        int vc = v % (n + 1);
//        for (int u : g[v]) {
//            int ur = u / (n + 1);
//            int uc = u % (n + 1);
//            cout << vr << " " << vc << " " << ur << " " << uc << "\n";
//        }
//    }




    return 0;
}
