#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

const int INF = (int) 2e9;
const int N = 100500;
int x[N];
int y[N];
vector<pair<int, int>> pts;
int n, w, h;

void solve() {
  cin >> n >> w >> h;
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  pts = {};
  for (int i = 0; i < n; i++) {
    pts.pb({x[i], y[i]});
  }
  int ans = 0;
  sort(all(pts));

  for (int i = 0; i < n; i++) {
    x[i] = pts[i].first;
    y[i] = pts[i].second;
  }

  int sus = 0;
  int l = 0, r = n, lf = 0;

  while (r > l) {

    int mny = h, indy = 0, mny2 = h, indy2 = 0;
    for (int i = l; i < r; i++) {
      if (y[i] < h) {
        if (mny2 > y[i]) {
          mny2 = y[i];
          indy2 = i;
        }
        if (mny > mny2) {
          swap(mny, mny2);
          swap(indy, indy2);
        }
      }
    }
    if (mny == mny2) {
      ans = max(ans, sus + (h - mny) * (w - lf));
      break;
    }

    if (mny2 == h) {
      ans = max(ans, sus + (h - mny) * max(x[indy] - lf, w - x[indy]));
      break;
    }

    if (indy2 > indy) {
      ans = max(ans, sus + (w - lf) * (h - mny) - (x[indy] - lf) * (mny2 - mny));
      int mnyy = h;
      for (int j = l; j < indy - 1; j++) {
        mnyy = min(mnyy, y[j]);
      }
      sus += (h - mnyy) * (w - x[indy]);
      sus += (x[indy] - lf) * (h - mny);
      h = mnyy;
      l = indy + 1;
      lf = x[indy];
    } else {
      ans = max(ans, sus + (w - lf) * (h - mny) - (w - x[indy]) * (mny2 - mny));
      int mnyy = h;
      for (int j = indy + 1; j < r; j++) {
        mnyy = min(mnyy, y[j]);
      }
      sus += (h - mnyy) * (x[indy] - lf);
      sus += (w - x[indy]) * (h - mny);
      h = mnyy;
      w = x[indy];
      r = indy;
    }
  }

  cout << ans << '\n';

}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int k;
  cin >> k;
  vector<int> gd(k);
  for (int i = 0; i < k; i++) {
    cin >> gd[i];
  }
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}