#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

#define long long long int

struct p {
    long f, s;
    int num;

    p(long _f, long _s, int _num) : f(_f), s(_s), num(_num) { }

    p() { }
};

bool less_p(const p a, const p b) {
    return a.f < b.f;
}

bool greater_p(const p a, const p b) {
    return a.f > b.f;
}

vector<vector<int>> a;
vector<long> c, l, r, s;

vector<long> ans;
vector<long> ans_for_s;

bool flag;

vector<p> dfs(int v, int pre) {
    if (flag) return vector<p>();
    vector<vector<p>> deq;
    long cnt = 0;
    long sans = 0;
    for (auto to : a[v]) {
        if (to != pre) {
                //cout << to << " from " << v << endl;
            deq.push_back(dfs(to, v));
            cnt += s[to];
            sans = ans[to];
        }
    }
    if (deq.empty()) {
        ans[v] = 1ll * l[v] * c[v];
        s[v] = l[v];
        ans_for_s[v] = s[v];
        return vector<p>{p(c[v], r[v] - l[v], v)};
    }
    else {
            //cout << cnt << endl;
        vector<p> res;
        vector<p> temp = {p(c[v], r[v], v)};
        deq.push_back(temp);
        for (auto i : deq) {
            vector<p> resc = res;
            res.resize(res.size() + i.size());
            merge(resc.begin(), resc.end(), i.begin(), i.end(), res.begin(), less_p);
        }
        //cout << "res for " << v << " ";
        //for (auto i : res) cout << "(" << i.f << ", " << i.s << ") ";
        //cout << endl;
        // long cnt_start = cnt;
        if (cnt > r[v]) {
            flag = true;
            return vector<p>();
        }
        else {
            if (cnt >= l[v]) {
                s[v] = cnt;
                ans[v] = sans;
            }
            else {
                while (cnt < l[v]) {
                        // cout << sans << endl;
                        //cout << "f " << cnt << endl;
                    if (res[0].s > (l[v] - cnt)) {
                        //cout << "case 1" << endl;
                        sans += res[0].f * (l[v] - cnt);
                        ans_for_s[res[0].num] += (l[v] - cnt);
                        res[0].s = res[0].s - (l[v] - cnt);
                        cnt = l[v];
                    }
                    else if (res[0].s == (l[v] - cnt)) {
                        sans += res[0].f * (l[v] - cnt);
                        ans_for_s[res[0].num] += (l[v] - cnt);
                        res.erase(res.begin());
                        cnt = l[v];
                    }
                    else {
                        sans += res[0].f;
                        cnt += res[0].s;
                        ans_for_s[res[0].num] += res[0].s;
                        res.erase(res.begin());
                    }
                }
                s[v] = cnt;
                ans[v] = sans;
                return res;
            }
        }
    }
}

void solve() {
    a.clear();
    c.clear();
    l.clear();
    r.clear();
    s.clear();
    ans.clear();
    ans_for_s.clear();
    flag = false;
    int n;
    cin >> n;
    a.resize(n);
    ans.resize(n, 0);
    ans_for_s.resize(n, 0);
    s.resize(n, 0);
    c.resize(n, 0); l.resize(n, 0); r.resize(n, 0);
    for (int i = 1;i < n;i++) {
        int cur;
        cin >> cur;
        a[i].push_back(cur - 1);
        a[cur - 1].push_back(i);
    }
    for (int i = 0;i < n;i++) cin >> c[i];
    for (int i = 0;i < n;i++) cin >> l[i] >> r[i];
    //
    dfs(0, 0);
    if (flag) cout << -1 << endl;
    else {
        long res = 0;
        for (int i = 0;i < n;i++) {
            res += 1ll * c[i] * ans_for_s[i];
        }
        cout << res << endl;
        for (auto i : ans_for_s) cout << i << " ";
        cout << endl;
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
}











