#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#pragma GCC-Optimize("0-fast")

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back

template<class T>
T upmin(T &a, T b){return a > b ? a = b, 1 : 0;}
template<class T>
T upmax(T &a, T b){return a < b ? a = b, 1 : 0;}

const int maxN = 1e5 + 1;

vector<int> graph[maxN];
pair<ll,ll> lr[maxN];
ll in[maxN], b[maxN], c[maxN];
set<pair<pair<ll,ll>,int>> can[maxN];// cost, count, id;
int ok = 0;

void upd(int n){
    ok  = 0;
    for(int i = 0;i<n;i++){
        graph[i].clear();
        in[i] = b[i] = c[i] = 0;
        can[i].clear();
    }
}




void dfs(int v){
    if(ok){
        return;
    }
    ll l = lr[v].first, r = lr[v].second;
    for(auto to : graph[v]){
        dfs(to);
        for(auto &i : can[to])
            can[v].insert(i);
        in[v] += in[to];
    }
    can[v].insert({{c[v], r}, v});
//    ll need = r - in[v];
//    set<pair<pair<pair<ll,ll>, int>, int>> st;
//    for(auto to : graph[v]){
//        st.insert({(*can[to].begin()), to});
//    }
//    while(need > 0 && !st.empty()){
//        auto now = *st.begin();
//        need -= now.first.first.second;
//        st.erase(now);
//        can[v].insert(now.first);
//        can[now.second].erase(now.first);
//        if(!can[now.second].empty()){
//            st.insert({*can[now.second].begin(), now.second});
//        }
//    }
    if(in[v] > r) {
        ok = 1;
        return;
    }
    while(in[v] < l){
        auto fst = *can[v].begin();
        can[v].erase(fst);
        ll add = min(l - in[v], fst.first.second);
        in[v] += add;
        fst.first.second -= add;
        b[fst.second] += add;
        if(fst.first.second > 0){
            can[v].insert(fst);
        }
    }
    ll cnt = r - in[v];
    ll sum_add = 0;
    for(auto &i : can[v]){
        sum_add += i.first.second;
    }
    if(cnt == 0){
        can[v].clear();
        return;
    }
    while(sum_add > cnt){
        auto last = *can[v].rbegin();
        can[v].erase(last);
        ll del = min(last.first.second, sum_add - cnt);
        last.first.second -= del;
        sum_add -= del;
        if(last.first.second > 0){
            can[v].insert(last);
        }
    }
}


void solve(){
    int n;
    cin>>n;
    upd(n);
    for(int i = 0;i<n-1;i++){
        int x;
        cin>>x;
        graph[x-1].pb(i+1);
    }
    for(int i = 0;i<n;i++)cin>>c[i];
    for(int i = 0;i<n;i++)cin>>lr[i].first>>lr[i].second;
    dfs(0);
    if(ok == 1){
        cout<<"-1\n";
        return;
    }
    ll ans = 0;
    for(int i = 0;i<n;i++) {
        ans += b[i] * c[i];
    }
    cout<<ans<<'\n';
    for(int i = 0;i<n;i++){
        cout<<b[i]<<' ';
    }
    cout<<'\n';
}

signed main() {
    ioss
    int t = 1;
    cin>>t;
    while(t--){
        solve();
    }
    return 0;
}