#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

vector<ll> vec;

vector<ll> getup(int r, int c) {
	vector<ll> vals;
	for (int i = 0; i < vec.size(); i++) {
		if (vals.size() == r - c) break;
		if (vec[i] <= r) {
			vals.push_back(vec[i] - 1);
		}
	}

	return vals;
}

int main() {
	fastInp;

	ll n;
	cin >> n;
	vec.resize(n);

	for (auto& c : vec) cin >> c;

	ll t = n;
	for (int i = 0; i < vec.size(); i++) {
		if (i != vec[i] - 1) {
			t = i;
			break;
		}
	}
	ll q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		ll r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		if (r1 == r2 && c1 == c2) {
			cout << r1 << " " << c1 << endl;
			continue;
		}

		if (max(r1 - c1, r2 - c2) <= t) {
			if (r1 - c1 == r2 - c2) {
				pair<ll, ll> ans = min(make_pair(r1, c1), make_pair(r2, c2));
				cout << ans.first << " " << ans.second << endl;
			}
			else {
				cout << min(r1 - c1, r2 - c2) << " 0" << endl;
			}
		}
		else {
			if (min(r1 - c1, r2 - c2) < t) {
				ll mn = min(r1 - c1, r2 - c2);
				cout << mn << " 0\n";
				continue;
			}

			if (min(r1 - c1, r2 - c2) == t) {
				ll mn = min(r1 - c1, r2 - c2);
				cout << mn + min(c1, c2) << " " << min(c1, c2) << "\n";
				continue;
			}

			if (c1 == c2) {
				pair<ll, ll> ans = min(make_pair(r1, c1), make_pair(r2, c2));
				cout << ans.first << " " << ans.second << endl;
			}
			else {
				cout << t + min(c1, c2) << " " << min(c1, c2) << endl;
			}
		}

		continue;

		vector<ll> a = getup(r1, c1);
		vector<ll> b = getup(r2, c2);

		set<ll> a1, b1;
		for (auto c : a) a1.insert(c);
		for (auto c : b) b1.insert(c);

		ll cmn = 0;

		pair<ll, ll> ans = { 0, 0 };
		for (int i = 0; i < n; i++) {
			ll x = (b1.find(i) == b1.end());
			ll x2 = (a1.find(i) == a1.end());

			if (ans == make_pair(r1, c1) || ans == make_pair(r2, c2)) break;
			if (x == x2 && x == 0) { // found
				ans.first++;
			}
			else if (x == x2 && x == 1) { // not found
				ans.first++;
				ans.second++;
			}
			else {
				break;
			}
		}

		cout << ans.first << " " << ans.second << "\n";
	}

	return 0;
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
*/