#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#define int long long
using namespace std;

int d(int i, int j) {
	return abs(i - j);
}

signed main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	
	int n; cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector <vector <int>> d(n + 1, vector <int>(n + 1));
	for (int l = 0; l < n; l++) {
		for (int r = l + 1; r <= n; r++) {
			vector <int> b = a;
			sort(b.begin() + l, b.begin() + r);
			for (int i = 0; i < n; i++) {
				for (int j = i; j < n; j++) {
					int x = b[i];
					int y = b[j];
					d[x][y] = d[y][x] = max(d[x][y], j - i);
				}
			}
		}
	}

	int ans = 0;
	for (int x = 1; x <= n; x++) {
		for (int y = x + 1; y <= n; y++) {
			ans += d[x][y];
		}
	}
	cout << ans;

	return 0;
}