#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#define int long long
using namespace std;

void solve() {
	int n, X, Y; cin >> n >> X >> Y;
	vector <pair <int, int>> p(n);
	for (int i = 0; i < n; i++) {
		int x, y; cin >> x >> y;
		p[i] = { x, Y - y };
	}
	p.push_back({ 0, 0 });
	p.push_back({ X, 0 });
	int ans = 0;
	n += 2;
	int h = 0;
	for (int i = 1; i < n; i++) {
		ans += h * (p[i].first - p[i - 1].first);
		h = max(h, p[i].second);
	}
	cout << ans << '\n';
}

signed main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int k; cin >> k >> k;
	int tt = 1; cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}