#include <vector>
#include <ios>
#include <iostream>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <math.h>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;

#define all(x) ((x).begin()), ((x).end())
#define rall(x) ((x).rbegin()), ((x).rend())
#define nl '\n'

void solve_1() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> points;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		points.push_back({ x, y });
	}

	sort(all(points));

	ll answer = 0;

	int minH = h;
	for (auto pt : points)
	{
		if (pt.second >= minH) {
			continue;
		}

		answer += (ll)(w - pt.first) * (ll)(minH - pt.second);
		minH = pt.second;
	}

	cout << answer << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(16);

	int k;
	cin >> k;

	set<int> granted;
	for (int i = 0; i < k; i++)
	{
		int q;
		cin >> q;
		granted.insert(q);
	}
	int t;
	cin >> t;
	while (t--)
	{
		if (granted.size() == 1 && *granted.begin() == 1) {
			solve_1();
		}
	}
	

	return 0;
}