#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
const int N = 1e5 + 113;
vector<int> edges[N];
set<pii> opt[N];
ll price[N], cnt[N];
int l[N], r[N], c[N], sz[N], depth[N], tin[N], zzz = 1, nxt[N], anc[N], ans[N];
struct segtree{
    vector<int> mins, sumpush;
    int n;
    segtree(int sz) {
        n = sz;
        mins.resize(sz * 4 + 1), sumpush.resize(sz * 4 + 1);
    }
    void push(int v, int l, int r) {
        mins[v] += sumpush[v];
        if (l != r)
            sumpush[v * 2] += sumpush[v], sumpush[v * 2 + 1] += sumpush[v];
        sumpush[v] = 0;
    }
    void addval(int v, int l, int r, int l1, int r1, int val) {
        push(v, l, r);
        if (l > r1 || l1 > r)
            return;
        if (l1 <= l && r <= r1) {
            sumpush[v] += val;
            push(v, l, r);
            return;
        }
        addval(v * 2, l, (l + r) / 2, l1, r1, val), addval(v * 2 + 1, (l + r) / 2 + 1, r, l1, r1, val);
        mins[v] = min(mins[v * 2], mins[v * 2 + 1]);
    }
    int getmin(int v, int l, int r, int l1, int r1) {
        push(v, l, r);
        if (l > r1 || l1 > r)
            return 2e9;
        if (l1 <= l && r <= r1)
            return mins[v];
        return min(getmin(v * 2, l, (l + r) / 2, l1, r1), getmin(v * 2 + 1, (l + r) / 2 + 1, r, l1, r1));
    }
};
segtree t(0);
void calc_sz(int v) {
    sz[v] = 1;
    for (auto i : edges[v])
        anc[i] = v, depth[i] = depth[v] + 1, calc_sz(i), sz[v] += sz[i];
}
void dfs1(int v) {
    tin[v] = zzz++;
    for (int i = 1; i < edges[v].size(); i++) {
        if (sz[edges[v][i]] > sz[edges[v][0]])
            swap(edges[v][i], edges[v][0]);
    }
    if (!nxt[v])
        nxt[v] = v;
    if (edges[v].size())
        nxt[edges[v][0]] = nxt[v];
    for (auto i : edges[v])
        dfs1(i);
}
int getmin_path(int s, int e) {
    int res = 1e9;
    while (1) {
        if (depth[nxt[s]] <= depth[e])
            return min(res, t.getmin(1, 1, t.n, tin[e], tin[s]));
        res = min(res, t.getmin(1, 1, t.n, tin[nxt[s]], tin[s]));
        s = anc[nxt[s]];
    }
}
void addval_path(int s, int e, int vl) {
    while (1) {
        if (depth[nxt[s]] <= depth[e]) {
            t.addval(1, 1, t.n, tin[e], tin[s], vl);
            return;
        }
        t.addval(1, 1, t.n, tin[nxt[s]], tin[s], vl);
        s = anc[nxt[s]];
    }
}
bool brk = 0;
void dfs(int v) {
    for (auto i : edges[v])
        dfs(i);

    opt[v].insert({c[v], v});
    for (auto i : edges[v]) {
        cnt[v] += cnt[i];
        price[v] += price[i];
        if (opt[i].size() > opt[v].size())
            opt[i].swap(opt[v]);
        for (auto j : opt[i])
            opt[v].insert(j);
    }
    if (r[v] < cnt[v])
        brk = 1;
    if (brk)
        return;
    t.addval(1, 1, t.n, tin[v], tin[v], r[v] - cnt[v]);
    while (!opt[v].empty()) {
        if (cnt[v] >= l[v])
            break;
        int u = (*opt[v].begin()).second;
        int f = getmin_path(u, v);
        if (f <= l[v] - cnt[v]) {
            opt[v].erase(opt[v].begin());
            ans[u] += f;
            cnt[v]  += f;
            addval_path(u, v, -f);

            price[v] += ((ll)f)*c[u];
            continue;
        }
        f = l[v] - cnt[v];
        ans[u] += f;
        cnt[v] += f;
        addval_path(u, v, -f);
        price[v] += ((ll)f)*c[u];
    }
    if (cnt[v] < l[v])
        brk = 1;
}
void clear(int n) {
    brk = 0;
    zzz = 1;
    for (int i = 1; i <= n; i++)
        edges[i].clear(), depth[i] = 0, sz[i] = 0, price[i] = 0, cnt[i] = 0, opt[i].clear(), nxt[i] = 0, ans[i] = 0, anc[i] = 0;
}
void solve() {
    // brk почисть
    int n;
    cin >> n;
    clear(n);
    t = segtree(n);
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        edges[p].push_back(i);
    }
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    calc_sz(1);
    dfs1(1);
    dfs(1);
    if (brk) {
        cout << -1 << endl;
        return;
    }
    cout << price[1] << '\n';
    for (int i = 1; i <= n; i++)
        cout << ans[i] << " ";
    cout << '\n';
}
signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--)
        solve();
}