#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
const int N = 2e6 + 113;
mt19937 rng(228);
struct treap{
    int key, prior, sz;
    treap *lson, *rson;
    treap(int vl) {
        prior = (rng());
        key = vl;
        sz = 1;
        lson = (0), rson =(0);
    }
};
void recalc(treap *t) {
    t->sz = 1;
    if (t->lson)
        t->sz += t->lson->sz;
    if (t->rson)
        t->sz += t->rson->sz;
}
treap *merge(treap *l, treap *r) {
    if (!l)
        return r;
    if (!r)
        return l;
    if (l->prior > r->prior) {
        l->rson = merge(l->rson, r);
        recalc(l);
        return l;
    }
    r->lson = merge(l, r->lson);
    recalc(r);
    return r;
}
pair<treap*, treap*> split(treap *t, int need) {
    if (!t)
        return {t, t};
    int bruh = 1;
    if (t->lson)
        bruh += t->lson->sz;
    if (bruh > need) {
        auto a = split(t->lson, need);
        t->lson = a.second;
        recalc(t);
        return {a.first, t};
    }
    auto a = split(t->rson, need - bruh);
    t->rson = a.first;
    recalc(t);
    return {t, a.second};
}
int getleft(treap *t) {
    if (!t->lson)
        return t->key;
    return getleft(t->lson);
}
int getright(treap *t) {
    if (!t->rson)
        return t->key;
    return getright(t->rson);
}
struct segtree{
    vector<int> sumpush;
    segtree(int sz) {
        sumpush.resize(sz * 4 + 1);
    }
    void add(int v, int l, int r, int l1, int r1, int val) {
        if (l > r1 || l1 > r)
            return;
        if (l1 <= l && r <= r1) {
            sumpush[v] += val;
            return;
        }
        add(v * 2, l, (l + r) / 2, l1, r1, val), add(v * 2 + 1, (l + r) / 2 + 1, r, l1, r1, val);
    }
    int getval(int v, int l, int r, int pos) {
        if (l > pos || r < pos)
            return 0;
        if (l == r)
            return sumpush[v];
        return getval(v * 2, l, (l + r) / 2, pos) + getval(v * 2 + 1, (l + r) / 2 + 1, r, pos) + sumpush[v];
    }
};
int pos[N];
int n;
vector<int> anc[N];
int depth[N];
int get_lca(int a, int b) {
    if (depth[a] > depth[b])
        swap(a, b);
    for (int st = 21; st >= 0; st--) {
        if (anc[b].size() > st && depth[anc[b][st]] >= depth[a])
            b = anc[b][st];
    }
    if (a == b)
        return a;
    for (int st = 21; st >= 0; st--) {
        if (anc[b].size() > st && anc[b][st] != anc[a][st])
            a = anc[a][st], b = anc[b][st];
    }
    return anc[a][0];
}
void print(treap *t) {
    if (!t)
        return;
    print(t->lson);
    cout << t->key << " ";
    print(t->rson);
}
vector<int> queries[N];
pii who[N];
signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin >> n;
    segtree t(n + 1);
    vector<int> kek(n);
    for (int i = 0; i < n; i++)
        cin >> kek[i];
    reverse(all(kek));
    for (int i = 0; i < n; i++) {
        int a = kek[i];
        a--;
        t.add(1, 0, n, a + 1, n, 1);
        pos[a] = t.getval(1, 0, n, a);
    }
    int q;
    cin >> q;
    vector<vector<int>> bruh;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        bruh.push_back({r1, c1, r2, c2});
        queries[r1].push_back(c1);
        queries[r2].push_back(c2);
    }
    treap *s = nullptr;
    map<pair<int, int>, int> ind;
    int c = 1;
    for (int i = 0; i <= n; i++) {
        queries[i].push_back(pos[i]);
        sort(all(queries[i]));
        queries[i].erase(unique(all(queries[i])), queries[i].end());
        int p = 0;
        if (i)
            p = pos[i - 1];
        auto a = split(s, p);
        if (i) {
            s = merge(a.first, merge(new treap(ind[{i - 1, pos[i - 1]}]), a.second));
        }
        if (!i)
            s = merge(a.first, merge(new treap(0), a.second));
        for (auto j : queries[i]) {
            if (!ind[{i, j}])
                ind[{i, j}] = c++, who[c - 1] = {i, j};
            int h = ind[{i, j}];
            auto b = split(s, j);
            auto f = split(b.second, 1);
            int vl = f.first->key;
            if (vl)
                anc[h].push_back(vl), depth[h] = depth[vl] + 1;
            s = merge(b.first, merge(new treap(h), f.second));
        }
    }
    for (int i = 2; i < c; i++) {
        for (int j = 0; j < anc[anc[i][j]].size(); j++)
            anc[i].push_back(anc[anc[i][j]][j]);
    }
    for (auto i : bruh) {
        int x = ind[{i[0], i[1]}], y = ind[{i[2], i[3]}];
        int l = get_lca(x, y);
        cout << who[l].first << " " << who[l].second << '\n';
    }
}