#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define ld long double
#define ll long long
#define mp make_pair
#define pii pair<int, int>

const int INF = 1e9 + 1;

vector<vector<int>> g;
vector<int> cost;
vector<int> ban;

void dfs(int v, int &ans) {
    if (!ban[v]) {
        if (ans == -1 || cost[v] < cost[ans]) ans = v;
    }
    for (auto &to : g[v]) dfs(to, ans);
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n, -1);
    vector<int> depth(n);
    g.clear();
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
        depth[i] = depth[p[i]] + 1;
    }
    cost.resize(n);
    ban.assign(n, 0);
    for (auto &c : cost) cin >> c;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    vector<pii> d(n);
    for (int i = 0; i < n; i++) d[i] = mp(depth[i], i);
    sort(all(d));
    reverse(all(d));
    vector<int> cur(n);
    ll ans = 0;
    vector<int> take(n);
    for (auto &c : d) {
        int v = c.se;
        while (1) {
            if (cur[v] >= l[v]) break;
            int u = -1;
            while (1) {
                u = -1;
                dfs(v, u);
                if (u == -1) break;
                if (ban[u] == 1) exit(0);
                int w = u;
                while (w != -1) {
                    if (cur[w] == r[w]) ban[u] = 1;
                    w = p[w];
                }
                if (ban[u]) continue;
                break;
            }
            if (u == -1) {
                cout << -1 << "\n";
                return;
            }
            ans += cost[u];
            take[u]++;
            int w = u;
            while (w != -1) {
                cur[w]++;
                w = p[w];
            }
        }
    }
    cout << ans << "\n";
    for (auto &c : take) cout << c << " ";
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
