#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

mt19937_64 rnd(1231);

void solve() {
	int n;
	ll w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> arr(n);
	for (auto& p : arr)
		cin >> p.first >> p.second;
	sort (arr.begin(), arr.end(), [](pair<int, int>& a, pair<int, int>& b) {
		if (a.second == b.second)
			return a.first < b.first;
		return a.second < b.second;
	});

	ll nowx = w;
	ll lasty = 0;
	ll ans = 0;
	for (auto& p : arr) {
		ans += (w - nowx) * (p.second - lasty);
		lasty = p.second;
		nowx = min(nowx, (ll)p.first);
	}
	ans += (h - lasty) * (w - nowx);
	cout << ans << "\n";

}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int k;
	cin >> k;
	vector<int> allow(k);
	input(allow);

	assert(k == 1);

	int t;
	cin >> t;
	while (t--)
		solve();
}