#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int main() {
	#ifndef LOCAL
		ios_base::sync_with_stdio(0);
		cin.tie(0);
	#endif

	int n;
	cin >> n;
	vector<int> a(n);
	const int inf = 1e9 + 228;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	vector<vector<int>> ans(n, vector<int> (n));
	for (int i = 0; i < n; ++i) {
		auto b = a;
		sort(b.begin(), b.begin() + i + 1);
		vector<pair<int, int>> who(n, {inf, -inf});
		for (int i = 0; i < n; ++i) {
			who[b[i]].first = min(who[b[i]].first, i);
			who[b[i]].second = max(who[b[i]].second, i);
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				ans[i][j] = max(ans[i][j], abs(who[i].first - who[j].second));
				ans[i][j] = max(ans[i][j], abs(who[j].first - who[i].second));
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		auto b = a;
		vector<pair<int, int>> who(n, {inf, -inf});
		sort(b.begin() + n - i - 1, b.begin() + n);
		for (int i = 0; i < n; ++i) {
			who[b[i]].first = min(who[b[i]].first, i);
			who[b[i]].second = max(who[b[i]].second, i);
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				ans[i][j] = max(ans[i][j], abs(who[i].first - who[j].second));
				ans[i][j] = max(ans[i][j], abs(who[j].first - who[i].second));
			}
		}
	}
	long long res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j)
			res += ans[i][j]; 
	}
	cout << res << '\n';
}