#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
using namespace std;
const int N = 1e5 + 5;
int p[N], c[N], l[N], r[N], ans[N];
long long dp[N], a[N];
vector<int> g[N];
struct Map {
    long long sum = 0;
    map<pair<int, int>, int> s;
    void clear_back(int x) {
        while (sum > x) {
            auto it = --s.end();
            if (sum - it->second >= x) {
                sum -= it->second;
                s.erase(it);
            } else {
                it->second -= sum - x;
                sum = x;
            }
        }
    }
    void insert(pair<int, int> it, int x) {
        s[it] = x;
        sum += x;
    }
};
bool dfs(int v, Map & s) {
    vector<Map> t(g[v].size());
    dp[v] = a[v] = ans[v] = 0;
    for (int i = 0; i < t.size(); ++i) {
        int u = g[v][i];
        if (dfs(u, t[i]))
            return true;
        a[v] += a[u];
        dp[v] += dp[u];
        for (auto [it, x] : t[i].s)
            s.insert(it, x);
//        if (t[i].s.size() > s.s.size()) {
//            swap(s.s, t[i].s);
//            swap(s.sum, t[i].sum);
//        }
    }

//    for (int i = 0; i < t.size(); ++i) {
//        s.sum += t[i].sum;
//        for (auto [it, x] : t[i].s)
//            s.s[it] = x;
//    }
    if (a[v] > r[v])
        return true;
    s.insert(make_pair(c[v], v), r[v] - a[v]);
    while (a[v] < l[v]) {
        auto it = s.s.begin();
        long long c1 = it->first.first;
        int i = it->first.second;

        if (a[v] + it->second > l[v]) {
            int x = l[v] - a[v];
            a[v] += x;
            ans[i] += x;
            dp[v] += c1 * x;
            it->second -= x;
            s.sum -= x;
        } else {
            int x = it->second;
            a[v] += x;
            ans[i] += x;
            dp[v] += c1 * x;
            s.s.erase(it);
            s.sum -= x;
        }
    }
    s.clear_back(r[v] - a[v]);
    return false;
}
void solve() {
    int n;
    cin >> n;
    Map x;
    for (int i = 2; i <= n; ++i) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; ++i)
        cin >> c[i];
    for (int i = 1; i <= n; ++i)
        cin >> l[i] >> r[i];

    if (dfs(1, x)) {
        cout << -1 << '\n';
    } else {
        cout << dp[1] << '\n';
        for (int i = 1; i <= n; ++i)
            cout << ans[i] << ' ';
        cout << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}