#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>

using namespace std;

mt19937 rnd(time(0));

using ll = long long;
using ld = long double;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int k;
	cin >> k;
	vector<int> razr(k);
	for (int i = 0; i < k; ++i) {
		cin >> razr[i];
	}
	int t;
	cin >> t;
	while (t--) {
		ll n, w, h;
		cin >> n >> w >> h;
		vector<pair<ll, ll>> a(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].first >> a[i].second;
			swap(a[i].first, a[i].second);
		}
		sort(a.begin(), a.end());
		for (int i = 0; i < n; ++i) {
			swap(a[i].first, a[i].second);
		}
		ll ans = 0, maxx = w;
		for (auto& i : a) {
			ll x = i.first;
			ll y = i.second;
			if (x < maxx) {
				ans += (h - y) * (maxx - x);
				maxx = x;
			}
		}
		cout << ans << '\n';
	}
}