#include <iostream>
#include <vector>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    long long ans = 0;
    vector<int> p(n);
    vector<int> pos(n);
    for(int i = 0; i < n; ++i){
        cin >> p[i];
        pos[p[i]-1] = i;
    }
    vector<int> l(n, 0);
    vector<int> r(n, 0);
    for(int i = 0; i < n; ++i){
        for(int j = pos[i]-1; j > -1; --j){
            if(p[j] > i+1){
                ++l[i];
            }
        }
        for(int j = pos[i] + 1; j < n; ++j){
            if(p[j] < i+1){
                ++r[i];
            }
        }
        //cout << i << ' ' << l[i] << ' ' << r[i] << endl;
    }
    for(int i = 0; i < n-1; ++i){
        for(int j = i+1; j < n; ++j){
            int d = j - i;
            if(pos[i] < pos[j]){
                d = max(d, pos[j] - pos[i] + l[i]);
                d = max(d, pos[j] - pos[i] + r[j]);
            }else{
                d = max(d, pos[i] - pos[j] + l[j]);
                d = max(d, pos[i] - pos[j] + r[i]);
            }
            //cout << i+1 << ' ' << j+1 << ' ' << d << endl;
            ans += d;
        }
    }
    cout << ans << endl;
    return 0;
}
