#pragma GCC target("sse,sse2,sse3,sse4,fma,avx,avx2,popcnt")
#pragma GCC optimize("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <array>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <list>
#include <cassert>
#define ar array
std::mt19937 rnd(503);
using namespace std;
typedef long long ll;
const int N = 1e5 + 5;

int n, w, h;
ar<int, 2> a[N];

void solve1() {
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		cin >> a[i][0] >> a[i][1];
	}
	sort(a, a + n);
	a[n] = { 0,h };
	ll ans = 0;
	vector<int> st = { n };
	for (int i = 0; i < n; ++i) {
		if (a[st.back()][1] < a[i][1]) {
			continue;
		}
		ans += ll(a[st.back()][1] - a[i][1]) * (w - a[i][0]);
		st.push_back(i);
	}
	cout << ans;
}
void clear1() {
}

int L, R;
vector<ar<int, 2>> hist;

ll upd(int idx, bool dir) {
	ll ans = 0;
	hist.push_back({ L,R });
	if (dir == 0) {
		if (L < a[idx][0]) {
			ll dx = min(a[idx][0] - L, R - L);
			ans = dx * (h - a[idx][1]);
			L += dx;
		}
	}
	else {
		if (a[idx][0] < R) {
			ll dx = min(R - a[idx][0], R - L);
			ans = dx * (h - a[idx][1]);
			R -= dx;
		}
	}
	return ans;
}

void roll_back(int i) {
	for (int j = 0; j < i; ++j) {
		L = hist.back()[0], R = hist.back()[1];
		hist.pop_back();
	}
}

void solve12() {
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		cin >> a[i][0] >> a[i][1];
	}
	sort(a, a + n, [&](ar<int, 2> x, ar<int, 2> y) {
		return x[1] < y[1];
	});
	a[n] = { 0,h };
	L = 0, R = w;
	ll ans = 0, cur = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i][0] < a[i + 1][0]) {
			ll new_ans = cur + upd(i, 1) + upd(i + 1, 0);
			ans = max(ans, new_ans);
			roll_back(2);
			cur += upd(i, 0);
		}
		else {
			ll new_ans = cur + upd(i, 0) + upd(i + 1, 1);
			ans = max(ans, new_ans);
			roll_back(2);
			cur += upd(i, 1);
		}
		ans = max(ans, cur);
	}
	cout << ans;
}
void clear12() {
	hist.clear();
}


void clear() {
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int k, t = 1;
	cin >> k;
	vector<int> dir(k);
	for (int i = 0; i < k; ++i) {
		cin >> dir[i];
	}
	cin >> t;
	while (t--) {
		if (dir == vector<int>({1})) solve1(), clear1();
		else if (dir == vector<int>({1, 2})) solve12(), clear12();
		cout << "\n";
	}
}