#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <cassert>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 10;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int k; cin >> k;
	while (k--) {
		int kok; cin >> kok;
	}
	int tt; cin >> tt;
	while (tt--) {
		int n, w, h; cin >> n >> w >> h;
		vector <vector <int>> a(n, vector <int>(2));
		for (auto& x : a) cin >> x[0] >> x[1];

		sort(a.begin(), a.end());
		int ans = 0;
		vector <int> ys;
		for (auto& x : a) ys.push_back(x[1]);
		ys.push_back(0);
		ys.push_back(h);
		sort(ys.begin(), ys.end());
		for (int i = 0; i <= n; ++i) {
			int res = 0;
			vector <vector <int>> g(w + 1, vector <int>(h + 1));
			for (int j = 0; j < i; ++j) {
				for (int x = a[j][0]; x < w; ++x)
					for (int y = a[j][1]; y < h; ++y)
						g[x][y] = 1;
			}
			for (int j = i; j < n; ++j) {
				for (int x = a[j][0]; x >= 0; --x)
					for (int y = a[j][1]; y < h; ++y)
						g[x][y] = 1;
			}
			for (auto& x : g)
				for (auto& y : x)
					res += y;
			ans = max(ans, res);
		}
		cout << ans << '\n';
	}
}