#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) { return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) { return a < b ? a = b, true : false; }

struct sgt{
    int sz = 1;
    vector<int> t;

    sgt(int n) {
        while (sz < n) sz<<=1;
        t.resize(2*sz);
    }

    void upd(int i, int x) {
        t[i+sz] = x;
        for (i = (i+sz)/2; i > 0; i/=2) {
            t[i] = t[i*2]+t[i*2+1];
        }
    }

    int rsq(int i, int j) {
        int res = 0;
        for (i+=sz, j+=sz; i <= j; i/=2, j/=2) {
            if (i%2) res += t[i++];
            if (!(j%2)) res += t[j--];
        }
        return res;
    }
};

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n;
    vector<int> a(n), id(n+1), cntmin(n), cntmax(n);
    vector<pi> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        id[a[i]] = i;
    }
    sgt tree_min(n), tree_max(n);
    for (int x = 1; x <= n; ++x) {
        cntmin[id[x]] = tree_min.rsq(id[x]+1, n-1);
        tree_min.upd(id[x], 1);
    }
    for (int x = n; x >= 1; --x) {
        cntmax[id[x]] = tree_max.rsq(0, id[x]-1);
        tree_max.upd(id[x], 1);
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            int cnt = max(j-i, abs(a[i]-a[j]));
            int k1 = cntmax[i], k2 = cntmin[j];
            //for (int q = j+1; q < n; ++q) k2 += (a[q] < a[j]);
            //for (int q = 0; q < i; ++q) k1 += (a[q] > a[i]);
            ckmax(cnt, j-i+k1);
            ckmax(cnt, j-i+k2);
            ans += cnt;
            //cout << a[i] << ", " << a[j] << ": " << cnt << "\n";
        }
    }
    cout << ans << "\n";
    return 0;
}