#define ll long long

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

signed main() {
	ll n;
	cin >> n;

	vector<ll> a(n);

	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector<ll> dl(n, 0);
	vector<ll> dr(n, 0);

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < i; j++) {
			if (a[i] < a[j]) {
				dl[i]++;
			}
		}
	}

	for (ll i = n - 1; i >= 0; i--) {
		for (ll j = n - 1; j >= i; j--) {
			if (a[i] > a[j]) {
				dr[i]++;
			}
		}
	}

	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			ll dst = j - i;

			dst = max(dst, abs(a[i] - a[j]));
			dst = max(dst, abs(j - i + dl[i]));
			dst = max(dst, abs(j - i + dr[j]));

			ans += dst;
		}
	}

	cout << ans;
}
