#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define vi vector<int>
#define vvi vector<vi>
#define vll vector<ll>
#define pll pair<ll, ll>
#define pi pair<int, int>
#define vpi vector<pi>
#define vpll vector<pll>
#define vb vector<bool>

mt19937 gen(153);

void solve() {
    ll n, w, h;
    cin >> n >> w >> h;
    vpll points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
    }

    sort(points.begin(), points.end(), [&](const pll &a, const pll &b) {
        if (a.second != b.second) return a.second > b.second;
        return a.first > b.first;
    });

    vi st;
    for (int i = 0; i < n; i++) {
        while (!st.empty() and points[st.back()].first >= points[i].first) {
            st.pop_back();
        }
        st.push_back(i);
    }

    ll sq = 0;
    for (int i = 0; i < st.size(); i++) {
        if (!i) {
            sq += (w - points[st[i]].first) * (h - points[st[i]].second);
        } else {
            ll old_h = points[st[i - 1]].second;
            ll tmp = old_h - points[st[i]].second;
            sq += tmp * (w - points[st[i]].first);
        }
    }

    cout << sq << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int k;
    cin >> k;
    vi nums;
    for (int i = 0; i < k; i++) {
        int num;
        cin >> num;
        nums.push_back(num);
    }
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

