#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

int n;
const int maxn = 1e5, inf = 1e9 + 1;
int p[maxn], c[maxn], cnt[maxn], in[maxn];
vector<int> g[maxn];
pair<int, int> b[maxn];
int sum = 0;


bool check(int v) {
	int sl = 0;
	for (const auto& u : g[v]) {
		if (!check(u))
			return false;
		sl += b[u].first;
	}
	if (sl > b[v].second) {
		return false;
	}
	b[v].first = max(b[v].first, sl);
	return true;
}

int find(int v) {
	if (cnt[v] == b[v].second)
		return inf;
	int mn = c[v], mi = v;
	for (const auto& u : g[v]) {
		int f = find(u);
		if (f!= inf && c[f] < mn)
			mn = c[f], mi = f;
	}
	return mi;
}

void nas(int u, int d) {
	cnt[u] += d;
	assert(cnt[u] <= b[u].second);
	if (u == 0)
		return;
	nas(p[u], d);
}

void get(int v) {
	for (const auto& u : g[v]) {
		get(u);
	}
	while (cnt[v] < b[v].first) {
		int u = find(v);
		int d = min(b[v].first - cnt[v], b[u].second - cnt[u]);
		nas(u, d);
		sum += c[u] * d;
		in[u] += d;
	}
}

void solve() {
	cin >> n;
	for (int i = 1; i < n; ++i)
		cin >> p[i], p[i]--, g[p[i]].push_back(i);
	for (int i = 0; i < n; ++i)
		cin >> c[i];
	for (int i = 0; i < n; ++i)
		cin >> b[i].first >> b[i].second;
	if (!check(0)) {
		cout << "-1\n";
		return;
	}
	get(0);
	cout << sum << '\n';
	for (int i = 0; i < n; ++i)
		cout << in[i] << ' ';
	cout << '\n';
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		cnt[i] = 0;
		in[i] = 0;
	}
	sum = 0;
}

signed main()
{
	int t;
	cin >> t;
	p[0] = 0;
	while (t--) {
		solve();
	}
}
