#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;
using ll = long long;
 
const ll MAXN = 1e5 + 12;
ll cnt[10];
ll pw10[19];
 
signed main() {
    pw10[0] = 1;
    for (ll i = 1; i < 19; ++i)
        pw10[i] = pw10[i - 1] * 10;
    string s;
    cin >> s;
    ll y;
    cin >> y;
    ll n = s.size();
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i)
        a[i] = s[n - i - 1] - '0';
    ll mult = 1;
    ll mnvl = 10;
    while (a.size() >= 17) {
        ++cnt[a.back()];
        mnvl = min(mnvl, a.back());
        a.pop_back();
    }
    n = a.size();
    ll avl = 0;
    for (ll i = 0; i < n; ++i)
        avl += a[i] * pw10[i];
    while (a.size()) {
        if (a.back() <= mnvl) {
            mnvl = a.back();
            ++cnt[a.back()];
            a.pop_back();
            continue;
        }
        n = a.size();
        vector<ll> a0 = a;
        for (ll i = 0; i < 10; ++i) {
            for (ll j = 0; j < cnt[i] && a0.size() <= 20; ++j)
                a0.push_back(i);
        }
        vector<ll> last_poses(10);
        vector<pair<ll, pair<ll, ll>>> anss;
        vector<pair<pair<int, int>, int>> anss0;
        for (ll i = n - 1; i >= 0; --i) {
            ll new_pos = n - 1;
            for (ll j = 0; j < a[i]; ++j)
                new_pos += cnt[j];
            if (new_pos >= 18) {
                anss0.push_back({{new_pos, a[i]}, i});
            } else {
                ll acur = 0;
                ll aafter = 0;
                for (ll j = i + 1; j <= new_pos; ++j) {
                    acur += pw10[j] * a0[j];
                }
                aafter = acur / 10;
                acur += a0[i] * pw10[i];
                for (ll j = 0; j < i; ++j) {
                    aafter += pw10[j] * a0[j];
                    acur += pw10[j] * a0[j];
                }
                aafter += a0[i] * pw10[new_pos];
                if (acur + (new_pos - i) * y <= aafter) {
                    anss.push_back({aafter - acur - (new_pos - i) * y, {i, new_pos}});
                }
            }
        }
        if (anss0.size()) {
            ll i = max_element(anss0.begin(), anss0.end())->second;
            ++cnt[a[i]];
            mnvl = min(mnvl, a[i]);
            a.erase(a.begin() + i);
        } else if (anss.size()) {
            ll old_pos = max_element(anss.begin(), anss.end())->second.first;
            ++cnt[a[old_pos]];
            mnvl = min(mnvl, a[old_pos]);
            a.erase(a.begin() + old_pos);
        }
         
         
        if (n == a.size())
            break;
    }
     
    for (ll i = 9; i >= 0; --i) {
        while (cnt[i]--)
            cout << i;
    }
    reverse(a.begin(), a.end());
    for (auto x : a)
        cout << x;
    cout << endl;
}
