#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <string>
#include <assert.h>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 1000;

string s;
string ans;
ll y;
ll cost = 0;


void get(string t)
{
	int n = t.size();
	string p = s;
	ll a = 0;
	for (int i = 0; i < n; i++)
	{
		int j = i;
		for (; j < n; j++)
		{
			if (t[i] == p[j])
			{
				break;
			}
		}

		for (; j > i; j--)
		{
			swap(p[j], p[j - 1]);
			a += y;
		}
	}

	ll c = stoll(t) - a;
	if (c > cost)
	{
		cost = c;
		ans = t;
	}
	else if (c == cost)
	{
		if (ans < t)
		{
			ans = t;
		}
	}
}

void solve()
{
	cin >> s >> y;

	string pref = "";

	if (s.size() >= 5)
	{
		string t = "";
		int i = s.size() - 1;
		for (int j = 0; i >= 0 && j < 5; i--, j++)
		{
			t += s[i];
		}
		for (; i >= 0; i--)
		{
			pref += s[i];
		}
		sort(rall(pref));
		reverse(all(t));
		s = t;
	}

	ans = s;
	cost = stoll(s);
	string t = s;
	sort(t.begin(), t.end());

	do
	{
		get(t);
	} while (next_permutation(t.begin(), t.end()));

	pref += ans;

	cout << pref << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	// cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}
