#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template <typename T, typename U>
bool ckmin(T& a, const U& b) {
    return a > b && (a = b, true);
}

template <typename T, typename U>
bool ckmax(T& a, const U& b) {
    return a < b && (a = b, true);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    rep(i, 0, n) cin >> a[i];

    sort(all(a));
    vector<ll> t;
    rep(i, 1, n) {
        t.push_back(a[i] - a[i - 1]);
    }

    sort(all(t));
    while (q--) {
        int T;
        cin >> T;

        if (T == 1) {
            ll k;
            cin >> k;
            cout << n - (upper_bound(all(t), k) - t.begin()) << '\n';
        }
    }
}