#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize "Ofast"
#pragma GCC optimize "no-exceptions"
using namespace std;
using namespace __gnu_pbds;
typedef int64_t ll;
typedef tree<pair<ll, int>, null_type, less<pair<ll, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

ll vtoll(vector<int> &t) {
    ll res = 0;
    for (int i : t) res = res * 10 + i;
    return res;
}
typedef array<ll, 3> query;
constexpr int MAXN = 300000;
constexpr int TREES = 1 << 20;
ll trees[MAXN];
void build(int v, int l, int r) {
    trees[v] = 0;
    if (l + 1 < r) {
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
    }
}
void av(int v, int l, int r, int q, ll x) {
    if (q < l || r <= q) return;
    if (l + 1 == r) {
        trees[v] += x;
        return;
    }
    int m = (l + r) / 2;
    av(2 * v + 1, l, m, q, x);
    av(2 * v + 2, m, r, q, x);
    trees[v] = trees[2*v+1]+trees[2*v+2];
}
ll ask(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return 0;
    if (ql <= l && r <= qr) return trees[v];
    int m = (l + r) / 2;
    return ask(2 * v + 1, l, m, ql, qr) + ask(2 * v + 2, m, r, ql, qr);
}

int main()
{
//    ordered_set cringe;
//    for (int i = 0; i < 5; ++i) {cringe.insert(i);cringe.insert(i);cringe.insert(i);}
//    for (int i = -1; i < 8; ++i) {cout << cringe.order_of_key(i) << ' ';}
//    cout << '\n';
    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for (auto &x : c) cin >> x;

    vector<int> p(n);
    for (int i = 0; i < n; ++i) p[i] = i;
    sort(p.begin(), p.end(), [&](int x, int y){return c[x] < c[y];});

    vector<int> snum(n);
    for (int i = 0; i < n; ++i) snum[p[i]] = i;

    vector<ll> sc(n);
    for (int i = 0; i < n; ++i) sc[i] = c[p[i]];

    vector<int> cntg(n);
    {
        int cc = 0;
        for (int i = n-1; i > -1; --i) {
            cntg[i] = cc;
            if (i != 0 && sc[i-1] != sc[i]) ++cc;
        }
    }

    vector<pair<ll, int>> df(n - 1);
    for (int i = 0; i + 1 < n; ++i) df[i] = pair<ll, int>(sc[i+1] - sc[i], i);
    vector<pair<ll, int>> close(n-1);
    for (int i= 0; i < n-1; ++i) close[i] = pair<ll, int>(df[i].first, df[i].second);
    sort(close.begin(), close.end());

    vector<ll> psum(n);
    for (int i = 0; i < n-1; ++i) psum[i + 1] = psum[i] + close[i].first * (close[i].second + 1);
    vector<ll> psum2(n);
    for (int i = 0; i < n-1; ++i) psum2[i+1] = psum2[i] + close[i].second + 1;
    vector<ll> sdf(n - 1);
    for (int i = 0; i + 1 < n; ++i) sdf[i] = df[i].first;
    sort(sdf.begin(), sdf.end());
    vector<ll> ans(q);
    vector<query> cp;
//    for (int i = 0; i < n; ++i) cout << psum[i] << ' ';
//    cout << '\n';
//    for (int i = 0; i < n; ++i) cout << psum2[i] << ' ';
//    cout << '\n';
//    for (auto &x : sdf) cout << x << ' ';
//    cout << "\n";
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            ll k;
            cin >> k;
            int l = -1, r = n - 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (sdf[m] <= k) l = m;
                else r = m;
            }
            ans[i] = n - 1 - r + 1;
        } else if (t == 2) {
            ll k;
            cin >> k;
            int l = -1, r = n - 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (sdf[m] <= k) l = m;
                else r = m;
            }
//            cout << r <<  ' ';
//            cout << psum[r] << ' ' << psum2[n-1] - psum2[r] << ' ' << "whatever\n";
            ans[i] = (psum[r] + (psum2[n-1] - psum2[r]) * k);
        } else {
            ll k, ii;
            cin >> k >> ii;
            --ii;
            ii = snum[ii];
            cp.push_back(query{(ll)i, k, ii});
        }
    }
//    cout << "ok read\n";
    sort(cp.begin(), cp.end(), [&](query &x, query &y){
         return x[1] < y[1];
         });
    vector<pair<ll, int>> dddf(df);
    sort(dddf.begin(), dddf.end(), [&](auto x, auto y){return x.first < y.first;});
    int cl = 0;
    build(0, 0, n);
    for (query x : cp) {
        while (cl < n - 1 && dddf[cl].first < x[1]) {
            av(0, 0, n, dddf[cl].second, dddf[cl].first);
//            cout << "ok add\n";
            ++cl;
        }
        ans[x[0]] += ask(0, 0, n, x[2], n);
    }
    sort(dddf.begin(), dddf.end(), [&](auto x, auto y){return x.second < y.second;});
    sort(cp.begin(), cp.end(), [&](query &x, query &y){
         return x[2] > y[2];
        });
    int ct = n - 2;
    ordered_set rdel;
    int trash = 1000-7;
    for (query x : cp) {
        while (ct > -1 && dddf[ct].second >= x[2]) {
            rdel.insert(make_pair(dddf[ct].first, trash++));
            --ct;
        }
//        cout << rdel.size() << ' ' << ((ll)(rdel.size() - rdel.order_of_key(x[1]))) << ' ' << x[1] << '\n';
        ans[x[0]] += ((ll)(rdel.size() - rdel.order_of_key(pair<ll, int>(x[1], 0)))) * x[1];
    }
    for (query x : cp) {
        ans[x[0]] += sc[x[2]];
    }
//    cout << "ok ans\n";
    for (auto &x : ans) cout << x << '\n';
    return 0;
}
