#include <iostream>
#include <vector>
#include <algorithm>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

const int maxN = 3e5;

int n, q, t, i, cnt[maxN], n0;
long long c[maxN], k, a[maxN];
std::vector<long long> b[maxN], d[maxN];

long long get(int i, long long k) {
	int id = std::upper_bound(b[i].begin(), b[i].end(), k) - b[i].begin() - 1;
	return d[i][id] + (b[i].size() - id - 1) * (k - b[i][id] + 1);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> q;
	n0 = n;
	for (int i = 0; i < n; i++) {
		std::cin >> c[i];
		a[i] = c[i];
	}
	std::sort(a, a + n);
	n = std::unique(a, a + n) - a;
	for (int i = 0; i < n0; i++)
		cnt[std::lower_bound(a, a + n, c[i]) - a]++;
	b[n - 1].push_back(1);
	d[n - 1].push_back(0);
	for (i = n - 2; i >= 0; i--) {
		b[i] = b[i + 1];
		b[i].push_back(a[i + 1] - a[i] + 1);
		std::sort(b[i].begin(), b[i].end());
		d[i].resize(b[i].size());
		d[i][0] = 0;
		for (int j = 1; j < b[i].size(); j++)
			d[i][j] = d[i][j - 1] + (b[i][j] - b[i][j - 1]) * (b[i].size() - j);
	}
	b[n] = b[0];
	d[n].resize(b[n].size());
	d[n][0] = 0;
	for (int i = 1; i < b[n].size(); i++)
		for (int j = 0; j < n; j++)
			d[n][i] += cnt[j] * get(j, b[n][i - 1]);
	while (q--) {
		std::cin >> t >> k;
		if (t == 1)
			std::cout << n - (std::upper_bound(b[n].begin(), b[n].end(), k + 1) - b[n].begin()) + 1 << "\n";
		else if (t == 2) {
			if (k == 0)
				std::cout << "0\n";
			else {
				long long res = 0;
				for (int i = 0; i < n; i++)
					res += cnt[i] * get(i, k);
				std::cout << res << "\n";
			}
		}
		else {
			std::cin >> i;
			if (k == 0)
				std::cout << c[i - 1] << "\n";
			else
				std::cout << c[i - 1] + get(std::lower_bound(a, a + n, c[i - 1]) - a, k) << "\n";
		}
	}
	return 0;
}