#pragma GCC optimize("Ofast,no-stack-prtoector")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

int n;

unordered_map<int, bool> used;
unordered_map<int, int> d;

inline int geti(vector<int> x) {
    int res = 0;
    for (int i = n - 1; i >= 0; --i) {
        res = 10 * res + x[i];
    }
    return res;
}

inline vector<int> getv(int x) {
    vector<int> res;
    while (x > 0) {
        res.push_back(x % 10);
        x /= 10;
    }
    reverse(res.begin(), res.end());
    while (res.size() < n) {
        res.push_back(0);
    }
    reverse(res.begin(), res.end());
    return res;
}

inline vector<int> getg (int x) {
    vector<int> v = getv(x);
    vector<int> res;
    for (int i = 0; i < n - 1; ++i) {
        swap(v[i], v[i + 1]);
        res.push_back(geti(v));
        swap(v[i], v[i + 1]);
    }
    return res;
}

signed main() {
    int x; cin >> x;
    int y; cin >> y;
    n = 0;
    int p = 1;
    while (x >= p) {
        p *= 10;
        n += 1;
    }
    queue<int> q;
    q.push(x);
    d[x] = 0;
    used[x] = true;
    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (int v : getg(u)) {
            if (!used[v] || d[v] > d[u] + 1) {
                d[v] = d[u] + 1;
                used[v] = true;
                q.push(v);
            }
        }
    }
    vector<pair<int, int>> all;
    for (auto [u, b] : used) {
        all.emplace_back(u - y * d[u], u);
    }
    sort(all.begin(), all.end());
    cout << all.back().second << '\n';
}