#include <iostream>
#include <vector>
#include <set>
#include <algorithm> 

using namespace std;
typedef long long ll;

vector<vector<int>>g;
void solveC(int n, int m) {
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	vector<int>d0(n, 1e9), d1(n, 1e9);
	set<pair<int, int>>q0, q1;
	q0.insert({ 0, 0 });
	d0[0] = 0;
	while (!q0.empty() || !q1.empty()) {
		if (!q0.empty()) {
			int v = q0.begin()->second;
			q0.erase(q0.begin());
			for (auto u : g[v]) {
				if (d0[v] + 1 < d1[u]) {
					q1.erase({ d1[u], u });
					d1[u] = d0[v] + 1;
					q1.insert({ d1[u], u });
				}
			}
		}
		else {
			int v = q1.begin()->second;
			q1.erase(q1.begin());
			for (auto u : g[v]) {
				if (d1[v] + 1 < d0[u]) {
					q0.erase({ d0[u], u });
					d0[u] = d1[v] + 1;
					q0.insert({ d0[u], u });
				}
			}
		}
	}
	for (int i = 1; i < n; i++) {
		if (d0[i] != 1e9)
			cout << d0[i] << ' ';
		else
			cout << "-1 ";
	}
	cout << '\n';
	g.clear();
}

void solve() {
	int n, q;
	cin >> n >> q;
	set<ll>c;
	for (int i = 0; i < n; i++) {
		ll x; cin >> x;
		c.insert(x);
	}
	auto it = c.begin(), it2 = c.begin();
	it2++;
	vector<int>dop;
	while (it2 != c.end()) {
		dop.push_back(*it2 - *it);
		it2++;
		it++;
	}
	sort(dop.begin(), dop.end());
	while (q--) {
		int t; cin >> t;
		if (t == 1) {
			ll k; cin >> k;
			int cnt = upper_bound(dop.begin(), dop.end(), k) - dop.begin();
			cout << c.size() - cnt << '\n';
		}
	}
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}