#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <cmath>


using namespace std;


#define int long long


int dev(int a, vector<int> &p) {
    if (a == p[a]) {
        return a;
    }
    p[a] = dev(p[a], p);
    return p[a];
}


void uni(int a, int b, vector <int> &p, vector <int> &mx, vector <int> &sz, vector <int> &cn, vector <int> &mi) {
    a = dev(a, p);
    b = dev(b, p);
    if (a != b) {
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        mx[a] = max(mx[a], mx[b]);
        mi[a] = min(mi[a], mi[b]);
        cn[a] += cn[b];
    }
}


void dfs (int x, int lx, int rx, int L, int R, int add, vector <int> &tree, vector <int> &pus) {
    if (lx >= L and rx <= R) {
        pus[x] += add;
        tree[x] += pus[x] * (rx - lx);
        if (lx + 1 != rx) {
            pus[2 * x + 1] += pus[x];
            pus[2 * x + 2] += pus[x];
        }
        pus[x] = 0;
        return;
    }
    else if (lx >= R or L >= rx) {
        tree[x] += pus[x] * (rx - lx);
        if (lx + 1 != rx) {
            pus[2 * x + 1] += pus[x];
            pus[2 * x + 2] += pus[x];
        }
        pus[x] = 0;
        return;
    }
    tree[x] += pus[x] * (rx - lx);
    if (lx + 1 != rx) {
        pus[2 * x + 1] += pus[x];
        pus[2 * x + 2] += pus[x];
    }
    pus[x] = 0;
    int helpp = (lx + rx) / 2;
    dfs(2 * x + 1, lx, helpp, L, R, add, tree, pus);
    dfs(2 * x + 2, helpp, rx, L, R, add, tree, pus);
    tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
}


int summ(int x, int lx, int rx, int L, int R, vector <int> &tree, vector <int> &pus) {
    tree[x] += pus[x] * (rx - lx);
    if (lx + 1 != rx) {
        pus[2 * x + 1] += pus[x];
        pus[2 * x + 2] += pus[x];
    }
    pus[x] = 0;
    if (lx >= L and rx <= R) {
        return tree[x];
    }
    else if (lx >= R or L >= rx) {
        return 0;
    }
    int helpp = (lx + rx) / 2;
    int s1 = summ(2 * x + 1, lx, helpp, L, R, tree, pus);
    int s2 = summ(2 * x + 2, helpp, rx, L, R, tree, pus);
    tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    return s1 + s2;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, q;
    cin >> n >> q;
    vector <int> c(n);
    set <int> all;
    vector <int> nc(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        nc[i] = c[i];
        all.insert(c[i]);
    }
    vector <vector<int>> zp;
    for (int i = 0; i < q; i++) {
        int t, k, ii;
        cin >> t >> k;
        ii = -1;
        if (t == 3) {
            cin >> ii;
        }
        zp.push_back({k, t, ii, i});
    }
    sort(zp.begin(), zp.end());
    vector <int> h;
    int ukk = 1;
    map<int, int> sp;
    map<int, int> ni;
    vector <int> ans(q);
    for (auto nw : all) {
        h.push_back(nw);
        sp[nw] = (int)all.size() - ukk;
        ukk++;
    }
    sort(c.begin(), c.end());
    vector <int> b(n);
    vector <int> uk(n);
    vector <vector <int>> al;
    for (int i = 0; i < h.size() - 1; i++) {
        al.push_back({h[i + 1] - h[i], i, i + 1});
    }
    sort(al.begin(), al.end());
    int idd = 0;
    vector <int> cnt(h.size());
    vector <int> cntm(h.size());
    for (int i = 0; i < n; i++) {
        if (idd < h.size() and h[idd] <= c[i]) {
            idd++;
        }
        b[i] = h.size() - idd;
        uk[i] = idd - 1;
        cnt[idd - 1]++;
    }
    map<int, int> spm;
    map<int, int> d;
    for (int i = 1; i < h.size(); i++) {
        cntm[i] += cnt[i - 1] + cntm[i - 1];
        spm[h[i]] = cntm[i];
    }
    int su = 0;
    int usk = 0;
    int szz = 1;
    while (szz < n) {
        szz *= 2;
    }
    vector <int> tree(2 * szz - 1);
    vector <int> pus(2 * szz - 1);
    vector <int> ns(n);
    for (int i = 0; i < h.size(); i++) {
        ni[h[i]] = i;
        dfs(0, 0, szz, 0, cntm[i], 1, tree, pus);
        for (int j = 0; j < cntm[i]; j++) {
            ns[j]++;
        }
    }
    vector <int> p(h.size());
    vector <int> mx(h.size());
    vector <int> mi(h.size());
    vector <int> sz(h.size());
    for (int i = 0; i < h.size(); i++) {
        p[i] = i;
        mx[i] = h[i];
        sz[i] = 1;
        mi[i] = h[i];
    }
    int ro = 0;
    int pr = 0;
    int anss = (int)h.size();
    vector <int> a3(n);
    for (int i = 0; i < n; i++) {
        a3[i] = c[i];
    }
    for (auto nw : zp) {
        while (ro != al.size() and nw[0] >= al[ro][0]) {
            int nr = al[ro][0];
            int als = 0;
            for (int i = 0; i < n; i++) {
                als += ns[i];
                a3[i] += ns[i] * (nr - pr);
            }
            int mu = als;
            su += mu * (nr - pr);
            int a = dev(al[ro][1], p);
            int bb = dev(al[ro][2], p);
            if (a != bb) {
                anss--;
                int ma = mx[a];
                int mb = mx[bb];
                if (sz[a] < sz[bb]) {
                    swap(a, bb);
                }
                uni(a, bb, p, mx, sz, cnt, mi);
                ma = mx[a];
                dfs(0, 0, szz, 0, spm[ma], -1, tree, pus);
                for (int i = 0; i < spm[ma]; i++) {
                    ns[i]--;
                }
            }
            pr = nr;
            ro++;
        }
        int y = nw[3];
        if (nw[1] == 2) {
            int als = 0;
            for (int i = 0; i < n; i++) {
                als += ns[i];
            }
            int mu = als;
            ans[y] = su + (nw[0] - pr) * mu;
        }
        else if (nw[1] == 1) {
            ans[y] = anss;
        }
        else {
            int a = dev(ni[nc[nw[2] - 1]], p);
            ans[y] = a3[mx[a]] + ns[mx[a]] * (nw[0] - pr);
        }
    }
    for (auto nw : ans) {
        cout << nw << "\n";
    }
}