#include <bits/stdc++.h>

using namespace std;

const int R = 1 << 19;

pair<long long, long long> t[R * 2];

void build() {
    for (int i = 1; i < R * 2; ++i) {
        t[i] = {0, 0};
    }
}

void change(int pos, pair<long long, long long> val) {
    for (int i = pos + R; i > 0; i /= 2) {
        t[i].first += val.first;
        t[i].second += val.second;
    }
}

pair<long long, long long> get(int l, int r) {
    l += R;
    r += R;
    pair<long long, long long> ans = {0, 0};
    while (l < r) {
        if (l & 1) {
            ans.first += t[l].first;
            ans.second += t[l].second;
            l++;
        }
        if (r & 1) {
            --r;
            ans.first += t[r].first;
            ans.second += t[r].second;
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<long long> c(n), a(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        a[i] = c[i];
    }
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    vector<int> cnt(c.size());
    for (int i = 0; i < n; ++i) {
        cnt[(int) c.size() - (lower_bound(c.begin(), c.end(), a[i]) - c.begin()) - 1]++;
    }
    vector<int> pr(cnt.size() + 1);
    for (int i = 0; i < (int) cnt.size(); ++i) {
        pr[i + 1] = pr[i] + cnt[i];
    }
    vector<long long> kek;
    vector<pair<long long, int>> kek2;
    for (int i = 0; i + 1 < (int) c.size(); ++i) {
        kek.push_back(c[i + 1] - c[i]);
        kek2.emplace_back(c[i + 1] - c[i], (int) c.size() - i - 1);
    }
    sort(kek2.begin(), kek2.end());
    sort(kek.begin(), kek.end());
    vector<long long> add = {0};
    for (int i = 0; i < (int) cnt.size(); ++i) {
        add[0] += i * 1LL * cnt[i];
    }
    for (int i = 0; i < (int) kek.size(); ++i) {
        add.push_back(add.back() - (pr.back() - pr[kek2[i].second]));
    }
    // for (auto v : add) {
    //     cout << v << ' ';
    // }
    // cout << '\n';
    vector<long long> val(kek.size() + 1);
    val[0] = 0;
    for (int i = 0; i < (int) kek.size(); ++i) {
        long long prv = 0;
        if (i != 0) {
            prv = kek[i - 1];
        }
        val[i + 1] = val[i] + add[i] * (kek[i] - prv);
    }
    vector<long long> aaa(q);
    vector<pair<pair<long long, int>, int>> qs;
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            long long k;
            cin >> k;
            int ans = lower_bound(kek.begin(), kek.end(), k + 1) - kek.begin();
            aaa[i] = (int) c.size() - ans;
        } else if (t == 2) {
            long long k;
            cin >> k;
            int pos = lower_bound(kek.begin(), kek.end(), k + 1) - kek.begin();
            long long prv = 0;
            if (pos != 0) {
                prv = kek[pos - 1];
            }
            long long ans = val[pos] + add[pos] * (k - prv);
            aaa[i] = ans;
        } else {
            long long k, ind;
            cin >> k >> ind;
            ind--;
            qs.push_back({{k, ind}, i});
            // int p = lower_bound(c.begin(), c.end(), a[ind]) - c.begin();
            // long long ans = 0;
            // for (int i = p; i + 1 < (int) c.size(); ++i) {
            //     ans += min(c[i + 1] - c[i], k);
            // }
            // cout << a[ind] + ans << '\n';
        }
    }
    build();
    sort(qs.begin(), qs.end());
    int ppp = 0;
    for (auto k : qs) {
        while (ppp < (int) kek.size() && kek[ppp] < k.first.first) {
            change(kek2[ppp].second , {1, kek[ppp]});
            ppp++;
        }
        int p = (int) c.size() - (lower_bound(c.begin(), c.end(), a[k.first.second]) - c.begin()) - 1;
        auto pp = get(0, p);
        aaa[k.second] = a[k.first.second] + pp.second + k.first.first * (p - pp.second);
    }
    for (int i = 0; i < q; ++i) {
        cout << aaa[i] << '\n';
    }
    return 0;
}
