#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

#define int long long

//-------------------------------------------------

const int MAXN = 4e6 + 10;

ll c[MAXN], b[MAXN];

vector<ll> Union;

ll ans[MAXN];

void calc1(int cnt, int id){
    ll k;
    cin >> k;
    if (k < Union[0]){
        ans[id] = cnt;
        return;
    }
    int l = 0, r = sz(Union);
    while (r - l > 1){
        int m = (l + r) >> 1;
        if (Union[m] <= k)
            l = m;
        else
            r = m;
    }
    ans[id] = cnt - l - 1;
}

struct Node2{
    ll sum;
    ll rt;
    ll inc;
};
ll a[MAXN];
Node2 tree2[MAXN << 2];

void push2(int v, int ln){
    ll inc = tree2[v].inc;
    tree2[v << 1].sum += inc * (ln / 2);
    tree2[v << 1 | 1].sum += inc * ((ln + 1) / 2);
    tree2[v << 1].rt += inc, tree2[v << 1 | 1].rt += inc;
    tree2[v << 1].inc += inc, tree2[v << 1 | 1].inc += inc;
    tree2[v].inc = 0;
}


void build2(int v, int l, int r){
    if (r - l == 1){
        tree2[v] = {a[l - 1], a[l - 1], 0};
        return;
    }
    int m = (l + r) >> 1;
    build2(v << 1, l, m);
    build2(v << 1 | 1, m, r);
    tree2[v] = {tree2[v << 1].sum + tree2[v << 1 | 1].sum, tree2[v << 1 | 1].rt, 0};
}

void updPref2(int v, int l, int r, int ql, int qr, ll inc){
    if (r <= ql || qr <= l)
        return;
    if (ql <= l && r <= qr){
        tree2[v].sum += inc * (r - l);
        tree2[v].inc += inc;
        return;
    }
    int m = (l + r) >> 1;
    push2(v, r - l);
    updPref2(v << 1, l, m, ql, qr, inc);
    updPref2(v << 1 | 1, m, r, ql, qr, inc);
    tree2[v] = {tree2[v << 1].sum + tree2[v << 1 | 1].sum, tree2[v << 1 | 1].rt, 0};
}
#define int long long

int n;

void Union2(int i){
    updPref2(1, 1, n + 1, 1, i + 1, -1);
}

ll getSum2(){
    return tree2[1].sum;
}

int inds[MAXN];
int revind[MAXN];

const int C = 1e7 + 10;

vector<pair<pair<ll, int>, pt>> p[C];

ll bb[MAXN];
ll res[MAXN];

ll nw[MAXN];

void run(){
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; i++){
        cin >> c[i];
        b[i] = c[i];
        bb[i] = b[i];
    }
    iota(inds, inds + n, 0);
    sort(inds, inds + n, [&](int i, int j){return b[i] < b[j];});
    sort(bb, bb + n);
    for (int i = 0; i < n; i++)
        revind[inds[i]] = i;
    sort(b, b + n);
    for (int i = 0; i < q; i++){
        int t;
        cin >> t;
        ll k;
        cin >> k;
        if (t <= 2){
            p[k].push_back({{k, -1}, {i, t}});
        } else{
            int j;
            cin >> j;
            j--;
            p[k].push_back({{k, j}, {i, t}});
        }
    }

    for (int kk = 0; kk < C; kk++){
        for (auto z: p[kk]){
            if (z.y.y == 1){
                int diff = 1;
                for (int j = 1; j < n; j++){
                    if (b[j] != b[j - 1])
                        diff++;
                }
                res[z.y.x] = diff;
            } else if (z.y.y == 2){
                ll sm = 0;
                for (int i = 0; i < n; i++)
                    sm += b[i] - c[i];
                res[z.y.x] = sm;
            } else {
                ll val = 0;
                val = c[z.x.y];
                int pos = 0;
                for (int i = 0; i < n; i++){
                    if (bb[i] == val)
                        pos = i;
                }
                res[z.y.x] = b[pos];
            }
        }
        int cnt = 0;
        for (int i = n - 2; i >= 0; i--){
            if (b[i] != b[i + 1])
                cnt++;
            nw[i] = b[i] + cnt;
        }
        for (int i = 0; i < n - 1; i++)
            b[i] = nw[i];


    }
    for (int i = 0; i < q; i++)
        cout << res[i] << "\n";
    cout << endl;
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
    cerr << (stop - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
}