#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,abm,popcnt")
//#define int long long
#define ll long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e9;

void solve() {
    string s, y;
    cin >> s >> y;
    int n = sz(s), m = sz(y);
    if (n < m) {
        cout << s << "\n";
        return;
    }
    int iters = max(0, n - m - 1);
    string l = s, r;
    sort(all(l), greater<>());
    l.erase(iters, n - iters);
    vector<int> cnt(10);
    for (auto c: l)
        cnt[c - '0']++;
    for (int i = 0; i < n; ++i)
        if (cnt[s[i] - '0'] == 0)
            r.push_back(s[i]);
        else
            cnt[s[i] - '0']--;
    ll L = stoll(y);
    int len = n - iters;
    if (len == 1) {
        cout << l << r;
        return;
    }
    pair<ll, string> best = {0, r};
    for (int i = 0; i < len; ++i) {
        for (int j = 0; j < len; ++j) {
            if (i != j) {
                char c1 = r[i];
                char c2 = r[j];
                string cur = r;
                ll cnt = 0;
                int fnd = 0;
                for (int k = 0; k < len; ++k)
                    if (cur[k] == c1) {
                        fnd = k;
                        break;
                    }
                for (int k = fnd; k > 0; --k) {
                    cnt++;
                    swap(cur[k], cur[k - 1]);
                }
                for (int k = 1; k < len; ++k)
                    if (cur[k] == c2) {
                        fnd = k;
                        break;
                    }
                for (int k = fnd; k > 1; --k) {
                    cnt++;
                    swap(cur[k], cur[k - 1]);
                }
                best = max(best, {stoll(cur) - L * cnt, cur});
            }
        }
    }
    cout << l << best.second << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}