#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 3e18;
struct mem {
    int t, k, i, ind;
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> c(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(all(c));
    for (int i = 0; i < n; ++i)
        a[i] = c[i].first;
    vector<int> pos(n);
    for (int i = 0; i < n; ++i)
        pos[c[i].second] = i;
    vector<mem> qes(q);
    for (int i = 0; i < q; ++i) {
        cin >> qes[i].t >> qes[i].k;
        if (qes[i].t == 3)
            cin >> qes[i].i;
        qes[i].ind = i;
    }
    sort(all(qes), [&](mem u, mem v) {
        return u.k < v.k;
    });

    vector<int> ans(q);
    int curq = 0;
    int K = 0;
    auto calc = [&](int ind, int m) {
        vector<int> fake = a;
        m = qes[ind].k - m;
        vector<int> same(n);
        for (int i = 0; i < n - 1; ++i)
            same[i] = fake[i] == fake[i + 1];
        int t = 0;
        for (int i = n - 2; i >= 0; --i) {
            if (!same[i])
                t++;
            fake[i] += t * m;
        }
        ++t;
        if (qes[ind].t == 1) {
            ans[qes[ind].ind] = t;
            return;
        }
        if (qes[ind].t == 2) {
            int sum = 0;
            for (int i = 0; i < n; ++i)
                sum += fake[i] - c[i].first;
            ans[qes[ind].ind] = sum;
            return;
        }
        ans[qes[ind].ind] = fake[pos[qes[ind].i - 1]];
    };
    while (curq < q) {
        int m = inf;
        for (int i = 0; i < n - 1; ++i)
            if (a[i] != a[i + 1])
                m = min(m, a[i + 1] - a[i]);
        if (m == 0)
            break;
        while (curq < q && qes[curq].k < K + m) {
            calc(curq, K);
            ++curq;
        }
        K += m;
        int t = 0;
        vector<int> same(n);
        for (int i = n - 2; i >= 0; --i)
            same[i] = a[i] == a[i + 1];
        for (int i = n - 2; i >= 0; --i) {
            t += !same[i];
            a[i] += t * m;
        }
//        cout<<K<<" : ";
//        for(auto x:a)
//            cout<<x<<" ";
//        cout<<endl;
    }
    while (curq < q) {
        calc(curq, K);
        ++curq;
    }
    for(auto x:ans)
        cout<<x<<endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
