#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = uint32_t;
using int64 = int64_t;
using uint64 = uint64_t;

int64 fpow(int64 a, int64 n) {
	if (n == 0) return 1;

	int64 b = fpow(a, n / 2);
	b *= b;
	if (n % 2 == 1) b *= a;

	return b;
}

int32_t main() {
	string s; cin >> s;
	string y; cin >> y;

	int64 ny = stoll(y);
	int n = s.size();

	sort(s.begin(), s.end() - y.size());
	reverse(s.begin(), s.end() - y.size() - 1);

	cout << s;
}