//#include <bits/stdc++.h>
#include "iostream"
#include "set"
#include "unordered_set"
#include "map"
#include "unordered_map"
#include "vector"
#include "cmath"
#include "algorithm"
#include "numeric"
#include "string"
#include "bits/stdc++.h"
//#pragma optimize("Ofast")
//#pragma optimize("unroll-loops")
using namespace std;
typedef unsigned long long ll;
#include "ext/pb_ds/assoc_container.hpp"
using namespace __gnu_pbds;
typedef tree<int, null_type, greater<>, rb_tree_tag, tree_order_statistics_node_update> treap;



struct query {
    int type;
    ll k;
    int i;

    query() = default;
};


int get_root(int v, vector<int> &dsu) {
//    if (dsu[v] != v) dsu[v] = get_root(dsu[v], dsu);
    return dsu[v];
}

void merge_dsu(int a, int b, vector<int> &dsu, vector<int> &ranks) {
    a = get_root(a, dsu);
    b = get_root(b, dsu);
    if (ranks[a] > ranks[b]) swap(a, b);
    dsu[a] = dsu[b];
    ranks[b] += ranks[a];
}

//
//int get_size(int v, vector<int> &dsu, vector<ll> &sz) {
//    return sz[get_root(v, dsu)];
//}


int main() {
    int n, G;
    cin >> n >> G;
    vector<pair<ll, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first, a[i].second = i;
    vector<pair<ll, int>> c(n);
    copy(a.begin(), a.end(), c.begin());
    vector<pair<ll, vector<int>>> classes;
    sort(c.begin(), c.end());
    map<ll, int> squeeze;
    int cur = -1;
    ll last = -1;
    int last_ind = 0;
    vector<int> dsu(n);
    iota(dsu.begin(), dsu.end(), 0);
    vector<int> ranks(n, 1);
    vector <int> repr;
    for (int i = 0; i < n; i++) {
        if (c[i].first != last) {
            cur++;
            repr.push_back(c[i].second);
        }
        ranks[cur] ++;
        dsu[c[i].second] = cur;
        squeeze[c[i].first] = cur;
        last = c[i].first;
    }

    classes.reserve(squeeze.size());
    for (auto i: squeeze) {
        classes.emplace_back(i.first, vector<int>());
    }
    for (int i = 0; i < n; i++) {
        classes[squeeze[a[i].first]].second.push_back(i);
    }
    n = (int) classes.size();
    vector<ll> szs(n);
    for (auto i: c) {
        szs[squeeze[i.first]]++;
    }
    vector<pair<ll, int>> difs;
    for (int i = 0; i + 1 < n; i++) {
        ll val = 0;
        if (classes[i].first > classes[i + 1].first) val = classes[i].first - classes[i + 1].first;
        else val = -classes[i].first + classes[i + 1].first;
        difs.emplace_back(val, i);
    }
    sort(difs.begin(), difs.end());

    vector<pair<ll, int>> events;
    for (int i = 0; i + 1 < n; i++) {
        events.push_back(difs[i]);
    }

    bool flag = true;
    vector<query> q(G);
    for (int i = 0; i < G; i++) {
        int t;
        ll k;
        cin >> t >> k;
        q[i].type = t;
        q[i].k = k;
        if (t == 3) {
            flag = false;
            int ind;
            cin >> ind;
            q[i].i = ind - 1;
        }
    }

    vector<ll> pref(n);

    pref[0] = szs[0];
    for (int i = 1; i < n; i++) pref[i] = pref[i - 1] + szs[i];


    vector<ll> finalPref(n);
    ll tmp = 0;
    for (int i = 0; i < n; i++) {
        tmp += szs[i] * (n - i - 1);
    }
    finalPref[0] = tmp * difs[0].first;
//    last = difs[0].second;
    for (int i = 1; i < n - 1; i++) {
        tmp -= pref[difs[i - 1].second];
        finalPref[i] = finalPref[i - 1] + tmp * (difs[i].first - difs[i - 1].first);
    }
    vector <vector <ll>> anses;
    vector <vector <int>> tcl;
    vector <treap> treaps;
    if (!flag) {
        anses.resize(n + 1, vector<ll>(a.size()));
        tcl.resize(n + 1, vector <int>(a.size()));
        treaps.resize(n + 1);
        treap t;
        for (int i = 0; i < n; i ++) t.insert(i);
        treaps[0] = t;
        for (int i = 0; i < a.size(); i ++) anses[0][i] = a[i].first;
        for (int i = 1; i <= n; i ++) {
            anses[i] = anses[i - 1];
            for (int j = 0; j < a.size(); j ++) {
                int jd = get_root(j, dsu);
                tcl[i][j] = jd;
                anses[i][j] += t.order_of_key(jd) * (difs[i - 1].first - ((i > 1) ? difs[i - 2].first : 0));
            }
            if (i != n) merge_dsu(repr[difs[i - 1].second], repr[difs[i - 1].second + 1], dsu, ranks);
            t.erase(difs[i - 1].second);
            treaps[i] = t;
        }
    }


    for (auto ql: q) {
        int left = 0, right = n - 1;
        if (ql.k < difs[0].first) {
            if (ql.type == 1) {
                cout << n << '\n';
            } else if (ql.type == 2) {
                cout << n * ql.k << '\n';
            } else {
                ll res = anses[0][ql.i];
                res += treaps[0].order_of_key(tcl[0][ql.i]) * ql.k;
                cout << res << '\n';
            }
            continue;
        }
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (events[mid].first <= ql.k) left = mid;
            else right = mid;
        }
        if (ql.type == 1) {
            cout << n - right << '\n';
        } else if (ql.type == 2) {
            cout << finalPref[left] + (ql.k - difs[left].first) * (n - right) << '\n';
        } else {
            ll res = anses[right][ql.i];
            res += treaps[right].order_of_key(tcl[right][ql.i]) * (ql.k - difs[left].first);
            cout << res << '\n';
        }
    }
}