#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el;
    return out;
}

int get_cost(vector <int> b, vector <int> a) {
    int ans = 0;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (a[j] == b[i]) {
                int x = a[j];
                for (int d = j; d > i; d--) a[d] = a[d - 1];
                a[i] = x;
                ans += j - i;
                break;
            }
        }
    }
    return ans;
}

int get_arr_value(vector <int> a) {
    int x = 0;
    for (int i = a.size() - 1, p = 1; i >= 0; i--, p *= 10) x += a[i] * p;
    return x;
}

int bin_pow(int a, int b) {
    if (b == 0) return 1;
    int z = bin_pow(a, b / 2);
    if (b % 2 == 1) return z * z * a;
    else return z * z;
}

vector <int> stupid(vector <int> a, int y) {
    int n = a.size();
    vector <int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;

    pair <int, vector <int> > best = {get_arr_value(a), a};


    vector <int> b(n);
    while (true) {
        for (int i = 0; i < n; i++) b[i] = a[p[i]];
        best = max(best, {get_arr_value(b) - get_cost(b, a) * y, b});
        if (!next_permutation(p.begin(), p.end())) break;
    }
    return best.second;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    string s;
    cin >> s;
    int n = s.size();
    vector <int> a(n);
    for (int i = 0; i < n; i++) a[i] = s[i] - '0';
    int y;
    cin >> y;
    int k = min(11ll, n);

    for (int i = 0; i < n - k; i++) {
        for (int c = 9; c > a[i]; c--) {
            int good = 0;
            for (int j = i; j < n; j++) {
                if (a[j] == c) {
                    int x = a[j];
                    for (int d = j; d > i; d--) a[d] = a[d - 1];
                    a[i] = x;
                    good = 1;
                    break;
                }
            }
            if (good) break;
        }
    }

    vector <int> b;
    for (int i = n - k; i < n; i++) b.push_back(a[i]);

    auto last_res = stupid(b, y);
    for (int i = 0; i < n - k; i++) cout << a[i];
    for (auto x: last_res) cout << x;
    cout << endl;
}
