#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define all(x) x.begin(), x.end()

void solve() {
    int n, q; cin >> n >> q;
    vi a(n); for (ll &i : a) cin >> i;
    map<ll, int> cnt;
    for (int i = 0; i < n; ++i) {
        if (cnt.find(a[i]) == cnt.end()) cnt[a[i]] = 0;
        cnt[a[i]]++;
    }
    vi merge_events;
    for (auto it = cnt.begin(); it != cnt.end(); ++it) {
        auto it_next = ++it; it--;
        if (it_next == cnt.end()) continue;
        merge_events.push_back(it_next->first - it->first);
    }
    vi sums(1);
    for (int i = 0, j = cnt.size(); i < merge_events.size(); ++i) {
        ll t = (i == 0? merge_events[i]: merge_events[i] - merge_events[i - 1]);
        sums.push_back(j * (j - 1) / 2 * t);
    }
    for (int i = 1; i < sums.size(); ++i) {
        sums[i] += sums[i - 1];
    }
    sort(all(merge_events));
    for (int i = 0; i < q; ++i) {
        int t; cin >> t;
        if (t == 1) {
            ll k; cin >> k;
            cout << cnt.size() - (upper_bound(all(merge_events), k) - merge_events.begin()) << "\n";
        } else if (t == 2) {
            ll k; cin >> k;
            int pos = upper_bound(all(merge_events), k) - merge_events.begin();
            ll ans = sums[pos];
            ll n = cnt.size();
            if (pos == 0) ans += n * (n - 1) / 2 * k;
            else ans += (n - pos) * (n - pos - 1) / 2 * (k - merge_events[pos]);
            cout << ans << "\n";
        } else {
            cout << "\n";
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif

    solve();


}
