#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <limits>
#include <random>
#include <functional>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using ii = pair<int,int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

ll cnt(vi a, const vi &b, int n) {
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if (a[j] == b[i]) {
                ans += j - i;
                a.erase(a.begin() + j);
                a.insert(a.begin() + i, b[i]);
                break;
            }
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

/*#ifdef ONPC
    vi _a{3,1,4,5,9,9};
    vi _b{9,3,1,4,5,9};
    vi _c{9,9,5,4,3,1};
    cout << cnt(_a, _b, 6) << endl;
    cout << cnt(_a, _c, 6) << endl;
#endif*/
    string s;
    ll y;
    cin >> s >> y;
    int n = static_cast<int>(s.size());
    vi a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = s[i] - '0';
    }
    sort(all(a), greater<>());

    for (int i = 0; i < n; ++i)
        cout << a[i];
    cout << endl;
}