#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <limits>
#include <random>
#include <functional>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using ii = pair<int,int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

struct robot {
    int l, r;
    ll c;
    bool t;
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vll a(n);
        for (auto &e : a)
            cin >> e;
        vector<robot> r(m);
        for (auto &e : r) {
            cin >> e.l >> e.r >> e.c >> e.t;
            --e.l, --e.r;
        }
        if (m == 1) {
            auto get = [&a, &e = r[0]](int x) -> ll {
                int l = min(e.l, x);
                int r = max(e.r, x);
                ll ans = accumulate(a.begin() + l, a.begin() + r + 1, 0ll);
                return min(ans, e.c);
            };
            if (!r[0].t) {
                ll ans = get(r[0].l);
                for (int x = 0; x < n; ++x)
                    cout << ans << ' ';
                cout << endl;
            } else {
                for (int x = 0; x < n; ++x)
                    cout << get(x) << ' ';
                cout << endl;
            }
        }
    }
}