#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

#define endl '\n'

using namespace std;

const int Base = 5e5 + 333;

int t;
int n, m;
bool used[Base];
int dp[Base];
vector<int> e[Base];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n >> m;
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
			used[i] = false;
			dp[i] = -1;
		}
		for (int i = 0; i < m; i++)
		{
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			e[u].push_back(v);
			e[v].push_back(u);
		}

		dp[0] = 0;
		queue<int> que;
		que.push(0);
		while (!que.empty())
		{
			int x = que.front();
			que.pop();
			for (auto v : e[x])
			{
				if (!used[v])
				{
					used[v] = true;
					for (auto u : e[v])
					{
						if (dp[u] == -1)
						{
							dp[u] = dp[x] + 2;
							que.push(u);
						}
					}
				}
			}
		}
		for (int i = 1; i < n; i++)
		{
			cout << dp[i] << ' ';
		}
		cout << endl;
	}

	return 0;
}