//#define _GLIBCXX_DEBUG
#include <climits>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <vector>

int main()
{
	int T; std::cin >> T;
	while(T --> 0)
	{
		int N, M; scanf("%d%d", &N, &M);
		// sort "robot range exited" events
		// when they happen, place greedily into non-empty containers starting from the range's start
		struct ev
		{
			int end;
			int start;
			int cap;
		};
		std::vector<ev> evs0;
		std::vector<int> cap(N);
		for(int& x : cap) scanf("%d", &x);
		std::vector<ev> reprog;
		for(int i = 0; i < M; i++)
		{
			int l,r,c,t; scanf("%d%d%d%d", &l,&r,&c,&t);
			l--;
			if(t == 0)
			{
				evs0.push_back({r, l, c});
			}
			else reprog.push_back({r,l,c});
		}
		for(int x = 0; x < N; x++)
		{
			std::vector<ev> evs = evs0;
			for(auto[r,l,c] : reprog)
				evs.push_back({std::max(r,x+1), std::min(l,x), c});
			std::sort(evs.begin(), evs.end(), [](auto a, auto b) { return a.end < b.end; });
			//for(auto[r,l,c] : evs)
			//	printf("[%d,%d): %d\n", l, r, c);
			std::vector<int> placed(N);
			for(auto[r,l,c] : evs)
			{
				int rem = c;
				int ci = l;
				while(ci < r && rem > 0)
				{
					int mp = std::min(rem, cap[ci] - placed[ci]);
					//printf("placing %d at %d (cap=%d placed=%d)\n", mp, ci, cap[ci], placed[ci]);
					placed[ci] += mp;
					rem -= mp;
					ci++;
				}
			}
			int64_t s = 0; for(int x : placed) s += x;
			printf("%lld\n", s);
		}
		printf("\n");
	}
}
