#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;

void solve1() {
    int n, m;
    cin >> n >> m;
    if (m != 1)
        return;
    vll psums(n + 1);
    for (int i = 1; i <= n; i++) {
        int a;
        cin >> a;
        psums[i] = psums[i - 1] + a;
    }
    ll l, r, c, t;
    cin >> l >> r >> c >> t;
    if (t == 0) {
        ll ans = psums[r] - psums[l - 1];
        if (ans > c)
            ans = c;
        for (int i = 0; i < n; i++)
            cout << ans << ' ';
        return;
    }
    for (ll x = 1; x <= n; x++) {
        int li = min(l, x), ri = max(r, x);
        cout << min(psums[ri] - psums[li - 1], c) << ' ';
    }
}

int main() {
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while(t--)
        solve1();
}