#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
//#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<ull, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(all(a));
    vector<int> pos(n);
    vector<ull> un;
    for (int i = 0; i < n; ++i) {
        pos[a[i].second] = i;
        if (un.empty() || un.back() != a[i].first) un.push_back(a[i].first);
    }
    sort(all(un));
    un.erase(unique(all(un)), un.end());
    ull nxt = UINT64_MAX;
    ull prevCont = 0;
    ull everyRound = 0; // !
    vector<ull> plus(n);
    ull allCount = 0;
    for (int i = n - 1, cnt = 0; i >= 0; --i) {
        if (i + 1 != n && a[i + 1].first != a[i].first) ++cnt;
        plus[i] = cnt;
        everyRound += cnt;
//        allCount += a[i].first;
    }
    for (int i = 0; i + 1 < un.size(); ++i) nxt = min(nxt, un[i + 1] - un[i]);
    vector<pair<pair<ull, pair<ull, ull>>, int>> queries(q);
    vector<ull> ans(q);
    int curID = 0;
    for (auto &[tpr, id] : queries) {
        auto &[type, i] = tpr.second;
        cin >> type >> tpr.first;
        if (type == 3) cin >> i;
        id = curID++;
    }
    sort(all(queries));
    for (auto &[tpr, id] : queries) {
        auto &[type, ind] = tpr.second;
        auto &time = tpr.first;
        if (time >= nxt) {
            un.clear();
            for (int i = 0; i < n; ++i) {
                a[i].first += plus[i] * (nxt - prevCont);
                un.push_back(a[i].first);
            }
            allCount += everyRound * (nxt - prevCont);
            sort(all(un));
            un.erase(unique(all(un)), un.end());

            prevCont = nxt;
            nxt = UINT64_MAX;
            for (int i = 0; i + 1 < un.size(); ++i) nxt = min(nxt, un[i + 1] - un[i]);
            if (nxt != UINT64_MAX) nxt += prevCont;
            // ?

            everyRound = 0;
//            allCount = 0;
            for (int i = n - 1, cnt = 0; i >= 0; --i) {
                if (i + 1 != n && a[i + 1].first != a[i].first) ++cnt;
                plus[i] = cnt;
                everyRound += cnt;
//                allCount += a[i].first;
            }
        }
        if (type == 1) {
            ans[id] = un.size();
        } else if (type == 2) {
            ans[id] = allCount + everyRound * (time - prevCont);
        } else {
            ans[id] = a[pos[ind - 1]].first + plus[pos[ind - 1]] * (time - prevCont);
        }
    }
    for (auto &elem : ans) cout << elem << en;
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}