#include <bits/stdc++.h>

// #define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
const int N = 5022;
const int INF = (int) 2e9;
int ban[N][N];
int tp[N][N];
int d[N];
vector<int> gg[N], subtree[N];
bool used[N];

int dfs(int v) {
  used[v] = true;
  int md = INF;
  subtree[v] = {v};
  vector<pair<int, int>> dt;
  for (auto u: gg[v]) {
    if (!used[u]) {
      d[u] = 1 + d[v];
      int bro = dfs(u);
      for (auto x: subtree[u]) {
        subtree[v].pb(x);
      }
      dt.pb({u, bro});
      md = min(md, bro);
    } else {
      md = min(md, d[u]);
    }
  }

  int num = 1;
  for (auto p: dt) {
    if (p.second < d[v]) {
    } else {
      for (auto u: subtree[p.first]) {
        tp[v][u] = num;
      }
      num++;
    }
  }

  return md;
}

void solve() {
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; i++) {
    gg[i] = {};
    subtree[i] = {};
    used[i] = false;
    for (int j = 0; j < n; j++) {
      tp[i][j] = 0;
    }
  }
  vector<bitset<N>> g(n);
  vector<int> cnt(n);
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    g[a][b] = true;
    g[b][a] = true;
    gg[b].pb(a);
    gg[a].pb(b);
    cnt[a]++;
    cnt[b]++;
  }

  for (int a = 0; a < n; a++) {
    for (int b = 0; b < n; b++) {
      bitset<N> ad = (g[a] & g[b]);
      if (ad.count() == 1) {
        int who = 0;
        if (cnt[a] < cnt[b]) {
          for (auto w: gg[a]) {
            if (g[b][w]) {
              who = w;
              break;
            }
          }
        } else {
          for (auto w: gg[b]) {
            if (g[a][w]) {
              who = w;
              break;
            }
          }
        }
        ban[a][b] = who;
      } else if (ad.count() == 0) {
        ban[a][b] = -1;
      } else {
        ban[a][b] = INF;
      }
    }
  }

  d[0] = 0;
  dfs(0);

  vector<vector<int>> g2(n);
  for (int a = 0; a < n; a++) {
    for (int b = a + 1; b < n; b++) {
      if (ban[a][b] == -1) {
      } else if (ban[a][b] == INF) {
        g2[a].pb(b);
        g2[b].pb(a);
      } else {
        int w = ban[a][b];
        if (tp[w][a] == tp[w][b]) {
          g2[a].pb(b);
          g2[b].pb(a);
        }
      }
    }
  }

  for (int v = 0; v < n; v++) {
    used[v] = false;
  }
  used[0] = true;
  deque<int> q = {0};
  vector<int> dist(n, INF);
  dist[0] = 0;
  while (!q.empty()) {
    int v = q.front();
    q.pop_front();
    for (auto u: g2[v]) {
      if (!used[u]) {
        used[u] = true;
        q.pb(u);
        dist[u] = 1 + dist[v];
      }
    }
  }

  for (int v = 1; v < n; v++) {
    if (dist[v] == INF) {
      cout << -1 << ' ';
    } else {
      cout << 2 * dist[v] << ' ';
    }
  }

  cout << '\n';

}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}
