#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Args>
    decltype(auto) operator()(Args&&... args) const {
        return fun(ref(*this), forward<Args>(args)...);
    }
};

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    string s;
    cin >> s;
    ll k;
    cin >> k;

    using int128 = __int128;
    vector<int128> p10{1};
    for (int i = 1; i <= 30; i++) {
        p10.push_back(p10.back() * 10);
    }

    int n = len(s);
    for (int pref = 0; pref < n; pref++) {
        int mx = max_element(s.begin() + pref, s.end()) - s.begin();
        for (int new_pos = pref; new_pos < mx; new_pos++) {
            int128 before =0;
            for (int i = new_pos; i <= mx; i++) {
                before *= 10;
                before += s[i] - '0';
            }
            int128 now = s[mx] - '0';
            for (int i = new_pos; i < mx; i++) {
                now *= 10;
                now += s[i] - '0';
            }
            before *= p10[n - mx - 1];
            now *= p10[n - mx - 1];
            // cout << mx << ' ' << new_pos << ' ' << ll(before) << ' ' << ll(now) << endl;
            if (now - int128(k) * (mx - new_pos) >= before) {
                rotate(s.begin() + pref, s.begin() + mx, s.begin() + mx + 1);
                break;
            }
        }
    }
    cout << s << '\n';
}
