//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

vector<pair<int, int>> changes;

pair<int, int> get(int t0, int i0) {
    pair<int, int> ans;
    for (auto pp : changes) {
        if (pp.first < t0 && i0 <= pp.second) {
            ans.first++;
            ans.second += pp.first;
        }
    }
    return ans;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> arr(n);
    int tot_sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first;
        tot_sm += arr[i].first;
        arr[i].second = i;
    }
    sort(arr.begin(), arr.end());
    vector<int> rperm(n);
    for (int i = 0; i < n; i++) {
        rperm[arr[i].second] = i;
    }
    vector<array<int, 4>> ans1; // {time, sum, delta, cnt}
    vector<int> start_df(n);
    {
        ans1.push_back({0, 0, 0, 0});
        for (int i = 0; i < n; i++) {
            ans1[0][1] += arr[i].first;
            if (i == 0 || arr[i - 1].first != arr[i].first) {
                ans1[0][3]++;
            }
        }
        int cd = 0;
        for (int i = n - 2; i >= 0; i--) {
            if (arr[i + 1].first != arr[i].first) {
                cd++;
            }
            start_df[i] = cd;
            ans1[0][2] += cd;
        }
    }
    map<int, vector<int>> evs;
    for (int i = 0; i < n - 1; i++) {
        if (arr[i].first != arr[i + 1].first) {
            evs[arr[i + 1].first - arr[i].first].push_back(arr[i].first);
            changes.push_back({arr[i + 1].first - arr[i].first, i});
        }
    }
    for (auto el : evs) {
        int time = el.first;
        int sum = ans1.back()[1] + ans1.back()[2] * (time - ans1.back()[0]);
        int cnt = ans1.back()[3] - el.second.size();
        int delta = ans1.back()[2];
        for (int x : el.second) {
            int cnt = lower_bound(arr.begin(), arr.end(), pair<int,int>{x + 1, -1}) - arr.begin();
            delta -= cnt;
        }
        ans1.push_back({time, sum, delta, cnt});
    }
    while (q--) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            int i = (int) (upper_bound(ans1.begin(), ans1.end(), array<int, 4>{k + 1, -1, -1, -1}) - ans1.begin()) - 1;
            cout << ans1[i][3] << endl; 
        } else if (t == 2) {
            int i = (int) (upper_bound(ans1.begin(), ans1.end(), array<int, 4>{k + 1, -1, -1, -1}) - ans1.begin()) - 1;
            int a = ans1[i][1] + ans1[i][2] * (k - ans1[i][0]);
            cout << a - tot_sm << endl;
        } else {
            int i;
            cin >> i;
            i--;
            i = rperm[i];
            int ans = start_df[i] * k + arr[i].first;
            auto pp = get(k, i);
            ans -= k * pp.first - pp.second;
            cout << ans << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
