#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 3e5 + 100, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;

ll n, m;
vector<ll> vec;

struct robot {
	ll l, r, c, t;
};

vector<robot> rbs, cur;
vector<vector<robot>> rem;
void sol() {
	cin >> n >> m;

	vec.resize(n);

	for (auto& c : vec) cin >> c;

	rbs.clear();
	for (int i = 0; i < m; i++) {
		ll l, r, c, t;
		cin >> l >> r >> c >> t;
		l--; r--;
		rbs.push_back({ l, r, c, t });
	}

	cur.clear();
	for (int i = 0; i < n; i++) {
		vector<ll> add(n);
		vector<ll> pref(1);
		rem.clear();
		rem.resize(n);
		for (auto& c : rbs) {
			cur.push_back(c);
			if (c.t == 1) {
				cur.back().l = min(c.l, i);
				cur.back().r = max(c.r, i);
			}

			rem[cur.back().r].push_back(cur.back());
			add[cur.back().l] += cur.back().c;
		}

		ll sm = 0, ans = 0, itr = 0;
		vector<ll> res(n);
		set<pair<ll, ll>> st;
		for (int j = 0; j < n; j++) {
			sm += add[j];
			ll q = min(vec[j], sm);
			res[j] = q;
			ans += q;
			sm -= q;
			st.insert({ j, res[j] });
			pref.push_back(pref.back() + q);

			for (auto c : rem[j]) {
				ll del = c.c;
				auto it = st.lower_bound({ c.l, -2ll });
				while (del > 0 && it != st.end()) {
					pair<ll, ll> pos = (*it);
					st.erase(pos);
					ll t = min(del, pos.second);
					pos.second -= t;
					del -= t;
					if (pos.second != 0) st.insert(pos);
					it = st.lower_bound({ c.l, -2ll });
				}

				sm -= del;
			}
		}

		cout << ans << " ";
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}

/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1
*/