#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <set>
#include <math.h>
#include <algorithm>
using namespace std;
#define ll long long
#define ld long double
#define ii pair<ll, ll>
#define vp vector<ii>
#define vvp vector<vp>
#define vl vector<ll>
#define vvl vector<vl>
const ll INF = (ll)1e18;
const ll MOD = (ll)1e9 + 7;
struct qu {
	ll k, type, i, ind;
};
bool operator < (qu a, qu b) {
	return a.k < b.k;
}
ll cost;
ll check(vl& mass, ll ban=0) {
	ll x = 0;
	for (auto i : mass) x = x * 10 + i;
	return x - ban * cost;
}

void solve() {
	string k;
	cin >> k;
	ll n = (ll)k.size();
	ll rr = 1;
	for (ll i = 2; i <= n; i++) rr *= i;
	ll cost;
	cin >> cost;
	if (cost == 1) {
		sort(k.rbegin(), k.rend());
		cout << k;
		return;
	}
	string tec = k;
	ll ans = 0;
	string ans_v;
	for (ll i = 0; i < rr; i++) {
		string val = k;
		ll ctn = 0;
		for (ll a = 0; a < n; a++) ctn += (val[a] != tec[a]);
		ctn /= 2;
		ll r = 0;
		for (auto i : tec) r = r * 10 + (i - '0');
		if (r - cost * ctn > ans) {
			ans = r - cost * ctn;
			ans_v = tec;
		}
		next_permutation(tec.begin(), tec.end());
	}
	cout << ans_v;

}

int main()
{
	//ll t;
	//cin >> t;
	//while (t--) 
		solve();
}

