#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <set>
#include <math.h>
#include <algorithm>
using namespace std;
#define ll long long
#define ld long double
#define ii pair<ll, ll>
#define vp vector<ii>
#define vvp vector<vp>
#define vl vector<ll>
#define vvl vector<vl>
const ll INF = (ll)1e18;
const ll MOD = (ll)1e9 + 7;
struct qu {
	ll k, type, i, ind;
};
bool operator < (qu a, qu b) {
	return a.k < b.k;
}
ll cost;
ll check(vl& mass, ll ban=0) {
	ll x = 0;
	for (auto i : mass) x = x * 10 + i;
	return x - ban * cost;
}
void solve() {
	ll n, q;
	cin >> n >> q;
	vvl a(n+1);
	vector<set<ll>> b(n+1);
	vl val(n + 1);
	for (ll i = 0; i < n; i++) {
		ll x;
		cin >> x;
		a[0].push_back(x);
		b[0].insert(x);
	}
	for (ll i = 1; i <= n * n; i++) {
		for (ll j = 0; j < n; j++) {
			ll tec = a[i - 1][j];
			ll uu = 0;
			for (auto h : b[i - 1]) uu += (h > tec);
			a[i].push_back(tec + uu);
			val[i] += uu;
			b[i].insert(tec + uu);
		}
	}
	while (q--) {
		ll type;
		cin >> type;
		if (type == 1) {
			ll k;
			cin >> k;
			k = min(k, n);
			cout << b[k].size() << '\n';
		}
		else if (type == 2) {
			ll k;
			cin >> k;
			k = min(k, n);
			cout << val[k] << '\n';
		}
		else {
			ll k, i;
			cin >> k >> i;
			k = min(k, n);
			cout << a[k][i] << '\n';
		}
	}
}

int main()
{
	//ll t;
	//cin >> t;
	//while (t--) 
		solve();
}

