#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#define int long long
using namespace std;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, q; cin >> n >> q;
	set <int> cc;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		cc.insert(x);
		a[i] = x;
	}
	vector <int> c;
	for (auto x : cc) {
		c.push_back(x);
	}
	n = c.size();
	vector <int> p(n, 1e13);
	for (int i = 0; i + 1 < n; i++) {
		p[i] = c[i + 1] - c[i];
	}
	sort(p.begin(), p.end());

	vector <int> cnt(n);
	for (int i = 0; i < a.size(); i++) {
		a[i] = lower_bound(c.begin(), c.end(), a[i]) - c.begin();
		cnt[a[i]]++;
	}

	while (q--) {
		int t; cin >> t;
		if (t == 1) {
			int k; cin >> k;
			cout << p.end() - upper_bound(p.begin(), p.end(), k) << '\n';
		}
		else {
			int k; cin >> k;

			vector <int> dp(n);
			for (int i = n - 2; i >= 0; i--) {
				dp[i] = dp[i + 1] + min(k, c[i + 1] - c[i]);
			}

			if (t == 2) {
				int ans = 0;
				for (int i = 0; i < n; i++) {
					ans += cnt[i] * dp[i];
				}
				cout << ans << '\n';
			}
			else {
				int j; cin >> j; j--;
				j = a[j];
				cout << c[j] + dp[j] << '\n';
			}
		}
	}

	return 0;
}