#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	else return a * bin_pow(a, n - 1);
}

int main() {
	string s; cin >> s;
	ll n = s.size();
	ll y; cin >> y;

	for (ll cur = '9'; cur >= '0'; cur--) {
		for (ll i = 1; i < n; i++) {
			if (s[i] == cur) {
				string t = s;
				ll diff = 0;
				for (ll j = i - 1; j >= 0; j--) {
					diff -= 1ll * (t[j] - '0') * bin_pow(10, n - (j + 1));
					diff -= 1ll * (t[j + 1] - '0') * bin_pow(10, n - (j + 1 + 1));
					diff += 1ll * (t[j] - '0') * bin_pow(10, n - (j + 1 + 1));
					diff += 1ll * (t[j + 1] - '0') * bin_pow(10, n - (j + 1));

					swap(t[j], t[j + 1]);

					if (diff >= 1ll * (i - j) * y) {
						s = t;
					}
				}
			}
		}
	}

	cout << s;

	return 0;
}