#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define X first
#define Y second

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    queue<int> q;
    const int inf = 1e9;
    vector<int> dist(n, inf);
    q.push(0);
    dist[0] = 0;
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (int to : gr[v]) {
            if (dist[to] != inf)
                continue;
            dist[to] = dist[v] + 1;
            q.push(to);
        }
    }
    for (int i = 1; i < n; ++i)
        cout << dist[i] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
        solve();
}