#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
#define pb emplace_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &c : a) cin >> c;
    vector<pii> seg(m);
    vector<int> b(m), t(m);
    for (int i = 0; i < m; i++) {
        cin >> seg[i].fi >> seg[i].se;
        seg[i].fi--;
        seg[i].se--;
        cin >> b[i] >> t[i];
    }
    for (int x = 0; x < n; x++) {
        ll ans = 0;
        vector<int> cur = b;
        vector<vector<int>> start(n), finish(n);
        for (int i = 0; i < m; i++) {
            int l = seg[i].fi, r = seg[i].se;
            if (t[i] == 1) l = min(l, x);
            if (t[i] == 1) r = max(r, x);
            start[l].pb(i);
            finish[r].pb(i);
        }
        set<pii> s;
        vector<int> now(n);
        for (int i = 0; i < n; i++) {
            for (auto &c : start[i]) {
                if (t[c] == 1) s.insert(mp(max(x, seg[c].se), c));
                else s.insert(mp(seg[c].se, c));
            }
            while (s.size() && now[i] < a[i]) {
                int id = s.begin()->se;
                int mn = min(a[i] - now[i], cur[id]);
                now[i] += mn;
                cur[id] -= mn;
                if (cur[id] == 0) s.erase(s.begin());
                ans += mn;
            }
            for (auto &c : finish[i]) s.erase(mp(i, c));
        }
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
