//#pragma GCC optimize("O3,unroll-loops,rename-register,rename-registers,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define int long long

using ll = long long;
#define all(a) a.begin(), a.end()
using pii = std::pair<int, int>;
const ll INFLL = 0x3f3f3f3f3f3f3f3f;

struct query {
    int type, k, i, ind;

    query() = default;
};

struct robot {
    int l, r, c, t;

    robot() = default;

    bool operator<(const robot &ro) const {
        return r < ro.r;
    }
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);

    int t;
    std::cin >> t;
    while (t--) {
        int n, m;
        std::cin >> n >> m;
        int a[n];
        for (auto &i : a) std::cin >> i;
        std::vector<robot> r(m);
        for (auto &i : r) std::cin >> i.l >> i.r >> i.c >> i.t, --i.l, --i.r;

        for (int x = 0; x < n; x++) {
            std::vector<robot> r1(m);
            for (int i = 0; i < m; i++) {
                r1[i] = r[i];
                if (r[i].t == 0) continue;
                r1[i].l = std::min(r1[i].l, x);
                r1[i].r = std::max(r1[i].r, x);
            }

            std::vector<std::vector<robot>> start(n);
            for (int i = 0; i < m; i++) {
                start[r1[i].l].push_back(r1[i]);
            }

            int b[n];
            memcpy(b, a, sizeof b);
            ll ans = 0;

            std::multiset<robot> st;

            for (int pos = 0; pos < n; pos++) {
                for (auto &ro : start[pos]) st.insert(ro);
                while (!st.empty() && st.begin()->r < pos) st.erase(st.begin());
                while (!st.empty() && b[pos] > 0) {
                    auto now = *st.begin();
                    st.erase(st.begin());
                    int take = std::min(now.c, b[pos]);
                    now.c -= take;
                    ans += take;
                    b[pos] -= take;
                    if (now.c > 0) st.insert(now);
                }
                //                for (auto &robot : r1) {
//                    if (pos < robot.l || pos > robot.r) continue;
//                    int take = std::min(robot.c, b[pos]);
//                    robot.c -= take;
//                    ans += take;
//                    b[pos] -= take;
//                }
            }

            std::cout << ans << ' ';
        }
        std::cout << '\n';
    }
}
