#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 5e5 + 100, K = 8, INF = 1e18;

int t, n, m, col[N], dist[N];
bool bi;
vector<int> a[N];

//void dfs(int v, int cl) {
//    col[v] = cl;
//    for (int to : a[v]) {
//        if (col[to] == 0) {
//            dist[to] = dist[v] + 1;
//            dfs(to, cl % 2 + 1);
//        } else if (col[to] == col[v]) {
//            bi = false;
//        }
//    }
//}

void solve() {
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            a[i].clear();
            dist[i] = 0;
            col[i] = 0;
        }
        bi = true;
        for (int i = 0; i < m; i++) {
            int f, s;
            cin >> f >> s;
            f--, s--;
            a[f].push_back(s);
            a[s].push_back(f);
        }
        for (int i = 0; i < n; i++) {
            if (col[i] == 0) {
                queue<int> q;
                q.push(i);
                col[i] = 1;
                dist[i] = 0;
                while (!q.empty()) {
                    int v = q.front();
                    q.pop();
                    for (int to : a[v]) {
                        if (col[to] == 0) {
                            dist[to] = dist[v] + 1;
                            col[to] = col[v] % 2 + 1;
                            q.push(to);
                        } else if (col[to] == col[v]) {
                            bi = false;
                        }
                    }
                }
            }
        }
        if (!bi) {
            for (int i = 1; i < n; i++) {
                if (col[i] == col[0]) {
                    cout << dist[i] << " ";
                } else {
                    cout << dist[i] + n << " ";
                }
            }
        } else {
            for (int i = 1; i < n; i++) {
                if (col[i] == col[0]) {
                    cout << dist[i] << " ";
                } else {
                    cout << -1 << " ";
                }
            }
        }
        cout << '\n';
    }
}