#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

const int N = 1e5 + 100, K = 8, INF = 1e18;

int q, n, m, a[N], l[N], r[N], ll[N], rr[N], ost[N], c[N], t[N];
vector<int> add[N], del[N];

void solve() {
    cin >> q;
    while (q--) {
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < m; i++) {
            cin >> l[i] >> r[i] >> c[i] >> t[i];
            l[i]--, r[i]--;
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                add[j].clear();
                del[j].clear();
            }
            for (int j = 0; j < m; j++) {
                if (t[j] == 1) {
                    ll[j] = min(l[j], i);
                    rr[j] = max(r[j], i);
                } else {
                    ll[j] = l[j];
                    rr[j] = r[j];
                }
                ost[j] = c[j];
                add[ll[j]].push_back(j);
                del[rr[j] + 1].push_back(j);
            }
            set<pair<int, int>> se;
            long long sum = 0;
            for (int j = 0; j < n; j++) {
                for (int x : del[j]) {
                    se.erase({j, x});
                }
                for (int x : add[j]) {
                    se.insert({rr[x] + 1, x});
                }
                int cur = a[j];
                while (!se.empty() && cur > 0) {
                    int x = se.begin()->second;
                    se.erase(se.begin());
                    int e = min(cur, ost[x]);
                    sum += e;
                    cur -= e;
                    ost[x] -= e;
                    if (ost[x] > 0) {
                        se.insert({rr[x] + 1, x});
                    }
                }
            }
            cout << sum << " ";
        }
        cout << '\n';
    }
}