#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

struct rob{
    int l;
    int r;
    int c;
    int t;
};

bool operator<(rob a, rob b){
    return a.r < b.r;
}

struct sob{
    int pos;
    rob i;
    int type;
};

bool operator<(sob a, sob b){
    if(a.pos == b.pos) return a.type < b.type;
    return a.pos < b.pos;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t, n, m;
    cin >> t;
    vector<int> a;
    vector<rob> b;
    for(int iter = 0; iter < t; ++iter){
        cin >> n >> m;
        a.resize(n);
        b.resize(m);
        for(int i = 0; i < n; ++i) cin >> a[i];
        for(int i = 0; i < m; ++i){
            cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
            --b[i].l;
            --b[i].r;
        }
        vector<sob> scnl;
        multiset<rob> cur;
        rob ne;
        for(int x = 0; x < n; ++x){
            long long ans = 0;
            scnl.clear();
            cur.clear();
            for(rob i : b){
                if(i.t == 1){
                    ne.l = min(i.l, x);
                    ne.r = max(i.r, x);
                }else{
                    ne.l = i.l;
                    ne.r = i.r;
                }
                ne.c = i.c;
                scnl.push_back({ne.l, ne, 1});
                scnl.push_back({ne.r+1, ne, -1});
            }
            sort(scnl.begin(), scnl.end());
            //for(sob i : scnl){
            //    cout << i.pos << '\n';
            //}
            int y = 0;
            rob cc;
            long long cucu;
            for(int i = 0; i < n; ++i){
                while(scnl[y].pos == i){
                    if(scnl[y].type == 1){
                        cur.insert(scnl[y].i);
                    }else{
                        if(cur.count(scnl[y].i)){
                            cur.erase(scnl[y].i);
                        }
                    }
                    ++y;
                }
//                for(auto i : cur){
//                    cout << i.l << ' ' << i.r << ' ' << i.c << '\n';
//                }
                cucu = a[i];
                while(cucu > 0 && cur.size() != 0){
                    cc = *cur.begin();
                    cur.erase(cur.begin());
                    if(cc.c >= cucu){
                        cc.c -= cucu;
                        ans += cucu;
                        cucu = 0;
                        if(cc.c != 0) cur.insert(cc);
                    }else{
                        cucu -= cc.c;
                        ans += cc.c;
                    }
                }
//                cout << cucu << '\n';
//                for(auto i : cur){
//                    cout << i.l << ' ' << i.r << ' ' << i.c << '\n';
//                }
            }
            cout << ans << ' ';
        }
        cout << '\n';
    }
}
