﻿#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <math.h>
using namespace std;

using s64 = long long;
using ld = long double;

#define all(obj) obj.begin(), obj.end()

s64 cast(string s) {
	reverse(all(s));
	ld n = 0;
	for (char c : s) {
		n *= 10;
		n += c - '0';
	}
	return n;
}

s64 epow(s64 a, s64 n) {
	if (n == 0) {
		return 1;
	}
	else {
		s64 z = epow(a, n / 2);
		z *= z;
		if (n & 1) {
			z *= a;
		}
		return z;
	}
}

void solve(istream& cin) {
	string s;
	cin >> s;
	reverse(all(s));
	int n = s.size();
	s64 y;
	cin >> y;

	auto f = [&](string s, int k) {
		for (int i = n - 1; i >= 0; i--) {
			// хотим поставить на место s[i] самую наибольшую цифру
			for (int d = 9; d > s[i] - '0'; d--) {
				int j;
				for (j = i - 1; j >= 0 && s[j] != d + '0'; j--) {}
				if (j != -1 && i - j <= k) {
					k -= i - j;
					while (j < i) {
						swap(s[j], s[j + 1]);
						j++;
					}
				}
			}
		}
		return s;
	};

	s64 ans = cast(s);
	string ans_str = s;


	// давайте зафиксируем k
	// получим самую большую строчку из s за не более k действий
	for (int k = 0; k < 1e4; k++) {
		s64 cur = cast(f(s, k)) - y * k;
		if (ans < cur) {
			ans = cur;
			ans_str = f(s, k);
		}
		//cout << f(s, k) << " " << cast(f(s, k)) << " " << cast(f(s, k)) - y * k << "\n";
	}
	reverse(all(ans_str));
	cout << ans_str << "\n";
}

int main() {
	//ifstream cin("input.txt");

	solve(cin);

	return 0;
}