#include<bits/stdc++.h>
using namespace std;
 
#define int long long
#define siz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define eb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
 
const int N = 1e5 + 3, inf = 1e15;
 
struct rob {
    int l, r, c, t;
    rob() {}
    rob(int l, int r, int c, int t) : l(l), r(r), c(c), t(t) {}
};
 
int n, m;
int a[N], p[N], res[N];
 
void solve(vector<rob> b, int l, int r) {
    //cout << "solve " << l+1 << " " << r+1 << endl;
 
    vector<int> cha(m);
    //vector<vector<int>> L(n), R(n);
    vector<pii> L, R;

    for (int i = 0; i < m; ++i) {
        if (b[i].t == 1) {
            if (b[i].r < l) { b[i].r = l; cha[i] = true; }
            if (b[i].l > r) { b[i].l = r; cha[i] = true; }
        }
 		
 		L.eb(b[i].l, i);
 		L.eb(b[i].r+1, -1);
        //L[b[i].l].eb(i);
        R.eb(b[i].r, i);
        R.eb(b[i].l-1, -1);
        //R[b[i].r].eb(i);
    }

    sort(all(L));
    sort(all(R), [](auto v1, auto v2) { return v1 > v2; });
 	
    int sum = 0;
    {
        auto comp1 = [&](int v1, int v2) { return b[v1].r < b[v2].r; };
        multiset<int, decltype(comp1)> so(comp1);
        
        int ind = 0;

        for (int i = 0; i < l; ++i) {
        	while (ind < siz(L) && L[ind].fi == i) {
        		so.emplace(L[ind++].se);
        	}
            if (siz(so) && b[*so.begin()].r + 1 == i) so.erase(so.begin());
 
            int val = a[i];
            while (val && siz(so)) {
                int id = *so.begin();
                int t = min(val, b[id].c);
                sum += t;
                val -= t;
                b[id].c -= t;
                if (b[id].c == 0) so.erase(so.begin());
            }
        }
    }
 
    {
        auto comp2 = [&](int v1, int v2) { return b[v1].l > b[v2].l; };
        multiset<int, decltype(comp2)> so(comp2);

        int ind = 0;

        for (int i = n-1; i > r; --i) {
        	while (ind < siz(R) && R[ind].fi == i) {
        		so.emplace(R[ind++].se);
        	}
            if (siz(so) && b[*so.begin()].l - 1 == i) so.erase(so.begin());
 
            int val = a[i];
            while (val && siz(so)) {
                int id = *so.begin();
                int t = min(val, b[id].c);
                sum += t;
                val -= t;
                b[id].c -= t;
                if (b[id].c == 0) so.erase(so.begin());
            }
 
        }
    }
 
    int pr = 0, all = 0, suf = 0;
    for (int i = 0; i < m; ++i) {
        if (cha[i]) {
            if (b[i].r >= r) suf += b[i].c;
            else pr += b[i].c;
        } else if (b[i].l <= l && b[i].r >= r) all += b[i].c;
    }
 
    //cout << "end " << sum << " " << pr << " " << all << " " << suf << endl;
 
    int les = 0, ris = 0;
    for (int i = l; i <= r; ++i)
        ris += a[i];
    for (int i = l; i <= r; ++i) {
        ris -= a[i];
 
        int nles = les - min(les, pr);
        int npr = pr - min(les, pr);
        int nris = ris - min(ris, suf);
        int nsuf = suf - min(ris, suf);
 
        int noth = nles + nris - min(nles + nris, all);
        int nall = all - min(nles + nris, all);
         
        res[i] = sum + (les + ris - noth) + min(a[i], nall + npr + nsuf);
 
        les += a[i];
    }
}
 
void run() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p[i+1] = p[i] + a[i];
    }

    vector<rob> b;
    vector<int> lin = {0, n};
    for (int i = 0; i < m; ++i) {
        int l, r, c, t; cin >> l >> r >> c >> t; --l, --r;
        b.eb(l, r, c, t);
        lin.eb(max(0ll, l-1));
        lin.eb(l);
        lin.eb(r);
        lin.eb(r+1);
    }
    /*for (int i = 0; i < n; ++i)
        lin.eb(i);*/
 
    sort(all(lin));
    lin.erase(unique(all(lin)), lin.end());
 
    for (int i = 0; i < siz(lin)-1; ++i) {
        solve(b, lin[i], lin[i+1]-1);
    }
 
    for (int i = 0; i < n; ++i)
        cout << res[i] << " ";
    cout << '\n';
}
 
signed main() {
    cin.tie(0), ios_base::sync_with_stdio(0);
 
    int t;
    cin >> t;
    while (t--) {
        run();  
    }
}