#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define pii pair<int,int>
#define lll __int128

void solve () {
    int n, q; cin >> n >> q;
    vector<ll> c(n);
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    sort(all(c));
    c.erase(unique(all(c)), c.end());
    n = c.size();
    vector<ll> d(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        d[i] = c[i + 1] - c[i];
    }
    sort(all(d));
    for (int _ = 0; _ < q; ++_) {
        int t; ll k; cin >> t;
        assert(t == 1);
        cin >> k;
        int j = upper_bound(all(d), k) - d.begin();
        cout << n - j << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
