#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <cassert>

using namespace std;
#pragma GCC optimize("O3")
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

vector <vector <int>> g;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int tt; cin >> tt;
	while (tt--) {
		int n, m; cin >> n >> m;
		g.assign(n + 1, {});
		for (int i = 0, u, v; i < m; ++i) {
			cin >> u >> v;
			g[u].push_back(v);
			g[v].push_back(u);
		}

		vector <int> dp(n + 1, mod), dp2(n + 1, mod);
		dp[1] = 0;
		set <pair <int, int>> h1, h2;
		for (int i = 1; i <= n; ++i) {
			h1.insert({ dp[i], i });
		}
		vector <bool> used(n + 1), was(n + 1);
		while (!h1.empty()) {
			auto it = h1.begin();
			int v = it->second;
			if (!h2.empty()) {
				auto it2 = h2.begin();
				int u = it2->second;
				if (dp2[u] < dp[v]) {
					was[u] = true;
					for (auto& x : g[u]) {
						if (!used[x]) {
							h1.erase({ dp[x], x });
							dp[x] = min(dp[x], dp2[u] + 2);
							h1.insert({ dp[x], x });
						}
					}
					h2.erase(it2);
					continue;
				}
			}
			used[v] = true;
			h1.erase(it);
			for (auto& u : g[v]) {
				if (was[u]) continue;
				h2.erase({ dp2[u], u });
				dp2[u] = min(dp2[u], dp[v]);
				h2.insert({ dp2[u], u });
			}
		}
		for (int i = 2; i <= n; ++i) cout << (dp[i] == mod ? -1 : dp[i]) << ' ';
		cout << '\n';
	}

}