#define ll long long

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

struct el {
	ll t = 0, k = 0, pos = 0, i = 0;

	const bool operator <(const el& e) const {
		return k < e.k;
	}
};

/*void dfs(vector<ll>& a, ll v, ll& ans, ll a, ll y, ll n, ll b, ll &op, ll cnt) {
	b *= 10;
	if (v == n - 1) {
		b += a[v];
		ll sum = b - a - y * cnt;
		
		if (b == 931459) {
			b += 0;
		}

		if (ans < sum) {
			ans = max(ans, sum);
			op = b;
		}
		else if (ans == sum && b > op) {
			op = b;
		}

		b -= a[v];
		return;
	}

	for (ll i = v; i < n; i++) {
		for (ll j = i - 1; j >= v; j--) {
			swap(a[j], a[j + 1]);
		}
		b += a[v];
		dfs(a, v + 1, ans, a, y, n, b, op, cnt + (i - v));
		b -= a[v];
		for (ll j = v; j < i; j++) {
			swap(a[j], a[j + 1]);
		}
	}
}*/

signed main() {
	ll n, q;
	cin >> n >> q;

	vector<ll> c(n);
	vector<pair<ll, ll>> a(n);

	for (ll i = 0; i < n; i++) {
		cin >> c[i];
		a[i] = (make_pair(c[i], i));
	}

	sort(a.begin(), a.end());
	multiset<ll> dst;
	vector<ll> cng(n);
	cng.back() = 0;

	for (ll i = 0; i < n - 1; i++) {
		if (a[i].first != a[i + 1].first) {
			dst.insert(a[i + 1].first - a[i].first);
		}
	}

	ll un = 1;
	ll cn = 0;

	for (ll i = n - 2; i >= 0; i--) {
		if (a[i].first == a[i + 1].first) {
			cng[a[i].second] = cng[a[i + 1].second];
		}
		else {
			cng[a[i].second] = cng[a[i + 1].second] + 1;
			un++;
		}

		cn += cng[a[i].second];
	}

	vector<el> qu(q);

	for (ll i = 0; i < q; i++) {
		cin >> qu[i].t >> qu[i].k;
		if (qu[i].t == 3) {
			cin >> qu[i].pos;
			qu[i].pos--;
		}
		qu[i].i = i;
	}

	sort(qu.begin(), qu.end());
	vector<ll> ans(q);

	ll t = 0;
	ll j = 0;
	ll sum = 0;
	dst.insert(1e18);

	while (dst.size() > 0) {
		while (j < qu.size() && qu[j].k < *dst.begin()) {
			ll pos = qu[j].pos;
			ll k = qu[j].k;

			if (qu[j].t == 1) {
				ans[qu[j].i] = un;
			}
			else if (qu[j].t == 2) {
				ans[qu[j].i] = sum + cn * (k - t);
			}
			else {
				ans[qu[j].i] = c[pos] + cng[pos] * (k - t);
			}
			j++;
		}

		ll d = *dst.begin() - t;
		dst.erase(dst.begin());

		for (ll i = 0; i < n; i++) {
			c[i] += d * cng[i];
			sum += d * cng[i];
		}

		vector<pair<ll, ll>> a1;

		for (ll i = 0; i < n; i++) {
			a1.push_back(make_pair(c[i], i));
		}

		sort(a1.begin(), a1.end());
		vector<ll> cng1(n);
		cng1.back() = 0;

		ll un1 = 1;
		ll cn1 = 0;

		for (ll i = n - 2; i >= 0; i--) {
			if (a1[i].first == a1[i + 1].first) {
				cng1[a1[i].second] = cng1[a1[i + 1].second];
			}
			else {
				cng1[a1[i].second] = cng1[a1[i + 1].second] + 1;
				un1++;
			}

			cn1 += cng1[a1[i].second];
		}

		t += d;

		un = un1;
		cn = cn1;
		a = a1;
		cng = cng1;
	}

	for (auto i : ans) {
		cout << i << "\n";
	}
}

