#define ll long long

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>

using namespace std;

struct el {
	ll t = 0, k = 0, pos = 0, i = 0;

	const bool operator <(const el& e) const {
		return k < e.k;
	}
};

struct el1 {
	ll val = 0, cnt = 0, i = 0, l = 0;

	el1(ll val1 = 0, ll cnt1 = 0, ll i1 = 0, ll l1 = 0) {
		val = val1;
		cnt = cnt1;
		i = i1;
		l = l1;
	}

	const bool operator <(const el1& e) const {
		return tie(val, cnt, i, l) < tie(e.val, e.cnt, e.i, e.l);
	}
};

/*void dfs(vector<ll>& a, ll v, ll& ans, ll a, ll y, ll n, ll b, ll &op, ll cnt) {
	b *= 10;
	if (v == n - 1) {
		b += a[v];
		ll sum = b - a - y * cnt;
		
		if (b == 931459) {
			b += 0;
		}

		if (ans < sum) {
			ans = max(ans, sum);
			op = b;
		}
		else if (ans == sum && b > op) {
			op = b;
		}

		b -= a[v];
		return;
	}

	for (ll i = v; i < n; i++) {
		for (ll j = i - 1; j >= v; j--) {
			swap(a[j], a[j + 1]);
		}
		b += a[v];
		dfs(a, v + 1, ans, a, y, n, b, op, cnt + (i - v));
		b -= a[v];
		for (ll j = v; j < i; j++) {
			swap(a[j], a[j + 1]);
		}
	}
}*/

void add(vector<ll>& tree, ll v, ll l, ll r, ll pos, ll x) {
	if (l == r) {
		tree[v] += x;
		return;
	}

	ll mid = (l + r) / 2;

	if (mid >= pos) {
		add(tree, v * 2 + 1, l, mid, pos, x);
	}
	else {
		add(tree, v * 2 + 2, mid + 1, r, pos, x);
	}

	tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
}

ll geta(vector<ll>& tree, ll v, ll l, ll r, ll ql, ll qr) {
	ql = max(ql, l);
	qr = min(qr, r);

	if (ql > qr) {
		return 0;
	}

	if (ql == l && qr == r) {
		return tree[v];
	}

	ll mid = (l + r) / 2;

	ll ansl = geta(tree, v * 2 + 1, l, mid, ql, qr);
	ll ansr = geta(tree, v * 2 + 2, mid + 1, r, ql, qr);

	return ansr + ansl;
}

signed main() {
	ll n, q;
	cin >> n >> q;

	if (n < 5001) {
		vector<ll> c(n);
		vector<pair<ll, ll>> a(n);

		for (ll i = 0; i < n; i++) {
			cin >> c[i];
			a[i] = (make_pair(c[i], i));
		}

		sort(a.begin(), a.end());
		multiset<ll> dst;
		vector<ll> cng(n);
		cng.back() = 0;

		for (ll i = 0; i < n - 1; i++) {
			if (a[i].first != a[i + 1].first) {
				dst.insert(a[i + 1].first - a[i].first);
			}
		}

		ll un = 1;
		ll cn = 0;

		for (ll i = n - 2; i >= 0; i--) {
			if (a[i].first == a[i + 1].first) {
				cng[a[i].second] = cng[a[i + 1].second];
			}
			else {
				cng[a[i].second] = cng[a[i + 1].second] + 1;
				un++;
			}

			cn += cng[a[i].second];
		}

		vector<el> qu(q);

		for (ll i = 0; i < q; i++) {
			cin >> qu[i].t >> qu[i].k;
			if (qu[i].t == 3) {
				cin >> qu[i].pos;
				qu[i].pos--;
			}
			qu[i].i = i;
		}

		sort(qu.begin(), qu.end());
		vector<ll> ans(q);

		ll t = 0;
		ll j = 0;
		ll sum = 0;
		dst.insert(1e18);

		while (dst.size() > 0) {
			while (j < qu.size() && qu[j].k < *dst.begin()) {
				ll pos = qu[j].pos;
				ll k = qu[j].k;

				if (qu[j].t == 1) {
					ans[qu[j].i] = un;
				}
				else if (qu[j].t == 2) {
					ans[qu[j].i] = sum + cn * (k - t);
				}
				else {
					ans[qu[j].i] = c[pos] + cng[pos] * (k - t);
				}
				j++;
			}

			ll d = *dst.begin() - t;
			dst.erase(dst.begin());

			for (ll i = 0; i < n; i++) {
				c[i] += d * cng[i];
				sum += d * cng[i];
			}

			vector<pair<ll, ll>> a1;

			for (ll i = 0; i < n; i++) {
				a1.push_back(make_pair(c[i], i));
			}

			sort(a1.begin(), a1.end());
			vector<ll> cng1(n);
			cng1.back() = 0;

			ll un1 = 1;
			ll cn1 = 0;

			for (ll i = n - 2; i >= 0; i--) {
				if (a1[i].first == a1[i + 1].first) {
					cng1[a1[i].second] = cng1[a1[i + 1].second];
				}
				else {
					cng1[a1[i].second] = cng1[a1[i + 1].second] + 1;
					un1++;
				}

				cn1 += cng1[a1[i].second];
			}

			t += d;

			un = un1;
			cn = cn1;
			a = a1;
			cng = cng1;
		}

		for (auto i : ans) {
			cout << i << "\n";
		}
		return 0;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////////

	vector<ll> c(n);
	for (ll i = 0; i < n; i++) {
		cin >> c[i];
	}

	map<ll, ll> mp;

	sort(c.begin(), c.end());
	multiset<el1> dst;
	ll cnt = 1;
	mp[c[0]] = 0;

	for (ll i = 0; i < n - 1; i++) {
		if (c[i] != c[i + 1]) {
			mp[c[i]] = dst.size() + 1;
			dst.insert(el1(c[i + 1] - c[i], cnt, mp[c[i]]));
			cnt = 1;
		}
		else {
			cnt++;
		}
	}

	ll un = 1;
	ll cn = 0;

	vector<ll> tree(4 * n + 10, 0);

	auto it = dst.end();
	--it;

	multiset<el1> dst2;

	while(1) {
		add(tree, 0, 0, n - 1, it->i, it->cnt);

		auto pr = *it;

		pr.l = geta(tree, 0, 0, n - 1, 0, pr.i);

		dst2.insert(pr);
		
		if (it == dst.begin()) {
			break;
		}
		--it;
	}

	dst.swap(dst2);

	vector<ll> cng(n);
	cng.back() = 0;

	for (ll i = n - 2; i >= 0; i--) {
		if (c[i] == c[i + 1]) {
			cng[i] = cng[i + 1];
		}
		else {
			cng[i] = cng[i + 1] + 1;
			un++;
		}

		cn += cng[i];
	}

	vector<el> qu(q);

	for (ll i = 0; i < q; i++) {
		cin >> qu[i].t >> qu[i].k;
		if (qu[i].t == 3) {
			cin >> qu[i].pos;
			qu[i].pos--;
		}
		qu[i].i = i;
	}

	sort(qu.begin(), qu.end());
	vector<ll> ans(q);

	ll t = 0;
	ll j = 0;
	ll sum = 0;
	dst.insert(el1(1e18, 0));

	while (dst.size() > 0) {
		while (j < qu.size() && qu[j].k < dst.begin()->val) {
			ll pos = qu[j].pos;
			ll k = qu[j].k;

			if (qu[j].t == 1) {
				ans[qu[j].i] = un;
			}
			else {
				ans[qu[j].i] = sum + cn * (k - t);
			}
			j++;
		}

		ll d = dst.begin()->val - t;
		ll val = dst.begin()->cnt;
		ll ld = dst.begin()->l;
		dst.erase(dst.begin());

		sum += cn * d;
		t += d;
		un--;
		cn -= ld;
	}

	for (auto i : ans) {
		cout << i << "\n";
	}

}

/*
6 6
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
2 2
*/

