#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

int n, m, timer;
vector <bool> cutp;
vector <int> tin, fup, d0, d1;
vector <vector <int>> g;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int T;
    cin >> T;
    while (T--) {
        cin >> n >> m;
        g.resize(n);
        for (int i = 1; i <= m; i++) {
            int v, u;
            cin >> v >> u;
            v--, u--;
            g[v].push_back(u), g[u].push_back(v);
        }

        d0.assign(n, 1e9), d1.assign(n, 1e9);
        queue <pair <int, int>> q;
        d0[0] = 0, q.push(make_pair(0, 0));

        while (!q.empty()) {
            auto [v, t] = q.front();
            q.pop();
            if (t == 0) {
                for (auto &u: g[v]) {
                    if (d0[v] + 1 < d1[u]) {
                        d1[u] = d0[v] + 1;
                        q.push(make_pair(u, 1));
                    }
                }
            } else {
                for (auto &u: g[v]) {
                    if (d1[v] + 1 < d0[u]) {
                        d0[u] = d1[v] + 1;
                        q.push(make_pair(u, 0));
                    }
                }
            }
        }

        for (int v = 0; v < n; v++)
            if (d0[v] == 1e9)
                d0[v] = -1;
        for (int v = 1; v < n; v++)
            cout << d0[v] << " ";
        cout << endl;
        g.clear();
    }

    return 0;
}
