#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>

using namespace std;

typedef __int128 ll;

void solve(string s, ll y){
    ll n = s.size();
    ll times = 1;
    for (ll i = 2; i <= n; i++)
        times *= i;
    string shift = s;
    ll max = 0;
    string ans = s;
    vector<vector<int>> pos(10);
    for (int i = 0; i < n; i++)
        pos[s[i] - '0'].push_back(i);
    for (ll t = 0; t < times; t++){
        vector<int> it(10);
        ll swaps = 0, moves = 0;
        for (ll i = 0; i < n; i++){
            int j = pos[shift[i] - '0'][it[shift[i] - '0']];
            swaps += j - i + moves;
            if (j - i + moves)
                moves++;
            it[shift[i] - '0']++;
        }
        ll cost = 0;
        for (ll i = 0; i < n; i++){
            cost *= 10;
            cost += shift[i] - '0';
        }
        cost -= y * swaps;
        if (cost > max || (cost == max && shift > ans)){
            max = cost;
            ans = shift;
        }
        next_permutation(shift.begin(), shift.end());
    }
    cout << ans;
}

const int k = 11;

int32_t main() {
	cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
	string s;
	int y, n;
	cin >> s >> y;
	n = s.size();
    int pos = 0;
    if (n > k){
        pos = n - k;
        int cnt[10];
        for (int i = 0; i < 10; i++)
            cnt[i] = 0;
        for (int i = 0; i < n; i++)
            cnt[s[i] - '0']++;
        string t = s;
        for (int i = 0; i < pos; i++)
            for (int c = 9; c >= 0; c--)
                if (cnt[c]){
                    cnt[c]--;
                    t[i] = '0' + c;
                    break;
                }
        for (int i = 0; i < n; i++)
            if (cnt[s[i] - '0']){
                cnt[s[i] - '0']--;
                t[pos] = s[i];
                pos++;
            }
        pos = n - k;
        for (int i = 0; i < pos; i++)
            cout << t[i];
        s = "";
        for (int i = pos; i < n; i++)
            s += t[i];
    }
    solve(s, y);
}