#include<bits/stdc++.h>

using namespace std;

#define int long long

int INF = 1000000000000ll;
struct node {
	int l;
	int r;
	int val1;
	int val2;
	int vl, vr;
	node(int ll, int rr) {
		l = -1;
		r = -1;
		vl = ll;
		vr = vr;
		val1 = 0;
		val2 = 0;
	}
	node() {
		l = -1;
		r = -1;
		val1 = 0;
		val2 = 0;
	}
};

node T[20000000];
int cnt = 0;

void update(int v, int vl, int vr, int ind) {
	if (vr - vl == 1) {
		T[v].val1 += ind;
		T[v].val2 += 1;
		return;
	}
	int vm = (vl + vr) / 2;
	if (T[v].l == -1) {
		T[v].l = cnt;
		T[cnt] = node(vl, vm);
		cnt++;
	}
	if (T[v].r == -1) {
		T[v].r = cnt;
		T[cnt] = node(vm, vr);
		cnt++;
	}
	if (vm > ind) {
		update(T[v].l, vl, vm, ind);
	} else {
		update(T[v].r, vm, vr, ind);
	}
	T[v].val2 = T[T[v].l].val2 + T[T[v].r].val2;
	T[v].val1 = T[T[v].l].val1 + T[T[v].r].val1;
}

int get1(int v, int l, int r, int vl, int vr) {
	if (l >= r) {
		return 0;
	}
	if (l == vl && r == vr) {
		return T[v].val1;
	}
	int vm = (vl + vr) / 2;
	if (T[v].l == -1) {
		T[v].l = cnt;
		T[cnt] = node(vl, vm);
		cnt++;
	}
	if (T[v].r == -1) {
		T[v].r = cnt;
		T[cnt] = node(vm, vr);
		cnt++;
	}
	int now1 = get1(T[v].l, l, min(r, vm), vl, vm);
	int now2 = get1(T[v].r, max(l, vm), r, vm, vr);
	return now1 + now2;
}

int get2(int v, int l, int r, int vl, int vr) {
	if (l >= r) {
		return 0;
	}
	if (l == vl && r == vr) {
		return T[v].val2;
	}
	int vm = (vl + vr) / 2;
	if (T[v].l == -1) {
		T[v].l = cnt;
		T[cnt] = node(vl, vm);
		cnt++;
	}
	if (T[v].r == -1) {
		T[v].r = cnt;
		T[cnt] = node(vm, vr);
		cnt++;
	}
	int now1 = get2(T[v].l, l, min(r, vm), vl, vm);
	int now2 = get2(T[v].r, max(l, vm), r, vm, vr);
	return now1 + now2;
}

signed main() {
	int n, q;
	cin >> n >> q;
	vector<pair<int, int>> arr1(n);
	for (int i = 0; i < n; i++) {
		cin >> arr1[i].first;
		arr1[i].second = i;
	}
	sort(arr1.begin(), arr1.end());

	vector<int> pos(n);
	for (int i = 0; i < n; i++) {
		pos[arr1[i].second] = i;
	}

	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		arr[i] = arr1[i].first;
	}

	vector<int> t(n - 1);
	for (int i = 0; i < n - 1; i++) {
		t[i] = arr[i + 1] - arr[i];
	}

	auto t1 = t;
	sort(t1.begin(), t1.end());

	vector<pair<int, int>> t2;
	for (int i = 0; i < n - 1; i++) {
		t2.push_back(make_pair(t[i], i + 1));
	}

	sort(t2.begin(), t2.end());

	vector<int> pref(n - 1);
	for (int i = 0; i < n - 1; i++) {
		pref[i] = t2[i].first * t2[i].second;
		if (i) {
			pref[i] += pref[i - 1];
		}
	}

	vector<int> suf(n - 1);
	for (int i = n - 2; i >= 0; i--) {
		suf[i] = t2[i].second;
		if (i != n - 2) {
			suf[i] += suf[i + 1];
		}
	}
	vector<int> ans(q);
	vector<vector<pair<int, int>>> tasks(n);
	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			auto it = upper_bound(t1.begin(), t1.end(), k);
			ans[i] = (t1.end() - it) + 1;
			//cout << (t1.end() - it) + 1 << endl;
		}
		if (type == 2) {
			int k;
			cin >> k;
			auto it = upper_bound(t2. begin(), t2.end(), make_pair(k, 1000000ll));
			int cnt1 = it - t2.begin();
			int ans1 = 0;
			if (cnt1 != 0) {
				ans1 += pref[cnt1 - 1];
			}
			int ind = cnt1;
			if (ind != n - 1) {
				ans1 += suf[ind] * k;
			}
			ans[i] = ans1;
			//cout << ind << " " << endl;
			//cout << ans << endl;
		}
		if (type == 3) {
			int k, ind;
			cin >> k >> ind;
			ind--;
			tasks[pos[ind]].push_back(make_pair(k, i));
		}
	}
	T[0] = node(0ll, INF);
	cnt++;
	for (int i = n - 1; i >= 0; i--) {
		for (auto q: tasks[i]) {
			int k = q.first;
			//cout << "task: " << i << " " << k << endl;
			int now = get1(0, 0, k, 0, INF) + get2(0, k, INF, 0, INF) * k;
			//cout << "! " << now << " ";
			ans[q.second] = now + arr[i];
		}
		if (i != 0) {
			//cout << "! " << t[i - 1] << endl;
			update(0, 0, INF, t[i - 1]);
		}
	}
	//cout << "KEKE" << T[0].val2 << endl;
	for (int i = 0; i < q; i++) {
		cout << ans[i] << endl;
	}
}
