#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 3010;

int k;

void solve()
{
	int n;
	ll w, h;
	cin >> n >> w >> h;

	ll ans = 0;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(all(a));
	ll prv = h;

	for (int i = 0; i < n; i++)
	{
		ll x = a[i].first;
		ll y = a[i].second;
		if (y < prv)
		{
			ans += (w - x) * (prv - y);
			prv = y;
		}
	}

	cout << ans << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> k >> t >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}
