#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cmath>
#include <algorithm>
#define int long long
using namespace std;
struct node {
	int mn = 0, ps = 0;
};
vector <vector <int> > g;
vector <int> c;
vector <vector <int> > lr;
vector <int> ans;
vector <int> pp;
vector <int> sz;
vector <int> eul;
vector <int> wh;
vector <vector <int> > pts;
vector <node> tree;
vector <int> w2;
int cen = 0;
int n;
void push(int v, int l, int r) {
	if (r - l == 1 || tree[v].ps == 0) {
		tree[v].ps = 0;
		return;
	}
	int mid = (r + l) / 2;
	tree[v * 2 + 1].mn += tree[v].ps;
	tree[v * 2 + 2].mn += tree[v].ps;
	tree[v * 2 + 1].ps += tree[v].ps;
	tree[v * 2 + 2].ps += tree[v].ps;
	tree[v].ps = 0;
}
void build(int v, int l, int r) {
	if (r - l == 1) {
		tree[v].mn = lr[eul[l]][1];
		return;
	}
	int mid = (r + l) / 2;
	build(v * 2 + 1, l, mid);
	build(v * 2 + 2, mid, r);
	tree[v].mn = min(tree[v * 2 + 1].mn, tree[v * 2 + 2].mn);
}
int getmn(int v, int l, int r, int ql, int qr) {
	push(v, l, r);
	if (ql <= l && r <= qr) {
		return tree[v].mn;
	}
	if (r <= ql || l >= qr) {
		return 1e18;
	}
	int mid = (r + l) / 2;
	return min(getmn(v * 2 + 1, l, mid, ql, qr), getmn(v * 2 + 2, mid, r, ql, qr));
}

void upd(int v, int l, int r, int ql, int qr, int x) {
	push(v, l, r);
	if (ql <= l && r <= qr) {
		tree[v].mn -= x;
		tree[v].ps -= x;
		return;
	}
	if (r <= ql || l >= qr) {
		return;
	}
	int mid = (r + l) / 2;
	upd(v * 2 + 1, l, mid, ql, qr, x);
	upd(v * 2 + 2, mid, r, ql, qr, x);
}


void getp(int v, int p) {
	pp[v] = p;
	for (auto u : g[v]) {
		if (u != p) {
			getp(u, v);
		}
	}
}
void cnt_sz(int v) {
	sz[v] = 1;
	for (auto u : g[v]) {
		cnt_sz(u);
		sz[v] += sz[u];
	}
	for (int i = 0; i < g[v].size(); ++i) {
		if (sz[g[v][i]] > sz[g[v][0]]) {
			swap(g[v][i], g[v][0]);
		}
	}
}
int getmn(int v) {
	int mn = 1e18;
	while (v != -1) {
		int lft = pts[wh[v]][0];
		int cc = getmn(0, 0, n, lft, w2[v] + 1);
		mn = min(cc, mn);
		v = pp[eul[lft]];
	}
	return mn;
}
void build_hld(int v, int p) {
	wh[v] = p;
	pts[p][1] ++;
	w2[v] = eul.size();
	eul.push_back(v);
	
	if (g[v].size()) {
		build_hld(g[v][0], p);
		for (int i = 1; i < g[v].size();++i) {
			int np = pts.size();
			pts.push_back({ eul.size(),0 });
			build_hld(g[v][i], np);
		}
	}
}
void add(int v, int c) {
	while (v != -1) {
		int lft = pts[wh[v]][0];
		upd(0, 0, n, lft, w2[v] + 1, c);
		int cc = getmn(0, 0, n, lft, w2[v] + 1);
		v = pp[eul[lft]];
	}
}
bool solve(int v, int p, set <vector <int> >& d) {
	int ob = 0;
	for (auto u : g[v]) {
		if (u != p) {
			set <vector <int> > dd;
			bool an1 = solve(u, v, dd);
			if (!an1) {
				return 0;
			}
			if (dd.size() > d.size()) {
				swap(dd, d);
			}
			for (auto x : dd) {
				d.insert(x);
			}
		}
	}
	ob = lr[v][1] - getmn(0, 0, n, w2[v], w2[v] + 1);
	if (ob > lr[v][1]) {
		return 0;
	}
	else {
		d.insert({ c[v], v });
		while (ob < lr[v][0] && d.size()) {
			auto it = d.begin();
			int c = getmn((*it)[1]);
			c = min(lr[v][0] - ob, c);
			ob += c;
			add((*it)[1], c);
			if (getmn((*it)[1]) <= 0) {
				d.erase(it);
			}
		}
		if (ob < lr[v][0]) {
			return 0;
		}
		else {
			return 1;
		}
	}
}
int vost(int v, int p) {
	int sm = 0;
	for (auto u : g[v]) {
		if (u != p) {
			sm += vost(u, v);
		}
	}
	int vz = lr[v][1] - getmn(0, 0, n, w2[v], w2[v] + 1);
	ans[v] = vz - sm;
	cen += ans[v] * c[v];
	return vz;
}
void init() {
	g.clear();
	g.resize(n);
	c.clear();
	c.resize(n);
	lr.clear();
	ans.clear();
	ans.resize(n);
	pp.clear();
	pp.resize(n);
	sz.clear();
	sz.resize(n);
	cen = 0;
	eul.clear();
	wh.clear();
	wh.resize(n);
	pts.clear();
	tree.clear();
	tree.resize(4 * n);
	w2.clear();
	w2.resize(n);
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		cin >> n;
		init();
		for (int i = 0; i < n - 1; ++i) {
			int p;
			cin >> p;
			g[p - 1].push_back(i + 1);
		}
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		for (int i = 0; i < n; ++i) {
			int l, r;
			cin >> l >> r;
			lr.push_back({ l,r });
		}
		set <vector <int>> nn;
		getp(0, -1);
		cnt_sz(0);
		pts.push_back({ 0,0 });
		build_hld(0, 0);
		build(0, 0, n);
		bool e = solve(0, -1, nn);
		if (!e) {
			cout << "-1\n";
		}
		else {
			vost(0, -1);
			cout << cen << "\n";
			for (auto x : ans) {
				cout << x << " ";
			}
			cout << "\n";
		}

	}
}