#include <bits/stdc++.h>

#define int long long

using namespace std;

template <typename T>
istream& operator>> (istream& is, vector<T>& a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

template <typename T>
ostream& operator<< (ostream& is, vector<T>& a) {
    for (auto &i : a) {
        is << i << ' ';
    }
    return is;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].first -= 1;
        a[i].second = i;
    }
    map<pair<int, int>, int> c;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            c[{a[i].first, a[j].first}] = abs(a[j].first - a[i].first);
        }
    }
    vector<int> b(n);
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (a[j].first > a[i].first) {
                b[i] += 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[j].first < a[i].first) {
                d[i] += 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
//            cout << max({c[{a[i].first, a[j].first}], a[j].second - a[i].second - b[i], a[j].second - a[i].second + d[j]}) << endl;
            c[{a[i].first, a[j].first}] = max({c[{a[i].first, a[j].first}], a[j].second - a[i].second + b[i], a[j].second - a[i].second + d[j]});
        }
    }
    int ans = 0;
    for (auto [fi,se] : c) {
        ans += se;
    }
    cout << ans << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout.setf(ios::fixed);
    cout.precision(10);

    solve();
    return 0;
}
