#include <bits/stdc++.h>
#define int long long
using namespace std;

int l[100500];
int r[100500];
int c[100500];
int b[100500];

vector<int> g[100500];

struct comp {
    bool operator()(int a, int b) const {
        return tie(c[a], a) < tie(c[b], b);
    }
};

map<int, int, comp> A[100500];

bool dfs(int u) {

    if (g[u].empty()) {
        b[u] += l[u];
        if (r[u] > l[u]) {
            A[u][u] += r[u] - l[u];
        }
        return true;
    }

    int suml = 0;
    int sumr = 0;

    for (int v : g[u]) {
        bool res = dfs(v);
        if (!res) return false;
        suml += l[v];
        sumr += r[v];
    }

    if (suml > r[u]) {
        return false;
    }

    for (int i = 0; i < (int)g[u].size(); i++) {
        int& fir = g[u][0];
        int& cur = g[u][i];
        if (A[fir].size() < A[cur].size()) {
            swap(fir, cur);
        }
    }

    for (int i = 1; i < (int)g[u].size(); i++) {
        int v = g[u][i];
        int f = g[u][0];
        for (auto [a, b] : A[v]) {
            A[f][a] += b;
        }
        A[v].clear();
    }

    swap(A[u], A[g[u].front()]);

    if (suml < l[u]) {
        A[u][u] += l[u] - suml;

        int cnt = l[u] - suml;
        while (cnt) {
            if (A[u].begin()->second > cnt) {
                A[u].begin()->second -= cnt;
                b[A[u].begin()->first] += cnt;
                cnt = 0;
            }
            else if (A[u].begin()->second == cnt) {
                b[A[u].begin()->first] += cnt;
                A[u].erase(A[u].begin());
                cnt = 0;
            }
            else {
                b[A[u].begin()->first] += A[u].begin()->second;
                cnt -= A[u].begin()->second;
                A[u].erase(A[u].begin());
            }
        }
    }
    else {
        l[u] = suml;
    }
    return true;
}

void solve() {
    int n; cin >> n;
    for (int u = 1; u <= n; u++) {
        g[u].clear();
        b[u] = 0;
        A[u].clear();
    }

    for (int u = 2; u <= n; u++) {
        int v; cin >> v;
        g[v].push_back(u);
    }

    for (int i = 1; i <= n; i++) cin >> c[i];
    for (int i = 1; i <= n; i++) cin >> l[i] >> r[i];

    bool res = dfs(1);
    if (res) {
        int ans = 0;
        for (int i = 1; i <= n; i++) {
            ans += b[i] * c[i];
        }
        cout << ans << "\n";
        for (int i = 1; i <= n; i++) {
            cout << b[i] << " ";
        }
        cout << "\n";
    }
    else {
        cout << -1 << "\n";
    };
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}