#include <bits/stdc++.h>
#define int long long
using namespace std;

void solve() {
    int n, w, h; cin >> n >> w >> h;
    vector<pair<int, int>> A(n);
    for (auto& [x, y] : A) {
        cin >> x >> y;
    }

    sort(A.begin(), A.end(), [](pair<int, int> A, pair<int, int> B){
        return tuple(A.first, -A.second) < tuple(B.first, -B.second);
    });
    vector<pair<int, int>> B;
    B.push_back(A[0]);
    for (int i = 1; i < n; i++) {
        if (A[i].second < A[i - 1].second) {
            B.push_back(A[i]);
        }
    }

    int sum = 0;
    n = (int)B.size();
    for (int i = n - 2; i >= 0; i--) {
        sum += abs(B[i].first - B[i + 1].first) * (h - B[i].second);
    }
    sum += (w - B[n - 1].first) * (h - B[n - 1].second);
    cout << sum << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int k; cin >> k;
    vector<int> A(k);
    for (int &i : A) cin >> i;

    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}