#include <bits/stdc++.h>
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

const int cnst = 3000;

int hsh(int a, int b) {
    return a * cnst + b;
}

pair<int, int> unhsh(int hsh) {
    return {hsh / cnst, hsh % cnst};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> c;
    for (int i = 0; i <= n; ++i) {
        c.emplace_back(i);
    }
    int sz = hsh(n, n);
    unordered_map<int, vector<int>> g;
    auto Go = [&](int from) {
        for (int t = from; t < n; ++t) {
            auto v1 = c[t];
            auto v2 = c[t + 1];
            g[hsh(t, v1)].push_back(hsh(t + 1, v2));
            g[hsh(t + 1, v2)].push_back(hsh(t, v1));
        }
    };
    Go(0);
    for (int i = 0; i < n; ++i) {
        int pos;
        cin >> pos;
        for (int j = pos; j <= n; ++j) {
            c[j] -= 1;
        }
        Go(pos - 1);
    }
    vector<int> depth(sz + 1);
    const int max_log = 25;
    vector<vector<int>> jmp(max_log, vector<int>(sz + 1));
    function<void(int, int)> Dfs = [&](int v, int pr) {
        jmp[0][v] = pr;
        if (v == hsh(0, 0)) {
            depth[v] = 0;
        } else {
            depth[v] = depth[pr] + 1;
        }
        for (int u : g[v]) {
            if (u != pr) {
                Dfs(u, v);
            }
        }
    };
    Dfs(0, -1);
    for (int lg = 1; lg < max_log; ++lg) {
        for (int i = 0; i <= sz; ++i) {
            if (jmp[lg - 1][i] == -1) {
                jmp[lg][i] = -1;
            } else {
                jmp[lg][i] = jmp[lg - 1][jmp[lg - 1][i]];
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v = hsh(r1, c1), u = hsh(r2, c2);
        if (depth[v] < depth[u]) swap(u, v);
        for (int lg = max_log - 1; lg >= 0; --lg) {
            if (depth[v] - (1 << lg) >= depth[u]) {
                v = jmp[lg][v];
            }
        }
        if (v == u) {
            auto [ans1, ans2] = unhsh(v);
            cout << ans1 << ' ' << ans2 << '\n';
            continue;
        }
        for (int lg = max_log - 1; lg >= 0; --lg) {
            if (jmp[lg][v] == -1 || jmp[lg][u] == -1) {
                continue;
            }
            if (jmp[lg][v] != jmp[lg][u]) {
                v = jmp[lg][v];
                u = jmp[lg][u];
            }
        }
        auto [ans1, ans2] = unhsh(jmp[0][v]);
        cout << ans1 << ' ' << ans2 << '\n';
    }
    return 0;
}