#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
const int maxn = 100'031;

vector<int> ch [maxn];
int l [maxn];
int r [maxn];
int c [maxn];
int a [maxn];

vector<int> ans (maxn, 0);

int mc [maxn];
void dfs(int u) {
    mc[u] = u;
    for (int v : ch[u]) {
        dfs(v);
        if (c[mc[v]] < c[mc[u]]) {
            mc[u] = mc[v];
        }
    }
}

void dfssolve(int u) {
    for (int v : ch[u]) {
        dfssolve(v);
        a[u] += a[v];
    }
    if (a[u] >= l[u]) return;
    ans[mc[u]] += l[u] - a[u];
    a[u] += l[u] - a[u];
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        ch[i] = vector<int>();
    }
    for (int i = 1; i < n; ++i) {
        int pi; cin >> pi; pi -= 1;
        ch[pi].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    ans.assign(n, 0);
    fill(a, a + n, 0);
    dfs(0);
    dfssolve(0);
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        res += 1ll * ans[i] * c[i];
    }
    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    } cout << '\n';
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}