#include <bits/stdc++.h>
using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<int>> dist(n + 1, vector<int>(n + 1, 0));
    for (int  i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            dist[a[i]][a[j]] = max(j - i, abs(a[j] - a[i]));
            dist[a[j]][a[i]] = max(j - i, abs(a[j] - a[i]));
        }
    }
    vector<int> more_pref(n);
    vector<int> less_suf(n);
    for (int i = 0; i < n; i++) {
        int ct = 0;
        for (int j = 0; j < i; j++) {
            if (a[j] > a[i]) ct++;
        }
        more_pref[i] = ct;
    }
    for (int i = n - 1; i >= 0; i--) {
        int ct = 0;
        for (int j = n - 1; j > i; j--) {
            if (a[j] < a[i]) ct++;
        }
        less_suf[i] = ct;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            dist[a[i]][a[j]] = max(dist[a[i]][a[j]], j - i + more_pref[i]);
            dist[a[i]][a[j]] = max(dist[a[i]][a[j]], j - i + less_suf[j]);
            dist[a[j]][a[i]] = dist[a[i]][a[j]];
        }
    }
    int ans = 0;
    for (int i = 0; i < n + 1; i++) {
        for (int j = i + 1; j < n + 1; j++) ans += dist[i][j];
    }
    cout << ans << '\n';
//    for (int i = 0; i < n + 1; i++) {
//        for (int j = 0; j < n + 1; j++) cout << dist[i][j] << " ";
//        cout << "\n";
//    }
}
