#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define sz(x) (int) size(x)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define uniq(x) x.resize(unique(all(x)) - begin(x));
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 998244353;
const int N = (100000) + 1;

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int xp1 = x1 - y1;
        int xp2 = x2 - y2;
        if (xp1 == xp2) {
            if (x1 > x2) {
                cout << x2 << " " << y2 << '\n';
            } else {
                cout << x1 << " " << y1 << '\n';
            }
        } else {
            cout << min(xp1, xp2) << " 0\n";
        }
    }
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}