#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int const N = 3000 + 4;
int t[4 * N];

void build(int tl, int tr, int v, vector <int>& a){
    if(tl == tr){
        t[v] = a[tl];
        return;
    }
     int tm = (tl + tr) >> 1;
     build(tl, tm, (v << 1) + 1, a);
     build(tm + 1, tr, (v << 1) + 2, a);
     t[v] = t[(v << 1) + 1] + t[(v << 1) + 2];
     return;
}

void update(int tl, int tr, int v, int pos){
    if(pos < tl or tr < pos){
        return;
    }
    if(tl == pos and pos == tr){
        t[v]++;
        return;
    }
    int tm = (tl + tr) >> 1;
    update(tl, tm, (v << 1) + 1, pos);
    update(tm + 1, tr, (v << 1) + 2, pos);
    t[v] = t[(v << 1) + 1] + t[(v << 1) + 2];
    return;
}

int get(int l, int r, int tl, int tr, int v){
    l = max(l, tl);
    r = min(r, tr);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, tl, tm, (v << 1) + 1) + get(l, r, tm + 1, tr, (v << 1) + 2);
}

signed main(){
    int n;
    cin >> n;
    vector <int> p(n), pref(n, 0), suff(n, 0);
    for(int i = 0; i < n; ++i){
        cin >> p[i];
        --p[i];
    }
    build(0, n - 1, 0, pref);
    for(int i = 0; i < n; ++i){
        pref[i] = get(p[i], n - 1, 0, n - 1, 0);
        update(0, n - 1, 0, p[i]);
    }
    build(0, n - 1, 0, suff);
    for(int i = n - 1; i >= 0; --i){
        suff[i] = get(0, p[i], 0, n - 1, 0);
        update(0, n - 1, 0, p[i]);
    }
    ll ans = 0;
    for(int i = 0; i < n; ++i){
        for(int j = i + 1; j < n; ++j){
            int dij = abs(p[j] - p[i]), di = (j - i) + pref[i], dj = (j - i) + suff[j];
            ans += max(dij, max(di, dj));
        }
    }
    cout << ans;
}
/**
5
5 2 4 1 3

10
2 1 6 8 3 5 9 10 7 4

2
2 1
**/
