#include <bits/stdc++.h>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i, --i;
    vector<vector<int>> pr_cnt(n + 1, vector<int>(n)), suf_cnt(n + 1, vector<int>(n));
    for (int i = 1; i <= n; ++i) {
        pr_cnt[i] = pr_cnt[i - 1];
        pr_cnt[i][a[i - 1]] = 1;
    }
    for (int i = n - 1; i > -1; --i) {
        suf_cnt[i] = suf_cnt[i + 1];
        suf_cnt[i][a[i]] = 1;
    }
    vector<vector<int>> pr(n + 1, vector<int>(n + 1)), suf(n + 1, vector<int>(n + 1));
    for (int i = 0; i <= n; ++i)
        for (int j = n - 1; j > -1; --j)
            pr[i][j] = pr[i][j + 1] + pr_cnt[i][j];
    for (int i = 0; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            suf[i][j] = suf[i][j - 1] + suf_cnt[i][j - 1];
    long long ans = 0;
    for (int i = 0; i < n - 1; ++i)
        for (int j = i + 1; j < n; ++j)
            ans += max(j - i + max(suf[j + 1][a[j]], pr[i][a[i] + 1]), abs(a[i] - a[j]));
    cout << ans << endl;
}
