#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define pb push_back
#define eb emplace_back
#define lb lower_bound
#define debug(x) cerr << #x << ' ' << x << '\n';
#define ub upper_bound
const int inf = (int)1e9 + 1;
const ll infll = (ll)1e18 + 1;
const int mod = (int)1e9 + 7;
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b){
    if (a > b){
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b){
    if (a < b){
        a = b;
        return true;
    }
    return false;
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i].first;
        a[i].second = i;
    }
    vector<vector<int>> dist(n, vector<int>(n, 0));
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            dist[i][j] = j - i;
            dist[j][i] = j - i;
        }
    }
    for (int l = 0; l < n; l++){
        for (int r = l + 1; r < n; r++){
            vector<pair<int, int>> old = a;
            sort(a.begin() + l, a.begin() + r + 1);
            for (int o = 0; o < n; o++){
                for (int d = 0; d < n; d++){
                    chmax(dist[a[d].second][a[o].second], abs(o - d));
                    chmax(dist[a[o].second][a[d].second], abs(o - d));
                }
            }

            a = old;
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            //debug(i << ' ' << j << ' ' << dist[i][j]);
            ans += dist[i][j];
        }
    }
    cout << ans << '\n';
}