#include <bits/stdc++.h>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb emplace_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

//--------------------------------------

const int MAXN = 1e5 + 10;

pt a[MAXN];

void solve1(){
    int n, w, h;
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
    map<int, int> byx;
    map<int, bool> used;
    sort(a, a + n, [&](pt p, pt q){return (p.x > q.x) || (p.x == q.x && p.y > q.y);});
    for (int i = 0; i < n; i++){
        int xi = a[i].x, yi = a[i].y;
        if (!used[xi]){
            used[xi] = true;
            byx[xi] = yi;
        } else
            byx[xi] = min(byx[xi], yi);
    }
    vector<pt> b = {{w, h}};
    int mn = 1e9;
    for (auto [x, y]: byx){
        if (y < mn){
            mn = y;
            b.pb(x, y);
        }
    }
    ll ans = 0;
    for (int i = 1; i < sz(b); i++){
        int x = b[i].x, y = b[i].y;
        ans += (ll)(w - x) * (b[i - 1].y - y);
    }
    cout << ans << '\n';
}

void run(){
    int k;
    cin >> k;
    int x;
    for (int i = 0; i < k; i++)
        cin >> x;
    int t;
    cin >> t;
    if (k == 1){
        while (t--)
            solve1();
    }
}

int main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << (stop - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
    return 0;

}