#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<map>
#include<unordered_map>
#include<set>
#include<unordered_set>
#include<stack>
#include<queue>
#include<iomanip>
#include<random>

using namespace std;

int arr[3005];
pair<int, int>sortedarr[3005];
int sortpos[3005];
vector<int> lefts;
vector<int> rights;
vector<int> leftsort[3005];
vector<int> rightsort[3005];

int dist[3005][3005];

void solve() {
	long long ans = 0;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		sortedarr[i].first = arr[i];
		sortedarr[i].second = i;
	}
	sort(sortedarr, sortedarr + n);
	for (int i = 0; i < n; i++) {
		sortpos[sortedarr[i].second] = i;
	}
	for (int i = 0; i < n; i++) {
		lefts.push_back(arr[i]);
		sort(lefts.begin(), lefts.end());
		leftsort[i] = lefts;
	}
	for (int i = n - 1; i >= 0; i--) {
		rights.push_back(arr[i]);
		sort(rights.begin(), rights.end());
		rightsort[i] = rights;
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			dist[i][j] = j - i;
			dist[i][j] = max(dist[i][j], abs(sortpos[i] - sortpos[j]));
			int pos_i = lower_bound(leftsort[i].begin(), leftsort[i].end(), arr[i]) - leftsort[i].begin();
			int pos_j = j + (lower_bound(rightsort[j].begin(), rightsort[j].end(), arr[j]) - rightsort[j].begin());
			dist[i][j] = max(dist[i][j], max(j - pos_i, pos_j - i));
			ans += dist[i][j];
		}
	}
	cout << ans << "\n";
	return;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}