#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma")

#include <bits/stdc++.h>
using namespace std;

using ll = long long;

#define int long long
const int N = 100010;
int c[N];
pair<int, int> lr[N];
int tin[N];
int tout[N];
ll fen[N];
int cc_e = 0;

void add(int ind, ll add) {
    for (; ind < N; ind |= (ind + 1)) {
        fen[ind] += add;
    }
}

ll su(int r) {
    ll su = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        su += fen[r];
    }
    return su;
}

ll su(int l, int r) {
    return su(r) - su(l - 1);
}

void dfs(int v, vector<vector<int>>& g, int p = -1) {
    tin[v] = cc_e++;
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, g, v);
        }
    }
    tout[v] = cc_e - 1;
}

set<pair<int, int>> se[N];
ll ns[N];
int pr[N];


pair<pair<int, ll>, set<pair<int, int>>&> dfs1(int v, vector<vector<int>>& g, int p = -1) {
    ll cost = 0;
    ll cou = 0;
    int ind_se = -1;
    set<pair<int, int>>& ss = se[v];
    vector<pair<int, set<pair<int, int>>&>> ve;
    for (auto to : g[v]) {
        if (to != p) {
            auto ans = dfs1(to, g, v);
            ve.emplace_back(to, ans.second);
            if (ans.first.first == -1) {
                return {{-1, -1}, ans.second};
            }
            cost += ans.first.second;
            cou += ans.first.first;
            if ((int)ans.second.size() > (int)ss.size()) {
                ind_se = to;
                ss = ans.second;
            }
        }
    }
    for (auto& to : ve) {
        if (to.first != ind_se) {
            for (auto i : to.second) {
                ss.insert(i);
            }
        }
    }
    ss.insert({c[v], v});
    int l = lr[v].first;
    int r = lr[v].second;
    if (cou > r) {
        return {{-1, -1}, ss};
    }

    while (!ss.empty() && cou < l) {
        auto nw = *ss.begin();
        ll can = lr[nw.second].second - su(tin[nw.second], tout[nw.second]);

        int vv = nw.second;
        do {
            vv = pr[vv];
            can = min(can, lr[vv].second - su(tin[vv], tout[vv]));
        } while(vv);

        if (can <= l - cou) {
            cou += can;
            add(tin[nw.second], can);
            ns[nw.second] += can;
            cost += 1ll * c[nw.second] * can;
            ss.erase(ss.begin());
        } else {
            add(tin[nw.second], l - cou);
            ns[nw.second] += l - cou;
            cost += 1ll * c[nw.second] * (l - cou);
            cou = l;
        }
    }
    if (cou > r || cou < l) {
        return {{-1, -1}, ss};
    }
    return {{cou, cost}, ss};
}

void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<int>> g(n);
        fill(fen, fen + n, 0);
        fill(ns, ns + n, 0);
        cc_e = 0;
        for (int i = 0; i < n; ++i) {
            se[i].clear();
        }
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            pr[i] = p - 1;
            g[p - 1].push_back(i);
            g[i].push_back(p - 1);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> lr[i].first >> lr[i].second;
        }
        dfs(0, g);

        auto ans = dfs1(0, g);
        if (ans.first.first == -1) {
            cout << "-1\n";
        } else {
            cout << ans.first.second << '\n';
            for (int i = 0; i < n; ++i) {
                cout << ns[i] << ' ';
            }
            cout << '\n';
        }
    }
}

signed main() {
#ifdef Debugg
    freopen("C:\\Users\\roi\\CLionProjects\\untitled\\ain.txt", "r", stdin);
    freopen("C:\\Users\\roi\\CLionProjects\\untitled\\aout.txt", "w", stdout);
#endif
    solve();
    return 0;
}
