#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
typedef long long ll;

/*void getSubtree(int u, vector<vector<ll> > &g, vector<ll> &res)
{
    //cout << u << endl;
    res.push_back(u);
    for (auto v : g[u])
    {
        getSubtree(v, g, res);
    }
}

void getMin(int u, int p, vector<ll> &h, vector<ll> &seg, int &mnw, int mode = 0)
{
    if (u == p && mode) return;
    mnw = min(mnw, seg[u].s - seg[u].f);
    if (u == p) return;
    getMin(h[u], p, h, seg, mnw);
}

void change(int u, int p, vector<ll> &h, vector<ll> &seg, int mnc)
{
    seg[u].s -= mnc;
    if (u == p)
        return;
    change(h[u], p, h, seg, mnc);
}

void dfs(int u, vector<vector<ll> > &g, vector<pair<ll, ll> > &seg, vector<ll> &c, bool &ok)
{
    int lsum = 0, rsum = 1e+9;
    if (g[u].empty())
    {
        lsum = seg[u].f;
        rsum = seg[u].s;
    }
    for (auto v : g[u])
    {
        cout << v << endl;
        dfs(v, g, seg, c, ok);
        lsum += seg[v].f;
        rsum += seg[v].s;
    }
    //cout << u << " " << lsum << " " << rsum << endl;
    if (rsum < seg[u].f || lsum > seg[u].s)
    {
        ok = false;
        return;
    }
    cout << u << endl;
    vector<ll> res;
    getSubtree(u, g, res);
    sort(res.begin(), res.end(), [&](int a, int b)
    {
        return c[a] > c[b];
    });

}
*/

void mark(int r, int c, vector<vector<vector<bool> > > &tube, vector<vector<int> > &used)
{
    used[r][c] ^= 1;
    if (r == 0) return;
    if (tube[r - 1][c][0])
        mark(r - 1, c, tube, used);
    else
        mark(r - 1, c - 1, tube, used);
}

pair<int, int> getAns(int r, int c, vector<vector<vector<bool> > > &tube, vector<vector<int> > &used)
{
    if (used[r][c])
        return {r, c};
    if (tube[r - 1][c][0])
        return getAns(r - 1, c, tube, used);
    else
        return getAns(r - 1, c - 1, tube, used);
}


int main()
{
    /*int n;
    cin >> n;
    vector<vector<ll> > g(n);
    vector<ll> h(n, -1);
    for (int i = 1; i < n; i++)
    {
        cin >> h[i];
        h[i]--;
        g[h[i]].push_back(i);
    }
    vector<ll> c(n);
    for (int i = 0; i < n; i++)
    {
        cin >> c[i];
    }
    vector<pair<ll, ll> > seg(n);
    for (int i = 0; i < n; i++)
    {
        int l, r;
        cin >> l >> r;
        seg[i] = {l, r};
    }
    bool ok = true;
    dfs(0, g, seg, c, ok);*/
    int n;
    cin >> n;
    vector<vector<vector<bool> > > tube(n + 1, vector<vector<bool> > (n + 1, vector<bool> (2, 0)));
    vector<int> down(n + 1, 1);
    for (int i = -1; i < n; i++)
    {
        if (i >= 0)
        {
            int a;
            cin >> a;
            down[a - 1] = 0;
        }
        int r = 0, c = 0;
        for (int i = 0; i < n; i++)
        {
            //cout << r << " " << c << " - " << down[i] << endl;
            tube[r][c][down[i]] = 1;
            r++;
            c += down[i];
            //cout << r << " " << c << endl;
        }
        //cout << "---" << endl;
    }
    int q;
    cin >> q;
    vector<vector<int> > used(n + 1, vector<int> (n + 1));
    while (q--)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        mark(r1, c1, tube, used);
        pair<int, int> ans = getAns(r2, c2, tube, used);
        mark(r1, c1, tube, used);
        cout << ans.f << " " << ans.s << endl;
    }
}
