#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int n;
vector<int> vec;
set<int> st;
int A[4000][4000];
int INF = 1000000000;

int main()
{
	cin >> n;
	vec.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vec[i];
	}
	for (int L = 0; L < n; ++L)
	{
		for (int R = L + 1; R < n; ++R)
		{
			A[L][R] = max(R - L, abs(vec[R] - vec[L]));
		}
	}

	for (int LS = 0; LS < n; LS++)
	{
		vector<pair<int, int>> v2;
		for (int RS = LS; RS < n; RS++)
		{
			v2.push_back(make_pair(vec[RS], RS));
			sort(v2.begin(), v2.end());
			int MS = int(upper_bound(v2.begin(), v2.end(), make_pair(vec[RS], RS)) - v2.begin()) - 1;
			for (int i = RS + 1; i < n; ++i)
			{
				A[RS][i] = max(A[RS][i], abs(i - MS - LS));
			}
		}
		for (int j = 0; j < v2.size(); j++)
		{
			for (int i = 0; i < LS; ++i)
			{
				A[i][v2[j].second] = max(A[i][v2[j].second], j + LS - i);
			}
		}
	}
	long long sum = 0;
	for (int L = 0; L < n; ++L)
	{
		for (int R = 0; R < n; ++R)
		{
			sum += A[L][R];
		}
	}
	cout << sum;
}