#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 5000;

vector<int> g[MAXN];
vector<int> nab(MAXN), p(MAXN), c(MAXN), inpuct(MAXN);
vector<pair<int, int>> zap(MAXN);
vector<int> nizhe;

bool cmp(int i, int j)
{
    return c[i] < c[j];
}

void dfs_min(int v)
{
    for (auto i : g[v])
    {
        dfs_min(i);
    }
    nizhe.push_back(v);
}

int dfs_rev(int v, int nd)
{
    if (p[v] != nd) return min(zap[v].second - nab[v], dfs_rev(p[v], nd));
    else return zap[v].second - nab[v];
}

void dfs_plus(int v, int pl, int nd)
{
    nab[v] += pl;
    if (p[v] != nd)
        dfs_plus(p[v], pl, nd);
}

int dfs(int v)
{
    for (auto i : g[v])
    {
        if (dfs(i) == -1) return -1;
    }
    int sum = 0;
    for (auto i : g[v])
    {
        sum += nab[i];
    }
    nab[v] = sum;
    if (sum > zap[v].second)
    {
        return -1;
    }
    nizhe.clear();
    for (auto i : g[v])
    {
        dfs_min(i);
    }
    nizhe.push_back(v);
    sort(nizhe.begin(), nizhe.end(), cmp);
    for (int i = 0; i < nizhe.size(); ++i)
    {
        if (c[nizhe[i]] < c[v])
        {
            inpuct[nizhe[i]] += min(dfs_rev(nizhe[i], v), zap[v].first - nab[v]);
            dfs_plus(nizhe[i], min(dfs_rev(nizhe[i], v), zap[v].first - nab[v]), p[v]);
        }
    }
    if (nab[v] < zap[v].first)
    {
        inpuct[v] += zap[v].first - nab[v];
        nab[v] = zap[v].first;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        p[0] = -1;
        for (int i = 1; i < n; ++i)
        {
            cin >> p[i];
            p[i]--;
            g[p[i]].push_back(i);
        }
        for (int i = 0; i < n; ++i)
        {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i)
        {
            cin >> zap[i].first >> zap[i].second;
        }
        if (dfs(0) == -1)
        {
            cout << -1;
        }
        else
        {
            int sum = 0;
            for (int i = 0; i < n; ++i)
            {
                sum += inpuct[i] * c[i];
            }
            cout << sum << '\n';
            for (int i = 0; i < n; ++i)
            {
                cout << inpuct[i] << ' ';
            }
        }
        cout << '\n';
    }
    return 0;
}
