#include <bits/stdc++.h>

using namespace std;

map<pair<pair<int, int>, pair<int, int>>, bool> mp;
vector<vector<int>> t(3000, vector<int> (3000));
pair<int, int> ans;

void path(vector<bool> &op)
{
    pair<int, int> pos = {0, 0};
    for (int i = 0; i < op.size(); ++i)
    {
        if (!op[i])
        {
            mp[{pos, {pos.first + 1, pos.second + 1}}] = true;
            pos.first++;
            pos.second++;
        }
        else
        {
            mp[{pos, {pos.first + 1, pos.second}}] = true;
            pos.first++;
        }
    }
}

void dfs1(int str, int stl, int oper)
{
    t[str][stl] = oper;
    if (mp[{{str - 1, stl - 1}, {str, stl}}]) dfs1(str - 1, stl - 1, oper);
    if (mp[{{str - 1, stl}, {str, stl}}]) dfs1(str - 1, stl, oper);
}

void check(int str, int stl, int oper)
{
    if (t[str][stl] == oper)
    {
        if (str > ans.first) ans = {str, stl};
    }
    if (mp[{{str - 1, stl - 1}, {str, stl}}]) check(str - 1, stl - 1, oper);
    if (mp[{{str - 1, stl}, {str, stl}}]) check(str - 1, stl, oper);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> v[i];
    }
    vector<bool> nap(n);
    path(nap);
    for (int i = 0; i < n; ++i)
    {
        nap[v[i] - 1] = true;
        path(nap);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        dfs1(r1, c1, i + 1);
        ans = {0, 0};
        check(r2, c2, i + 1);
        cout << ans.first << ' ' << ans.second << '\n';
    }
    return 0;
}
