#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <functional>
#include <iomanip>
#include <set>
#include <map>
#include <random>
#include <array>

using namespace std;
using ll = long long;

const ll INF = 2.5e18;

//#define int ll
#define ve vector
#define pb push_back
#define all(h) (h).begin(), (h).end()
#define ft first
#define sd second


ve<ve<int> > g;
ve<ll> sum;
ve<int> b;
ve<int> c;
ve<pair <int, int> > h;
ll ans = 0;
bool flag = true;


ve<array<int, 3>> dfs(int v) {
	if (!flag) return {};
	ve<array<int, 3>> tec;
	tec.pb({ c[v], v, h[v].sd });
	ve<array<int, 3>> to_swap;
	for (auto u : g[v]) {
		auto it = dfs(u);
		to_swap.clear();
		to_swap.resize(it.size() + tec.size());
		merge(all(it), all(tec), to_swap.begin());
		sum[v] += sum[u];
		swap(tec, to_swap);
	}
	if (sum[v] > h[v].sd) {
		ans = -INF;
		flag = false;
		return {};
	}
	int id = 0;
	for (int i = 0; i < tec.size() && sum[v] < h[v].ft; ++i) {
		if (sum[v] + tec[i][2] <= h[v].ft) {
			sum[v] += tec[i][2];
			b[tec[i][1]] += tec[i][2];
			ans += (ll)tec[i][2] * tec[i][0];
			id = i + 1;
		}
		else {
			int cnt = h[v].ft - sum[v];
			sum[v] += cnt;
			b[tec[i][1]] += cnt;
			ans += (ll)cnt * tec[i][0];
			tec[i][2] -= cnt;
			id = i;
			break;
		}
	}
	to_swap.clear();
	if (sum[v] < h[v].ft) {
		ans = -INF;
		flag = false;
		return {};
	}
	int cnt = h[v].sd - sum[v];
	for (int i = id; i < tec.size() && cnt; ++i) {
		if (cnt >= tec[i][2] && tec[i][2]) {
			cnt -= tec[i][2];
			to_swap.pb(tec[i]);
		}
		else if (tec[i][2]) {
			to_swap.pb({ tec[i][0], tec[i][1], cnt });
			cnt = 0;
		}
	}
	return to_swap;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int T;
	cin >> T;
	while (T--) {
		int n;
		cin >> n;
		ans = 0;
		flag = true;
		g.assign(n, {});
		c.assign(n, 0);
		b.assign(n, 0);
		sum.assign(n, 0);
		h.clear();
		for (int i = 1; i < n; ++i) {
			int p;
			cin >> p;
			--p;
			g[p].pb(i);
		}
		for (auto& el : c) {
			cin >> el;
		}
		for (int i = 0; i < n; ++i) {
			int l, r;
			cin >> l >> r;
			h.pb({ l, r });
		}
		dfs(0);
		if (!flag) {
			cout << -1 << "\n";
		}
		else {
			cout << ans << "\n";
			for (int i = 0; i < n; ++i) {
				cout << b[i] << " ";
			}
			cout << "\n";
		}
	}
	return 0;
}