#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
const ll MOD = 1000000007;

int a[3001][3001];
int ft[3001][3001];

void slv2(int n)
{
	for (int i = 0; i < n; ++i)
	{
		int nw; cin >> nw;
	}
	int q; cin >> q;
	for (int i = 0; i < q; ++i)
	{
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		cout << min(r1 - c1, r2 - c2) << ' ' << 0 << '\n';
	}
}

inline void solve(int test_case)
{
	int n; cin >> n;
	if (n > 3000)
	{
		slv2(n);
		return;
	}
	for (int i = 0; i < n; ++i)
		a[0][i] = 1;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 0; j < n; ++j)
			a[i][j] = a[i - 1][j];
		int p; cin >> p;
		a[i][p - 1] = 0;
		int c = 0;
		for (int j = 0; j <= n; ++j)
		{
			if (j >= p)
			{
				ft[j][c] = i;
			}
			c += a[i][j];
		}
	}
	int q; cin >> q;
	for (int i = 0; i < q; ++i)
	{
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int ft1 = ft[r1][c1];
		int ft2 = ft[r2][c2];
		int c = 0; int ans1 = -1, ans2 = -1;
		for (int j = 0; j < min(r1, r2); ++j)
		{
			if (a[ft1][j] != a[ft2][j])
			{
				ans1 = j; ans2 = c;
				break;
			}
			c += a[ft1][j];
		}
		if (ans1 != -1) cout << ans1 << ' ' << ans2 << '\n';
		else cout << min(r1, r2) << ' ' << c << '\n';
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; //cin >> t;
	for (int i = 0; i < t; ++i)
	{
		solve(t);
	}
}
