#include <bits/stdc++.h>

using namespace std;
using ll = int;
using vll = vector<ll>;
using pll = pair<ll, ll>;
using str = string;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define forn(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define sz(a) (ll)(a).size()
#define ff first
#define ss second
#define endl '\n'

const ll lg = 12;
const ll Maxn = 3010 * 3010;
//mt19937 rnd(123114);
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());



vector<pll> pth;

ll gt(pll f) {
    return lower_bound(all(pth), f) - pth.begin();
    //return 1;
}

ll up[lg][Maxn];
ll d[Maxn];
vll gr[Maxn];

void df(ll v, ll p) {
    d[v] = d[p] + 1;
    for (ll adj : gr[v]) {
        if (adj == p) continue;
        df(adj, v);
    }
}

ll lca(ll u, ll v) {
    if (d[u] < d[v]) swap(u, v);
    ll diff = d[u] - d[v];
    for (ll i = lg - 1; i >= 0; --i) {
        if (diff & (1 << i)) {
            u = up[i][u];
        }
    }
    if (u == v) return u;
    for (ll i = lg - 1; i >= 0; --i) {
        if (up[i][u] != up[i][v]) {
            u = up[i][u];
            v = up[i][v];
        }
    }
    return up[0][u];
}


void solve() {
    ll n;
    cin >> n;
    ll last = (n + 1) * (n + 2) / 2;
    vll a(n);
    forn (i, n) {
        cin >> a[i];
        --a[i];
    }
    pll st = {0, 0};
    forn (i, n + 1) {
        forn (j, i + 1) {
            pth.pb({i, j});
        }
    }
    ll was = gt(st);
    up[0][was] = was;
    vll pos(n, 1);
    forn (i, n) {
        if (pos[i] == 0) {
            st.ff += 1;
        } else {
            st.ff += 1;
            st.ss += 1;
        }
        ll nw = gt(st);
        up[0][nw] = was;
        was = nw;
    }
    forn (j, n) {
        pos[a[j]] = 0;
        st = {0, 0};
        was = gt(st);
        forn (i, n) {
            if (pos[i] == 0) {
                st.ff += 1;
            } else {
                st.ff += 1;
                st.ss += 1;
            }
            ll nw = gt(st);
            up[0][nw] = was;
            was = nw;
        }
    }
    st = {0, 0};
    was = gt(st);
    forn (i, n) {
        if (pos[i] == 0) {
            st.ff += 1;
        } else {
            st.ff += 1;
            st.ss += 1;
        }
        ll nw = gt(st);
        up[0][nw] = was;
        was = nw;
    }
    for (ll k = 1; k < lg; ++k) {
        forn (i, last) {
            up[k][i] = up[k - 1][up[k - 1][i]];
        }
    }
    forn (i, last) {
        gr[up[0][i]].pb(i);
        gr[i].pb(up[0][i]);
    }
    df(0, 0);
    ll q;
    cin >> q;
    forn (i, q) {
        pll lh, rh;
        cin >> lh.ff >> lh.ss >> rh.ff >> rh.ss;
        pll ans = pth[lca(gt(lh), gt(rh))];
        cout << ans.ff << ' ' << ans.ss << endl;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // n ^ 2
    ll t = 1;
    while (t--) solve();
    return 0;
}