#include <iostream>
#include<vector>
#include<algorithm>
#include<set>
using namespace std;

#define int long long

vector<int> answ;
vector<int> cost;
vector<int> l, r;
vector<int> need, cur;
vector<vector<int>> g;
vector<vector<int>> d;
vector<int> pred;

bool dfs(int i, int p, int deep) {
	d[deep].push_back(i);
	pred[i] = p;
	if (!g[i].size()) {
		cur[i] = l[i];
		need[i] = 0;
		answ[i] = l[i];
		return 0;
	}

	bool is = 0;
	for (int j : g[i]) {
		if (j != p) {
			pred[j] = pred[i];
			is |= dfs(j, i, deep + 1);
		}
	}

	if (is) {
		return 1;
	}

	int tmp = 0;
	for (int j : g[i]) {
		if (j != p) {
			tmp += cur[j];
		}
	}

	if (tmp > r[i]) {
		return 1;
	}

	cur[i] = tmp;
	need[i] = max(0ll, l[i] - cur[i]);

	return 0;
}

struct elem {
	int ind;
	bool operator<(const elem other) const {
		return pair<int, int>{cost[ind], ind} < pair<int, int>{cost[other.ind], other.ind};
	}
};

int tum = 0;

int check(int i) {
	int k = r[i] - cur[i];
	while (i != 0) {
		i = pred[i];
		k = min(k, r[i] - cur[i]);
	}

	return k;
}

set<elem>* solve(int i, int p) {
	if (!g[i].size()) {
		set<elem>* st = new set<elem>;
		if (r[i] != l[i])
			st->insert(elem{i});

		return st;
	}

	vector<set<elem>*> vec;
	for (int j : g[i]) {
		if (j != p) {
			vec.push_back(solve(j, i));
		}
	}

	if (tum) {
		return new set<elem>;
	}

	sort(vec.begin(), vec.end(), [](set<elem>* a, set<elem>* b) {
		return a->size() > b->size();
	});

	auto ans = *(vec.begin());
	vec.erase(vec.begin());

	for (int i = 0; i < vec.size(); i++) {
		set<elem> st = *vec[i];
		for (auto j : st) {
			ans->insert(j);
		}
	}

	if (check(i)) {
		ans->insert(elem{ i });
	}

	need[i] = max(0ll, l[i] - cur[i]);

	while (need[i] != 0) {
		if (ans->size() == 0) {
			tum = 1;
			break;
		}

		auto k = (*(ans->begin()));
		int kk = check(k.ind);
		if (kk) {
			int tmpp = need[i];
			need[i] -= min(tmpp,kk);
			answ[k.ind] += min(tmpp, kk);
			
			cur[k.ind] += min(tmpp, kk);
			while (k.ind != 0) {
				k.ind = pred[k.ind];
				cur[k.ind] += min(tmpp, kk);
			}
		}
		else {
			ans->erase(k);
		}
	}

	return ans;
}

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t, napr;
	cin >> t;
	cin >> napr;
	cin >> t;
	for (int z = 0; z < t; z++) {
		int n, w, h;
		cin >> n >> w >> h;
		vector<pair<int, int>> vec;
		for (int i = 0; i < n; i++) {
			int a, b;
			cin >> a >> b;

			vec.push_back({ a, b });
		}

		//vec.push_back({ 0, h });
		sort(vec.begin(), vec.end());
		long long ans = 0;
		int maxi = h;
		for (int i = 0; i < n; i++) {
			if (vec[i].second < maxi) {
				if (i == 0) {
					ans += (w - vec[i].first) * (h - vec[i].second);
				}
				else {
					ans += (w - vec[i].first) * (maxi - vec[i].second);
				}

				maxi = vec[i].second;
			}
		}

		cout << ans << "\n";
	}
}

/*

1
1
1
4 6 4
3 3
1 2
4 1
5 0

//////////////////////////////////////////
5
5 2 4 1 3
10
2 1 6 8 3 5 9 10 7 4
2
2 1


/////////////////////////////////////////
3
3
1 1 
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
10
1 1 2 2 2 6 6 3 3
1 2 3 4 5 6 7 8 9 10
100 100
19 20
9 10
3 10
3 10
3 10
3 10
3 10
3 10
3 10


1
10
1 1 2 2 2 6 6 3 3
1 2 3 4 5 6 7 8 9 10
100 100
10 20
10 10
5 10
5 10
5 10
5 10
5 10
5 10
5 10

1
4
1 2 2
1000 1000 1 1000
10 20
0 5
0 10 
0 10
*/