// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#define int long long 
#define real long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define f first
#define s second
#define pi M_PI
#define elif else if
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 1e18, MOD = 1e9 + 7, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(43);


const int maxn = 5e3 + 100;
int n;
int pr[maxn];
vector<int> graph[maxn];
int c[maxn], le[maxn], ri[maxn], answer[maxn];
int cnt[maxn];


set<pair<int, int>> dfs(int v, int p){
	set<pair<int, int>> st;
	st.insert({c[v], v});
	for (auto u: graph[v]){
		if (u == p) continue;
		set<pair<int, int>> cur = dfs(u, v);
		if (cur.size() > st.size()) st.swap(cur);
		for (auto i: cur) st.insert(i);
	}
	while (cnt[v] < le[v] and !st.empty()){
		int t = (*st.begin()).s;
		int u = t;
		int need = le[v] - cnt[v];
		while (u != -1){
			need = min(need, ri[u] - cnt[u]);
			u = pr[u];
		}
		if (!need){
			st.erase(st.begin());
			continue;
		}
		u = t;
		while (u != -1){
			cnt[u] += need;
			u = pr[u];
		}
		answer[t] += need;
	}
	return st;
}


void init(){
	fill(graph, graph + n, vector<int>());
	fill(answer, answer + n, 0);
	fill(cnt, cnt + n, 0);
}


void debug(){
	cerr << "\n";

	cerr << "\n";
}


signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t; cin >> t;
	pr[0] = -1;
	while (t--){
		cin >> n;
		init();
		for (int i=1; i<n; ++i){
			int v; cin >> v; --v;
			pr[i] = v;
			graph[v].push_back(i);
			graph[i].push_back(v);
		}
		for (int i=0; i<n; ++i) cin >> c[i];
		for (int i=0; i<n; ++i) cin >> le[i] >> ri[i];
		dfs(0, -1);
		bool res = true;
		for (int i=0; i<n; ++i){
			if (cnt[i] < le[i]){
				res = false;
				break;
			}
		}
		if (!res){
			cout << -1 << "\n";
			continue;
		}
		int ans = 0;
		for (int i=0; i<n; ++i) ans += answer[i] * c[i];
		cout << ans << "\n";
		for (int i=0; i<n; ++i) cout << answer[i] << " ";
		cout << "\n";
	}
}

/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

8
0 2 3
-1
*/