#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int) (x).size()
#define endl "\n"
#define int long long

using namespace std;

const int N = 1e5 + 100;
vector<int> g[N];
int price[N], l[N], r[N];
int ans[N];

bool ok;

tuple<int, int, int, set<array<int, 3>> *> dfs(int v) {
    auto *now = new set<array<int, 3>>;
    int total = 0, bought = 0, can = 0;

    for (int i : g[v]) {
        auto[cost, bo, ca, st] = dfs(i);
        if (!ok) {
            return {0, 0, 0, now};
        }

        total += cost, bought += bo, can += ca;

        if (st -> size() > now -> size()) {
            swap(st, now);
        }

        auto it = now -> begin();
        for (auto x : *st) {
            now -> insert(x);
        }
    }

    if (bought > r[v]) {
        ok = false;
        return {0, 0, 0, now};
    }
    now -> insert({price[v], r[v] - bought, v});
    can += r[v] - bought;
    while (bought < l[v]) {
        auto [c, cnt, id] = *(now -> begin());
        now -> erase(now -> begin());
        int buy = min(cnt, l[v] - bought);
        ans[id] += buy;
        can -= buy;
        total += buy * c;
        bought += buy;
        cnt -= buy;
        if (cnt) {
            now -> insert({c, cnt, id});
        }
    }
    while (bought + can > r[v]) {
        auto [c, cnt, id] = *(now -> rbegin());
        now -> erase(prev(now -> end()));

        int val = min(cnt, bought + can - r[v])
        can -= val;
        cnt -= val;
        if (cnt) {
            now -> insert({c, cnt, id});
        }
    }
    return {total, bought, can, now};
}


void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        ans[i] = 0;
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        g[x].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> price[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }

    ok = true;
    auto[cost, bought, can, st] = dfs(0);
    if (!ok) {
        cout << -1 << endl;
    } else {
        cout << cost << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i] << " ";
        }
        cout << endl;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
