#include <bits/stdc++.h>
#define x first
#define y second
#define int long long

using namespace std;

struct st{
    pair<int, int> * t;
    int n;
    int * add;
    st(){}

    void build(int k, int l, int r){
        if(l+1==r){
            t[k] = {LLONG_MAX, l};
            return;
        }
        build(2*k+1, l, (l+r)/2);
        build(2*k+2, (l+r)/2, r);
        t[k] = min(t[2*k+1], t[2*k+2]);
    }

    st(int _n){
        n = _n;
        t = new pair<int, int>[4*n];
        add = new int [4*n];
        for(int i = 0; i<4*n; i++)
            add[i] = 0;
        build(0, 0, n);
    }

    void push(int k, int l, int r){
        if(add[k]){
            t[k] = {LLONG_MAX, -2};
            if(l+1!=r){
                add[2*k+1] = 1;
                add[2*k+2] = 1;
            }
            add[k] = 0;
        }
    }

    pair<int, int> get(int k, int l, int r, int ql, int qr){
        push(k, l, r);
        if(l>=qr || r<=ql)
            return {LLONG_MAX, -1};
        if(l>=ql && r<=qr)
            return t[k];
        return min(get(2*k+1, l, (l+r)/2, ql, qr), get(2*k+2, (l+r)/2, r, ql, qr));
    }
    void upd(int k, int l, int r, int x, int val){
        push(k, l, r);
        if(x>=r || x<l)
            return;
        if(l+1==r){
            t[k] = {val, l};
            return;
        }
        upd(2*k+1, l, (l+r)/2, x, val);
        upd(2*k+2, (l+r)/2, r, x, val);
        t[k] = min(t[2*k+2], t[2*k+1]);
    }
    void updrange(int k, int l, int r, int ql, int qr){
        push(k, l, r);
        if(ql>=r || qr<=l)
            return;
        if(l>=ql && r<=qr){
            add[k] = 1;
            push(k, l, r);
            return;
        }
        updrange(2*k+1, l, (l+r)/2, ql, qr);
        updrange(2*k+2, (l+r)/2, r, ql, qr);
        t[k] = min(t[2*k+2], t[2*k+1]);
    }
};

struct st1{
    pair<int, int> * t;
    int n;
    int * add;
    st1(){}

    void build(int k, int l, int r){
        if(l+1==r){
            t[k] = {LLONG_MAX, l};
            return;
        }
        build(2*k+1, l, (l+r)/2);
        build(2*k+2, (l+r)/2, r);
        t[k] = min(t[2*k+1], t[2*k+2]);
    }

    st1(int _n){
        n = _n;
        t = new pair<int, int>[4*n];
        add = new int [4*n];
        for(int i = 0; i<4*n; i++)
            add[i] = 0;
        build(0, 0, n);
    }

    void push(int k, int l, int r){
        t[k].x+=add[k];
        if(l+1!=r){
            add[2*k+1] += add[k];
            add[2*k+2] += add[k];
        }
        add[k] = 0;
    }

    pair<int, int> get(int k, int l, int r, int ql, int qr){
        push(k, l, r);
        if(l>=qr || r<=ql)
            return {LLONG_MAX, -1};
        if(l>=ql && r<=qr)
            return t[k];
        return min(get(2*k+1, l, (l+r)/2, ql, qr), get(2*k+2, (l+r)/2, r, ql, qr));
    }
    void upd(int k, int l, int r, int x, int val){
        push(k, l, r);
        if(x>=r || x<l)
            return;
        if(l+1==r){
            t[k] = {val, l};
            return;
        }
        upd(2*k+1, l, (l+r)/2, x, val);
        upd(2*k+2, (l+r)/2, r, x, val);
        t[k] = min(t[2*k+2], t[2*k+1]);
    }
    void updrange(int k, int l, int r, int ql, int qr, int val){
        push(k, l, r);
        if(ql>=r || qr<=l)
            return;
        if(l>=ql && r<=qr){
            add[k] = val;
            push(k, l, r);
            return;
        }
        updrange(2*k+1, l, (l+r)/2, ql, qr, val);
        updrange(2*k+2, (l+r)/2, r, ql, qr, val);
        t[k] = min(t[2*k+2], t[2*k+1]);
    }
};

int n;
vector<int> * e;
int * sz;
int * p;
int * tin;
int * btin;
int * tout;
int * head;
int * c;
int * l;
int * r;
int * ans;

st tc;
st1 tn;

void dfssz(int v){
    sz[v] = 1;
    for(auto u:e[v]){
        dfssz(u);
        sz[v]+=sz[u];
    }
}

bool cmp(int a, int b){
    return make_pair(sz[a], a)>make_pair(sz[b], b);
}

int timer = 0;
void dfstin(int v, int root){
    tin[v] = timer++;
    btin[tin[v]] = v;
    head[v] = root;
    int ind = 0;
    for(auto u:e[v]){
        if(!ind)
            dfstin(u, root);
        else dfstin(u, u);
        ind++;
    }
    tout[v] = timer;
}

pair<int, int> dfsans(int v){
    int res = 0;
    int cnt = 0;
    for(auto u:e[v]){
        pair<int, int> temp = dfsans(u);
        if(temp==make_pair(-1ll, -1ll))
            return temp;
        res+=temp.x;
        cnt+=temp.y;
    }
    if(cnt>r[v])
        return make_pair(-1, -1);
    if(cnt>=l[v]){
        tn.upd(0, 0, n, tin[v], r[v]-cnt);
        return {res, cnt};
    } else {
        int dif = l[v]-cnt;
        tn.upd(0, 0, n, tin[v], r[v]-cnt);
        while(dif>0){
            pair<int, int> temp = tc.get(0, 0, n, tin[v], tout[v]);
            if(temp.x==LLONG_MAX){
                assert(0);
                return make_pair(-1, -1);
            }
            int u = btin[temp.y];
            pair<int, int> toadd = {LLONG_MAX, -1};
            while(head[u]!=head[v]){
                toadd = min(toadd, tn.get(0, 0, n, tin[head[u]], tin[u]+1));
                u = p[head[u]];
            }
            toadd = min(toadd, tn.get(0, 0, n, tin[v], tin[u]+1));
            u = btin[toadd.y];
            int toupd = dif;
            if(toadd.x<dif){
                toupd = toadd.x;
            }
            int z = btin[temp.y];
            while(head[z]!=head[v]){
                tn.updrange(0, 0, n, tin[head[z]], tin[z]+1, -toupd);
                z = p[head[z]];
            }
            tn.updrange(0, 0, n, tin[v], tin[z]+1, -toupd);
            if(toadd.x<=dif){
                u = btin[toadd.y];
                tc.updrange(0, 0, n, tin[u], tout[u]);
            }
            ans[btin[temp.y]]+=toupd;
            dif-=toupd;
            cnt+=toupd;
            res+=temp.x*toupd;
        }
        return {res, cnt};
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int qq;
    cin >> qq;
    for(int qqq = 0; qqq<qq; qqq++){
            timer = 0;
        cin >> n;
        p = new int[n];
        c = new int[n];
        l = new int[n];
        r = new int[n];
        tin = new int[n];
        btin = new int[n];
        head = new int[n];
        tout = new int[n];
        ans = new int[n];
        sz = new int[n];
        e = new vector<int>[n];
        p[0] = -1;
        for(int i = 1; i<n; i++){
            cin >> p[i];
            p[i]--;
            e[p[i]].push_back(i);
        }
        for(int i = 0; i<n; i++)
            cin >> c[i];
        for(int i = 0; i<n; i++)
            cin >> l[i] >> r[i];
        dfssz(0);
        for(int i = 0; i<n; i++){
            ans[i] = 0;
            sort(e[i].begin(), e[i].end(), cmp);
        }
        dfstin(0, 0);
        tc = st(n);
        tn = st1(n);
        for(int i = 0; i<n; i++){
            tc.upd(0, 0, n, tin[i], c[i]);
        }
        pair<int, int> fin = dfsans(0);
        cout << fin.x << "\n";
        if(fin.x!=-1){
            for(int i = 0; i<n; i++)
                cout << ans[i] << " ";
            cout << "\n";
        }
    }
    return 0;
}
