#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MAXN = 1e5 + 5;


vector<int> t[MAXN];
int p[MAXN];
ll c[MAXN], b[MAXN];
int l[MAXN], r[MAXN];
int power[MAXN];


struct node {
    int v;

    node(int v) : v(v) {}
};

bool operator<(node i, node j) {
    return c[i.v] < c[j.v] || (c[i.v] == c[j.v] && i.v < j.v);
}

/*

map<node, int> da[MAXN];
bool aboba = false;


void update(int v) {

}

void dfs(int v = 1, int minr = 1e9, int maxl = 0) {
    cnt[v] = sum[v] = 0;
    da[v].clear();
    minr = min(minr, r[v]);
    maxl = max(maxl, l[v]);
    for (int u: t[v]) {
        dfs(u, minr, maxl);
        minr -= cnt[u];
        maxl -= cnt[u];
        cnt[v] += cnt[u];
        sum[v] += sum[u];
        if (da[v].size() < da[u].size())
            swap(da[v], da[u]);
        for (auto[w, cnt]: da[v])
    }

}
*/

int cur[MAXN];

void dfs(int v = 1, int maxl = 0, int minr = 1e9) {
    maxl = max(maxl, l[v]);
    minr = min(minr, r[v]);
    cur[v] = min(maxl, minr);
    for (int u: t[v]) {
        dfs(u, maxl, minr);
    }
}

int used[MAXN];

void update(int v) {
    used[v] = true;
    b[v] = cur[v];
    power[p[v]]--;
    int w = v;
    while (w != 0) {
        r[w] -= cur[v];
        l[w] -= cur[v];
        w = p[w];
    }
}

void solve() {
    int n;
    cin >> n;
    for (int v = 2; v <= n; v++) {
        cin >> p[v];
        t[p[v]].push_back(v);
        power[p[v]]++;
    }
    for (int v = 1; v <= n; v++)
        cin >> c[v];
    for (int v = 1; v <= n; v++) {
        cin >> l[v] >> r[v];
    }
    c[0] = 1e9 + 5;
    for (int i = 0; i < 2 * n; i++) {
        dfs();
        int u = 0;
        for (int v = 1; v <= n; v++) {
            if (power[v] == 0 && !used[v]) {
                if (c[u] > c[v]) {
                    u = v;
                } else if (c[u] == c[v] && cur[u] < cur[v])
                    u = v;
            }
        }
        if (u == 0)
            break;
        update(u);
    }
    ll ans = 0;
    bool aboba = false;
    for (int v = 1; v <= n; v++) {
        ans += c[v] * b[v];
        if (l[v] > 0 || r[v] < 0)
            aboba = true;
    }
    if (aboba)
        cout << -1;
    else {
        cout << ans << '\n';
        for (int v = 1; v <= n; v++)
            cout << b[v] << ' ';
    }
    cout << '\n';
    for (int v = 1; v <= n; v++) {
        t[v].clear();
        power[v] = 0;
        b[v] = 0;
        used[v] = false;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
