#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) (int)x.size()

vector<int> dir;

void sol() {
  int n, w, h;
  cin >> n >> w >> h;
  vector<int> x(n), y(n);
  vector<pair<int, int>> xy(n);
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> y[i];
    xy[i] = {x[i], y[i]};
  }
  sort(all(xy));
  vector<pair<int, int>> hull{{0, h}};
  for (int i = 0; i < n; ++i) {
    while (!hull.empty() && hull.back().second >= xy[i].second && hull.back().first == xy[i].first) hull.pop_back();
    if (hull.empty() || xy[i].second < hull.back().second) hull.push_back(xy[i]);
  }
  ll res = 0;
  for (int i = 1; i < len(hull); ++i) {
    res += -(hull[i].second - hull[i - 1].second) * (w - hull[i].first);
  }
  cout << res << endl;
}

int32_t main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int k;
  cin >> k;
  dir.resize(k);
  for (auto &e : dir) cin >> e;
  int t;
  cin >> t;
  while (t--) sol();
  return 0;
}
