#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;
using db = double;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()

const int INF = 1e18 + 2;

void solve() {
	int n; cin >> n;
	vi a(n);
	rep(n) cin >> a[i];
	vi less(n), greater(n);
	rep(n) {
		for (int j = 0; j < i; j++)
			greater[i] += a[i] < a[j];
		for (int j = i + 1; j < n; j++)
			less[i] += a[i] > a[j];
	}
	int res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int cur = j - i + max(greater[i], less[j]);
			cur = max(cur, abs(a[i] - a[j]));
			res += cur;
			//cout << a[i] << " " << a[j] << " " << cur << "\n";
		}
	}
	cout << res << "\n";
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) solve();
}