#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;
using lli = pair<ll, int>;

const ll INF = 1e18;

int n;
vi c;
vll l, r;
vector<vi> children;

vll calc(int v) {
    int cc = children[v].size();
    if (cc == 0) {
        vll res(r[v]  - l[v] + 1, 0);
        ll k = l[v] * c[v];
        for (int i = 0; i < (int)res.size(); i++) {
            res[i] = k;
            k += c[v];
        }
        return move(res);
    }
    vi b(cc, 0);
    vector<vll> prices(cc);
    ll lsum = 0;
    ll lprice = 0;
    for (int i = 0; i < cc; i++) {
        prices[i] = calc(children[v][i]);
        if (prices[i].size() == 0)
            return vll();
        lsum += l[children[v][i]];
        b[i] = 1;
        lprice += prices[i][0];
    }
    if (lsum > r[v])
        return vll();
    vll res(r[v] - lsum + 1, 0);
    res[0] = lprice;
    for (int i = 1; i < (int)res.size(); i++) {
        ll step = c[v];
        int bb = -1;
        for (int j = 0; j < cc; j++) {
            if (b[j] >= prices[j].size())
                continue;
            ll p = prices[j][b[j]] - prices[j][b[j] - 1];
            if (p < step) {
                step = p;
                bb = j;
            }
        }
        res[i] = res[i - 1] + step;
        if (bb != -1)
            b[bb]++;
    }
    if (l[v] > lsum) {
        int d = l[v] - lsum;
        return move(vll(res.begin() + d, res.end()));
    }
    l[v] = lsum;
    return move(res);
}

void solve() {
    cin >> n;
    children = vector<vi>(n);
    c.assign(n, 0);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        children[p - 1].push_back(i);
    }
    for (int i = 0; i < n; i++)
        cin >> c[i];
    l.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    vll ans = calc(0);
    if (ans.size() == 0)
        cout << -1 << '\n';
    else
        cout << ans[0] << '\n';
}

int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}