#include <bits/stdc++.h>

//#define int long long

using namespace std;
typedef vector<int> vi;

const int maxn = 3002 * 3002;

vi g[maxn];
bool used[maxn];
int cnt[maxn];
int tin[maxn];
int tout[maxn];

int get(int r, int c){
    return r * (r + 1) / 2 + c;
}

int timer = 0;

void dfs(int v){
    used[v] = true;
    cnt[v]++;
    for(int i:g[v]){
        if(!used[i]) {
            dfs(i);
        }
    }
}

bool upper(int a, int b){
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

pair<bool, bool> step[maxn];

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for(int &i:a)
        cin >> i;
    vi kek(n, 0);
    for(int i=0; i<=n; i++){
        pair<int, int> cur = make_pair(0, 0);
        for(int j=0; j<n; j++){
            pair<int, int> nxt = cur;
            nxt.first++;
            if(!kek[j])
                nxt.second++;
            if(!kek[j])
                step[get(nxt.first, nxt.second)].first = true;
            else
                step[get(nxt.first, nxt.second)].second = true;
            cur = nxt;
        }
        if(i < n)
            kek[a[i] - 1] = 1;
    }

    int q;
    cin >> q;
    for(int i=0; i<q; i++){
        pair<int, int> a;
        cin >> a.first >> a.second;
        pair<int, int> b;
        cin >> b.first >> b.second;
        if(a.first < b.first){
            swap(a, b);
        }
        if(a.second < b.second){
            while(a.first > b.first){
                if(!step[get(a.first, a.second)].second){
                    a.second--;
                }
                a.first--;
            }
            while(a != b){
                if(!step[get(a.first, a.second)].second)
                    a.second--;
                if(step[get(b.first, b.second)].first)
                    b.second--;
                a.first--;
                b.first--;
            }
            cout << a.first << " " << a.second << endl;
        } else{
            while(a.first > b.first){
                if(step[get(a.first, a.second)].first){
                    a.second--;
                }
                a.first--;
            }
            if(a.second <= b.second){
                cout << b.first << " " << b.second << endl;
                continue;
            }
            while(a != b){
                if(step[get(a.first, a.second)].first)
                    a.second--;
                if(!step[get(b.first, b.second)].second)
                    b.second--;
                a.first--;
                b.first--;
            }
            cout << a.first << " " << a.second << endl;
        }
    }
}

signed main() {
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2

=====
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
 */