#include <bits/stdc++.h>
using namespace std;

int t = 0;
const int lg = 23;
vector <vector <int>> g, up;
vector <int> tin, tout;
vector <int> used;

void dfs(int v, int p) {
    used[v] = 1;
    tin[v] = t;
    t += 1;
    up[0][v] = p;
    for (int i = 1; i < lg; ++i) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }
    for (auto u : g[v]) {
        if (u != p && !used[u]) {
            dfs(u, v);
        }
    }
    tout[v] = t;
    t += 1;
}

bool check(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

long long lca(int u, int v) {
    if (check(u, v)) {
        return u;
    }
    if (check(v, u)) {
        return v;
    }
    for (int i = lg - 1; i >= 0; --i) {
        if (!check(up[i][v], u)) {
            v = up[i][v];
        }
    }
    return up[0][v];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n;
    cin >> n;

    vector <long long> a(n);
    n += 1;
    long long k = 0;
    map <pair <int, int>, int> d;
    map <int, pair <int, int>> dd;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            d[{i, j}] = k;
            dd[k] = {i, j};
            k += 1;
        }
    }
    long long m = k;
    for (int i = 0; i < n - 1; ++i) {
        cin >> a[i];
    }
    vector <int> c(n, 1);
    g.resize(m);
    used.resize(m, 0);
    k = 0;
    for (int i = 1; i < n; ++i) {
        long long u, v;
        u = d[{i - 1, i - 1}];
        v = d[{i, i}];
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n - 1; ++i) {
        c[a[i] - 1] ^= 1;
        k = 0;
        long long h = 0;
        for (int j = 0; j < n - 1; ++j) {
            long long u, v;
            if (c[j] == 1) {
                u = d[{k, h}];
                v = d[{k + 1, h + 1}];
                g[u].push_back(v);
                g[v].push_back(u);
                h += 1;
            }
            else {
                u = d[{k, h}];
                v = d[{k + 1, h}];
                g[u].push_back(v);
                g[v].push_back(u);
            }
            k += 1;
        }
    }
    int y = 0;

    up.resize(lg, vector <int>(m));
    tin.resize(m);
    tout.resize(m);
    dfs(0, 0);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x, y, k, h;
        cin >> x >> y >> k >> h;
        long long p = lca(d[{x, y}], d[{k, h}]);
        //cout << p << endl;
        cout << dd[p].first << ' ' << dd[p].second << '\n';
    }
}
