#include <bits/stdc++.h>

using namespace std;

#define int long long

int n;
vector<int> a;

string path_to(pair<int, int> u) {
	auto [r, c] = u;

	string s(r, 'R');

	int i;
	int cnt_above = 0;
	for(i = 0; cnt_above < r - c && i < n; i++) {
		if(a[i] < r) {
			cnt_above++;
			s[a[i]] = 'L';
		}
	}
	assert(cnt_above == r - c);

	return s;
}

pair<int, int> lca(pair<int, int> u, pair<int, int> v) {
	string s_u = path_to(u);
	string s_v = path_to(v);

	int c = 0;

	int r = 0;
	while(r < s_u.size() && r < s_v.size() && s_u[r] == s_v[r]) {
		if(s_u[r] == 'R') {
			c++;
		}
		r++;
	}

	return make_pair(r, c);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;

	a.resize(n);
	for(int& x: a) {
		cin >> x;
		x--;
	}

	int q;
	cin >> q;

	for(int i = 0; i < q; i++) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		auto [r3, c3] = lca(make_pair(r1, c1), make_pair(r2, c2));
		cout << r3 << " " << c3 << "\n";
	}

	return 0;
}