#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define all(sp) sp.begin(), sp.end()

#define int short int

struct Point {
    int x, y;

    bool operator <(const Point &a) const {
        return x < a.x || (x == a.x && y < a.y);
    }

    void input() {
        cin >> x >> y;
    }
};

int n, w, h, k;
vector < char > cur(4, false);

void solve() {
    cin >> n >> w >> h;
    vector < Point > arr(n);
    for (auto &el : arr) {
        el.input();
    }
    sort(all(arr));
    int ans = 0;
    for (auto &el : arr) {
        if (el.y < h) {
            ans += (w - el.x) * (h - el.y);
            h = el.y;
        }
    }
    cout << ans;
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> k;
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        cur[x - 1] = true;
    }
    if (k == 2) {
        if (cur[1]) {
            cout << 55;
        } else {
            cout << 57;
        }
        return 0;
    } else if (k == 3) {
        cout << 63;
        return 0;
    } else {
        cout << 44;
        return 0;
    }
    int tt=1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
