#pragma GCC optimize("inline", "Ofast", "O3", "fast-math", "no-stack-protector", "unroll-loops")
#pragma GCC otimize("avx2")

#include <bits/stdc++.h>

using namespace std;

#define int long long

//mt19937 rnd;



const int maxn = 100001;

vector<int> a[maxn];

int l[maxn];
int r[maxn];
int c[maxn];
int now[maxn];
int cnt[maxn];
set<pair<int, int>> s[maxn];

bool prov(int v)
{
    //cout << v << " " << l[v] << " " << r[v] << "\n";
    bool ans = 0;
    int sum = 0;

    for (int u : a[v])
        if (prov(u))
            ans = 1;

    for (int u : a[v])
        sum += cnt[u];
    cnt[v] = max(sum, l[v]);
    if (sum > r[v])
    {
        //cout << sum << " " << r[v] << "\n";
        //cout << "problem in v: " << v << "\n";
        return 1;
    }
    return ans;
}

void dfs(int v)
{
    int in = 0;
    for (int u : a[v])
    {
        dfs(u);
        in += cnt[u];
        for (auto j : s[u])
            s[v].insert(j);
    }

    s[v].insert({c[v], v});
    int cost, i;
    while (in < l[v])
    {
        cost = (*(s[v].begin())).first;
        i = (*(s[v].begin())).second;
        //cout << v << " " << in << " " << cost << " " << i << "\n";
        //s.erase(s.begin());
        if (r[i] - now[i] > l[v] - in)
        {
            now[i] += l[v] - in;
            in = l[v];
            break;
            //s.insert({cost, i});
        }
        else
        {
            in += r[i] - now[i];
            now[i] = r[i];
            s[v].erase(s[v].begin());
        }
    }
    //cout << v << " " << in << "\n";
    return;
}

signed main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n, x;
        cin >> n;
        for (int i = 0; i < n; i++)
        {
            s[i].clear();
            now[i] = 0;
            a[i].clear();
        }
        for (int i = 1; i < n; i++)
        {
            cin >> x;
            x--;
            a[x].push_back(i);
        }
        for (int i = 0; i < n; i++)
            cin >> c[i];
        for (int i = 0; i < n; i++)
            cin >> l[i] >> r[i];

        if (prov(0))
        {
            cout << "-1\n";
            continue;
        }

        dfs(0);
        int ans = 0;
        for (int i = 0; i < n; i++)
            ans += c[i] * now[i];
        cout << ans << "\n";
        for (int i = 0; i < n; i++)
            cout << now[i] << " ";
        cout << "\n";
    }


    return 0;
}



