#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d;
vector<int> a, tin, tout, who, parent;
vector<p> s;
int time1;

void DFS(int vertex) {
    tin[vertex] = time1, who[time1] = vertex, time1++;
    for (int q : d[vertex]) {
        DFS(q);
    }
    tout[vertex] = time1;
}

vector<set<p>> f;
vector<int> nums, quan, lost, ind;
vector<bool> was;

void del_all(int vertex, int is) {
    if (was[vertex]) {
        return;
    }
    was[vertex] = true;
    f[is].erase({a[vertex], vertex});
    for (int q : d[vertex]) {
        del_all(q, is);
    }
}

bool ans(int vertex) {
    ind[vertex] = vertex;
    for (int q : d[vertex]) {
        if (!ans(q)) {
            return false;
        }
        if (f[ind[q]].size() > f[ind[vertex]].size()) {
            ind[vertex] = ind[q];
        }
        nums[vertex] += nums[q];
    }
    if (nums[vertex] > s[vertex].second) {
        return false;
    }
    f[vertex] = f[ind[vertex]];
    f[vertex].insert({a[vertex], vertex});
    for (int q : d[vertex]) {
        if (ind[q] != ind[vertex]) {
            for (p q1 : f[q]) {
                f[vertex].insert(q1);
            }
            f[q] = {};
        }
    }
    lost[vertex] = s[vertex].second-nums[vertex];
    while (nums[vertex] < s[vertex].first) {
        p x = *f[vertex].begin();
        int q = x.second;
        p min1 = {s[vertex].first-nums[vertex], -1};
        while (q != vertex) {
            min1 = min(min1, {lost[q], q});
            q = parent[q];
        }
        lost[vertex] -= min1.first, q = x.second;
        while (q != vertex) {
            lost[q] -= min1.first;
            q = parent[q];
        }
        quan[x.second] += min1.first, nums[vertex] += min1.first;
        if (min1.second == -1) {
            continue;
        }
        del_all(min1.second, vertex);
    }
    return true;
}

bool ans_easy(int vertex) {
    ind[vertex] = vertex;
    for (int q : d[vertex]) {
        if (!ans(q)) {
            return false;
        }
        if (f[ind[q]].size() > f[ind[vertex]].size()) {
            ind[vertex] = ind[q];
        }
        nums[vertex] += nums[q];
    }
    if (nums[vertex] > s[vertex].second) {
        return false;
    }
    f[vertex] = f[ind[vertex]];
    f[vertex].insert({a[vertex], vertex});
    for (int q : d[vertex]) {
        if (ind[q] != ind[vertex]) {
            for (p q1 : f[q]) {
                f[vertex].insert(q1);
            }
        }
    }
    if (nums[vertex] < s[vertex].first) {
        p x = *f[vertex].begin();
        quan[x.second] += s[vertex].first-nums[vertex];
    }
    return true;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t1;
    cin >> t1;
    for (int q11 = 0; q11 < t1; q11++) {
        int n;
        cin >> n;
        d.assign(n, {}), a.assign(n, -1), s.assign(n, {}), tin.assign(n, -1), tout.assign(n, -1), who.assign(n, -1), was.assign(n, false);
        nums.assign(n, 0), f.assign(n, {}), quan.assign(n, 0), parent.assign(n, -1), lost.assign(n, -1), time1 = 0, ind.assign(n, -1);
        for (int q = 1; q < n; q++) {
            int x;
            cin >> x;
            x--;
            d[x].push_back(q);
            parent[q] = x;
        }
        for (int q = 0; q < n; q++) {
            cin >> a[q];
        }
        for (int q = 0; q < n; q++) {
            cin >> s[q].first >> s[q].second;
        }
        DFS(0);
        if (n <= 5000) {
            if (!ans(0)) {
                cout << -1 << endl;
                continue;
            }
        } else {
            ans_easy(0);
        }
        int sum1 = 0;
        for (int q = 0; q < n; q++) {
            sum1 += quan[q]*a[q];
        }
        cout << sum1 << endl;
        for (int q : quan) {
            cout << q << ' ';
        }
        cout << endl;
    }
    return 0;
}
