#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define vi vector<int>
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back
#define int ll

using namespace std;



const int maxn = 1e5 + 50;
mt19937 rnd(time(0));

namespace dd {
    struct node {
        node *l, *r;
        pii x;
        int y;
        int s = 0;
        int p = 0;
        node(pii x) : x(x), y(rnd()), l(0), r(0), s(1) {};
    };

    int getS(node *v) {
        if (!v)
            return 0;
        return v->s;
    }

    void upd(node *v) {
        if (!v)
            return;
        v->s = 1 + (v->r ? v->r->s : 0) + (v->l ? v->l->s : 0);
    }

    void push(node *v) {
        if (!v)
            return;
        if (v->p) {
            if (v->l) {
                v->l->x.f += v->p;
                v->l->p += v->p;
            }
            if (v->r) {
                v->r->x.f += v->p;
                v->r->p += v->p;
            }
            v->p = 0;
        }
    }

    node *merge(node *a, node *b) {
        if (!a)
            return b;
        if (!b)
            return a;
        push(a);
        push(b);
        if (a->y > b->y) {
            a->r = merge(a->r, b);
            upd(a);
            return a;
        } else {
            b->l = merge(b->l, b);
            upd(b);
            return b;
        }
    }
    pair<node*, node*> split(node *v, int x) {
        if (!v)
            return {0, 0};
        push(v);
        if (v->x.f <= x) {
            auto p = split(v->r, x);
            v->r = p.f;
            upd(v);
            return {v, p.s};
        } else {
            auto p = split(v->l, x);
            v->l = p.s;
            upd(v);
            return {p.f, v};
        }
    }
    pair<node*, node*> splitk(node *v, int x) {
        if (!v)
            return {0, 0};
        push(v);
        if (v->x.s <= x) {
            auto p = split(v->r, x);
            v->r = p.f;
            upd(v);
            return {v, p.s};
        } else {
            auto p = split(v->l, x);
            v->l = p.s;
            upd(v);
            return {p.f, v};
        }
    }
}
vi r[maxn];
vi c;
vector<pii> a;
vi b(maxn);

struct node {
    int l, r;
    dd::node *dx = 0;
    node(int l = 0, int r = 0) : l(l), r(r) {
        dx = 0;
    }
} dp[maxn];

node merge(const node &a, const node &b) {

    return x;
}

void dfs(int v) {
    dp[v] = node(0, a[v].s);
    dp[v].dx = new dd::node({0, c[v]});
    for (auto &u : r[v]) {
        dfs(u);
        if (dd::getS(dp[u].dx)) {
            dp[v] = node(0, -1);
            return;
        }
        if (dd::getS(dp[u].dx) > dd::getS(dp[v].dx))
            swap(dp[u], dp[v]);
        dp[v] = merge(dp[v], dp[u]);
    }
    if (max(a[v].f, dp[v].l) > min(a[v].s, dp[v].r)) {
        dp[v] = node(0, -1);
        return;
    }
}
void dfs2(int v, int x) {
    int k = r[v].size();
    node nx[k + 1];
    node pref[k + 1];
    for (int i = 0; i < k; ++i) {
        nx[i] = pref[i] = dp[r[v][i]];
        if (i)
            pref[i] = merge(pref[i], pref[i - 1]);
        //  cout << i << ' ' << pref[i].a.size() << endl;
    }
    nx[k] = pref[k] = node(0, a[v].s);
    for (int j = 0; j < nx[k].a.size(); ++j) {
        nx[k].a[j] = c[v] * j;
    }
    if (k)
        pref[k] = merge(pref[k], pref[k - 1]);
    int need[k + 1];
    int zn[k + 1];
    for (int j = k; j > 0; --j) {
        int l = pref[j - 1].a.size() - 1, r = nx[j].a.size() - 1;
        while (l + r + pref[j - 1].l + nx[j].l > x) {
            if (l <= 0) {
                r--;
            } else if (r <= 0) {
                l--;
            } else {
                int d1 = pref[j - 1].a[l] - (l ? pref[j - 1].a[l - 1] : 0);
                int d2 = nx[j].a[r] - (r ? nx[j].a[r - 1] : 0);
                if (d1 > d2) {
                    l--;
                } else {
                    r--;
                }
            }
        }

        zn[j] = r + nx[j].l;
        x -= zn[j];
    }
    zn[0] = x;
    for (int j = 0; j < k; ++j) {
        dfs2(r[v][j], zn[j]);
    }
    b[v] = zn[k];

}

void solve() {
    int n;
    cin >> n;
    c.resize(n);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        r[i].clear();
    }

    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        r[p - 1].pb(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].f >> a[i].s;
        dp[i] = {a[i].f, a[i].s};
    }

    dfs(0);
    if (dp[0].a.size() == 0) {
        cout << -1 << endl;
        return;
    }
    cool_dfs(0);
    cout << cool_dp[0].val << endl;
    dfs2(0, dp[0].l);
    for (int i = 0; i < n; ++i) {
        cout << b[i] << ' ';
    }
    cout << endl;
}

signed main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--)
        solve();

    return 0;
}
