#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define vi vector<int>
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back
//#define int ll

using namespace std;

const int maxn = 3200;

vector<pii> r[maxn][maxn];

int T = 0;
pii bin2[maxn][maxn];

void dfs(pii v, pii p) {
    bin2[v.f][v.s] = p;
    sort(r[v.f][v.s].begin(), r[v.f][v.s].end());
    r[v.f][v.s].resize(unique(r[v.f][v.s].begin(), r[v.f][v.s].end()) - r[v.f][v.s].begin());
    for (auto &u : r[v.f][v.s]) {
        dfs(u, v);
    }
}

pii lca(pii a, pii b) {
    while (a != b) {
        if (a.f < b.f)
            swap(a, b);
        a = bin2[a.f][a.s];
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    int now[n];
    for (int i = 0; i < n; ++i) {
        now[i] = 1;
    }
    int r = 0, c = 0;
    for (int i = 0; i < n; ++i) {
        int nx = r + 1;
        int ny = c + now[i];
        ::r[r][c].pb({nx, ny});
        r = nx, c = ny;
    }
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        r = 0, c = 0;
        x--;
        now[x] = 0;
        for (int i = 0; i < n; ++i) {
            int nx = r + 1;
            int ny = c + now[i];
            ::r[r][c].pb({nx, ny});
            r = nx, c = ny;
        }
    }
    dfs({0, 0}, {0, 0});
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        pii ans = lca({r1, c1}, {r2, c2});
        cout << ans.f << ' ' << ans.s << endl;
    }
}

signed main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    while(t--)
        solve();

    return 0;
}
