#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
using namespace ::std;


void doWork()
{
	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> vect(n);
	for (int i = 0; i < n; i++)
	{
		cin >> vect[i].first >> vect[i].second;
		vect[i].first = w - vect[i].first;
		vect[i].second = h - vect[i].second;

	}
	vect.push_back(pair<int, int>(0, 0));
	sort(vect.begin(), vect.end());
	int maxSec = -1;
	for (int i = n; i >= 0; --i)
	{
		//cout << vect[i].first << " " << vect[i].second << "\n";
		if (maxSec < vect[i].second)
		{
			maxSec = vect[i].second;
		}
		else
		{
			vect[i].first = 0;
			vect[i].second = 0;
		}
	}
	long long sum = 0;
	sort(vect.begin(), vect.end());
	for (int i = 1; i < n + 1; i++)
	{
		sum += ((long long)(vect[i].first - vect[i - 1].first)) * vect[i].second;
	}
	cout << sum << "\n";
}


int main()
{
	int k;
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		int x;
		cin >> x;
	}
	int t;
	cin >> t;
	while (t--)
	{
		doWork();
	}

	return 0;
}