#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

void solve() {
    int n; cin >> n;
    vector<int> p(n);
    for (int& x : p) cin >> x, x--;

    vector<int> gor(n), gol(n);

    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) gor[i] += p[j] < p[i];
        for (int j = i; j >= 0; j--) gol[i] += p[j] > p[i];
    }

    ll ans = 0;
    for (int i = 0;   i < n; ++i) 
    for (int j = i+1; j < n; ++j) {
        int res = abs(p[i] - p[j]);
        ckmax(res, j - i + gor[j]);
        ckmax(res, j - i + gol[i]);
        ans += res;
    }

    cout << ans << endl;    
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}