#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

int curma[3002][3002];

int main(){
    int n;
    cin >> n;
    vector<int> a;
    a.resize(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    vector<int> cursor;
    cursor.reserve(n);
    int offset, y;
    for(int i = 0; i < n-1; ++i){
        cursor.push_back(a[i]);
        y = cursor.size()-1;
        while(y != 0 && cursor[y] < cursor[y-1]){
            swap(cursor[y], cursor[y-1]);
            --y;
        }
        for(int j = i+1; j < n; ++j){
            curma[a[i]][a[j]] = j-y;
        }
    }
    cursor.clear();
    cursor.reserve(n);
    for(int i = n-1; i > 0; --i){
        cursor.push_back(a[i]);
        y = cursor.size()-1;
        while(y != 0 && cursor[y] < cursor[y-1]){
            swap(cursor[y], cursor[y-1]);
            --y;
        }
        for(int j = i-1; j >= 0; --j){
            curma[a[j]][a[i]] = max(curma[a[j]][a[i]], i-j+y);
        }
    }
    long long ans = 0;
    for(int i = 0; i < n-1; ++i){
        for(int j = i+1; j < n; ++j){
            ans += max(curma[a[i]][a[j]], max(a[i], a[j]) - min(a[i], a[j]));
        }
    }
    cout << ans << endl;
}
