#include<bits/stdc++.h>
using namespace std;

#define int long long
#define siz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define eb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second

struct P {
	int x, y;
	P() {}
	P(int x, int y) : x(x), y(y) {}
};

const int N = 1e5 + 3;

int n, W, H;
P p[N];

int pro(int i, int f, int& x1, int& x2) {
	int res = 0;
	if (x1 >= x2) return 0;
	if (f == 1) {
		if (p[i].x < x2) {
			res += (x2 - max(p[i].x, x1)) * (H - p[i].y);
			x2 = p[i].x;
		}
	} else if (p[i].x > x1) {
		res += (min(p[i].x, x2) - x1) * (H - p[i].y);
		x1 = p[i].x;
	}
	return res;
}

int solve(int st, int x1, int x2) {
	if (st >= min(n, 25ll)) return 0;
	int t1 = x1, t2 = x2;
	int res1 = 0, res2 = 0;

	if (p[st].x < x2) res1 = pro(st, 1, x1, x2) + solve(st+1, x1, x2);
	if (p[st].x > x1) res2 = pro(st, 2, t1, t2) + solve(st+1, t1, t2);
	return max(res1, res2);
}

void run() {
	cin >> n >> W >> H;
	for (int i = 0; i < n; ++i)
		cin >> p[i].x >> p[i].y;

	sort(p, p + n, [](auto v1, auto v2) { return v1.y < v2.y; });

	int res = solve(0, 0, W);
	cout << res << '\n';
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	int k; cin >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i)
		cin >> a[i];

	int t = 1; cin >> t;
	while (t--) {
		run();	
	}
}