//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx, avx2, sse, sse2, sse3, sse4, fma, popcnt")
//#pragma GCC optimize ("-Ofast, unroll-loops, fast-math")
#include <iostream>
#include <vector>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	long long ans = 0;
	vector<int> l(n, n), r(n, -1);
	vector<int> nw;
	nw.reserve(n);
	for (int i = 0; i < n; ++i) {
		int ind = i;
		for (int j = 0; j < i; ++j)
			if (nw[j] > a[i]) {
				ind = j;
				break;
			}
		l[i] = ind;
		nw.insert(nw.begin() + ind, a[i]);
	}
	nw.clear();
	for (int i = n - 1; i >= 0; --i) {
		int ind = n - 1 - i;
		for (int j = 0; j < n - 1 - i; ++j)
			if (nw[j] > a[i]) {
				ind = j;
				break;
			}
		r[i] = ind + i;
		nw.insert(nw.begin() + ind, a[i]);
	}
	vector<pair<int, int>> srt(n);
	vector<int> pos(n);
	for (int i = 0; i < n; ++i)
		srt[i] = { a[i], i };
	sort(all(srt));
	for (int i = 0; i < n; ++i)
		pos[srt[i].second] = i;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			ans += max(abs(pos[i] - pos[j]), max(j - l[i], r[j] - i));
	cout << ans;
}
