#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int n; cin >> n;
	vector <int> a(n), p(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		p[a[i]] = i;
	}

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			vector <int> b = a;
			int res = j - i;
			int id1 = p[i], id2 = p[j];
			sort(b.begin(), b.begin() + min(id1, id2) + 1);
			int i1 = -1, i2 = -1;
			for (int k = 0; k < n; ++k)
				if (b[k] == i) i1 = k;
				else if (b[k] == j) i2 = k;
			res = max(res, abs(i1 - i2));
			b = a;
			sort(b.end() - n + max(id1, id2), b.end());
			for (int k = 0; k < n; ++k)
				if (b[k] == i) i1 = k;
				else if (b[k] == j) i2 = k;
			res = max(res, abs(i1 - i2));
			//cout << i << ' ' << j << ' ' << res << '\n';
			ans += res;
		}
	}

	cout << ans << '\n';

}