#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;
using ll = long long;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) { return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) { return a < b ? a = b, true : false; }

const int N = 1e5+7;

int flag = 1;
ll ans = 0;
int c[N], l[N], r[N], cnt[N], used[N];
vector<int> g[N];
set<pair<pi, int>> st[N];

void dfs(int v, int p = -1) {
    vector<pair<int, int>> add;
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        cnt[v] += cnt[u];
        add.push_back({st[u].size(), u});
    }
    sort(rall(add));
    if (add.size()) st[v].swap(st[add[0].S]);
    st[v].insert({{c[v], r[v]}, v});
    for (int i = 1; i < add.size(); ++i) {
        for (auto tmp : st[add[i].S])
            st[v].insert(tmp);
    }
    if (cnt[v] > r[v]) flag = 0;
    while (cnt[v] < l[v]) {
        int w = st[v].begin() -> F.F;
        int k = st[v].begin() -> F.S;
        int id = st[v].begin() -> S;
        st[v].erase(st[v].begin());
        if (cnt[v] + k > l[v]) {
            st[v].insert({{w, cnt[v]+k - l[v]}, id});
            used[id] += (l[v] - cnt[v]);
            ans += (ll)w*(l[v] - cnt[v]);
            cnt[v] = l[v];
        } else {
            used[id] += k;
            ans += (ll)w*k;
            cnt[v] += k;
        }
    }
    set<pair<pi, int>> cur_st;
    ll cur_sum = 0;
    for (auto tmp : st[v]) {
        if (cur_sum + cnt[v] >= r[v]) break;
        int k = tmp.F.S;
        if (cur_sum + k + cnt[v] <= r[v]) {
            cur_sum += k;
            cur_st.insert(tmp);
        } else {
            int w = tmp.F.F, id = tmp.S;
            cur_st.insert({{w, r[v] - (cur_sum + cnt[v])}, id});
            cur_sum = r[v] - cnt[v];
        }
    }
    st[v].swap(cur_st);
}

void solve() {
    int n; cin >> n;
    flag = 1; ans = 0;
    for (int i = 0; i < n; ++i) g[i].clear(), st[i].clear(), cnt[i] = 0, used[i] = 0;
    for (int i = 1; i < n; ++i) {
        int u, v; cin >> u; v = i+1;
        g[--u].push_back(--v); g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
    dfs(0);
    //cout << "FLAG " << flag << "\n";
    if (!flag) {
        cout << "-1\n";
        return;
    }
    cout << ans << "\n";
    for (int i = 0; i < n; ++i) cout << used[i] << " "; cout << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}