#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	int n;
	cin >> n;

	vector<int> a(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector<int> dl(n, 0);
	vector<int> dr(n, 0);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if (a[i] < a[j]) {
				dl[i]++;
			}
		}
	}

	for (int i = n - 1; i >= 0; i--) {
		for (int j = n - 1; j >= i; j--) {
			if (a[i] > a[j]) {
				dr[i]++;
			}
		}
	}

	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int dst = j - i;

			dst = max(dst, abs(a[i] - a[j]));
			dst = max(dst, abs(j - i + dl[i]));
			dst = max(dst, abs(j - i + dr[j]));

			ans += dst;
		}
	}

	cout << ans;
}
