#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int N = 3010;

int a[N];
int pos[N];
int posl[N];
int posr[N];

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		pos[a[i]] = i;
	}
	for (int i = 0; i < n; ++i) {
		posl[i] = 0;
		for (int j = 0; j < i; ++j) {
			if (a[j] < a[i]) ++posl[i];
		}
	}
	for (int i = n - 1; i >= 0; --i) {
		posr[i] = n - 1;
		for (int j = n - 1; j > i; --j) {
			if (a[j] > a[i]) --posr[i];
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i == j) continue;
			int pi = pos[i];
			int pj = pos[j];
			if (pi > pj) swap(pi, pj);
			int now = max(max(posr[pj] - pi, pj - posl[pi]), abs(i - j));
			//cout << "d(" << i + 1 << ", " << j + 1 << ") = " << now << "\n";
			ans += now;
		}
	}
	cout << ans / 2;
}

signed main() {
	solve();
}