#include <bits/stdc++.h>

using namespace std;

int diff(int a, int b)
{
    return max(a - b, b - a);
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n), l_sort(n), r_sort(n);
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        l_sort[i] = r_sort[i] = a[i];
    }
    vector<vector<int>> d(n + 1, vector<int>(n + 1));

    for(int r = 0; r < n; r++)
    {
        int k = r;
        while(k > 0 && r_sort[k] < r_sort[k - 1])
        {
            swap(r_sort[k], r_sort[k - 1]);
            k--;
        }

        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < i; j++)
            {
                d[r_sort[j]][r_sort[i]] = max(d[r_sort[j]][r_sort[i]], diff(i, j));
                d[r_sort[i]][r_sort[j]] = d[r_sort[j]][r_sort[i]];
            }
        }
    }

    for(int l = n - 1; l >= 0; l--)
    {
        int k = l;
        while(k < n - 1 && l_sort[k] > l_sort[k + 1])
        {
            swap(l_sort[k], l_sort[k + 1]);
            k++;
        }

        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < i; j++)
            {
                d[l_sort[j]][l_sort[i]] = max(d[l_sort[j]][l_sort[i]], diff(i, j));
                d[l_sort[i]][l_sort[j]] = d[l_sort[j]][l_sort[i]];
            }
        }
    }

    long long ans = 0;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j < i; j++)
        {
            ans += d[i][j];
            //cout << "D(" << j << "; " << i << ") = " << d[i][j] << "\n";
        }
        //cout << "\n";
    }
    cout << ans << "\n";
}
