#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

const ll MAXN = 3e5 + 123;
ll a[MAXN];

struct dsu {
    void resize(ll n) {
        rt.resize(n);
        for (ll i = 0; i < n; ++i)
            rt[i] = i;
    }

    ll gst(ll i) {
        if (rt[i] == i)
            return i;
        return rt[i] = gst(rt[i]);
    }

    void unite(ll i, ll j) {
        i = gst(i);
        j = gst(j);
        rt[min(i, j)] = max(i, j);
    }
 private:
    vector<ll> rt;
};

signed main() {
    ll n, q;
    cin >> n >> q;
    vector<ll> cpr;
    ll sm = 0;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
        cpr.push_back(a[i]);
    }
    sort(cpr.begin(), cpr.end());
    vector<pair<ll, pair<ll, ll>>> qrs(q);
    for (ll i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        if (t == 1 || t == 2) {
            ll k;
            cin >> k;
            qrs[i] = {k, {-t, i}};
        } else {
            ll k, j;
            cin >> k >> j;
            --j;
            qrs[i] = {k, {j, i}};
        }
    }
    sort(qrs.begin(), qrs.end());
    vector<ll> ans(q);
    vector<ll> vals = cpr;
    ll t = 0;
    ll ans_qr1 = 1;
    for (int i = n - 2; i >= 0; --i) {
        if (vals[i] < vals[i + 1])
            ++ans_qr1;
    }
    ll ans_qr2 = sm;
    ll qri = 0;
    while (qri < q) {
        while (qri < q && qrs[qri].first == t) {
            auto [type, qri0] = qrs[qri].second;
            if (type == -1) {
                ans[qri0] = ans_qr1;
            } else if (type == -2) {
                ans[qri0] = ans_qr2;
            } else {
                ll i = lower_bound(cpr.begin(), cpr.end(), a[type]) - cpr.begin();
                ans[qri0] = vals[i];
            }
            ++qri;
        }
        vector<ll> add(n, 0);
        for (ll i = n - 2; i >= 0; --i) {
            add[i] = add[i + 1];
            if (vals[i] < vals[i + 1])
                ++add[i];
        }
        for (int i = 0; i < n; ++i)
            vals[i] += add[i];
        ans_qr1 = 1;
        ans_qr2 = -sm;
        for (ll i = n - 2; i >= 0; --i) {
            if (vals[i] < vals[i + 1])
                ++ans_qr1;
        }
        for (ll i = 0; i < n; ++i)
            ans_qr2 += vals[i];
        ++t;
    }
    for (ll i = 0; i < q; ++i)
        cout << ans[i] << '\n';
}
