#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

using namespace std;

#define int long long
#define vout(v) for (auto i : v) cout << i;

const int c = 20;

bool more(int i, int x) {
    return i > (int)log10(x);
}

int power[19];

void precount() {
    power[0] = 1;
    for (int i = 1; i < 19; ++i) {
        power[i] = power[i - 1] * 10;
    }
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    precount();
    string s;
    cin >> s;
    int n = s.size();
    vector<int> start(n);
    for (int i = 0; i < n; ++i) {
        start[i] = s[i] - '0';
    }
    int cost;
    cin >> cost;
    auto v = start;
    auto best = start;
    sort(best.rbegin(), best.rend());
    int done_pref_size = 0;
    for (int d = 9; d >= 0; --d) {
        set<int> pos;
        for (int i = done_pref_size; i < n; ++i) {
            if (v[i] == d) pos.insert(i);
        }
        for (auto p : pos) {
            if (p == done_pref_size) {
                ++done_pref_size;
                continue;
            }
            int pls = 0;
            int l = done_pref_size;
            int r = p;
            bool can = false;
            if (r - l >= c) can = true;
            if (p + c <= n || l + c <= n) can = true;
            for (int i = r; i > l && !can; --i) {
                if (v[i] < v[i - 1]) {
                    can = false;
                    break;
                }
                pls += 9 * power[n - i - 1] * (d - v[i - 1]);
                if (pls > cost * (r - i + 1)) {
                    can = true;
                }
            }
            if (!can) {
                break;
            } else {
                ++done_pref_size;
                for (int i = r; i > l; --i) {
                    swap(v[i], v[i - 1]);
                }
            }
        }
    }
    vout(v);
}
