#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

#define int long long
#define vout(v) for (auto i : v) cout << i;

struct query {
    int t, k, ind;
    int pl = 0;
};

bool cmp(query a, query b) {
    return a.k < b.k;
}

signed main() {
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> v(n), real(n);
    int start_sum = 0, mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        start_sum += v[i];
        mx = max(mx, v[i]);
    }
    set<int> cur;
    map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        real[i] = v[i];
        cnt[v[i]] += 1;
        cur.insert(v[i]);
    }
    set<int> all_d;
    auto w = v;
    sort(w.begin(), w.end());
    for (int i = 0; i < w.size() - 1; ++i) {
        if (w[i] == w[i + 1]) continue;
        all_d.insert(w[i + 1] - w[i]);
    }
    vector<int> ans_q(q);
    vector<query> qq;
    for (int i = 0; i < n; ++i) {
        int t, k;
        cin >> t >> k;
        if (t != 3) {
            qq.push_back({t, k, i});
        } else {
            int pl;
            cin >> pl;
            --pl;
            qq.push_back({t, k, i, pl});
        }
    }
    sort(qq.begin(), qq.end(), cmp);
    int now_q = 0;
    int prev_sum = 0;
    int cur_sum = 0;
    int prev_k = 0;
    map<int, int> plus;
    int moo = 0;
    for (auto i : cur) {
        ++moo;
        plus[i] = moo;
    }
    cur_sum = 0;
    for (auto i : cur) {
        plus[i] = moo - plus[i];
        cur_sum += plus[i] * cnt[i];
    }
    vector<int> done(q);
    for (auto k : all_d) {
        while (now_q < q && qq[now_q].k < k) {
            query curr = qq[now_q];
            int t = curr.t;
            if (t == 1) {
                ans_q[curr.ind] = cur.size();
            } else if (t == 2) {
                ans_q[curr.ind] = prev_sum + (curr.k - prev_k) * cur_sum;
            } else {
                int x = real[curr.pl];
                ans_q[curr.ind] = x + (curr.k - prev_k) * plus[x];
            }
            done[curr.ind] = 1;
            ++now_q;
        }
        vector<int> new_real(n);
        for (int i = 0; i < n; ++i) {
            int x = real[i];
            new_real[i] = x + (k - prev_k) * plus[x];
        }
        real = new_real;
        prev_sum += (k - prev_k) * cur_sum;
        set<int> new_cur;
        map<int, int> new_cnt;
        for (auto i : cur) {
            new_cur.insert(i + (k - prev_k) * plus[i]);
            new_cnt[i + (k - prev_k) * plus[i]] += cnt[i];
        }
        cur = new_cur;
        cnt = new_cnt;
        plus.clear();
        int moo = 0;
        for (auto i : cur) {
            ++moo;
            plus[i] = moo;
        }
        cur_sum = 0;
        for (auto i : cur) {
            plus[i] = moo - plus[i];
            cur_sum += plus[i] * cnt[i];
        }
        prev_k = k;
    }
    for (int i = 0; i < q; ++i) {
        if (!done[qq[i].ind]) {
            int t = qq[i].t;
            if (t == 1) {
                ans_q[qq[i].ind] = 1;
            } else if (t == 2) {
                ans_q[qq[i].ind] = mx * n - start_sum;
            } else {
                ans_q[qq[i].ind] = mx;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans_q[i] << "\n";
    }
}
