#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define int long long

void task()
{
	string str;
	cin >> str;

	int y;
	cin >> y;

	vector<pair<int, int>> v;

	for (int i = 0; i < str.size(); i++)
	{
		v.push_back({ -str[i] + '0', i });
	}

	sort(v.begin(), v.end());

	for (int i = 0; i < v.size(); i++)
	{
		v[i].first = -v[i].first;
	}

	string ans;

	int p = 0;
	while (v.size() - ans.size() > 16)
	{
		ans.push_back(v[p].first + '0');
		p++;
	}

	vector<int> left;

	while (p != str.size())
	{
		left.push_back(v[p].second);
		p++;
	}

	sort(left.begin(), left.end());
	string e;

	for (int i = 0; i < left.size(); i++)
	{
		e.push_back(str[left[i]]);
	}

	int n = e.size();

	vector<int> twos;

	for (int i = 0; i < n; i++)
	{
		if (e[i] == '2')
		{
			twos.push_back(i);
		}
	}

	long long best = -1;
	string bstr = e;

	for (int i = 0; i <= twos.size(); i++)
	{
		long long sum = 0;

		for (int j = 0; j < i; j++)
		{
			sum += twos[j] - j;
		}

		sum *= y;

		string cur;

		for (int j = 0; j < i; j++)
		{
			cur.push_back('2');
		}

		int p = 0;

		for (int j = 0; j < n; j++)
		{
			if (e[j] == '2')
			{
				p++;

				if (p > i)
				{
					cur.push_back('2');
				}
			}
			else
			{
				cur.push_back('1');
			}
		}

		long long c = 0;

		for (int j = 0; j < cur.size(); j++)
		{
			c *= 10;
			c += cur[j] - '0';
		}

		if (c - sum >= best)
		{
			best = c - sum;
			bstr = cur;
		}
	}

	cout << ans << bstr << endl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	task();

	//cout << 2111111111 - 1111111112 << endl;

	return 0;
}