#include <bits/stdc++.h>


using namespace std;
vector<vector<pair<int, int>>> g;
vector<int> tin, fup;
vector<bool> used, br;
int t = 0;


void dfs(int v, int p){
    used[v] = true;
    tin[v] = fup[v] = t++;
    for(auto u:g[v]){
        if (u.first == p) continue;
        if (used[u.first]) fup[v] = min(fup[v], tin[u.first]);
        else {
            dfs(u.first, v);
            fup[v] = min(fup[v], fup[u.first]);
            if (fup[u.first] > tin[v]){
                br[u.second] = true;
            }
        }
    }
}


void solve(){
    int n, m;
    cin >> n >> m;
    t = 0;
    g.assign(n, {}), used.assign(n, false), tin.assign(n, 0), fup.assign(n, 0), br.assign(m, false);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back({u, i}), g[u].push_back({v, i});
    }
    vector<int> dist(2 * n, 1e9);
    vector<bool> used1(2 * n);
    used1[0] = true;
    dfs(0, -1);
    dist[0] = 0;
    queue<int> q;
    q.push(0);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto u:g[v / 2]){
            if (br[u.second] || used1[2 * u.first + 1 - v % 2]) continue;
            dist[2 * u.first + 1 - v % 2] = dist[v] + 1;
            used1[2 * u.first + 1 - v % 2] = true;
            q.push(2 * u.first + 1 - v % 2);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (!used1[2 * i]) cout << "-1 ";
        else cout << dist[2 * i] << " ";
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t1;
    cin >> t1;
    while(t1--){
        solve();
    }
}
