#include "bits/stdc++.h"
using namespace std;
#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)(a.size())
#define F first
#define S second
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
struct dsu {
    vector<int> p;
    vector<int> d;
    int n = 1;
    void init(int k){
        n = k;
        d.resize(n, 1);
        p.resize(n, -1);
        for(int i = 0;i < n;i++){
            p[i] = i;
        }
    }
    int find(int u){
        if(p[u] == u)return u;
        return p[u] = find(p[u]);
    }
    void unite(int u, int v){
        u = find(u);
        v = find(v);
        if(u == v)return;
        if(d[u] < d[v])swap(u, v);
        d[u] += d[v];
        p[v] = u;
    }
};
void stupid(){
    int n = rng() % 10 + 2;
    vector<int> c(n);
    for(int i = 0;i < n;i++){
        c[i] = rng() % 100;
    }
    vector<int> was = c;
    int K = 1000 + 10;
    vector<vector<int>> f;
    f.push_back(c);
    for(int j = 0;j < K;j++) {
        vector<int> d = c;
        sort(all(d));
        d.erase(unique(all(d)), d.end());
        for (int i = 0; i < sz(c); i++) {
            int pos = upper_bound(all(d), c[i]) - d.begin();
            c[i] += sz(d) - pos;
        }
        f.push_back(c);
    }
    for(int i = 0;i < sz(f);i++){
        cout << "# i = " << i << " : ";
        for(auto v: f[i]){
            cout << v << ' ';
        }
        cout << endl;
        if(f[i] == f[i + 1])break;
    }
}
vector<int> get_delta(vector<int> &x){
    vector<int> d = x;
    sort(all(d));
    d.erase(unique(all(d)), d.end());
    vector<int> delta(sz(x));
    for(int i = 0;i < sz(x);i++){
        int pos = upper_bound(all(d), x[i]) - d.begin();
        delta[i] = sz(d) - pos;
    }
    return delta;
}
void solve(){
    int n, q;
    cin >> n >> q;
    vector<int> c(n);
    for(int i = 0;i < n;i++){
        cin >> c[i];
    }
    vector<pair<int, pii>> dist;
    for(int i = 0;i < n;i++){
        for(int j = i + 1;j < n;j++){
            if(c[i] == c[j])continue;
            dist.push_back({abs(c[i] - c[j]), {i, j}});
        }
    }
    sort(all(dist));
    vector<int> rounds;
    vector<int> sum;
    vector<vector<int>> chel;
    vector<vector<int>> delta;
    chel.push_back(c);
    delta.push_back(get_delta(c));
    rounds.push_back(0);
    sum.push_back(0);
    int last = 0;
    for(int i = 0;i < sz(dist);i++){
        int now = dist[i].F;
        while(i < sz(dist) && dist[i].F == now){
            i++;
        }
        rounds.push_back(now);
        int btw = now - last;
        int cur = 0;
        for(int j = 0;j < sz(c);j++){
            c[j] += delta.back()[j] * btw;
            cur += delta.back()[j] * btw;
        }
        chel.push_back(c);
        delta.push_back(get_delta(c));
        last = now;
        sum.push_back(sum.back() + cur);
    }
    while (q--){
        int test;
        cin >> test;
        if(test == 1){
            int k;
            cin >> k;
            map<int, int> mp;
            int pos = upper_bound(all(rounds), k) - rounds.begin();
            pos--;
            for(int j = 0;j < sz(chel[pos]);j++){
                mp[chel[pos][j]]++;
            }
            cout << sz(mp) << '\n';
        } else if(test == 2){
            int k;
            cin >> k;
            int pos = upper_bound(all(rounds), k) - rounds.begin();
            pos--;
            int ans = 0;
            ans += sum[pos];
            int for_round = 0;
            for(int j = 0;j < sz(delta[pos]);j++){
                for_round += delta[pos][j];
            }
            ans += for_round * (k - rounds[pos]);
            cout << ans << '\n';
        } else {
            int k, i;
            cin >> k >> i;i--;
            int pos = upper_bound(all(rounds), k) - rounds.begin();
            pos--;
            int ans = chel[pos][i];
            int for_round = delta[pos][i];
            ans += for_round * (k - rounds[pos]);
            cout << ans << '\n';
        }
    }
}
signed main() {
    solve();
    return 0;
    int t = 10;
    while (t--){
        stupid();
    }
    return 0;
    int n, q;
    cin >> n >> q;

    return 0;
}
/*
314599
17713

931459

931549
 */