#include <bits/stdc++.h>
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector<ll> a(n);
        for (auto& x : a) cin >> x;
        vector<int> L(m), R(m), c(m), t(m);
        for (int i = 0; i < m; ++i) {
            cin >> L[i] >> R[i] >> c[i] >> t[i];
            --L[i], --R[i];
        }
        for (int x = 0; x < n; ++x) {
            vector<int> l = L, r = R;
            for (int i = 0; i < m; ++i) {
                if (t[i] == 1) {
                    l[i] = min(l[i], x);
                    r[i] = max(r[i], x);
                }
            }
            vector<tuple<int, int, ll>> v(m);
            for (int i = 0; i < m; ++i) {
                v[i] = {l[i], r[i], c[i]};
            }
            sort(all(v), [&](auto l, auto r) {
                return get<1>(l) - get<0>(l) < get<1>(r) - get<0>(r);
            });
            auto b = a;
            for (auto [le, ri, co] : v) {
                //for (auto x : b) cout << x << ' ';
                //cout << endl;
                //cout << le + 1 << ' ' << ri + 1 << ' ' << co << endl;
                for (int i = le; i <= ri; ++i) {
                    ll div = min(b[i], co);
                    b[i] -= div;
                    co -= div;
                }
                //for (auto x : b) cout << x << ' ';
                //cout << endl;
            }
            cout << accumulate(all(a), 0ll) - accumulate(all(b), 0ll) << ' ';
        }
    }
    return 0;
}