#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define mp(x, y) make_pair(x, y)
#define mt make_tuple
#define sz(x) (int) size(x)

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 98244353;
const int N = (5000) + 2;

vector<pii > g[N];
vector<int> gr[N];

int n, m;

int tin[N], tout[N], fup[N], T = 0, dist[N];
bool used[N];

void cl() {
    T = 0;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        gr[i].clear();
        used[i] = false;
    }
}


void dfs(int v, int i) {
    used[v] = true;
    tin[v] = fup[v] = T++;
    for (auto[to, j]: g[v]) {
        if (j == i) continue;
        if (!used[to]) {
            dfs(to, j);
            ckmn(fup[v], fup[to]);
        } else {
            ckmn(fup[v], tin[to]);
        }
    }
    tout[v] = T++;
}

void bfs() {
    fill(dist, dist + n, infI);
    dist[0] = 0;
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to: gr[v]) {
            if (dist[to] == infI) {
                dist[to] = dist[v] + 2;
                q.push(to);
            }
        }
    }
}

void yay(int v, int i) {
    used[v] = true;
    vector<int> ggg;
    for (auto[to, j]: g[v]) {
        if (j == i) continue;
        if (!used[to]) {
            yay(to, j);
        }
//        if (to == 1) {
//            cout << "OK" << endl;
//        }
        if (tin[v] <= tin[to] && tout[to] <= tout[v]) {
            ggg.push_back(to);
            for (auto[gg, wp]: g[to]) {
                if (tin[to] <= tin[gg] && tout[gg] <= tout[to]) {
                    if (fup[gg] < tin[to]) {
                        gr[v].push_back(gg);
                        gr[gg].push_back(v);
                    }
                } else {
                    gr[v].push_back(gg);
                    gr[gg].push_back(v);
                }
            }
        }
    }
    for (int a : ggg) {
        for (int b : ggg) {
            if (fup[b] < tin[v] && fup[a] < tin[v]) {
                gr[a].push_back(b);
                gr[b].push_back(a);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    cl();
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
    }
    dfs(0, -1);
    fill(used, used + n, false);
    yay(0, -1);
    bfs();
    for (int i = 1; i < n; ++i) {
        cout << (dist[i] == infI ? -1 : dist[i]) << ' ';
    }
    cout << '\n';
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    while (test--)
        solve();
    return 0;
}