#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 
#include <deque>


using namespace std;
typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n & 1)
		return a * bin_pow(a, n - 1);
	ll b = bin_pow(a, n / 2);
	return b * b;
}

ll to_ll(string s) {
	ll ans = 0;
	for (int i = 0; i < s.size(); i++) {
		ans *= 10;
		ans += s[i] - '0';
	}
	return ans;
}
string change(string s, int i, int j) {
	for (j; j - 1 >= i; j--)
		swap(s[j], s[j - 1]);
	return s;
}

void solve(string& s) {
	string fre;
	ll y;
	fre = s;
	cin >> y;
	ll ans = -1;
	string res = "0";
	do {
		string c = fre;
		ll win = to_ll(s);
		for (int i = 0; i < s.size(); i++) {
			if (c[i] == s[i])
				continue;
			int j = i + 1;
			while (c[j] != s[i])
				j++;
			for (j; j - 1 >= i; j--) {
				win -= y;
				swap(c[j], c[j - 1]);
			}
		}
		if (win > ans || (win == ans && s > res)) {
			ans = win;
			res = s;
		}
	} while (next_permutation(s.begin(), s.end()));
	cout << res;
}
void solve1(string s) {
	ll y;
	cin >> y;
	sort(s.rbegin(), s.rend());
	cout << s;
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		string s;
		cin >> s;
		if (s.size() <= 9)
			solve(s);
		else
			solve1(s);
	}
	return 0;
}