#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <array>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <sstream>
#include <cassert>
#include <random>
#include <chrono>
#include <numeric>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

//#define int __int128

using namespace std;

#ifdef LOCAL
#define __int128 long long
#endif

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	string s;
	cin >> s;
	int n = s.size();
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		a[i] = s[i] - '0';
	}
	int y;
	cin >> y;
	vector<int> parent(1 << n);
	vector<__int128> power(n + 1);
	power[0] = 1;
	for (int i = 1; i <= n; ++i) {
		power[i] = power[i - 1] * 10;
	}
	vector<__int128> dp(1 << n);
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<int> index;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				index.push_back(i);
			}
		}
		int len = index.size();
		for (int i = 0; i < len; ++i) {
			__int128 old_val = 0;
			for (int j = 0; j <= i; ++j) {
				old_val = old_val * 10 + a[index[j]];
			}
			__int128 new_val = a[index[i]];
			for (int j = 0; j < i; ++j) {
				new_val = new_val * 10 + a[index[j]];
			}
			__int128 dp_val = dp[mask ^ (1 << index[i])]
				+ (new_val - old_val) * power[len - i - 1]
				- 1ll * i * y;
			if (dp_val >= dp[mask]) {
				dp[mask] = dp_val;
				parent[mask] = index[i];
			}
		}
	}
	int mask = (1 << n) - 1;
	while (mask) {
		cout << a[parent[mask]];
		mask ^= 1 << parent[mask];
	}
}