#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> graph(n);
		vector<set<int>> gr(n);
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			graph[a].push_back(b);
			graph[b].push_back(a);
			gr[a].insert(b);
			gr[b].insert(a);
		}
		for (int e = 1; e < n; e++) {
			vector<map<int, int>> dist(n);
			dist[0][0] = 0;
			set<pair<int, pair<int, int>>> ss;
			ss.insert({ 0, {0, 0} });
			while (!ss.empty()) {
				int i = ss.begin()->second.first, j = ss.begin()->second.second;
				// cout << '!' << i << ' ' << j << ' ' << dist[i][j] << '\n';
				ss.erase(ss.begin());
				if (i == j) {
					for (auto to : graph[i]) {
						if (dist[i].find(to) == dist[i].end() || dist[i][to] > dist[i][j] + 1) {
							if (dist[i].find(to) != dist[i].end()) {
								ss.erase({ dist[i][to], {i, to} });
							}
							dist[i][to] = dist[i][j] + 1;

							ss.insert({ dist[i][to], {i, to} });
						}
					}
				}
				if (gr[i].find(j) != gr[i].end()) {
					if (dist[i].find(i) == dist[i].end() || dist[i][i] > dist[i][j] + 1) {
						if (dist[i].find(i) != dist[i].end()) {
							ss.erase({ dist[i][i], {i, i} });
						}
						dist[i][i] = dist[i][j] + 1;

						ss.insert({ dist[i][i], {i, i} });
					}
				}
				if (i != j) {
					for (auto to : graph[i]) {
						if (to != j && (dist[to].find(j) == dist[to].end() || dist[to][j] > dist[i][j])) {
							if (dist[to].find(j) != dist[to].end()) {
								ss.erase({ dist[to][j], {to, j} });
							}
							dist[to][j] = dist[i][j];

							ss.insert({ dist[to][j], {to, j} });
						}
					}
				}
			}
			if (dist[e].find(e) != dist[e].end()) {
				cout << dist[e][e] << ' ';
			}
			else {
				cout << -1 << ' ';
			}
		}
		cout << '\n';
	}
	return 0;
}