#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9 + 42;

int main() {
    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    vector<pair<ll, int>> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = {a[i], i};
    }
    sort(b.begin(), b.end());

    vector<pair<ll, int>> ev;
    int d = 1;
    for (int i = n - 1; i > 0; --i)
        if (b[i].first > b[i - 1].first)
            ev.push_back({b[i].first - b[i - 1].first, d}), ++d;
    sort(ev.begin(), ev.end());
    /*
    for (auto i : ev)
        cout << i.first << " " << i.second << endl;
    */
    vector<int> pl_sp(n);
    pl_sp[b[0].second] = d - 1;
    for (int i = 1; i < n; ++i)
        pl_sp[b[i].second] = pl_sp[b[i - 1].second] - (b[i].first > b[i - 1].first);

    vector<int> sc(d);
    int it = d - 1;
    for (int i = 0; i < n; ++i) {
        if (i == 0 || b[i].first == b[i - 1].first)
            ++sc[it];
        else
            ++sc[--it];
    }

    vector<ll> pr(d + 1);
    for (int i = 1; i <= d; ++i)
        pr[i] = pr[i - 1] + sc[i - 1];
    /*
    for (auto i : pr)
        cout << i << " ";
    cout << endl;
    */
    vector<ll> sp(d);
    for (int i = 0; i < d; ++i)
        sp[0] += i * sc[i];
    for (int i = 1; i < d; ++i)
        sp[i] = sp[i - 1] - (n - pr[ev[i - 1].second]);
    /*
    for (auto i : sp)
        cout << i << " ";
    cout << endl;
    */
    vector<ll> sum(d);
    ll cur = 0;
    for (int i = 1; i < d; ++i)
        sum[i] = sum[i - 1] + (ev[i - 1].first - cur) * sp[i - 1], cur = ev[i - 1].first;
    /*
    for (auto i : sum)
        cout << i << " ";
    cout << endl;
    */
    while (q--) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            int it = upper_bound(ev.begin(), ev.end(), make_pair(k, INF)) - ev.begin();
            cout << d - it << "\n";
        }
        if (t == 2) {
            int it = upper_bound(ev.begin(), ev.end(), make_pair(k, INF)) - ev.begin();
            ll ans = sum[it];
            ll last = it == 0 ? 0 : ev[it - 1].first;
            ans += (k - last) * sp[it];
            cout << ans << "\n";
        }
        if (t == 3) {
            int i;
            cin >> i, --i;
            ll ans = a[i];
            i = pl_sp[i];
            int last = 0;
            for (auto e : ev) {
                ans += (min(e.first, k) - last) * i;
                last = min(e.first, k);
                if (last == k)
                    break;
                if (e.second <= i)
                    --i;
            }
            cout << ans << endl;
        }
    }
}
