#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <ctime>
#include <cmath>
#include <cassert>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = int64_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using int128 = __int128_t;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct Robot {
    int id;
    int l, r;
    ll c;
    int t;

    Robot() {}

    Robot(int id, int l, int r, ll c, int t) : id(id), l(l), r(r), c(c), t(t) {}
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n + 1), pref(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    vector<Robot> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
    }
    if (b[0].t == 0) {
        ll ans = min(pref[b[0].r] - pref[b[0].l - 1], b[0].c);
        for (int i = 0; i < n; ++i) {
            cout << ans << ' ';
        }
    }
    else {
        for (int i = 1; i <= n; ++i) {
            int l = min(b[0].l, i), r = max(b[0].r, i);
            ll ans = min(pref[r] - pref[l - 1], b[0].c);
            cout << ans << ' ';
        }
    }
    cout << en;
}

int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("d.txt", "r", stdin);
    T = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
