#include <bits/stdc++.h>

using namespace std;
const int maxn = 5e5;
vector <int> gr[maxn];
vector <int> ans_odd(maxn);
vector <int> ans_even(maxn);
deque <pair <int, int> > dek;

void bfs(){
    pair <int, int> t = dek[0];
    dek.pop_front();
    int u = t.first, fl = t.second;
    for (auto v : gr[u]){
        if (fl == 0 && ans_odd[v] == -1){
            ans_odd[v] = ans_even[u]+1;
            dek.push_back(make_pair(v,1));
        }
        if (fl == 1 && ans_even[v] == -1){
            ans_even[v] = ans_odd[u]+1;
            dek.push_back(make_pair(v,0));
        }
    }
    if ((int) dek.size() > 0){
        bfs();
    }
}

int main()
{
    int t;
    cin >> t;
    for (int id = 0; id < t;++id){
        int n,m;
        cin >> n >> m;
        for (int i = 0; i < n;++i){
            gr[i] = {};
            ans_odd[i] = -1;
            ans_even[i] = -1;
        }
        for (int i = 0; i < m;++i){
            int u,v;
            cin >> u >> v;
            u--;
            v--;
            gr[u].push_back(v);
            gr[v].push_back(u);
        }
        ans_even[0] = 0;
        dek.push_back(make_pair(0,0));
        bfs();
        for (int i = 1; i < n;++i){
            cout << ans_even[i] << " ";
        }
        cout << endl;
    }
    return 0;
}
