#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

#define int long long

//-------------------------------------------------

const int MAXN = 3e5 + 10;

ll c[MAXN], b[MAXN];

vector<ll> Union;

vector<pair<pair<ll, int>, int>> qs2;
vector<pair<pair<ll, int>, pt>> qs3;

ll ans[MAXN];

void calc1(int cnt, int id){
    ll k;
    cin >> k;
    if (k < Union[0]){
        ans[id] = cnt;
        return;
    }
    int l = 0, r = sz(Union);
    while (r - l > 1){
        int m = (l + r) >> 1;
        if (Union[m] <= k)
            l = m;
        else
            r = m;
    }
    ans[id] = cnt - l - 1;
}

struct Node2{
    ll sum;
    ll rt;
    ll inc;
};
ll a[MAXN];
Node2 tree2[MAXN << 2];

void push2(int v, int ln){
    ll inc = tree2[v].inc;
    tree2[v << 1].sum += inc * (ln / 2);
    tree2[v << 1 | 1].sum += inc * ((ln + 1) / 2);
    tree2[v << 1].rt += inc, tree2[v << 1 | 1].rt += inc;
    tree2[v << 1].inc += inc, tree2[v << 1 | 1].inc += inc;
    tree2[v].inc = 0;
}


void build2(int v, int l, int r){
    if (r - l == 1){
        tree2[v] = {a[l - 1], a[l - 1], 0};
        return;
    }
    int m = (l + r) >> 1;
    build2(v << 1, l, m);
    build2(v << 1 | 1, m, r);
    tree2[v] = {tree2[v << 1].sum + tree2[v << 1 | 1].sum, tree2[v << 1 | 1].rt, 0};
}

void updPref2(int v, int l, int r, int ql, int qr, ll inc){
    if (r <= ql || qr <= l)
        return;
    if (ql <= l && r <= qr){
        tree2[v].sum += inc * (r - l);
        tree2[v].inc += inc;
        return;
    }
    int m = (l + r) >> 1;
    push2(v, r - l);
    updPref2(v << 1, l, m, ql, qr, inc);
    updPref2(v << 1 | 1, m, r, ql, qr, inc);
    tree2[v] = {tree2[v << 1].sum + tree2[v << 1 | 1].sum, tree2[v << 1 | 1].rt, 0};
}


int n;

void Union2(int i){
    updPref2(1, 1, n + 1, 1, i + 1, -1);
}

ll getSum2(){
    return tree2[1].sum;
}

int inds[MAXN];
int revind[MAXN];

void run(){
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; i++){
        cin >> c[i];
        b[i] = c[i];
    }
    iota(inds, inds + n, 0);
    sort(inds, inds + n, [&](int i, int j){return b[i] < b[j];});
    for (int i = 0; i < n; i++)
        revind[inds[i]] = i;
    sort(b, b + n);
    int cnt = 1;
    for (int i = 1; i < n; i++){
        if (b[i] != b[i - 1])
            cnt++;
    }
    for (int i = 1; i < n; i++){
        if (b[i] != b[i - 1]){
            Union.push_back(b[i] - b[i - 1]);
            qs2.push_back({{b[i] - b[i - 1], 0}, i});
        }
    }
    sort(all(Union));
    for (int i = 0; i < q; i++){
        int t;
        cin >> t;
        if (t == 1){
            calc1(cnt, i);
        } else if (t == 2){
            ll k;
            cin >> k;
            qs2.push_back({{k, 2}, i});
        } else {
            ll k, j;
            cin >> k >> j;
            j--;
            j = revind[j];
            qs3.push_back({{k, 3}, {i, j}});
        }
    }
    qs2.push_back({{0, -1}, 0});
    qs3.push_back({{0, -1}, {0, -1}});
    sort(all(qs2));
    sort(all(qs3));
    ll s = 0;
    for (int i = n - 2; i >= 0; i--){
        a[i] = a[i + 1];
        if (b[i] != b[i + 1])
            a[i]++;
    }
    build2(1, 1, n + 1);
    for (int i = n - 2; i >= 0; i--)
        a[i] = (b[i + 1] - b[i]);
    for (int i = 1; i < sz(qs2); i++){
        auto x = qs2[i];
        s += (qs2[i].x.x - qs2[i - 1].x.x) * getSum2();
        //cout << x.x.x << " " << x.x.y << " " << x.y << " " << s << endl;
        if (qs2[i].x.y == 0)
            Union2(qs2[i].y);
        else {
            ans[qs2[i].y] = s;
        }
    }
    for (int i = 1; i < sz(qs3); i++) {
        for (int j = 0; j < n; j++){
            a[j] -= (qs3[i].x.x - qs3[i - 1].x.x);
            a[j] = max(a[j], 0ll);
        }
        int j = qs3[i].y.y;
        if (j < 0 || j < 3e5 || qs3[i].y.x < 0 || qs3[i].y.x > 3e5){
            cout << 0;
            return;
        }
        ll sm = 0;
        for (int kk = j; kk < n; kk++)
            sm += a[kk];
        ans[qs3[i].y.x] = b[n - 1] - sm;
    }
    for (int i = 0; i < q; i++)
        cout << ans[i] << "\n";
    cout << endl;
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
    cerr << (stop - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
}