#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define int long long

using namespace std;


const int inf = 1e18;


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t;
    cin >> t;

    while (t --) {
        int n, m;
        cin >> n >> m;

        vector<pair<int, int>> edges(m);

        for (int i = 0; i < m; i++) {
            cin >> edges[i].first >> edges[i].second;
            edges[i].first--, edges[i].second--;
            edges.push_back({edges[i].second, edges[i].first});
        }


        vector<int> odd(n, inf), even(n, inf);

        even[0] = 0;

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 2 * m; j++) {
                int a = edges[j].first, b = edges[j].second;
                if (odd[a] < inf && odd[a] + 1 < even[b]) {
                    even[b] = odd[a] + 1;
                }
                if (even[a] < inf && even[a] + 1 < odd[b]) {
                    odd[b] = even[a] + 1;
                }
            }
        }

        for (int i = 1; i < n; i ++){
            if (even[i] == inf){
                cout << -1 << " ";
                continue;
            }
            cout << even[i] << " ";
        }
        cout << endl;
    }
}