#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

bool comp(char a, char b) {
	return a < b;
}

const int C = 23;

long long mysub(string a, string b) {
	int n = (int)a.size();
	long long res = 0;
	long long tpow = 1;
	for (int i = n - 1; i >= 0; i--) {
		if (a[i] < b[i]) {
			int id = i - 1;
			while (a[id] == '0') {
				a[id] = '9';
				id--;
			}
			a[id] = (char)((int)a[id] - 1);
			res += (a[i] - b[i] + 10) * tpow;
		}
		else {
			res += (a[i] - b[i]) * tpow;
		}
		tpow *= 10;
	}
	return res;
}

bool b(string a, string b) {
	int id = 0;
	while (id < a.size() && a[id] == b[id])
		id++;
	if (id == a.size())
		return false;
	return a[id] > b[id];
}

pair < string, long long> f(string s, long long y) {
	int n = (int)s.size();
	if (n <= 1)
		return { s, 0 };
	long long prof = 0;
	int id = 0;
	string ans = s;
	for (int i = 1; i < n; i++) {
		if (s[i] < s[0])
			continue;
		long long res = -i * (long long)y;
		string temp = s;
		temp.erase(temp.begin() + i);
		temp.insert(temp.begin(), s[i]);
		res += mysub(temp, s);
		string wha = "";
		wha += temp[0];
		temp.erase(temp.begin());
		res += f(temp, y).second;
		wha += f(temp, y).first;
		if (res > prof || (res == prof && b(wha, ans))) {
			prof = res;
			ans = wha;
		}
	}
	return { ans, prof };
}

void solve() {
	string x;
	cin >> x;
	long long y;
	cin >> y;
	vector <char> temp;
	for (auto e : x)
		temp.push_back(e);
	sort(temp.begin(), temp.end(), comp);
	string ans = "";
	for (int i = C; i < temp.size(); i++)
		ans += temp[i];
	string rest = "";
	vector <int> cnt(10, 0);
	for (int i = 0; i < min(C, (int)temp.size()); i++)
		cnt[temp[i] - '0']++;
	for (int i = x.size() - 1; i >= 0; i--) {
		if (cnt[x[i] - '0']) {
			rest.push_back(x[i]);
			cnt[x[i] - '0']--;
		}
	}
	reverse(rest.begin(), rest.end());
	ans += f(rest, y).first;
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}