#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Quer {
    int t, ind, k, i;

    Quer(int a = 0, int b = 0, int c = 0, int d = 0) {
        t = a;
        ind = b;
        k = c;
        i = d;
    }
};

const int N = 300005;

int pred[N];


int vec6[N];

int get_pr(int u) {
    if (pred[u] == u) return u;
    return pred[u] = get_pr(pred[u]);
}

int cnt_comp = 0;

void unite(int u, int v) {
    u = get_pr(u);
    v = get_pr(v);
    if (u == v) return;
    cnt_comp++;
    pred[v] = u;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i < N; ++i) {
        pred[i] = i;
    }
    int n, q;
    cin >> n >> q;
    vector<int> vec(n), vec5;
    for (int i = 0; i < n; ++i)cin >> vec[i];
    vec5 = vec;
    sort(vec.begin(), vec.end());
    vector<int> vec2;
    for (int i = 1; i < vec.size(); ++i) {
        vec2.push_back(vec[i] - vec[i - 1]);
    }
    sort(vec2.begin(), vec2.end());
    vector<Quer> quer;

    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            quer.push_back({t, i, k, 0});
        } else if (t == 2) {
            int k;
            cin >> k;
            quer.push_back({t, i, k, 0});
        } else {
            int ind, k;
            cin >> k >> ind;
            quer.push_back({t, i, k, ind});
        }
    }
    for (int i = 1; i < n; ++i) {
        quer.push_back({0, -1, vec[i] - vec[i - 1], i});
    }

    sort(quer.begin(), quer.end(), [&](Quer a, Quer b) {
        return a.k < b.k or (a.k == b.k and a.ind < b.ind);
    });
    long long summ = 0;
    int last = 0;
    vector<int> ans(q);
    for (auto c: quer) {
//        cout << c.t << " " << c.k << " " << c.i << " " << summ << endl;
        if (c.t == 0) {
            int razn = (c.k - last);
            int l1 = vec.back();
            int cnt = 0;
            for (int i = n - 1; i >= 0; --i) {
                int u1 = get_pr(i);
                if (vec[u1] == l1) {
                    summ += razn * cnt;
                    vec6[i] += razn * cnt;
                } else {
                    cnt++;
                    summ += razn * cnt;
                    l1 = vec[u1];
                    vec6[i] += razn * cnt;
                }
            }
            last = c.k;
            unite(c.i, c.i - 1);
//            cout << c.i - 1 << " - " << c.i << endl;
//            cout << cnt_comp << endl;
        } else if (c.t == 1) {
            ans[c.ind] = n - cnt_comp;
        } else if (c.t == 2) {
            int razn = (c.k - last);
            int l1 = vec.back();
            int cnt = 0;
            for (int i = n - 1; i >= 0; --i) {
                int u1 = get_pr(i);
                if (vec[u1] == l1) {
                    summ += razn * cnt;
                    vec6[i] += razn * cnt;
                } else {
                    cnt++;
                    summ += razn * cnt;
                    l1 = vec[u1];
                    vec6[i] += razn * cnt;
                }
            }
            last = c.k;
            ans[c.ind] = summ;
        } else {
            int razn = (c.k - last);
            int l1 = vec.back();
            int cnt = 0;
            for (int i = n - 1; i >= 0; --i) {
                int u1 = get_pr(i);
                if (vec[u1] == l1) {
                    summ += razn * cnt;
                    vec6[i] += razn * cnt;
                } else {
                    cnt++;
                    summ += razn * cnt;
                    l1 = vec[u1];
                    vec6[i] += razn * cnt;
                }
            }
            last = c.k;



            int el = lower_bound(vec.begin(), vec.end(), vec5[c.i - 1]) - vec.begin();

            el = get_pr(el);
//            cout << el << endl;

            ans[c.ind] = vec6[el]+ vec[el];
        }
    }
    for (auto c: ans) cout << c << "\n";
    return 0;
}