#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define pb push_back
#define all(x) (x).begin(), (x).end()
const int maxN = 5e5 + 9;
const int inf = 1e9 + 9;
vector<pii> g[maxN];
int d[maxN][2];

void clear(int n, int m) {
    for(int i = 0; i <= n; ++i) {
        g[i].clear();
        d[i][0] = d[i][1] = inf;
    }
}

struct edge {
    int u, v, i;
};

void solve() {
    int n, m; cin >> n >> m;
    clear(n, m);
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        g[u].pb({v, 2 * i});
        g[v].pb({u, 2 * i + 1});
    }


    queue<pii> q;
    d[1][0] = 0;
    q.push({1, 0});

    while(!q.empty()) {
        auto f = q.front(); q.pop();
        for(auto &i: g[f.first]) {
            if(d[i.first][f.second ^ 1] == inf) {
                d[i.first][f.second ^ 1] = d[f.first][f.second] + 1;
                q.push({i.first, f.second ^ 1});
            }
        }
    }
    for(int i = 2; i <= n; ++i) {
        if(d[i][0] == inf) {
            cout << -1 << ' ';
        }
        else cout << d[i][0] << ' ';
    }
    cout << '\n';
}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*
4
4 4
1 2
2 3
3 4
4 1

5 5
1 2
2 3
3 4
4 5
5 1

5 6
1 2
3 2
1 3
3 5
5 4
3 5

9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3

 */