#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

template<class A>
void print(A x) {
	cerr << x;
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

void solve() {
	int n, q;
	cin >> n >> q;

	vector<pair<int, int>> c(n);
	vector<int> d(n - 1);

	for (int i = 0; i < n; ++i) {
		cin >> c[i].first;
		c[i].second = i;
	}
	sort(c.begin(), c.end());

	for (int i = 0; i < n - 1; ++i) {
		d[i] = c[i + 1].first - c[i].first;
	}

	sort(d.rbegin(), d.rend());

	vector<pair<int, int>> q1;
	vector<pair<int, int>> q2;
	vector<tuple<int, int, int>> q3;

	for (int i = 0; i < q; ++i) {
		int t, k, j;
		cin >> t;
		if (t == 1) {
			cin >> k;
			q1.emplace_back(k, i);
		} else if (t == 2) {
			cin >> k;
			q2.emplace_back(k, i);
		} else {
			cin >> j >> k;
			q3.emplace_back(k, j - 1, i);
		}
	}

	sort(q1.begin(), q1.end());
	vector<int> ans(q);
	for (auto [k, i] : q1) {
		while (!d.empty() && d.back() <= k) d.pop_back();
		ans[i] = sz(d) + 1;
	}







	for (int i = 0; i < q; ++i) {
		cout << ans[i] << '\n';
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test# " << t << "_____\n";
		solve();
	}
}
