#include <bits/stdc++.h>
using namespace std;

#define int long long
#pragma comment(linker, "/stack:20000000")

string s;
vector <int> x;
int xn, y;

int dec(int x) {
    int res = 1;
    for (int i = 0; i<x; ++i) res *= 10;
    return res;
}

int scorebest = 0;
int xbest = 0;

void process(vector <int> &pref) {
    vector <int> p2 = pref;
    string s2 = s;
    int n = x.size();
    int cnt = 0;
    for (int i = 0; i<n-1; ++i) {
        for (int j = i+1; j<n; ++j) {
            if (p2[i] > p2[j]) cnt++;
        }
    }

    for (int R = n-1; R>=1; --R) {
        for (int i = 0; i<R; ++i) {
            if (p2[i] > p2[i+1]) {
                swap(p2[i], p2[i+1]);
                swap(s2[i], s2[i+1]);
            }
        }
    }
    int res = stoi(s2);
    int score = res - y*cnt;
    if (score > scorebest || (score == scorebest && res > xbest)) {
        scorebest = score;
        xbest = res;
    }
    return;
}

void gen(int n, int cur, vector <bool> &used, vector <int> &pref) {
    if (cur == n) process(pref);
    for (int i = 0; i<n; ++i) {
        if (used[i]) continue;
        used[i] = 1;
        pref.push_back(i);
        cur++;
        bool stop = 0;
        if (cur >= 2 && pref[cur-2] > pref[cur-1] && x[cur-2] >= x[cur-1]) {
            pref.pop_back();
            used[i] = 0;
            stop = 1;
            cur--;
            continue;
        }
        if (!stop) gen(n, cur, used, pref);
        pref.pop_back();
        used[i] = 0;
        cur--;
    }
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> s;
    int n = s.size();
    x.resize(n);
    for (int i = 0; i<n; ++i) x[i] = (s[i] - '0');

    vector <int> cnt(10, 0);
    for (int i = 0; i<n; ++i) cnt[x[i]]++;

    cin >> y;

    if (y == 1) {
        sort(x.rbegin(), x.rend());
        for (auto el: x) cout << el;
        cout << endl;
        return 0;
    }

    xbest = stoi(s);
    scorebest = 0;
    vector <bool> used(n, 0);
    vector <int> pref;
    gen(n, 0, used, pref);
    int ans = xbest;
    string res = "";
    for (int i = 0; i<n; ++i) res += ' ';
    for (int i = n-1; i>=0; --i) {
        res[i] = ('0' + ans%10);
        ans /= 10;
    }
    for (auto el: res) cout << el;
    cout << endl;
    return 0;
}
