#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define int long long
signed main() {
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	vector <int> bigger_than(n);
	int different = 0;
	int sum_of_bigger = 0;
	for (int i = 1; i < n; i++) {
		if (a[i] != a[i - 1]) {
			bigger_than[i] = i;
		}
		else {
			bigger_than[i] = bigger_than[i - 1];
		}
		sum_of_bigger += bigger_than[i];
	}
	vector <int> substr(n - 1);
	for (int i = 0; i < n - 1; i++) {
		substr[i] = a[i + 1] - a[i];
	}
	sort(substr.begin(), substr.end());
	vector <pair<int, int>> substr_index(n - 1);
	for (int i = 0; i < n - 1; i++) {
		substr_index[i].first = a[i + 1] - a[i];
		
		if (a[i] == a[i + 1]) {
			if (i == 0) {
				substr_index[i].second = 0;
			}
			else {
				substr_index[i].second = substr_index[i - 1].second;
			}
		}
		else {
			substr_index[i].second = i + 1;
		}
	}
	sort(substr_index.begin(), substr_index.end());
	vector <int> dead_index_sum(n);
	for (int i = 1; i < n; i++) {
		dead_index_sum[i] = dead_index_sum[i - 1] + substr_index[i - 1].second;
	}
	vector <int> sum_dead_turns(n);
	for (int i = 1; i < n; i++) {
		sum_dead_turns[i] = sum_dead_turns[i - 1] + substr[i - 1] * substr_index[i - 1].second;
	}
	for (int w = 0; w < q; w++) {
		int t, k;
		cin >> t >> k;
		int l = -1, r = n - 1;
		while (r - l > 1) {
			int m = (r + l) / 2;
			if (substr[m] <= k) {
				l = m;
			}
			else {
				r = m;
			}
		}
		if (t == 1) {
			cout << n - 1 - l << endl;
		}
		else if (t == 2) {
			cout << sum_of_bigger * k - (dead_index_sum[l + 1] * k - sum_dead_turns[l + 1]) << endl;
		}
	}
}