﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
#define int long long
signed main() {
	int t;
	cin >> t;
	for (int _ = 0; _ < t; _++) {
		int n, m;
		cin >> n >> m;
		vector <vector<int>> gr;
		gr.clear();
		gr.resize(n);
		for (int i = 0; i < m; i++) {
			int u, w;
			cin >> u >> w;
			u--; w--;
			gr[u].push_back(w);
			gr[w].push_back(u);
		}
		vector <int> dist(n, 10000000);
		dist[0] = 0;
		queue<int> q;
		q.push(0);
		while (!q.empty()) {
			int u = q.front();
			q.pop();
			for (int i = 0; i < gr[u].size(); i++) {
				if (dist[gr[u][i]] == 10000000) {
					dist[gr[u][i]] = dist[u] + 1;
					q.push(gr[u][i]);
				}
			}
		}
		for (int i = 0; i < n - 1; i++) {
			cout << dist[i + 1] << " ";
		}
		cout << endl;
	}
}