#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> g(n);
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			g[--u].push_back(--v);
			g[v].push_back(u);
		}
		vector<vector<int>> g1(n);
		for (int i = 0; i < n; ++i) {
			for (auto u : g[i]) {
				for (auto v : g[u]) {
					if (i != v) {
						g1[i].push_back(v);
						g1[v].push_back(i);
					}
				}
			}
		}
		vector<int> d(n, -1);
		d[0] = 0;
		vector<int> q = { 0 };
		for (int i = 0; i < q.size(); ++i) {
			int v = q[i];
			for (auto to : g1[v]) {
				if (d[to] == -1) d[to] = d[v] + 2, q.push_back(to);
			}
		}
		for (int i = 1; i < n; ++i) cout << d[i] << " ";
		cout << "\n";
	}
}