#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = uint32_t;
using int64 = int64_t;
using uint64 = uint64_t;

int64 fpow(int64 a, int64 n) {
	if (n == 0) return 1;

	int64 b = fpow(a, n / 2);
	b *= b;
	if (n % 2 == 1) b *= a;

	return b;
}

int32_t main() {
	string s; cin >> s;
	string y; cin >> y;
	if (y.size() > s.size()) {
		cout << s;
		return 0;
	}

	int64 ny = stoll(y);
	int n = s.size();

	for (int i = 0; i < n; ++i) {
		int j = i;
		for (int k = i; k < n; ++k) {
			if (s[k] >= s[j]) j = k;
		}

		if (j != i) {
			int64 d = (s[j] - '0') * (fpow(10, n - i - 1) - fpow(10, n - j - 1));
			d -= stoll(s.substr(i, j - i)) * fpow(10, n - j - 1) * 9;

			if (d >= ny * (j - i)) {
				for (int k = j; k > i; --k) swap(s[k], s[k - 1]);
			}
		}
		
	}

	cout << s;
}