#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el;
    return out;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    vector <int> uniq;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        uniq.push_back(a[i]);
    }
    sort(uniq.begin(), uniq.end());
    uniq.resize(unique(uniq.begin(), uniq.end()) - uniq.begin());

    vector <int> cnt(n);
    for (int i = 0; i < n; i++) {
        cnt[lower_bound(uniq.begin(), uniq.end(), a[i]) - uniq.begin()]++;
    }

    while (q--) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            int x = 0;
            for (int i = uniq.size() - 2; i >= 0; i--) {
                if (uniq[i + 1] - uniq[i] <= k) x++;
            }
            cout << uniq.size() - x << endl;
        } else if (t == 2) {
            int ans = 0;
            for (int i = uniq.size() - 2, sum = 0; i >= 0; i--) {
                sum += min(k, uniq[i + 1] - uniq[i]);
                ans += sum * cnt[i];
            }
            cout << ans << endl;
        } else {
            int ind;
            cin >> ind;
            ind--;
            if (uniq.back() == a[ind]) {
                cout << uniq.back() << endl;
                continue;
            }

            for (int i = uniq.size() - 2, sum = 0; i >= 0; i--) {
                sum += min(k, uniq[i + 1] - uniq[i]);
                if (uniq[i] == a[ind]) {
                    cout << uniq[i] + sum << endl;
                    break;
                }
            }
        }
    }
}


