#include <bits/stdc++.h>

using num = long long;

void print(std::vector<num> const& arr)
{
    for(auto elem : arr)
        std::cout << elem << ' ';
    std::cout << '\n';
}

void f(std::vector<num>& c)
{
    const auto set = std::set(c.begin(), c.end(), std::greater<>{});
    num val = 0;
    std::unordered_map<num, num> add;

    for(auto elem : set)
        add[elem] = val++;

    for(auto& elem : c)
        elem += add[elem];
}

int main()
{
    num n, q;
    std::cin >> n >> q;
    std::vector<num> c(n);
    for(auto& elem : c)
        std::cin >> elem;

    std::sort(c.begin(), c.end());
    std::vector<num> diffs(n-1);
    for(num i = 0; i < n-1; i++)
        diffs[i] = c[i+1] - c[i];
    std::sort(diffs.begin(), diffs.end());

    const auto f1 = [&](num k)
    {
        num l = -1, r = c.size();
        while(r - l > 1)
        {
            const num mid = (r + l)/2;
            if(diffs[mid] > k)
                r = mid;
            else
                l = mid;

        }
        return r;
    };

    while(q--)
    {
        num t;
        std::cin >> t;

        if(t == 1)
        {
            num k;
            std::cin >> k;
            std::cout << f1(k) << '\n';
        }
    }
}
