#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

const int Base = 3e5 + 333;

int n, q;
long long c[Base];
int posToVal[Base];
vector<pair<long long, int>> values;
vector<long long> d, dT1;
long long ans[Base];
vector<pair<long long, int>> q1, q2;
vector<pair<pair<long long, int>, int>> q3;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> q;

	vector<long long> v;
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
		v.push_back(c[i]);
	}

	sort(v.begin(), v.end());
	long long last = v[0];
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (last == v[i])
		{
			cnt++;
		}
		else
		{
			values.push_back(make_pair(last, cnt));
			last = v[i];
			cnt = 1;
		}
	}
	values.push_back(make_pair(last, cnt));
	for (int i = 0; i + 1 < values.size(); i++)
	{
		d.push_back(values[i + 1].first - values[i].first);
		dT1.push_back(d.back());
	}

	for (int i = 0; i < q; i++)
	{
		int type;
		cin >> type;
		long long k;
		cin >> k;
		if (type == 1)
		{
			q1.push_back(make_pair(k, i));
		}
		else if (type == 2)
		{
			q2.push_back(make_pair(k, i));
		}
		else
		{
			int id;
			cin >> id;
			q3.push_back(make_pair(make_pair(k, id), i));
		}
	}

	sort(q1.begin(), q1.end());
	sort(q2.begin(), q2.end());
	sort(q3.begin(), q3.end());

	//------------------------------------------------------T1---------------------------------------
	sort(dT1.begin(), dT1.end());
	
	int m = values.size();
	for (int i = 0; i < q1.size(); i++)
	{
		auto it = upper_bound(dT1.begin(), dT1.end(), q1[i].first);
		int r = (it - dT1.begin());
		ans[q1[i].second] = (long long)(m - r);
	}

	//------------------------------------------------------T2---------------------------------------

	//------------------------------------------------------T3---------------------------------------

	//------------------------------------------------------End--------------------------------------
	for (int i = 0; i < q; i++)
	{
		cout << ans[i] << endl;
	}

	return 0;
}