#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cstring>
#include <bitset>
#include <algorithm>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front


#define int long long



using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;



vector<vector<int> > g;
vector<int> ans;



const int INF = (int)2e9 + 109;;



void solve_solve_solve() {

    int n, m;
    cin >> n >> m;

    g.clear();
    g.resize(n);

    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;

        v--, u--;
        g[v].pub(u);
        g[u].pub(v);
    }

    vector<int> dp1(n, INF), dp2(n, INF);
    dp2[0] = 0;

    set<pii> s2 = {{0, 0}};
    set<pii> s1;
    s1.clear();

    while (!(s1.empty() && s2.empty())) {


        if (!s2.empty()) {

            int v = s2.begin()->y;
            s2.erase(s2.begin());

            for (int u : g[v]) {
                if (dp1[u] > dp2[v] + 1) {
                    s1.erase({dp1[u], u});
                    dp1[u] = dp2[v] + 1;
                    s1.insert({dp1[u], u});
                }
            }
        }

        if (!s1.empty()) {

            int v = s1.begin()->y;
            s1.erase(s1.begin());

            for (int u : g[v]) {
                if (dp2[u] > dp1[v] + 1) {
                    s2.erase({dp2[u], u});
                    dp2[u] = dp1[v] + 1;
                    s2.insert({dp2[u], u});
                }
            }
        }
    }



    ans.resize(n);
    ans[0] = 0;

    for (int i = 0; i < n; i++) {
        if (dp1[i] == INF) {
            dp1[i] = -1;
        }

        if (dp2[i] == INF) {
            dp2[i] = -1;
        }
    }
    for (int i = 1; i < n; i++) {
        cout << dp2[i] << " ";
    }
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int Q = 1;
    cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
