from math import gcd, inf
import sys
import itertools
from random import *


def main(s, y):
    n = len(s)
    for i in range(n):
        best_val = int(s)
        best_str = s
        for k in range(i, n):
            if s[k] <= s[i]: continue
            will = s[:i] + s[k] + s[i:k] + s[k + 1:]
            val = int(will) - y * (k - i)
            if val > best_val or (val == best_val and best_str < will):
                best_val = val
                best_str = will
        s = best_str
    return s


def stupid(s, y):
    n = len(s)
    mm = [i for i in s]
    ans = ''
    res = 0
    for mas in itertools.permutations(mm):
        delta = 0
        ss = s
        for j in range(n):
            for i in range(j, n):
                if mas[j] == ss[i]:
                    ss = ss[:j] + ss[i] + ss[j:i] + ss[i + 1:]
                    delta += y * (i - j)
                    break
        for i in range(n):
            assert ss[i] == mas[i]
        if int(ss) - delta > res or (int(ss) - delta == res and ss > ans):
            ans = ss
            res = int(ss) - delta
    return ans


def solve(s, y):
    s = [i for i in s]
    s.sort(reverse=True)
    print(''.join(s))


if __name__ == '__main__':
    s = input()
    y = int(input())
    print(main(s, y))
    quit()
    t = 1999999999 # int(input())
    for _ in range(t):
        n = randint(1, 6)
        s = ''
        for i in range(n):
            s += str(randint(0, 9))
        y = randint(1, 10 ** 6)
        s1 = main(s, y)
        s2 = stupid(s, y)
        if s1 != s2:
            print(s1, s2)
            print(s)
            print(y)
            break
# 705075
# 11977