#include<bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(x) (int) (x).size()
#define pb push_back
#define all(x) (x).begin(), (x).end()

const int N = 300022;
int a[N], id[N], pos[N], ans[N], n, q;
vector<int> b;
vector<pii> qu[N];

struct node {
    int sum, sum2, d;
    node() {}
};

node merge(node a, node b) {
	node res;
	res.sum2 = a.sum2 + b.sum2;
	res.sum = a.sum + b.sum;
	res.d = 0;
	return res;
}

int m;

node t[4 * N];

void build(int v, int l, int r) {
	if (l + 1 == r) {
		t[v].sum = t[v].d = 0;
		t[v].sum2 = b[r] - b[l];
		return;
	}
	int m = (l + r) / 2;
	build(v * 2 + 1, l, m);
	build(v * 2 + 2, m, r);
	t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
}

void push(int v, int l, int r) {
	t[v].sum += t[v].sum2 * t[v].d;
	if (l + 1 != r) {
		t[v * 2 + 1].d += t[v].d;
		t[v * 2 + 2].d += t[v].d;
	}
	t[v].d = 0;
}

void update(int v, int l, int r, int l1, int r1, int x) {
	push(v, l, r);
	if (l1 >= r || l >= r1) return;
	if (l1 <= l && r <= r1) {
		t[v].d += x;
		push(v, l, r);
		return;
	}
	int m = (l + r) / 2;
	update(v * 2 + 1, l, m, l1, r1, x);
	update(v * 2 + 2, m, r, l1, r1, x);
	t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int l, int r, int l1, int r1) {
	push(v, l, r);
	if (l1 >= r || l >= r1) return 0;
	if (l1 <= l && r <= r1) return t[v].sum;
	int m = (l + r) / 2;
	return get(v * 2 + 1, l, m, l1, r1) + get(v * 2 + 2, m, r, l1, r1);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> q;
	forn (i, n) {
		cin >> a[i];
	}
	iota(id, id + n, 0);
	sort(id, id + n, [&] (int i, int j) { return a[i] < a[j]; });
	forn (i, n) pos[id[i]] = i;
	b.pb(0);
	for (int i = 1; i < n; i++) {
		int x = id[i], y = id[i - 1];
		if (a[x] != a[y]) {
			b.pb(a[x] - a[y]);

		}
	}
	sort(all(b));
	b.pb((int) 1e12 + 22);
	m = sz(b) - 1;
	build(0, 0, m);
	//cout << "F" << endl;
	forn (tt, q) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			ans[tt] = sz(b);
			ans[tt] -= upper_bound(all(b), k) - b.begin();
		}
		if (t == 2) {
            int k;
            cin >> k;
            vector<int> tmp(n);
            forn (i, n) tmp[i] = a[i];
            sort(all(tmp));
            while (k--) {
                set<int> tmp2;
                for (int i = n - 1; i >= 0; i--) {
                    int cnt = sz(tmp2);
                    if (tmp2.find(tmp[i]) != tmp2.end()) cnt--;
                    tmp2.insert(tmp[i]);
                    tmp[i] += cnt;
                    ans[tt] += cnt;
                }
            }
		}
		if (t == 3) {
            int k, i;
            cin >> k >> i;
            i--;
            i = pos[i];
            qu[i].pb({tt, k});
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		if (i + 1 < n && a[id[i]] != a[id[i + 1]]) {
			int j = a[id[i + 1]] - a[id[i]];
			update(0, 0, m, 0, m, 1);
			j = lower_bound(all(b), j) - b.begin();
			update(0, 0, m, j, m, -1);
		}
		for (auto [tt, k] : qu[i]) {
			int j = lower_bound(all(b), k) - b.begin();
			ans[tt] = get(0, 0, m, 0, j - 1) + a[id[i]];
			if (j) {
				int l = b[j - 1];
				int t = k - l;
				int res = get(0, 0, m, j - 1, j);
				res /= (b[j] - b[j - 1]);
				ans[tt] += t * res;
			}
		}
	}
	forn (i, q) cout << ans[i] << '\n';
}
