#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
//#define int long long

using namespace std;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    vector<vector<int>> segs(m);
    set<int> interesting;
    for(int i=0; i<m; i++){
        int l, r, c, t;
        cin >> l >> r >> c >> t;
        r--, l--;
        segs[i] = {r, l, c, t};
        interesting.insert(l);
        interesting.insert(r + 1);
    }
    interesting.insert(0);
    interesting.insert(n-1);
    interesting.insert(n);
    vector<long long> pref;
    pref.push_back(0);
    for(int i:a)
        pref.push_back(pref.back() + i);
    vector<vector<int>> to_push(n);
    for(int i=0; i<n; i++){
        int was = interesting.count(i);
        interesting.insert(i);
        int was2 = interesting.count(i + 1);
        interesting.insert(i + 1);
        priority_queue<vector<int>> q;
        for(int j=0; j<m; j++){
            int l = segs[j][1];
            if(segs[j][3] == 1)
                l = min(l, i);
            to_push[l].push_back(j);
        }
        long long ans = 0;
        auto it = interesting.begin();
        for(int j=0; j<n;){
            it++;
            int nxt = *it;
            for(int l:to_push[j]){
                vector<int> psh = segs[l];
                if(psh[3] == 1){
                    psh[0] = max(psh[0], i);
                    psh[1] = min(psh[1], i);
                }
                psh[0] = -psh[0];
                q.push(psh);
            }
            to_push[j].clear();
            while(q.size() && -q.top()[0] < j) {
                q.pop();
            }
            long long add = 0;
            long long cur = pref[nxt] - pref[j];
            while(q.size() && add < cur){
                vector<int> v = q.top();
                q.pop();
                if(v[2] > cur - add){
                    v[2] -= cur - add;
                    add = cur;
                    q.push(v);
                } else{
                    add += v[2];
                }
            }
            j = nxt;
            ans += add;
        }
        if(!was)
            interesting.erase(i);
        if(!was2)
            interesting.erase(i + 1);
        cout << ans << " ";
    }
    cout << '\n';
}

/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> q;
    while(q-->0){
        solve();
    }
    return 0;
}