#ifdef LOCAL
#include "stdc++.h"
#else
#include <bits/stdc++.h>
#endif

using namespace std;

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    string number;
    cin >> number;
    int n = (int) number.size();
    long long y;
    cin >> y;

    vector<char> removed(n);
    vector<int> added(10);
    vector<vector<int>> pos(10);
    for (int i = 0; i < n; i++) {
        pos[number[i] - '0'].push_back(i);
    }

    int p = 9;
    for (int i = 0; i + 0 < n; i++) {
        while (true) {
            while (pos[p].empty()) {
                p--;
            }
            if (number[i] - '0' < p) {
                added[p]++;
                removed[pos[p].back()] = true;
                pos[p].pop_back();
            } else {
                break;
            }
        }
    }
    string newNumber;
    for (int i = 9; i >= 0; i--) {
        while (added[i]) {
            newNumber.push_back(i + '0');
            added[i]--;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!removed[i]) {
            newNumber.push_back(number[i]);
        }
    }
    cout << newNumber << '\n';
}
