#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 10;
const int INF = (int)1e18 + 10;

int a[MAXN];
pair<int, int> pa[MAXN];
int fa[MAXN];
int ans[MAXN];
vector<int> used;
vector<pair<int, int>> difs;
tuple<int, int, int> queries[MAXN];

signed main() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        fa[i] = a[i];
        pa[i] = {a[i], i};
        used.push_back(a[i]);
    }
    sort(a, a + n);
    sort(fa, fa + n);
    sort(pa, pa + n);
    sort(used.begin(), used.end());
    used.resize(unique(used.begin(), used.end()) - used.begin());
    for (int i = 0; i <= 1e4; ++i) {
        difs.push_back({i, -1});
    }
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        int k;
        cin >> k;
        difs.push_back({k, i});
        if (t == 3) {
            int j;
            cin >> j;
            queries[i] = {k, t, j};
        } else {
            queries[i] = {k, t, -1};
        }
    }
    sort(difs.begin(), difs.end());
    int t = 0;
    for (auto [k, j] : difs) {
        // cerr << k << ": ";
        int lst = a[n - 1];
        int cnt = 0;
        for (int i = n - 1; i >= 0; --i) {
            if (lst != a[i]) {
                cnt++;
            } 
            // cerr << lst << ' ';
            lst = a[i];
            a[i] += cnt * (k - t);
        }
        // cerr << endl;
        if (j != -1) {
            auto [k, t, i] = queries[j];
            if (t == 1) {
                ans[j] = cnt + 1;
            } else if (t == 3) {
                // for (int i = 0; i < n; ++i) {
                //     cerr << a[i] << ' ';
                // }cerr << endl;
                ans[j] = a[pa[i - 1].second];
            } else {
                for (int i = 0; i < n; ++i) {
                    ans[j] += a[i] - fa[i];
                }
            }
        }
        t = k;
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }
    return 0;
}