#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;
template<typename T>
using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
//#define int ll
typedef pair<int, int> pii;
#define vec vector
#define all(a) a.begin(), a.end()
#define _ << ' ' <<
#ifndef HOME
#define cerr if(0) cerr
#endif
#ifdef int
const int INF = 2e16;
#else
const int INF = 2e9;
#endif
const int MAXN = 10010;
vec<int> a[MAXN];

void solve() {
    int n, q;
    cin >> n >> q;
    a[0].resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[0][i];
    }
    for (int i = 0; i + 1 < MAXN; ++i) {
        orset<int> st;
        a[i + 1].resize(n);
        for (int j = 0; j < n; ++j) {
            st.insert(a[i][j]);
        }
        for (int j = 0; j < n; ++j) {
            a[i + 1][j] = a[i][j] + st.size() - 1 - st.order_of_key(a[i][j]);
        }
    }
    for (int tmp = 0; tmp < q; ++tmp) {
        int t, k, i;
        cin >> t >> k;
        if (t == 1) {
            set<int> st;
            for (int j = 0; j < n; ++j) {
                st.insert(a[k][j]);
            }
            cout << st.size();
        }
        if (t == 2) {
            int ans = 0;
            for (int j = 0; j < n; ++j) {
                ans += a[k][j] - a[0][j];
            }
            cout << ans;
        }
        if (t == 3) {
            cin >> i;
            cout << a[k][i];
        }
        cout << '\n';
    }

}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    for (int i = 0; i < tt; ++i) {
        ld s = clock();
        solve();
        cout << '\n';
        ld e = clock();
        cerr << "Worktime:" _ (e - s) / CLOCKS_PER_SEC << '\n';
    }
}