#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 1e5;

void solve() {
    int n, m;
    cin >> n >> m;
    vi a(n);
    rep(i, n) cin >> a[i];
    vector<ar<int, 4>> b(m);
    rep(i, m) rep(j, 4) cin >> b[i][j];
    rep(i, m) {
        b[i][0]--;
        b[i][1]--;
    }
    rep(x, n) {
        vector<ar<int, 3>> c(m);
        rep(i, m) {
            c[i][0] = b[i][0];
            c[i][1] = b[i][1];
            if (b[i][3] == 1) {
                c[i][0] = min(c[i][0], x);
                c[i][1] = max(c[i][1], x);
            }
            c[i][2] = b[i][2];
        }
        sort(all(c), [&](const ar<int, 3> &i, const ar<int, 3> &j) {
            return i[1] < j[1];
        });
        auto cur = a;
        set<int> alive;
        rep(i, n) alive.insert(i);
        ll ans = 0;
        for (auto &[l, r, have]: c) {
            while (have > 0) {
                auto it = alive.lower_bound(l);
                if (it == alive.end()) break;
                int i = *it;
                if (i > r) break;
                if (cur[i] > have) {
                    cur[i] -= have;
                    ans += have;
                    have = 0;
                    break;
                }
                alive.erase(i);
                ans += cur[i];
                have -= cur[i];
                cur[i] = 0;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}