#include <bits/stdc++.h>
using namespace std;
const int N = 5e5 + 113;
vector<int> edges[N];
map<int, int> type[N];
int tin[N], mintin[N];
int c = 1;
vector<vector<int>> paths;
int ind[N];
map<int, int> cnt_been[2][N];
void dfs(int v, int a) {
    paths.push_back(vector<int>{v});
    ind[v] = paths.size() - 1;
    type[v][a] = 0;
    tin[v] = c++, mintin[v] = tin[v];
    for (auto i : edges[v]) {
        if (!tin[i])
            dfs(i, v);
        if (i != a) {
            if (mintin[i] < tin[v])
                type[v][i] = 0;
            else
                type[v][i] = ind[i] + 1;
        }
    }
    for (auto i : edges[v]) {
        mintin[v] = min(mintin[v], mintin[i]);
        if (i != a && ind[i] != ind[v]) {
            int x = ind[i], y = ind[v];
            if (paths[x].size() > paths[y].size())
                swap(x, y);
            for (auto j : paths[x])
                ind[j] = y, paths[y].push_back(j);
        }
    }

}
void clear(int n) {
    c = 1;
    paths.clear();
    for (int i = 0; i <= n; i++)
        edges[i].clear(), type[i].clear(), tin[i] = mintin[i] = ind[i] = 0, cnt_been[0][i].clear(), cnt_been[1][i].clear();
}
void solve() {
    int n, m;
    cin >> n >> m;
    clear(n);
    map<pair<int, int>, int> dist[2];
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        dist[0][{u, v}] = dist[0][{v, u}] = dist[1][{u, v}] = dist[1][{v, u}] = 1e9;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
    dfs(1, -1);
    /*for (int i = 1; i <= n; i++) {
        for (auto j : edges[i])
            cout << i << " " << j << " " << type[i][j] << endl;
        cout << endl;
    }*/
    queue<pair<pair<bool, int>, int>> bfs;
    for (auto j : edges[1])
        dist[0][{1, j}] = 0, bfs.push({{0, 1}, j});
    vector<int> ans(n + 1, 1e9);
    while (bfs.size()) {
        bool tp = bfs.front().first.first;
        int u = bfs.front().first.second, v = bfs.front().second;
        if (!tp)
            ans[u] = min(ans[u], dist[tp][{u, v}] + 1);
        else
            ans[v] = min(ans[v], dist[tp][{u, v}] + 1);
        bfs.pop();
        int cringe = type[v][u];
        if (tp)
            cringe = 1;
        if (cnt_been[tp][v][cringe] < 1) {
            cnt_been[tp][v][cringe]++;
            for (auto i: edges[v]) {
                if (i != u && (type[v][i] == type[v][u] || tp) && dist[!tp][{v, i}] > dist[tp][{u, v}] + 1) {
                    dist[!tp][{v, i}] = dist[tp][{u, v}] + 1;
                    bfs.push({{!tp, v}, i});
                }
            }
        }
    }
    for (int i = 2; i <= n; i++) {
        /*   for (auto j : edges[i])
               ans[i] = min(ans[i], dist[0][{i, j}]);*/
        if (ans[i] > 1e7)
            cout << -1 << " ";
        else
            cout << ans[i] << " ";
    }
    cout << '\n';
}
signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}