#include<bits/stdc++.h>

#pragma GCC optimize("O3")

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 5111;
const int INF = 1e9 + 7;

int n, m;

int dst[MXN][MXN];
vector<int> g[MXN];

int ind0, ind1;
int sz0, sz1;
pii q0[MXN*MXN];
pii q1[MXN*MXN];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear();
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
        dst[i][j] = INF;
    }}
    dst[0][0] = 0;
    ind0 = ind1 = sz0 = sz1 = 0;
    q0[sz0++] = make_pair(0, 0);
    pii from, to;
    while (ind0 < sz0 || ind1 < sz1) {
        if (ind0 < sz0) {
            from = q0[ind0++];
        } else {
            from = q1[ind1++];
        }
        if (from.ff == from.ss) {
            for (auto x: g[from.ff]) {
                to = make_pair(x, from.ss);
                if (dst[to.ff][to.ss] > dst[from.ff][from.ss] + 1) {
                    dst[to.ff][to.ss] = dst[from.ff][from.ss] + 1;
                    q1[sz1++] = to;
                }
            }
        } else {
            for (auto y: g[from.ss]) {
                if (y == from.ff) {
                    to = make_pair(from.ss, from.ss);
                    if (dst[to.ff][to.ss] > dst[from.ff][from.ss] + 1) {
                        dst[to.ff][to.ss] = dst[from.ff][from.ss] + 1;
                        q1[sz1++] = to;
                    }
                } else {
                    to = make_pair(from.ff, y);
                    if (dst[to.ff][to.ss] > dst[from.ff][from.ss]) {
                        dst[to.ff][to.ss] = dst[from.ff][from.ss];
                        q0[sz0++] = to;
                    }
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (dst[i][i] == INF) cout << -1 << " ";
        else cout << dst[i][i] << " ";
    } cout << "\n";

}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

