#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    ll res = binpow(a, b / 2);
    if (b % 2) return res * res * a;
    return res * res;
}

string solve_slow(string s, ll y) {
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        int best_pos = i; ll best_res = 0;
        for (int j = i + 1; j < n; ++j) {
            ll res = (s[j] - '0') * binpow(10ll, n - i - 1);
            for (int k = i; k < j; ++k) {
                res -= 9ll * binpow(10ll, n - k - 2) * (s[k] - '0');
            }
            res -= (s[j] - '0') * binpow(10ll, n - j - 1);
            res -= y * (j - i);
//            cout << s << endl;
//            cout << i << " " << j << " " << res << endl;
            if (res >= best_res) {
                best_pos = j;
                best_res = res;
            }
        }

        for (int j = best_pos - 1; j >= i; --j) swap(s[j], s[j + 1]);
    }

    return s;
}

int main() {
    string s; cin >> s;
    int n = s.size();
    ll y; cin >> y;

    cout << solve_slow(s, y) << endl;
    return 0;
}
