#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

inline ll count(string now, string start, ll y) {
	ll ans = 0, des = pow(10, now.size() -1);
	for (int i = 0; i < now.size(); ++i, des /= 10) {
		ans += des * (now[i] - '0');
		if (now[i] != start[i]) {
			for (int j = i + 1;; ++j) {
				if (now[i] == start[j]) {
					ans -= y * (j - i);
					while (j != i) {
						swap(start[j], start[j - 1]);
						--j;
					}
					break;
				}
			}
		}
	}
	return ans;
}

inline string ez(string s, ll y) {
	string start = s;
	string sans = s;
	ll ans = count(s, start, y);
	do {
		ll temp = count(s, start, y);
		if (temp > ans) {
			ans = temp;
			sans = s;
		}
		else if (temp == ans && s > sans) {
			sans = s;
		}
	} while (next_permutation(s.begin(), s.end()));
	return sans;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	string s;
	ll y, n;
	cin >> s >> y;
	n = s.size();
	const ll K = 12;
	if (n <= K) {	
		cout << ez(s, y);
	}
	else {
		sort(s.begin(), s.end() - K, [](char fi, char se) {
			return fi > se;
			});
		while (1) {
			int it = n - K;
			for (int i = n - K; i < n; ++i) {
				if (s[i] > s[it]) {
					it = i;
				}
			}
			if (s[it] > s[n - K - 1]) {
				while (it > 0 && s[it] > s[it - 1]) {
					swap(s[it], s[it - 1]);
					--it;
				}
			}
			else {
				break;
			}
		}
		cout << s.substr(0, n - K) + ez(s.substr(n - K), y);
	}
	return 0;
}