#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int ll
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << ' ' <<
#define __ << ' '

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MAXN = 5e3 + 10, inf = 1e9;
int fl[MAXN];
vector<int> gr[MAXN];
int d[MAXN];

void dfs(int v) {
    fl[v] = 1;
    for (auto &u : gr[v]) {
        if (!fl[u]) dfs(u);
    }
    return;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        gr[i].resize(0);
        d[i] = inf;
    }
    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b; --a; --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    priority_queue<pii> q;
    q.push({0, 0});
    d[0] = 0;
    pii x;
    while (!q.empty()) {
        x = q.top();
        q.pop();
        if (-x.ff != d[x.ss]) continue;
        for (auto &t : gr[x.ss]) {
            for (int i = 0; i < n; ++i) {
                fl[i] = 0;
            }
            fl[t] = 1;
            dfs(x.ss);
            for (auto &u : gr[t]) {
                if (fl[u] && d[u] > d[x.ss] + 2) {
                    d[u] = d[x.ss] + 2;
                    q.push({-d[u], u});
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (d[i] == inf) cout << -1 __;
        else cout << d[i] __;
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
}

