#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#define int ll

const int MAXN = 3e5 + 1000;
int t[4 * MAXN + 4];
int add[4 * MAXN + 4];
int val[4 * MAXN + 4];
int add_val[4 * MAXN + 4];
int pos[MAXN];
int rev[MAXN];
int rig[MAXN];
int lft[MAXN];
pair<int, int> sp[MAXN];
vector<int> req[2 * MAXN];
int n, q;

void push_val(int i, int l, int r) {
    int m = (l + r) / 2;
    add_val[2 * i + 1] += add_val[i];
    add_val[2 * i + 2] += add_val[i];
    val[2 * i + 1] += (m - l) * add_val[i];
    val[2 * i + 2] += (r - m) * add_val[i];
    add_val[i] = 0;
}

void update_val(int i, int l, int r, int q_l, int q_r, int x) {
    if (q_l <= l && r <= q_r) {
        val[i] += x * (r - l);
        add_val[i] += x;
        return;
    }
    if (r <= q_l || q_r <= l) {
        return;
    }
    int m = (l + r) / 2;
    push_val(i, l, r);
    update_val(2 * i + 1, l, m, q_l, q_r, x);
    update_val(2 * i + 2, m, r, q_l, q_r, x);
    val[i] = val[2 * i + 1] + val[2 * i + 2];
}

int get_sum_val(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return val[i];
    }
    if (q_r <= l || r <= q_l) {
        return 0;
    }
    int m = (l + r) / 2;
    push_val(i, l, r);
    return get_sum_val(2 * i + 1, l, m, q_l, q_r) + get_sum_val(2 * i + 2, m, r, q_l, q_r);
}

void push(int i, int l, int r) {
    int m = (l + r) / 2;
    add[2 * i + 1] += add[i];
    add[2 * i + 2] += add[i];
    t[2 * i + 1] += add[i] * (m - l);
    t[2 * i + 2] += add[i] * (r - m);
    add[i] = 0;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        //cout << "** " << l << " " << r << " -> " << n - l - 1 << "\n";
        t[i] = n - l - 1;
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    t[i] = t[2 * i + 1] + t[2 * i + 2];
}

void update(int i, int l, int r, int q_l, int q_r, int x) {
    if (q_l <= l && r <= q_r) {
        add[i] += x;
        t[i] += x * (r - l);
        return;
    }
    if (r <= q_l || q_r <= l) {
        return;
    }
    push(i, l, r);
    int m = (l + r) / 2;
    update(2 * i + 1, l, m, q_l, q_r, x);
    update(2 * i + 2, m, r, q_l, q_r, x);
    t[i] = t[2 * i + 1] + t[2 * i + 2];
}

int get_sum(int i, int l, int r, int q_l, int q_r) {
    if (q_l <= l && r <= q_r) {
        return t[i];
    }
    if (q_r <= l || r <= q_l) {
        return 0;
    }
    push(i, l, r);
    int m = (l + r) / 2;
    return get_sum(2 * i + 1, l, m, q_l, q_r) + get_sum(2 * i + 2, m, r, q_l, q_r);
}

void solve() {
    cin >> n >> q;
    int cnt = n;
    int ans = 0;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sp[i] = {a[i], i};
    }
    sort(sp, sp + n);
    for (int i = 0; i < n - 1; ++i) {
        req[i] = {sp[i + 1].first - sp[i].first, 0, i, i + 1};
        pos[i] = sp[i].second;
        rev[sp[i].second] = i;
    }
    pos[n - 1] = sp[n - 1].second;
    rev[sp[n - 1].second] = n - 1;
    build(0, 0, n);
    int k, ind;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            cin >> k;
            req[n - 1 + i] = {k, type, -1, i};
        }
        else if (type == 2) {
            cin >> k;
            req[n - 1 + i] = {k, type, -1, i};
        }
        else {
            cin >> k >> ind;
            --ind;
            req[n - 1 + i] = {k, type, ind, i};
        }
    }
    sort(req, req + n - 1 + q);
    vector<int> vec;
    int lst = 0;
    vector<int> ot(q);
    for (int i = 0; i < n - 1 + q; ++i) {
        vec = req[i];
        if (vec[1] == 0) {
            ind = vec[2];
            update(0, 0, n, 0, ind + 1, -1);
            update_val(0, 0, n, 0, ind + 1, vec[0]);
            //cout << "update val: " << 0 << " " << ind + 1 << " " << vec[0] << "\n";
            lst = vec[0];
            --cnt;
        }
        else if (vec[1] == 1) {
            ot[vec[3]] = cnt;
        }
        else if (vec[1] == 2) {
            //cout << "!! " << val[0] << " + " << t[0] << " * " << vec[0] << "\n";
            ot[vec[3]] = val[0] + t[0] * vec[0];
        }
        else {
            int ind = vec[3];
            int el = vec[2];
            //cout << "** " << get_sum_val(0, 0, n, rev[el], rev[el] + 1) << " + " << get_sum(0, 0, n, rev[el], rev[el] + 1) << " * " << vec[0] << "\n";
            ot[ind] = a[el] + get_sum_val(0, 0, n, rev[el], rev[el] + 1) + get_sum(0, 0, n, rev[el], rev[el] + 1) * vec[0];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ot[i] << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}
