#include <bits/stdc++.h>

#define F first
#define S second
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using pi = pair<int, int>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false; }
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false; }

struct dat{
    ll k, t, pos, id;
};

ll sum = 0;

void change(int n, ll k, vector<ll> &a) {
    vector<pair<ll, int>> c(n);
    vector<ll> b, p_sum(n);
    map<ll, vector<int>> mp;
    for (int i = 0; i < n; ++i) mp[a[i]].push_back(i);
    for (auto x : mp) b.push_back(x.F);
    int m = b.size();
    p_sum[0] = b[0];
    for (int i = 1; i < m; ++i) p_sum[i] = p_sum[i-1] + b[i];
    //cout << "Add " << k << "\n";
    //for (auto x : b) cout << x << " "; cout << "\n";
    for (int i = m-2; i >= 0; --i) {
        auto j = lower_bound(all(b), b[i]+k) - b.begin();
        ll cnt1 = (m-j), cnt2 = j-i-1;
        ll pr = cnt1*k + (p_sum[j-1]-p_sum[i])-cnt2*b[i];
        sum += (ll)pr*mp[b[i]].size();
        //cout << b[i] << ": " << pr << " -> " << j << "\n";
        //cout << cnt1 << ", " << cnt2 << "\n";
        for (auto ind : mp[b[i]]) a[ind] += pr;
    }
    for (auto &x : a) cout << x << " "; cout << "\n";
}

void solve(int n, int q) {
    vector<ll> a(n); for (auto &x : a) cin >> x;
    vector<ll> d, ans(q);
    vector<ll> c = a; sort(all(c));
    ll cur_k = 0;
    for (int i = 1; i < n; ++i) d.push_back(c[i]-c[i-1]);
    sort(all(d));
    vector<dat> v(q);
    for (int i = 0; i < q; ++i) {
        int t; cin >> t;
        ll k, pos = -1; cin >> k;
        if (t == 3) cin >> pos;
        v[i] = {k, t, pos, i};
    }
    sort(all(v), [](dat a, dat b) { return a.k < b.k;} );
    for (auto tmp : v) {
        int i = tmp.id, t = tmp.t; ll k = tmp.k;
        if (t == 1) {
            int j = upper_bound(all(d), k) - d.begin();
            ans[i] = n-j;
        }
        else {
            if (cur_k < k) change(n, k-cur_k, a);
            cur_k = k;
            if (t == 2) ans[i] = sum;
            if (t == 3) ans[i] = a[tmp.pos-1];
        }
    }
    //for (auto x : ans) cout << x << "\n";
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, q; cin >> n >> q;
    if (n <= 5000) { solve(n, q); return 0; }
    vector<ll> a(n); for (auto &x : a) cin >> x;
    sort(all(a));
    vector<ll> d;
    for (int i = 1; i < n; ++i) d.push_back(a[i]-a[i-1]);
    sort(all(d));
    while (q--) {
        int t; ll k; cin >> t >> k;
        if (t == 1) {
            int j = upper_bound(all(d), k) - d.begin();
            cout << n-j << "\n";
        }
    }
    return 0;
}