#include <bits/stdc++.h>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//#pragma GCC optimise("O3, unroll-loops")
//#pragma GCC target("avx2")

//template <typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define _ << " " <<
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#ifdef LOCAL
#define err cerr
#else
#define err if(0) cerr
#endif

#define int ll

mt19937 rnd(time(0));

const int N = 5e3 + 10;

vector<pair<int, int> > g[N];
set<int> b;
int d[N];
bool fl[N];
int col[N];
int tin[N];
int up[N];
int u[N];
int lst = 1;
int timer = 1;

void fnd_b(int v, int p) {
    tin[v] = up[v] = timer++;
    int c = 0;
    for (auto [to, num] : g[v]) {
        if (to == p) continue;
        ++c;
        if (tin[to] == 0) {
            fnd_b(to, v);
            up[v] = min(up[v], up[to]);
            if (up[to] > tin[v]) {
                b.insert(num);
            }
            if (up[to] >= tin[v] && p != -1) {
                fl[v] = 1;
            }
        } else {
            up[v] = min(up[v], tin[to]);
        }
    }

    if (p == -1 && c == 1) fl[v] = 1;
}

void dfs(int v, int x) {
    u[v] = lst;
    for (auto [to, num] : g[v]) {
        if (to == x || b.count(num) || u[to] == lst) continue;
        dfs(to, x);
    }
}

void get_c(int v, int c) {
    col[v] = c;
    for (auto [to, num] : g[v]) {
        if (fl[to] || col[to] || b.count(num)) continue;
        get_c(to, c);
    }
}

bool check(int u1, int v, int x) {
    ++lst;
    dfs(u1, x);
    return u[v] == lst;
}

void bfs() {
    queue<vector<int> > q;
    q.push({0, 1});
    while (!q.empty()) {
        auto tmp = q.front();
        q.pop();
        int v = tmp[1];

        for (auto [to, num] : g[v]) {
            if (b.count(num)) continue;
            for (auto [to1, num1] : g[to]) {
                if (to1 == 1 || to1 == v) continue;
                if (b.count(num1)) continue;
                if (fl[to] && !check(v, to1, to)) continue;
                if (d[to1] == 0 || d[to1] > d[v] + 2) {
                    d[to1] = d[v] + 2;
                    q.push({-d[to1], to1});
                }
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    b.clear();
    lst = 1;
    for (int i = 0; i <= n; ++i) {
        g[i].clear();
        d[i] = 0;
        tin[i] = 0;
        up[i] = 0;
        timer = 1;
        fl[i] = 0;
        col[i] = 0;
        u[i] = 0;
    }

    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    fnd_b(1, -1);
    int c = 1;
    for (int i = 1; i <= n; ++i) {
        if (col[i] == 0) {
            get_c(i, c);
            ++c;
        }
    }
    bfs();

    for (int i = 2; i <= n; ++i) {
        if (d[i] == 0) cout << -1 << " ";
        else cout << d[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
        cout << "\n";
    }
}
