#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct robot {
    int l, r, c, t;
    robot (int a, int b, int co, int d) {
        l = a, r = b, c = co, t = d;
    }
};

bool cmp (robot a, robot b) {
    if (a.l == b.l) {
        if (a.r == b.r)
            return a.c < b.c;
        return a.r < b.r;
    }
    return a.l < b.l;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int T;
    cin >> T;
    while (T--) {
        int n, m;
        cin >> n >> m;
        vector <int> a(n);
        for (auto &el: a)
            cin >> el;

        vector <robot> r0;
        for (int i = 0; i < m; i++) {
            int l, r, c, t;
            cin >> l >> r >> c >> t;
            l--, r--;
            r0.emplace_back(l, r, c, t);
        }

        for (int i = 0; i < n; i++) {
            vector <robot> r1;
            for (auto &[l, r, c, t]: r0) {
                if (t == 0) {
                    r1.emplace_back(l, r, c, t);
                } else {
                    r1.emplace_back(min(i, l), max(i, r), c, t);
                }
            }

            sort(r1.begin(), r1.end(), cmp);
            priority_queue <pair <int, int>> q;

            ll sum = 0;

            for (int j = 0, k = 0; j < n; j++) {
                while (!q.empty() && -q.top().first < j)
                    q.pop();
                while (k < m && r1[k].l == j)
                    q.push(make_pair(-r1[k].r, r1[k].c)), k++;

                int x = 0;
                while (!q.empty() && x < a[j]) {
                    auto [r, c] = q.top();
                    q.pop();
                    if (c + x <= a[j]) {
                        x += c;
                    } else {
                        int c1 = c - (a[j] - x);
                        x = a[j];
                        q.push(make_pair(r, c1));
                    }
                }
                sum += x;
            }
            cout << sum << " ";
        }
        cout << endl;
    }


    return 0;
}
