#include <bits/stdc++.h>

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n, q;
    std::cin >> n >> q;
    std::vector<int64_t> c(n);
    std::map<int64_t, int64_t> c_cnt;
    for (auto &x : c) {
        std::cin >> x;
        c_cnt[x]++;
    }
    std::vector<int64_t> c_srtd = c;
    std::sort(c_srtd.begin(), c_srtd.end());
    auto c_srtd_nu = c_srtd;
    c_srtd.erase(std::unique(c_srtd.begin(), c_srtd.end()), c_srtd.end());
    std::reverse(c_srtd.begin(), c_srtd.end());
    int n_s = c_srtd.size();
    std::vector<int64_t> moments;
    std::vector<std::tuple<int64_t, int64_t, int64_t>> moments_cnts; // [{moment, how_many, speed}]
    int64_t summary_speed = 0;
    for (int i = 1; i < n_s; ++i) {
        moments.emplace_back(c_srtd[i - 1] - c_srtd[i]);
        moments_cnts.emplace_back(c_srtd[i - 1] - c_srtd[i], c_cnt[c_srtd[i]], i);
        summary_speed += c_cnt[c_srtd[i]] * i;
    }

    const int64_t INF = 1e13;
    moments.emplace_back(INF);
    moments_cnts.emplace_back(INF, c_cnt[c_srtd[0]], 0);
    std::sort(moments.begin(), moments.end());
    std::sort(moments_cnts.begin(), moments_cnts.end());

    std::vector<std::pair<int64_t, int64_t>> moments_speeds;
    moments_speeds.emplace_back(0, summary_speed);
    for (int i = 0; i + 1 < n_s; ++i) {
        summary_speed -= std::upper_bound(c_srtd_nu.begin(), c_srtd_nu.end(), c_srtd[std::get<2>(moments_cnts[i])]) -
                c_srtd_nu.begin();
        moments_speeds.emplace_back(moments[i], summary_speed);
    }
    std::vector<int64_t> pref_sums(n_s);
    for (int i = 1; i < n_s; ++i) {
        pref_sums[i] = pref_sums[i - 1] + moments_speeds[i - 1].second * (moments_speeds[i].first - moments_speeds[i - 1].first);
    }
    for (int ind_q = 0; ind_q < q; ++ind_q) {
        int t;
        std::cin >> t;
        if (t == 1) {
            int64_t k;
            std::cin >> k;
            int pos = std::upper_bound(moments.begin(), moments.end(), k) - moments.begin();
            std::cout << n_s - pos << "\n";
        } else if (t == 2) {
            int64_t k;
            std::cin >> k;
            int pos = std::upper_bound(moments.begin(), moments.end(), k) - moments.begin();
            std::cout << pref_sums[pos] + moments_speeds[pos].second * (k - moments_speeds[pos].first) << "\n";
        } else {
            std::cout << "hz\n";
        }
    }
    return 0;
}
