#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

const int N = 1e5 + 5;

int n, a[N], a1[N];
int64 y;

void read() {
    string s;
    cin >> s;
    n = sz(s);
    for (int i = 1; i <= n; ++i) {
        a[i] = s[i - 1] - '0';
    }
    cin >> y;
}

void gen() {
    n = 5;
    for (int i = 1; i <= n; ++i) {
        a[i] = randint(0, 9);
        a1[i] = a[i];
    }
    y = 100000000;
}

int64 deg10[15];

void precalc() {
    deg10[0] = 1;
    for (int i = 1; i < 15; ++i) {
        deg10[i] = deg10[i - 1] * 10;
    }
}

vector<int> slow(vector<int> &digits) {
    int m = sz(digits);
    vector<int> order(m);
    iota(all(order), 0);
    int64 ans = 0;
    vector<int> answ = digits, c(m), pos(m);
    do {
        int64 curr_ans = 0;
        for (int i = 0; i < m; ++i) {
            curr_ans += deg10[n - i - 1] * digits[order[i]];
        }
        iota(all(c), 0);
        iota(all(pos), 0);
        for (int i = 0; i < m; ++i) {
            int p = pos[order[i]];
            assert(p >= i);
            curr_ans -= y * (p - i);
            for (int j = p; j >= i + 1; --j) c[j] = c[j - 1];
            c[i] = order[i];
            for (int j = 0; j < m; ++j) pos[c[j]] = j;
        }
        if (curr_ans > ans) {
            ans = curr_ans;
            for (int i = 0; i < m; ++i) {
                answ[i] = digits[order[i]];
            }
        }
        if (ans == curr_ans) {
            bool sw = false;
            for (int i = 0; i < m; ++i) {
                if (answ[i] < digits[order[i]]) {
                    sw = true;
                    break;
                } else if (answ[i] > digits[order[i]]) {
                    break;
                }
            }
            if (sw) {
                for (int i = 0; i < m; ++i) {
                    answ[i] = digits[order[i]];
                }
            }
        }
    } while (next_permutation(all(order)));
    return answ;
}

void solve() {
    for (int i = 1; i <= max(0, n - 10); ++i) {
        pii mx = mp(0, 0);
        for (int j = i; j <= n; ++j) {
            mx = max(mx, mp(a[j], -j));
        }
        int j = -mx.se;
        for (int p = j; p >= i + 1; --p) a[p] = a[p - 1];
        a[i] = mx.fi;
    }
    vector<int> rem;
    for (int i = max(0, n - 10) + 1; i <= n; ++i) rem.emplace_back(a[i]);
    rem = slow(rem);
    for (int i = max(0, n - 10) + 1, j = 0; i <= n; ++i, ++j) a[i] = rem[j];
}

void write() {
    for (int i = 1; i <= n; ++i) {
        cout << a[i];
    }
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    precalc();
    read();
    solve();
    write();
    return 0;
}