#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cassert>
#include <cstring>
#include <map>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

//const long long INFll = 1e18 + 3;
const int INF = 1e8 + 3;
const int N = 2e5 + 228;

int a[N];

struct robot {
	int l, r, c, t;
	robot() {}
	robot(int l, int r, int c, int t): l(l) , r(r), c(c), t(t) {}
};

bool operator < (const robot& r1, const robot& r2) {
	if (r1.l == r2.l) return r1.r < r2.r;
	return r1.l < r2.l;
}

robot b[N];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < m; ++i) {
		int l, r, c, t;
		cin >> l >> r >> c >> t;
		assert(t == 0);
		--l;
		b[i] = robot(l, r, c, t);
	}
	sort(b, b + m);
	int pos = 0;
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		int l, r, c, t;
		l = b[i].l;
		r = b[i].r;
		c = b[i].c;
		t = b[i].t;
		while (pos < l) ++pos;
		while (pos < r) {
			if (a[pos] >= c) {
				ans += c;
				a[pos] -= c;
				break;
			}
			a[pos] = 0;
			++pos;
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << ans << " ";
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
*/