#include <bits/stdc++.h>
#define int long long
#define lint int
using namespace std;


int getr(vector<int> &cds, int k, int n)
{
    int l = -1, r = n - 1;
    while(r - l > 1)
    {
        int m = (l + r) / 2;
        if(cds[m] <= k) l = m;
        else r = m;
    }
    return r;
}

int ans1(vector<int> &cds, int k, int n)
{
    int r = getr(cds, k, n);
    return n - r;
}

int ans2(vector<int> &cds, vector<lint> &cdsd_pref, int k, int n)
{
    int r = getr(cds, k, n);
    lint ans = 0;
    if(r > 0) ans = cdsd_pref[r - 1];

    lint curdif = k;
    if(r > 0) curdif -= cds[r - 1];
    ans += curdif * (n - r);
    return ans;
}

signed main()
{
    int n, q;
    cin >> n >> q;
    vector<int> c(n), c_sort(n), c_dif(n - 1), c_dif_sort(n - 1), cds_dif(n - 1);
    vector<lint> cdsd_pref(n - 2);
    for(int i = 0; i < n; i++)
    {
        cin >> c[i];
        c_sort[i] = c[i];
    }

    sort(c_sort.begin(), c_sort.end());
    for(int i = 0; i < n - 1; i++)
    {
        c_dif_sort[i] = c_dif[i] = c_sort[i + 1] - c_sort[i];
    }
    sort(c_dif_sort.begin(), c_dif_sort.end());
    for(int i = 0; i < n - 1; i++)
    {
        cds_dif[i] = c_dif_sort[i];
        if(i > 0) cds_dif[i] -= c_dif_sort[i - 1];

        if(i > 0) cdsd_pref[i] = cdsd_pref[i - 1];
        cdsd_pref[i] += ((lint)(n - i) * (i - 1)) * cds_dif[i];
    }




    set<pair<int, pair<int, pair<int, int>>>> set_exp_mul; //{exp, {mul, {cnt, dif}}}
    set<pair<int, pair<int, int>>> set_dif_exp_pref;

    for(int i = n - 1; i >= 0; i--)
    {
        if(set_exp_mul.empty() || (set_exp_mul.begin())->first != c_sort[i])
        {
            if(set_exp_mul.empty())
            {
                set_dif_exp_pref.insert({1000000000, {c_sort[i], n}});
                set_exp_mul.insert({c_sort[i], {0, {1, 1000000000}}});
            }
            else
            {
                int pref = set_dif_exp_pref.lower_bound({(set_exp_mul.begin())->second.second.second, {(set_exp_mul.begin())->first, -1}})->second.second;
                int sz = (set_exp_mul.begin())->second.second.first;

                set_dif_exp_pref.insert({(set_exp_mul.begin())->first - c_sort[i], {c_sort[i], pref - sz}});
                set_exp_mul.insert({c_sort[i], {(set_exp_mul.begin())->second.first + 1, {1, (set_exp_mul.begin())->first - c_sort[i]}}});
            }
        }
        else
        {
            //cerr << "HERE AT " << i << "\n";
            auto pr = (set_exp_mul.begin())->second;
            set_exp_mul.erase(set_exp_mul.begin());
            set_exp_mul.insert({c_sort[i], {pr.first, {pr.second.first + 1, pr.second.second}}});
        }
    }





    lint curmul = 0;
    for(auto w : set_exp_mul) curmul += w.second.first * w.second.second.first;
    /*
    cout << "DEBUG: SETEXPMUL\n";
    for(auto w : set_exp_mul) cout << w.first << " " << w.second.first << " " << w.second.second.first << " " << w.second.second.second << "\n";
    cout << "\n\nDEBUG: SETDIF\n";
    for(auto w : set_dif_exp_pref) cout << w.first << " " << w.second.first << " " << w.second.second << "\n";
    */
    set<pair<int, pair<int, int>>> set_k_curmul;

    set_k_curmul.insert({0, {curmul, 0}});

   //return 0;

    while(set_dif_exp_pref.size() > 1)
    {
        int min_dif = (set_dif_exp_pref.begin())->first;

        while((set_dif_exp_pref.begin())->first == min_dif)
        {
            auto sdep_min = *(set_dif_exp_pref.begin());
            int exp_min = sdep_min.second.first, pref_min = sdep_min.second.second, dif_min = sdep_min.first;

            int exp_next = exp_min + dif_min;

            auto sem_min = *(set_exp_mul.lower_bound({exp_min, {-1, {-1, -1}}}));
            auto sem_next = *(set_exp_mul.lower_bound({exp_next, {-1, {-1, -1}}}));

            int cnt_min = sem_min.second.second.first;
            int cnt_next = sem_next.second.second.first;

            int dif_next = sem_next.second.second.second;


            auto sdep_next = *(set_dif_exp_pref.lower_bound({dif_next, {exp_next, -1}}));

            int pref_next = sdep_next.second.second;

            //int dif_next =

            set_exp_mul.erase(sem_min);
            set_exp_mul.erase(sem_next);
            set_exp_mul.insert({exp_next, {-1 , {cnt_min + cnt_next, dif_next} } });


            set_dif_exp_pref.erase(sdep_min);
            set_dif_exp_pref.erase(sdep_next);
            set_dif_exp_pref.insert({dif_next, {exp_next, pref_next}});

            curmul -= pref_min;
        }
        auto itlast = set_k_curmul.end();
        itlast--;
        int getlast = (itlast)->second.second;
        int klast = (itlast)->first;
        int mullast = (itlast)->second.first;
        set_k_curmul.insert({min_dif, {curmul, getlast + (min_dif - klast) * mullast}});
    }

    /*
    cout << "DEBUG SET:\n";

    for(auto w : set_k_curmul)
    {
        cout << w.first << " " << w.second.first << " " << w.second.second << "\n";
    }
    */
    //cout << "CURMUL: " << curmul << "\n";

    //cout << "\n\n\n\n\n";
    for(int query = 0; query < q; query++)
    {
        int t;
        cin >> t;

        lint k, x;

        if(t == 1)
        {
            cin >> k;
            cout << ans1(c_dif_sort, k, n) << "\n";
        }
        if(t == 2)
        {
            cin >> k;
            auto it = set_k_curmul.upper_bound({k, {-1, -1}});

            it--;
            cout << it->second.second + (k - it->first) * (it->second.first) << "\n";
        }
        if(t == 3)
        {
            cin >> k >> x;
            cout << "REST\n";
        }



    }
}
